'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ComponentBase = function (_React$Component) {
    _inherits(ComponentBase, _React$Component);

    function ComponentBase(props) {
        _classCallCheck(this, ComponentBase);

        var _this = _possibleConstructorReturn(this, (ComponentBase.__proto__ || Object.getPrototypeOf(ComponentBase)).call(this, props));

        if (bb.inu(props.Id)) {
            alert("Missing id attribute at component");
        }

        var options = {
            Id: props.Id,
            Caption: props.Caption,
            Errors: [],
            OnError: props.OnError,
            Class: props.Class,
            Disabled: props.Disabled,
            Hidden: props.Hidden,
            Tooltip: props.Tooltip,
            InitValue: !bb.inu(props.Value) ? props.Value : '',
            InfoClick: props.InfoClick,
            Click: function Click(e, value) {
                if (!bb.inu(e)) {
                    e.persist();
                }
                var options = _this.state.options;
                options.Errors = [];

                if (!bb.inu(value)) {
                    _this.setState({ value: value, options: options }, function () {
                        if (bb.isFunction(props.OnClick)) {
                            props.OnClick(value, props, e);
                        }
                    }.bind(_this));
                } else {
                    if (bb.isFunction(props.OnClick)) {
                        props.OnClick(props.Value, props, e);
                    }
                }
            },
            Change: function Change(e, value) {
                if (!bb.inu(e)) {
                    e.persist();
                }
                if (!bb.inu(e) && !bb.inu(e.target)) {
                    value = bb.inu(value) ? e.target.value : value;

                    switch (e.target.type) {
                        case 'checkbox':
                            value = e.target.checked;
                            break;
                    }
                }

                var options = _this.state.options;
                options.Errors = [];

                _this.setState({ value: value, options: options }, function () {
                    if (bb.isFunction(props.OnChange)) {
                        props.OnChange(this.state.value, props, e);
                    }
                }.bind(_this));
            }
        };

        _this.isInput = true;
        _this.state = { value: options.InitValue, options: options };

        if (bb.isFunction(_this['init'])) {
            _this['init'].call(_this, props, options);
        }
        return _this;
    }

    _createClass(ComponentBase, [{
        key: 'componentWillMount',
        value: function componentWillMount() {}
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            if (!bb.inu(this.props.Run)) {
                delete this.props.Run[this.props.Id];
            }
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (!bb.inu(this.props.Run)) {
                this.props.Run[this.props.Id] = this;
            }

            if (bb.isFunction(this['load'])) {
                this['load'].call(this, this.props, this.state.options);
            }
        }
    }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
            if (nextProps.Value !== undefined || nextProps.Value == '') {
                this.state.value = nextProps.Value;
            }
            if (nextProps.Class !== undefined) {
                this.state.options.Class = nextProps.Class;
            }
            if (nextProps.Hidden !== undefined) {
                this.state.options.Hidden = nextProps.Hidden;
            }
            if (nextProps.Disabled !== undefined) {
                this.state.options.Disabled = nextProps.Disabled;
            }
            if (nextProps.Currency !== undefined) {
                this.state.options.Currency = nextProps.Currency;
            }
            if (nextProps.Caption !== undefined) {
                this.state.options.Caption = nextProps.Caption;
            }
        }
    }, {
        key: 'val',
        value: function val(value, callback) {
            if (bb.inu(value)) {
                return this.state.value;
            } else {
                this.setState({ value: value }, callback);
            }
        }
    }, {
        key: 'error',
        value: function error(msg, callback) {
            var options = this.state.options;
            options.Errors = [];
            if (!bb.inu(msg) && msg != '') {
                options.Errors.push(bb.localize(msg));
                if (bb.isFunction(options.OnError)) {
                    options.OnError(msg);
                }
            }
            this.setState({ options: options }, callback);
        }
    }, {
        key: 'reset',
        value: function reset(callback) {
            var options = this.state.options;
            options.Errors = [];
            this.setState({ value: options.InitValue, options: options });
        }
    }, {
        key: 'clear',
        value: function clear(callback) {
            var options = this.state.options;
            options.Errors = [];
            this.setState({ value: '', options: options }, callback);
        }
    }, {
        key: 'hide',
        value: function hide(callback) {
            var options = this.state.options;
            options.Hidden = true;
            this.setState({ options: options }, callback);
        }
    }, {
        key: 'show',
        value: function show(callback) {
            var options = this.state.options;
            options.Hidden = false;
            this.setState({ options: options }, callback);
        }
    }, {
        key: 'disable',
        value: function disable(callback) {
            var options = this.state.options;
            options.Disabled = true;
            this.setState({ options: options }, callback);
        }
    }, {
        key: 'enable',
        value: function enable(callback) {
            var options = this.state.options;
            options.Disabled = false;
            this.setState({ options: options }, callback);
        }
    }, {
        key: 'getAppState',
        value: function getAppState() {
            var view = this.getView();
            return view.props.App.state.applicationState;
        }
    }, {
        key: 'getView',
        value: function getView() {
            var run = this.props.Run;
            return this.getViewBase(run);
        }
    }, {
        key: 'getViewBase',
        value: function getViewBase(run) {
            if (bb.inu(run)) return null;
            return run.IsView === true ? run : this.getViewBase(run.props.Run);
        }
    }]);

    return ComponentBase;
}(React.Component);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Layout = function (_React$Component) {
    _inherits(Layout, _React$Component);

    function Layout(props) {
        _classCallCheck(this, Layout);

        var _this = _possibleConstructorReturn(this, (Layout.__proto__ || Object.getPrototypeOf(Layout)).call(this, props));

        window.useSessionStorage = props.UseSessionStorage;
        var brandChanged = bb.getStore('brand') != null && bb.getStore('brand') != brand;
        if (brandChanged) {
            bb.setStore('brand', brand);
            bb.clearStore();
        }

        bb.setStore('brand', brand);

        var last = bb.getStore('last');
        var defaultPage = _this.props.Menu != null && _this.props.Menu != '' ? _this.props.Menu[0] : 'Login';
        _this.state = {
            loaded: false,
            reload: false,
            name: last == null ? defaultPage : last,
            history: [],
            app: _this,
            applicationState: {},
            stringMap: {},
            user: bb.getStore("user") == null ? null : JSON.parse(bb.getStore("user")),
            navigation: bb.getStore("navigation") == null ? [] : JSON.parse(bb.getStore("navigation")),
            navigationGuid: bb.guid(),
            navbarGuid: bb.guid(),
            userName: ""
        };

        if (_this.state.user != null) {
            moment.locale('en-gb');
        }

        bb.localize = _this.localize.bind(_this);
        return _this;
    }

    _createClass(Layout, [{
        key: 'current',
        value: function current() {
            return this.state.name;
        }
    }, {
        key: 'login',
        value: function login(user, navigation, callback, afterOpen) {
            var _this2 = this;

            user.NavigationCredentials = {};
            user.AnonymousCredentials = {};
            if (!bb.inu(user.UserRoles)) {
                for (var i = 0; i < user.UserRoles.length; i++) {
                    if (!bb.inu(user.UserRoles[i].Credentials)) {
                        for (var j = 0; j < user.UserRoles[i].Credentials.length; j++) {
                            var credentialType = { Anonymous: "Anonymous", Navigation: "Navigation" };
                            if (user.UserRoles[i].Credentials[j].CredentialType == credentialType.Navigation && !bb.inu(user.UserRoles[i].Credentials[j].Values)) {
                                for (var k = 0; k < user.UserRoles[i].Credentials[j].Values.length; k++) {
                                    user.NavigationCredentials[user.UserRoles[i].Credentials[j].Values[k].Name] = 1;
                                }
                            } else if (user.UserRoles[i].Credentials[j].CredentialType == credentialType.Anonymous) {
                                user.AnonymousCredentials[user.UserRoles[i].Credentials[j].Name] = 1;
                            }
                        }
                    }
                }
            }

            bb.setStore("user", JSON.stringify(user));
            var name = "";
            if (!bb.inu(navigation)) {
                name = bb.inu(afterOpen) ? "Dashboard" : afterOpen;
                bb.setStore("navigation", JSON.stringify(navigation));
                this.setState({ navbarGuid: bb.guid(), navigationGuid: bb.guid(), name: name, user: user, navigation: navigation }, callback);
            } else {
                name = bb.inu(afterOpen) ? this.state.name : afterOpen;
                this.setState({ navbarGuid: bb.guid(), name: name, user: user }, function () {
                    if (!bb.inu(_this2.Navbar.refs.ExternalNavbar)) {
                        _this2.Navbar.refs.ExternalNavbar.forceUpdate(callback);
                    } else if (bb.isFunction(callback)) {
                        callback();
                    }
                });
            }

            bb.setStore('last', name);
        }
    }, {
        key: 'logout',
        value: function logout() {
            bb.clearStore();
            bb.setStore('last', 'Login');
            this.setState({ name: 'Login', user: null, navigation: [] });
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            var _this3 = this;

            var params = new URLSearchParams(location.search);
            var lang = params.get('lang');
            var brand = params.get('brand');

            if (lang == null) {
                lang = 'en';
            }
            var brandQuery = bb.inu(brand) ? "" : '&Brand=' + brand;
            this.overlay(true);
            fetch('/System/GetApplicationState?Language=' + lang + brandQuery, {
                headers: {
                    'brand': brand,
                    'Authorization': 'Bearer ' + bb.getStore("AccessToken")
                }
            }).then(function (response) {
                return response.json();
            }).then(function (data) {
                _this3.overlay(false);

                var lastPage = bb.getStore('last');

                if (!bb.inu(lastPage) && lastPage !== 'Login' && lastPage !== 'Signup' && lastPage !== 'Home' && lastPage !== 'ForgotPassword' && lastPage !== 'CustomerLogin' && lastPage !== 'CustomerSession' && data.IsAuthorized == false) {
                    _this3.logout();
                }

                var stringMap = {};
                data.Strings.forEach(function (item, index) {
                    stringMap[item.Key] = item.Value;
                });

                moment.locale(data.Culture);
                _this3.setState({ loaded: true, applicationState: data, stringMap: stringMap }, function () {
                    if (!bb.inu(_this3.Language)) {
                        _this3.Language.val(data.Language);
                    }
                });
            });
        }
    }, {
        key: 'open',
        value: function open(name, params, waiting) {
            var _this4 = this;

            if (window[name] == null) {
                name = 'PageNotFound';
            }
            var overlay = document.querySelector('.overlay');
            if (!overlay.classList.contains('hidden')) {
                setTimeout(function () {
                    _this4.open(name, params, true);
                }, 100);
                return;
            }

            if (!bb.inu(window['ExternalAuthenticationManagement']) && !ExternalAuthenticationManagement.checkScreenCredential(name, this.CurrentView)) {
                if (this.state.name == '') {
                    this.open('Dashboard');
                }
                return;
            }

            if (name != 'Login') {
                bb.setStore("last", name);
            }

            if (bb.inu(params)) {
                bb.removeStoreItem("Params" + name);
            } else {
                bb.setStore("Params" + name, JSON.stringify(params));
            }

            var history = this.state.history;
            history.push({ name: name, params: params });
            this.setState({ name: name, history: history }, function () {
                _this4.adjustNavigationMenu(name);
            });
        }
    }, {
        key: 'adjustNavigationMenu',
        value: function adjustNavigationMenu(pageName) {
            var lastElement = document.getElementById(pageName);
            if (!bb.inu(lastElement)) {
                var closestDropDown = lastElement.closest(".dropdown");
                if (!bb.inu(closestDropDown)) {
                    if (!closestDropDown.classList.contains("open")) {
                        closestDropDown.classList.add("open");
                    }
                }

                if (!bb.inu(this.state.navigation)) {

                    var navigationExists = false;

                    for (var i = 0; i < this.state.navigation.length; i++) {
                        if (this.state.navigation[i].Page === pageName) {
                            navigationExists = true;
                        }

                        if (!bb.inu(this.state.navigation[i].Items)) {
                            for (var j = 0; j < this.state.navigation[i].Items.length; j++) {
                                if (this.state.navigation[i].Items[j].Page === pageName) {
                                    navigationExists = true;
                                }
                            }
                        }

                        if (navigationExists) {
                            break;
                        }
                    }

                    if (navigationExists) {
                        var link = lastElement.children[0];
                        if (!bb.inu(link)) {
                            var parent = document.getElementById("navbar");
                            if (!bb.inu(parent)) {
                                var allMenuLinks = parent.getElementsByTagName("a");
                                if (!bb.inu(allMenuLinks)) {
                                    for (var i = 0; i < allMenuLinks.length; i++) {
                                        allMenuLinks[i].classList.remove('active');
                                    }
                                }
                            }

                            link.classList.add("active");
                        }
                    }
                }
            } else {
                var parent = document.getElementById("navbar");
                if (!bb.inu(parent)) {
                    var allMenuLinks = parent.getElementsByTagName("a");
                    if (!bb.inu(allMenuLinks)) {
                        for (var i = 0; i < allMenuLinks.length; i++) {
                            allMenuLinks[i].classList.remove('active');
                        }
                    }
                }
            }
        }
    }, {
        key: 'back',
        value: function back() {
            if (this.state.history.length > 1) {
                this.state.history.pop();
                var previous = this.state.history.pop();
                this.open(previous.name, previous.params);
            } else {
                this.open("Dashboard");
            }
        }
    }, {
        key: 'reload',
        value: function reload() {
            this.forceUpdate();
        }
    }, {
        key: 'localize',
        value: function localize(str) {
            if (typeof str === 'string') {
                return this.state.stringMap[str.toLowerCase()] || str;
            } else {
                return str;
            }
        }
    }, {
        key: 'overlay',
        value: function overlay(state) {
            var overlay = document.getElementsByClassName('overlay')[0];
            if (state) {
                overlay.classList.remove('hidden');
            } else {
                overlay.classList.add('hidden');
            }
        }
    }, {
        key: 'openProfile',
        value: function openProfile() {

            if (!bb.inu(window['ExternalAuthenticationManagement']) && !ExternalAuthenticationManagement.checkIfUserEmailConfirmed(this.CurrentView)) {
                this.Toast.show("Please confirm your email first.", "warning");
                this.open('Dashboard');
                return;
            }

            if (window['UserProfile'] != null) {
                this.open('UserProfile');
            }
        }
    }, {
        key: 'langChanged',
        value: function langChanged(value) {
            var params = new URLSearchParams(location.search);
            params.set('lang', value);
            location.search = params.toString();
        }
    }, {
        key: 'renderFlag',
        value: function renderFlag(language) {
            return React.createElement('div', { key: language, className: "flag-icon-background m-r-xs phone-flag flag-icon-" + language.Flag });
        }
    }, {
        key: 'renderProfile',
        value: function renderProfile() {
            var externalNavBar = null;
            if (window['ExternalNavbar']) {
                var user = this.state.user;
                externalNavBar = React.createElement(ExternalNavbar, { key: this.state.navbarGuid, ref: 'ExternalNavbar', User: user, Run: this, Id: 'ExternalNavbar' });
            }

            if (this.state.user == null) {
                var buttons = [];
                if (this.props.SignUpDisable == false) {
                    buttons.push(React.createElement(Button, { key: bb.guid(), Run: this, Id: 'SignUpButton', Type: 'primary', Value: this.localize("signup"), Class: 'pull-right m-l-sm m-t-sm', To: 'Signup' }));
                }
                buttons.push(React.createElement(Button, { key: bb.guid(), Run: this, Id: 'LoginButton', Value: this.localize("login"), Class: 'pull-right m-l-sm m-t-sm', To: 'Login' }));

                if (this.props.LanguageDisable == false) {
                    buttons.push(React.createElement(Dropdown, { key: "language", Run: this, Id: 'Language', Type: 'link btn-sm', Suffix: this.renderFlag.bind(this), NoSelect: true, Class: 'pull-right m-l-sm m-t-sm', Data: this.state.applicationState.Languages, OnChange: this.langChanged.bind(this), KeyField: 'CodeNormalized', ValueField: 'Code' }));
                }
                buttons.push(this.renderStaticMenu());
                return React.createElement(
                    'div',
                    { className: 'pull-right login-profile' },
                    buttons
                );
            } else {
                var buttons = [];
                buttons.push(React.createElement(
                    'a',
                    { key: 'logout', onClick: this.logout.bind(this), href: 'javascript:void(0)', className: 'pull-right m-l-sm m-t-sm' },
                    React.createElement('i', { className: 'fa fa-sign-out fa-2x' })
                ));
                buttons.push(React.createElement(Button, { key: bb.guid(), Run: this, Id: 'UserNameButton', Icon: 'user', Value: this.state.user.Email, Class: 'pull-right m-l-xs m-t-sm logged-user-btn', OnClick: this.openProfile.bind(this) }));
                if (this.props.LanguageDisable == false) {
                    buttons.push(React.createElement(Dropdown, { key: "language", Run: this, Id: 'Language', Type: 'link btn-sm', Prefix: this.renderFlag.bind(this), NoSelect: true, Class: 'pull-right m-l-sm m-t-sm', Data: this.state.applicationState.Languages, OnChange: this.langChanged.bind(this), KeyField: 'Name', ValueField: 'Code' }));
                }
                buttons.push(externalNavBar);

                buttons.push(this.renderStaticMenu());
                return React.createElement(
                    'div',
                    { className: 'pull-right login-profile' },
                    buttons
                );
            }
        }
    }, {
        key: 'renderNavbar',
        value: function renderNavbar() {
            if (this.state.user == null) {
                return null;
            } else {
                return React.createElement(
                    Col,
                    { Sm: '2', CssClass: 'no-padding navigation-container border-right row-eq-height index-3' },
                    React.createElement(Navbar, { key: this.state.navigationGuid, Run: this, Id: 'Navbar', Navigation: this.state.navigation, Vertical: this.props.Vertical, Logo: this.props.Logo })
                );
            }
        }
    }, {
        key: 'renderStaticMenu',
        value: function renderStaticMenu() {
            var _this5 = this;

            if (!bb.inu(this.props.Menu) && this.state.user == null) {
                var arr = [];
                this.props.Menu.forEach(function (name) {
                    arr.push(React.createElement(Button, { key: name, Run: _this5, Id: name + 'Button', Value: name, Type: 'link', Class: 'pull-left', To: name }));
                });
                return React.createElement(
                    'div',
                    { key: 'menu-button', className: 'm-t-sm pull-right' },
                    arr
                );
            }
            return null;
        }
    }, {
        key: 'renderContent',
        value: function renderContent(name) {
            var view = window[name];
            var header = React.createElement('div', { className: 'm-t-md' });
            var title = bb.isFunction(view.prototype.title) ? view.prototype.title() : null;
            if (title !== false) {
                header = React.createElement(
                    'h1',
                    { className: 'display-4 white-text' },
                    React.createElement(
                        Localize,
                        null,
                        title == null ? name : title
                    )
                );
            }
            var className = "view-container animated fadeInDown ";

            return React.createElement(
                'div',
                { key: bb.guid(), className: className },
                header,
                React.createElement('div', { id: "success-" + name, className: 'alert alert-success page-alert animated fadeInDown ibox-shadow' }),
                React.createElement('div', { id: "error-" + name, className: 'alert alert-danger page-alert animated fadeInDown ibox-shadow' }),
                this.state.loaded == true ? React.createElement(window[name], { App: this }) : null
            );
        }
    }, {
        key: 'renderVertical',
        value: function renderVertical() {
            var loginClass = "";
            var whiteText = " white-text";
            var backgroundClass = " dashboard-background";
            if (!bb.inu(this.state.name) && (this.state.name === "Login" || this.state.name === "Signup" || this.state.name === "Home" || this.state.name === "ForgotPassword")) {
                loginClass = " text-center";
                backgroundClass = "";
                whiteText = "";
            }

            var colNumber = this.state.user == null ? 12 : 10;
            var logo = this.props.Logo != null && this.props.Logo != '' ? React.createElement('img', { src: "/images/" + this.props.Logo, className: 'header-logo m-sm p-w-md' }) : null;
            var headerClass = "container-fluid header m-r-sm ";
            if (this.state.user == null) {
                headerClass += "header-login";
            }
            return React.createElement(
                'div',
                null,
                React.createElement(
                    Row,
                    { CssClass: 'white-bg box-shadow' },
                    React.createElement(
                        Col,
                        { Sm: '12', CssClass: 'white-bg index-4' },
                        React.createElement(
                            'div',
                            { className: 'fixed-header m-r-sm' },
                            React.createElement(
                                Row,
                                null,
                                React.createElement(
                                    Col,
                                    { Sm: '2' },
                                    logo
                                ),
                                React.createElement(
                                    Col,
                                    { Sm: '10', CssClass: 'p-w-md' },
                                    this.renderProfile()
                                )
                            )
                        )
                    )
                ),
                React.createElement(
                    Row,
                    { CssClass: "transparent-bg row-eq-height" + backgroundClass },
                    this.renderNavbar(),
                    React.createElement(
                        Col,
                        { Sm: colNumber, CssClass: 'row-eq-height' },
                        React.createElement(
                            'div',
                            { className: 'layout-container ' },
                            React.createElement(
                                'div',
                                { className: 'container-fluid after-header' },
                                React.createElement(
                                    Row,
                                    null,
                                    React.createElement(
                                        Col,
                                        { Md: '12' },
                                        this.renderContent(this.state.name)
                                    )
                                )
                            ),
                            React.createElement(
                                'div',
                                { className: "container-fluid m-md no-padding" + whiteText + loginClass },
                                window["Footer"] != null ? React.createElement(Footer, null) : ""
                            )
                        )
                    )
                )
            );
        }
    }, {
        key: 'reLogin',
        value: function reLogin(callback) {
            var _this6 = this;

            this.TimerToken.stop();
            this.reLoginPost(function () {
                if (bb.isFunction(callback)) {
                    callback();
                } else {
                    _this6.TokenAlert.close();
                }
            });
        }
    }, {
        key: 'userLogout',
        value: function userLogout(callback) {
            this.TimerToken.stop();
            if (bb.isFunction(callback)) {
                callback();
            } else {
                this.TokenAlert.close();
            }
            this.logout();
        }
    }, {
        key: 'onRecive',
        value: function onRecive(ids) {
            var _this7 = this;

            ids.forEach(function (id) {
                if (_this7.state.user.Id == id) {
                    _this7.TimerToken.start();
                    _this7.TokenAlert.open();
                }
            });
        }
    }, {
        key: 'reLoginPost',
        value: function reLoginPost(callback) {
            var _this8 = this;

            var params = new URLSearchParams(location.search);
            var lang = params.get('lang');
            var brand = params.get('brand');
            this.overlay(true);
            fetch('/Authorization/TokenRefresh', {
                cache: 'no-cache',
                headers: {
                    'timezoneOffset': bb.getTimezoneOffset(),
                    'brand': brand != null ? brand : "default",
                    'lang': lang != null ? lang : "en",
                    'Authorization': 'Bearer ' + bb.getStore("AccessToken")
                },
                method: 'POST',
                mode: 'cors',
                redirect: 'follow',
                referrer: 'no-referrer'
            }).then(function (response) {
                return response.json();
            }).then(function (data) {
                if (!bb.inu(data.AccessToken)) {
                    bb.setStore("AccessToken", data.AccessToken);
                }
                _this8.overlay(false);
                callback();
            });
        }
    }, {
        key: 'render',
        value: function render() {
            if (!this.state.loaded || window[this.state.name] == null) {
                return React.createElement(
                    'div',
                    { className: 'overlay hidden' },
                    React.createElement(
                        'div',
                        { className: 'loader' },
                        'Loading...'
                    )
                );
            }

            var footer = window['Footer'] == null ? null : React.createElement(Footer, null);

            return React.createElement(
                'div',
                { className: "dashboard-vertical" },
                React.createElement(RealTimeDataReceiver, { Id: 'TokenExpireHandler', Type: 'TokenExpire', OnReceive: this.onRecive.bind(this) }),
                React.createElement(
                    Modal,
                    { Run: this, Id: 'TokenAlert', Size: 'Medium', DoneText: 'Confirm', OnClose: this.reLogin.bind(this), Buttons: 'Deny', OnDeny: this.reLogin.bind(this), OnCancel: this.userLogout.bind(this) },
                    React.createElement(
                        Row,
                        { CssClass: 'text-center' },
                        React.createElement(
                            Col,
                            { Md: 12 },
                            React.createElement(
                                'div',
                                { className: 'alert alert-danger' },
                                React.createElement(
                                    'h3',
                                    null,
                                    ' ',
                                    bb.localize("tokenexpreinfo")
                                )
                            )
                        ),
                        React.createElement(
                            Col,
                            { Md: 12 },
                            React.createElement(Timer, { Run: this, Id: 'TimerToken', Duration: 120000, OnComplete: this.userLogout.bind(this) })
                        )
                    )
                ),
                React.createElement(
                    'div',
                    { className: 'overlay hidden' },
                    React.createElement(
                        'div',
                        { className: 'loader' },
                        'Loading...'
                    )
                ),
                this.renderVertical()
            );
        }
    }]);

    return Layout;
}(React.Component);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LayoutTab = function (_React$Component) {
    _inherits(LayoutTab, _React$Component);

    function LayoutTab(props) {
        _classCallCheck(this, LayoutTab);

        var _this = _possibleConstructorReturn(this, (LayoutTab.__proto__ || Object.getPrototypeOf(LayoutTab)).call(this, props));

        bb.localize = _this.localize.bind(_this);
        window.useSessionStorage = props.UseSessionStorage;

        _this.OpenedViews = {};
        _this.state = {
            loaded: false,
            maxPages: 10,
            currentPageIndex: 0,
            pages: bb.getStore("user") === null ? ["Login"] : ["Dashboard"],
            user: bb.getStore("user") === null ? null : JSON.parse(bb.getStore("user")),
            navigation: bb.getStore("navigation") === null ? [] : JSON.parse(bb.getStore("navigation")),
            stringMap: {},
            applicationState: {}
        };
        return _this;
    }

    _createClass(LayoutTab, [{
        key: "current",
        value: function current() {
            return this.state.pages[this.state.currentPageIndex];
        }
    }, {
        key: "componentDidMount",
        value: function componentDidMount() {
            var _this2 = this;

            window.current = this;
            this.overlay(true);

            var lang = 'tr';
            if (!bb.inu(this.state.user)) {
                lang = this.state.user.Language || 'tr';
            }

            fetch('/System/GetApplicationState?Language=' + lang).then(function (response) {
                return response.json();
            }).then(function (data) {
                _this2.overlay(false);
                var stringMap = {};
                data.Strings.forEach(function (item, index) {
                    stringMap[item.Key] = item.Value;
                });
                moment.locale('en-gb');

                _this2.setState({ loaded: true, applicationState: data, stringMap: stringMap });
            });
        }
    }, {
        key: "login",
        value: function login(user, navigation, callback, afterOpen) {
            user.NavigationCredentials = {};
            user.AnonymousCredentials = {};
            if (!bb.inu(user.UserRoles)) {
                for (var i = 0; i < user.UserRoles.length; i++) {
                    if (!bb.inu(user.UserRoles[i].Credentials)) {
                        for (var j = 0; j < user.UserRoles[i].Credentials.length; j++) {
                            var credentialType = { Anonymous: "Anonymous", Navigation: "Navigation" };
                            if (user.UserRoles[i].Credentials[j].CredentialType == credentialType.Navigation && !bb.inu(user.UserRoles[i].Credentials[j].Values)) {
                                for (var k = 0; k < user.UserRoles[i].Credentials[j].Values.length; k++) {
                                    user.NavigationCredentials[user.UserRoles[i].Credentials[j].Values[k].Name] = 1;
                                }
                            } else if (user.UserRoles[i].Credentials[j].CredentialType == credentialType.Anonymous) {
                                user.AnonymousCredentials[user.UserRoles[i].Credentials[j].Name] = 1;
                            }
                        }
                    }
                }
            }

            bb.setStore("user", JSON.stringify(user));
            bb.setStore("navigation", JSON.stringify(navigation));

            this.setState({ pages: ["Dashboard"], currentPageIndex: 0, user: user, navigation: navigation }, callback);
        }
    }, {
        key: "logout",
        value: function logout() {
            bb.clearStore();
            this.setState({ pages: ['Login'], user: null, navigation: [] });
        }
    }, {
        key: "open",
        value: function open(name, params) {
            var _this3 = this;

            var pages = this.state.pages;
            var isFounded = false;

            if (bb.inu(params)) {
                bb.removeStoreItem("Params" + name);
            } else {
                bb.setStore("Params" + name, JSON.stringify(params));
            }

            pages.filter(function (current, index) {
                if (current == name) {
                    isFounded = true;
                    _this3.setState({ currentPageIndex: index });
                }
            });

            if (!isFounded) {
                if (this.state.maxPages == pages.length) {
                    alert("Please close a tab for new one!");
                    return;
                }
                if (this.state.user == null) {
                    pages[0] = name;
                    this.setState({ pages: pages });
                } else {
                    pages.push(name);
                    this.setState({ pages: pages, currentPageIndex: pages.length - 1 });
                }
            }

            this.CurrentView;
        }
    }, {
        key: "reload",
        value: function reload() {
            var _this4 = this;

            var pages = this.state.pages;
            var index = this.state.currentPageIndex;
            var current = this.current();
            pages.splice(index, 1);
            this.setState({ pages: pages }, function () {
                pages.splice(_this4.state.currentPageIndex, 0, current);
                _this4.setState({ pages: pages });
            });
        }
    }, {
        key: "back",
        value: function back() {
            var pages = this.state.pages;
            var currentIndex = this.state.currentPageIndex;
            var current = pages[currentIndex];
            pages = pages.filter(function (page, index) {
                return page != current;
            });
            if (this.state.currentPageIndex > 0) {
                currentIndex--;
            }
            this.setState({ pages: pages, currentPageIndex: currentIndex });
        }
    }, {
        key: "localize",
        value: function localize(str) {
            if (typeof str === 'string') {
                return this.state.stringMap[str.toLowerCase()] || str;
            } else {
                return str;
            }
        }
    }, {
        key: "overlay",
        value: function overlay(state) {
            var overlay = document.getElementsByClassName('overlay')[0];
            if (state) {
                overlay.classList.remove('hidden');
            } else {
                overlay.classList.add('hidden');
            }
        }
    }, {
        key: "adjustNavigationMenu",
        value: function adjustNavigationMenu(pageName) {
            var lastElement = document.getElementById(pageName);
            if (!bb.inu(lastElement)) {
                var closestDropDown = lastElement.closest(".dropdown");
                if (!bb.inu(closestDropDown)) {
                    if (!closestDropDown.classList.contains("open")) {
                        closestDropDown.classList.add("open");
                    }
                }

                if (!bb.inu(this.state.navigation)) {

                    var navigationExists = false;

                    for (var i = 0; i < this.state.navigation.length; i++) {
                        if (this.state.navigation[i].Page === pageName) {
                            navigationExists = true;
                        }

                        if (!bb.inu(this.state.navigation[i].Items)) {
                            for (var j = 0; j < this.state.navigation[i].Items.length; j++) {
                                if (this.state.navigation[i].Items[j].Page === pageName) {
                                    navigationExists = true;
                                }
                            }
                        }

                        if (navigationExists) {
                            break;
                        }
                    }

                    if (navigationExists) {
                        var link = lastElement.children[0];
                        if (!bb.inu(link)) {
                            var parent = document.getElementById("navbar");
                            if (!bb.inu(parent)) {
                                var allMenuLinks = parent.getElementsByTagName("a");
                                if (!bb.inu(allMenuLinks)) {
                                    for (var i = 0; i < allMenuLinks.length; i++) {
                                        allMenuLinks[i].classList.remove('active');
                                    }
                                }
                            }

                            link.classList.add("active");
                        }
                    }
                }
            } else {
                var parent = document.getElementById("navbar");
                if (!bb.inu(parent)) {
                    var allMenuLinks = parent.getElementsByTagName("a");
                    if (!bb.inu(allMenuLinks)) {
                        for (var i = 0; i < allMenuLinks.length; i++) {
                            allMenuLinks[i].classList.remove('active');
                        }
                    }
                }
            }
        }
    }, {
        key: "tabSelected",
        value: function tabSelected(index) {
            this.setState({ currentPageIndex: index });
        }
    }, {
        key: "openProfile",
        value: function openProfile() {
            if (window['UserProfile'] != null) {
                this.open('UserProfile');
            }
        }
    }, {
        key: "renderProfile",
        value: function renderProfile() {
            var buttons = [];
            if (this.state.user == null) {
                if (this.props.SignUpDisable == false) {
                    buttons.push(React.createElement(Button, { key: bb.guid(), Run: this, Id: "SignUpButton", Type: "primary", Value: this.localize("signup"), Class: "pull-right m-l-sm m-t-sm" }));
                }
                buttons.push(React.createElement(Button, { key: bb.guid(), Run: this, Id: "LoginButton", Value: this.localize("login"), Class: "pull-right m-l-sm m-t-sm" }));
            } else {
                buttons.push(React.createElement(
                    "a",
                    { key: "logout", onClick: this.logout.bind(this), href: "javascript:void(0)", className: "pull-right m-l-sm m-t-sm" },
                    React.createElement("i", { className: "fa fa-sign-out fa-2x" })
                ));
                buttons.push(React.createElement(Button, { key: bb.guid(), Run: this, Id: "UserNameButton", Icon: "user", Value: this.state.user.Email, Class: "pull-right m-l-xs m-t-sm logged-user-btn", OnClick: this.openProfile.bind(this) }));
            }
            return React.createElement(
                "div",
                { className: "pull-right login-profile" },
                buttons
            );
        }
    }, {
        key: "renderTabs",
        value: function renderTabs() {
            var _this5 = this;

            var arr = [];
            this.state.pages.forEach(function (page, index) {
                arr.push(React.createElement(
                    TabContent,
                    { Name: page, Caption: page, Page: _this5 },
                    React.createElement("div", { id: "success-" + page, className: "alert alert-success page-alert animated fadeInDown ibox-shadow" }),
                    React.createElement("div", { id: "error-" + page, className: "alert alert-danger page-alert animated fadeInDown ibox-shadow" }),
                    _this5.state.loaded == true ? React.createElement(window[page], { App: _this5 }) : null
                ));
            });
            return React.createElement(
                Tab,
                { Id: "LayoutTabContainer", OnChange: this.tabSelected.bind(this), Selected: this.state.currentPageIndex, HeaderClass: "gray-bg", CloseButton: true },
                arr
            );
        }
    }, {
        key: "renderLayoutWithUser",
        value: function renderLayoutWithUser() {
            return React.createElement(
                Row,
                null,
                React.createElement(
                    Col,
                    { Md: "2", CssClass: "navigation-container border-right index-3" },
                    React.createElement(Navbar, { Run: this, Id: "Navbar", Navigation: this.state.navigation, Vertical: false, BrandLogo: this.props.Logo })
                ),
                React.createElement(
                    Col,
                    { Md: "10" },
                    React.createElement(
                        Row,
                        { CssClass: "white-bg index-4 top-navbar" },
                        React.createElement(
                            Col,
                            { Md: "12" },
                            this.renderProfile()
                        )
                    ),
                    React.createElement(
                        Row,
                        { CssClass: "m-t-md" },
                        React.createElement(
                            Col,
                            { Md: "12" },
                            this.renderTabs()
                        )
                    )
                )
            );
        }
    }, {
        key: "renderLayoutWithoutUser",
        value: function renderLayoutWithoutUser() {
            var logo = this.props.Logo != null && this.props.Logo != '' ? React.createElement("img", { src: "/images/" + this.props.Logo, className: "header-logo m-sm" }) : null;
            return React.createElement(
                "div",
                null,
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        "div",
                        { "class": "col-md-2 col-md-offset-5 m-t-md" },
                        logo
                    )
                ),
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: "12" },
                        React.createElement(
                            "div",
                            { className: "m-t-lg" },
                            React.createElement(window[this.state.pages[0]], { App: this })
                        )
                    )
                )
            );
        }
    }, {
        key: "cancelProcess",
        value: function cancelProcess() {
            if (!bb.inu(this.CurrentView.onCancelProcess) && bb.isFunction(this.CurrentView.onCancelProcess)) {
                this.CurrentView.onCancelProcess();
            }
        }
    }, {
        key: "render",
        value: function render() {

            this.CurrentView = this.OpenedViews[this.state.pages[this.state.currentPageIndex]];

            if (!this.state.loaded) {
                return React.createElement(
                    "div",
                    { className: "overlay" },
                    React.createElement(
                        "div",
                        { className: "loader" },
                        "Loading..."
                    )
                );
            }
            var background = this.state.user == null ? "" : " dashboard-background";
            var content = this.state.user == null ? this.renderLayoutWithoutUser() : this.renderLayoutWithUser();

            return React.createElement(
                "div",
                { className: "dashboard-vertical" + background },
                React.createElement(
                    "div",
                    { className: "overlay hidden" },
                    React.createElement(
                        "div",
                        { className: "loader" },
                        "Loading..."
                    ),
                    React.createElement(
                        "div",
                        { className: "cancel-process hidden" },
                        React.createElement(
                            "i",
                            null,
                            " "
                        ),
                        React.createElement(Button, { Run: this, key: "CancelProcess", Id: "CancelProcess", CssClass: "btn-cancel-process", Icon: "times fa-9x", OnClick: this.cancelProcess.bind(this) }),
                        ";"
                    )
                ),
                content
            );
        }
    }]);

    return LayoutTab;
}(React.Component);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ViewBase = function (_React$Component) {
    _inherits(ViewBase, _React$Component);

    function ViewBase(props) {
        _classCallCheck(this, ViewBase);

        var _this = _possibleConstructorReturn(this, (ViewBase.__proto__ || Object.getPrototypeOf(ViewBase)).call(this, props));

        _this.IsView = true;
        _this.CallCount = 0;
        _this.state = {
            app: props.App
        };

        if (bb.isFunction(_this['init'])) {
            _this['init'].call(_this, props);
        }
        return _this;
    }

    _createClass(ViewBase, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            this.state.app.CurrentView = this;

            if (!bb.inu(this.state.app.OpenedViews) && !bb.inu(this.constructor) && Object.keys(this.state.app.OpenedViews).indexOf(this.constructor.name) < 0) {
                this.state.app.OpenedViews[this.constructor.name] = this;
            }

            if (bb.isFunction(this['init'])) {
                this['init'].call(this);
            }
        }
    }, {
        key: 'componentDidMount',
        value: function componentDidMount() {
            if (bb.isFunction(this['load'])) {
                this['load'].call(this);
            }

            window.scrollTo(0, 0);
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            if (!bb.inu(this.state.app.OpenedViews) && !bb.inu(this.constructor) && Object.keys(this.state.app.OpenedViews).indexOf(this.constructor.name) < 0) {
                delete this.state.app.OpenedViews[this.constructor.name];
            }
        }
    }, {
        key: 'user',
        value: function user() {
            return this.state.app.state.user;
        }
    }, {
        key: 'localize',
        value: function localize(key) {
            if (!bb.inu(key) && key != '') {
                var layoutState = this.props.App.state;
                var stringMap = layoutState.stringMap;
                return stringMap[key.toLowerCase()] || key;
            }
            return key;
        }
    }, {
        key: 'appState',
        value: function appState() {
            return this.props.App.state.applicationState;
        }
    }, {
        key: 'model',
        value: function model(value) {
            if (bb.inu(value)) {
                var model = {};
                for (var name in this) {
                    var el = this[name];
                    if (el.isInput === true) {
                        model[name] = el.val();
                    }
                }
                return model;
            } else {
                for (var name in this) {
                    var el = this[name];
                    if (el.isInput === true) {
                        el.val(value[name]);
                    }
                }
            }
        }
    }, {
        key: 'validate',
        value: function (_validate) {
            function validate(_x, _x2, _x3, _x4, _x5) {
                return _validate.apply(this, arguments);
            }

            validate.toString = function () {
                return _validate.toString();
            };

            return validate;
        }(function (model, modelName, validFunction, inValidFunction, ref) {
            var _this2 = this;

            var constraints = this.appState().Constraints.filter(function (item) {
                return item.Name == modelName;
            });
            var constraint = constraints != null && constraints.length > 0 ? constraints[0] : null;
            if (constraint != null) {
                var internalInValidFunction = function internalInValidFunction(errors) {
                    for (name in errors) {
                        var field = bb.inu(ref) ? this[name] : ref[name];
                        if (!bb.inu(field)) {
                            field.error(bb.localize(errors[name][0]));
                        }
                    }
                    if (bb.isFunction(inValidFunction)) {
                        inValidFunction(errors);
                    }
                };

                var serverModel = {};
                var mc = {};
                var customList = [];
                constraint.Constraints.forEach(function (field) {
                    if (model.hasOwnProperty(field.FieldName)) {
                        var rule = eval('({' + field.Rules.join(',') + '})');
                        if (!bb.inu(rule.custom)) {
                            var item = {
                                Name: field.FieldName,
                                FunctionName: rule.custom.functionName
                            };
                            customList.push(item);
                        } else {
                            mc[field.FieldName] = rule;
                        }
                        serverModel[field.FieldName] = model[field.FieldName];
                    }
                });
                var customIsValid = true;
                customList.forEach(function (item) {
                    var message = _this2[item.FunctionName]();
                    if (!bb.inu(message)) {
                        _this2[item.Name].error(message);
                        customIsValid = false;
                    }
                });
                validate.async(serverModel, mc, { fullMessages: false }).then(customIsValid == true ? validFunction.bind(this, serverModel) : internalInValidFunction.bind(this), internalInValidFunction.bind(this));
            } else {
                if (bb.isFunction(inValidFunction)) {
                    inValidFunction();
                }
            }
        })
    }, {
        key: 'disable',
        value: function disable() {
            for (var name in this) {
                var el = this[name];
                if (!bb.inu(el) && (el.isInput === true || el.isInput === false) && bb.isFunction(el.disable)) {
                    el.disable();
                }
            }
        }
    }, {
        key: 'enable',
        value: function enable() {
            for (var name in this) {
                var el = this[name];
                if (!bb.inu(el) && (el.isInput === true || el.isInput === false) && bb.isFunction(el.enable)) {
                    el.enable();
                }
            }
        }
    }, {
        key: 'clear',
        value: function clear() {
            for (var name in this) {
                var el = this[name];
                if (!bb.inu(el) && (el.isInput === true || el.isInput === false) && bb.isFunction(el.enable)) {
                    el.clear();
                }
            }
        }
    }, {
        key: 'success',
        value: function success(str) {
            if (str != null) {
                str = str.trim();
            }
            var name = this.constructor.name;
            var errorElId = "error-" + name;
            var successElId = "success-" + name;
            var errorElement = document.getElementById(errorElId);
            var successElement = document.getElementById(successElId);
            if (errorElement != null && successElement != null) {
                errorElement.innerHTML = "";
                successElement.innerHTML = this.localize(str);
            }
        }
    }, {
        key: 'error',
        value: function error(str) {
            if (str != null) {
                str = str.trim();
            }
            var name = this.constructor.name;
            var errorElId = "error-" + name;
            var successElId = "success-" + name;
            var errorElement = document.getElementById(errorElId);
            var successElement = document.getElementById(successElId);
            if (errorElement != null && successElement != null) {
                errorElement.innerHTML = this.localize(str);
                successElement.innerHTML = "";
            }
        }
    }, {
        key: 'open',
        value: function open(name, params) {
            this.state.app.open(name, params);
        }
    }, {
        key: 'params',
        value: function params() {
            var name = this.constructor.name;
            return JSON.parse(bb.getStore("Params" + name));
        }
    }, {
        key: 'parameters',
        value: function parameters(group, name) {
            var appState = this.appState();
            var groups = appState.Parameters.filter(function (item) {
                return item.Name == group;
            });
            if (!bb.inu(groups) && groups.length > 0) {
                var group = groups[0];
                return group.Values;
            }
            return null;
        }
    }, {
        key: 'post',
        value: function post(action) {
            var _this3 = this;

            this.error("");
            this.CallCount++;
            if (action.overlay !== false) {
                this.state.app.overlay(true);
            }
            var cancelProcess = document.getElementsByClassName('cancel-process')[0];
            if (!bb.inu(cancelProcess)) {
                if (action.isCancelProcess === true) {
                    cancelProcess.classList.remove('hidden');
                } else {
                    cancelProcess.classList.add('hidden');
                }
            }

            var url = "/" + action.controller + "/" + action.action;
            if (!bb.inu(action.ExternalUrl)) {
                url = action.ExternalUrl;
            }
            var params = new URLSearchParams(location.search);
            var lang = params.get('lang');
            fetch(url, {
                body: JSON.stringify(action.params),
                cache: 'no-cache',
                headers: {
                    'timezoneOffset': bb.getTimezoneOffset(),
                    'brand': brand,
                    'lang': lang,
                    'content-type': 'application/json',
                    'Authorization': 'Bearer ' + bb.getStore("AccessToken"),
                    "Application-Code": "Prod"
                },
                method: 'POST',
                mode: 'cors',
                redirect: 'follow',
                referrer: 'no-referrer'
            }).then(function (response) {
                if (response.status == 200) {
                    return response.json();
                } else if (response.status == 401) {
                    bb.clearStore();
                    setTimeout(function () {
                        //sessionStorage.setItem("message", "YourSessionTimeOutOrExpiredPleaseLoginAgain");
                        _this3.state.app.logout();
                    }, 1000);
                    //throw new Error();
                    return Promise.reject(response.text());
                } else {
                    var errorPromise = response.text();
                    //throw new Error('Network response was not ok.');
                    return Promise.reject(errorPromise);
                }
            }).then(function (data) {
                _this3.CallCount--;
                if (_this3.CallCount <= 0) {
                    _this3.state.app.overlay(false);
                }

                if (data.Succeeded === true || !bb.inu(action.ExternalUrl)) {
                    if (!bb.inu(data.AccessToken)) {
                        bb.setStore("AccessToken", data.AccessToken);
                    }

                    if (bb.isFunction(action.success)) {
                        if (bb.inu(action.ExternalUrl)) {
                            action.success(data.Result, data.Message);
                        } else {
                            action.success(data);
                        }
                    }
                } else {
                    if (bb.isFunction(action.error)) {
                        if (bb.inu(action.ExternalUrl)) {
                            action.error(data.Message);
                        } else {
                            action.error(data);
                        }
                    } else {
                        _this3.error(data.Message);
                    }
                }
            }).catch(function (errorPromise) {
                if (bb.isFunction(errorPromise.then)) {
                    errorPromise.then(function (error) {
                        _this3.CallCount--;
                        if (_this3.CallCount == 0) {
                            _this3.state.app.overlay(false);
                        }
                        if (!bb.inu(error) && error != "Error") {
                            var message = error.message == null ? error : error.message;
                            if (bb.isFunction(action.error)) {
                                action.error(message);
                            } else {
                                _this3.error(message);
                            }
                        }
                    });
                } else {
                    var error = errorPromise;
                    _this3.CallCount--;
                    if (_this3.CallCount == 0) {
                        _this3.state.app.overlay(false);
                    }
                    if (!bb.inu(error) && error != "Error") {
                        var message = error.message == null ? error : error.message;
                        if (bb.isFunction(action.error)) {
                            action.error(message);
                        } else {
                            _this3.error(message);
                        }
                    }
                }
            });
        }
    }, {
        key: 'get',
        value: function get(action) {
            var _this4 = this;

            this.error("");
            this.CallCount++;
            this.state.app.overlay(true);
            var url = "/" + action.controller + "/" + action.action;
            if (action.params != null) {
                var searchParams = new URLSearchParams();
                Object.keys(action.params).forEach(function (key) {
                    return searchParams.append(key, action.params[key]);
                });
                url += "?" + searchParams.toString();
            }

            fetch(url).then(function (response) {
                if (response.status == 200) {
                    return response.json();
                } else if (response.status == 401) {
                    bb.clearStore();
                    setTimeout(function () {
                        //sessionStorage.setItem("message", "YourSessionTimeOutOrExpiredPleaseLoginAgain");
                        _this4.state.app.logout();
                    }, 1000);
                    //throw new Error();
                    return Promise.reject(response.text());
                } else {
                    var errorPromise = response.text();
                    //throw new Error('Network response was not ok.');
                    return Promise.reject(errorPromise);
                }
            }).then(function (data) {
                _this4.CallCount--;
                if (_this4.CallCount == 0) {
                    _this4.state.app.overlay(false);
                }

                if (data.Succeeded === true) {
                    if (!bb.inu(data.AccessToken)) {
                        bb.setStore("AccessToken", data.AccessToken);
                    }

                    if (bb.isFunction(action.success)) {
                        action.success(data.Result, data.Message);
                    }
                } else {
                    if (bb.isFunction(action.error)) {
                        action.error(data.Message);
                    } else {
                        _this4.error(data.Message);
                    }
                }
            }).catch(function (errorPromise) {
                if (bb.isFunction(errorPromise.then)) {
                    errorPromise.then(function (error) {
                        _this4.CallCount--;
                        if (_this4.CallCount == 0) {
                            _this4.state.app.overlay(false);
                        }
                        if (!bb.inu(error) && error != "Error") {
                            var message = error.message == null ? error : error.message;
                            if (bb.isFunction(action.error)) {
                                action.error(message);
                            } else {
                                _this4.error(message);
                            }
                        }
                    });
                } else {
                    var error = errorPromise;
                    _this4.CallCount--;
                    if (_this4.CallCount == 0) {
                        _this4.state.app.overlay(false);
                    }
                    if (!bb.inu(error) && error != "Error") {
                        var message = error.message == null ? error : error.message;
                        if (bb.isFunction(action.error)) {
                            action.error(message);
                        } else {
                            _this4.error(message);
                        }
                    }
                }
            });
        }
    }, {
        key: 'download',
        value: function (_download) {
            function download(_x6) {
                return _download.apply(this, arguments);
            }

            download.toString = function () {
                return _download.toString();
            };

            return download;
        }(function (action) {
            var _this5 = this;

            this.error("");
            this.CallCount++;
            if (action.overlay !== false) {
                this.state.app.overlay(true);
            }
            var url = "/" + action.controller + "/" + action.action;
            fetch(url, {
                body: JSON.stringify(action.params),
                cache: 'no-cache',
                headers: {
                    'timezoneOffset': bb.getTimezoneOffset(),
                    'brand': brand,
                    'content-type': 'application/json',
                    'Authorization': 'Bearer ' + bb.getStore("AccessToken")
                },
                method: 'POST'
            }).then(function (response) {
                if (response.status === 200 || response.status === 0) {

                    var filename = "";
                    var disposition = response.headers.get('Content-Disposition');
                    if (disposition && disposition.indexOf('attachment') !== -1) {
                        var filenameRegex = /filename[^;=\n]*=((['"]).*?\2|[^;\n]*)/;
                        var matches = filenameRegex.exec(disposition);
                        if (matches != null && matches[1]) filename = matches[1].replace(/['"]/g, '');
                    }
                    response.blob().then(function (blob) {
                        download(blob, filename, blob.type);
                        if (bb.isFunction(action.success)) {
                            action.success();
                        }
                    });

                    _this5.CallCount--;
                    if (_this5.CallCount == 0) {
                        _this5.state.app.overlay(false);
                    }
                } else {
                    throw new Error('Network response was not ok.');
                }
            }).catch(function (error) {
                _this5.CallCount--;
                if (_this5.CallCount == 0) {
                    _this5.state.app.overlay(false);
                }
                if (!bb.inu(error) && error != "Error") {
                    if (bb.isFunction(action.error)) {
                        action.error(error);
                    } else {
                        _this5.error(error);
                    }
                }
            });
        })
    }, {
        key: 'upload',
        value: function upload(action, success, error) {
            var _this6 = this;

            this.error("");
            this.CallCount++;
            if (action.overlay !== false) {
                this.state.app.overlay(true);
            }

            var url = "/System/Upload";
            return fetch(url, {
                body: action,
                cache: 'no-cache',
                headers: {
                    'timezoneOffset': bb.getTimezoneOffset(),
                    'brand': brand,
                    'Authorization': 'Bearer ' + bb.getStore("AccessToken")
                },
                method: 'POST'
            }).then(function (response) {
                if (response.status === 200 || response.status === 0) {
                    return response.json();
                } else {
                    return Promise.reject(new Error('Error uploading: ' + url));
                }
            }).then(function (response) {
                _this6.CallCount--;
                if (_this6.CallCount == 0) {
                    _this6.state.app.overlay(false);
                }
                if (bb.isFunction(success)) {
                    success(response);
                }
            }).catch(function (error) {
                _this6.CallCount--;
                if (_this6.CallCount == 0) {
                    _this6.state.app.overlay(false);
                }
                if (!bb.inu(error) && error != "Error") {
                    if (bb.isFunction(error)) {
                        error(error);
                    } else {
                        _this6.error(error);
                    }
                }
            });
        }
    }, {
        key: 'getView',
        value: function getView() {
            return this;
        }
    }]);

    return ViewBase;
}(React.Component);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AddressForm = function (_ComponentBase) {
    _inherits(AddressForm, _ComponentBase);

    function AddressForm() {
        _classCallCheck(this, AddressForm);

        return _possibleConstructorReturn(this, (AddressForm.__proto__ || Object.getPrototypeOf(AddressForm)).apply(this, arguments));
    }

    _createClass(AddressForm, [{
        key: 'init',
        value: function init(props) {
            this.state.value = {
                Id: 0,
                AddressType: '',
                FlatNumber: '',
                BuildingNumber: '',
                BuildingName: '',
                Street: '',
                Town: '',
                County: '',
                PostCode: '',
                Country: '',
                AddressNote: '',
                ActivePassive: '',
                IsDefault: ''
            };
            this.IdField = "Id";
            this.AddressTypeField = "AddressType";
            this.FlatNumberField = "FlatNumber";
            this.BuildingNumberField = "BuildingNumber";
            this.BuildingNameField = "BuildingName";
            this.StreetField = "Street";
            this.TownField = "Town";
            this.CountyField = "County";
            this.PostCodeField = "PostCode";
            this.CountryField = "Country";
            this.AddressNoteField = "AddressNote";
            this.ActivePassiveField = "ActivePassive";
            this.IsDefaultField = "IsDefault";
            this.view = this.getView();
        }
    }, {
        key: 'clear',
        value: function clear() {
            this["Id"].clear();
            this["FlatNumber"].clear();
            this["BuildingNumber"].clear();
            this["BuildingName"].clear();
            this["Street"].clear();
            this["Town"].clear();
            this["County"].clear();
            this["PostCode"].clear();
            this["Country"].clear();
            //this["AddressNote"].clear();

            if (this.props.RenderOptional === true) {
                this["AddressType"].clear();
                this["ActivePassive"].clear();
                this["IsDefault"].clear();
            }

            this.setState({
                value: {
                    Id: 0,
                    AddressType: '',
                    FlatNumber: '',
                    BuildingNumber: '',
                    BuildingName: '',
                    Street: '',
                    Town: '',
                    County: '',
                    PostCode: '',
                    Country: '',
                    AddressNote: '',
                    ActivePassive: '',
                    IsDefault: ''
                }
            });
        }
    }, {
        key: 'onCountrySelected',
        value: function onCountrySelected(value) {
            this.state.Country = value;
        }
    }, {
        key: 'getAddressList',
        value: function getAddressList(event) {
            var self = this.getView();
            var value = self[this.props.Id + "PostCode"].state.value;
            if (String.prototype.trim.call(value) && this.state.Country == "GB") {
                var action = {
                    controller: 'Address',
                    action: 'GetAddressList',
                    params: value,
                    success: function (data) {
                        if (!bb.inu(data)) {
                            var addressList = [];

                            for (var i = 0; i < data.AddressList.length; i++) {
                                addressList.push({ Name: data.AddressList[i].FullAddress, Value: JSON.stringify(data.AddressList[i]) });
                            }
                            self[this.props.Id + "AddressList"].setState({ data: addressList, keyField: "Name", valueField: "Value" });
                        }
                    }.bind(this)
                };
                this.post(action);
            }
        }
    }, {
        key: 'selectAddress',
        value: function selectAddress(value) {
            var address = JSON.parse(value);
            this.District.setState({ value: address.County });
            this.Neighborhood.setState({ value: address.Locality });
            this.City.setState({ value: address.TownOrCity });
        }
    }, {
        key: 'fieldChanged',
        value: function fieldChanged(value, props) {
            var model = this.state.value;
            model[props.Id] = value;
            this.setState({ value: model });
        }
    }, {
        key: 'renderOptionals',
        value: function renderOptionals() {
            if (!this.props.RenderOptional === true) {
                return null;
            }

            return React.createElement(
                Row,
                null,
                React.createElement(
                    Col,
                    { Md: 4 },
                    React.createElement(ComboBox, { Run: this, Id: this.AddressTypeField, Caption: 'AddressType', Data: this.view.parameters('AddressType'), KeyField: 'Definition', ValueField: 'Value', OnChange: this.fieldChanged.bind(this) })
                ),
                React.createElement(
                    Col,
                    { Md: 4 },
                    React.createElement(ComboBox, { Run: this, Id: this.ActivePassiveField, Caption: 'ActivePassive', Data: this.view.parameters('ActivePassive'), KeyField: 'Definition', ValueField: 'Value', OnChange: this.fieldChanged.bind(this), NoSelect: true, Value: 'Active' })
                ),
                React.createElement(
                    Col,
                    { Md: 4 },
                    React.createElement(CheckBox, { Run: this, Id: this.IsDefaultField, Caption: 'isDefault', OnChange: this.fieldChanged.bind(this), Class: 'without-caption' })
                )
            );
        }
    }, {
        key: 'val',
        value: function val(value) {
            if (bb.inu(value)) {
                return this.state.value;
            } else {
                this.setState({ value: value }, function () {
                    this["Id"].val(value.Id);
                    this["FlatNumber"].val(value.FlatNumber);
                    this["BuildingNumber"].val(value.BuildingNumber);
                    this["BuildingName"].val(value.BuildingName);
                    this["Street"].val(value.Street);
                    this["Town"].val(value.Town);
                    this["County"].val(value.County);
                    this["PostCode"].val(value.PostCode);
                    this["Country"].val(value.Country);
                    //this["AddressNote"].clear();

                    if (this.props.RenderOptional === true) {
                        this["AddressType"].val(value.AddressType);
                        this["ActivePassive"].val(value.ActivePassive);
                        this["IsDefault"].val(value.IsDefault);
                    }
                });
            }
        }
    }, {
        key: 'validate',
        value: function validate(callBack) {
            var addressValue = this.val();
            var view = this.getView();
            view.validate(addressValue, "AddressModel", function () {
                callBack(true);
            }, function () {
                callBack(false);
            }, this);
        }
    }, {
        key: 'render',
        value: function render() {
            var id = this.props.Id;
            var model = this.state.value;

            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(TextBox, { Run: this, Id: this.IdField, Hidden: true }),
                this.renderOptionals(),
                React.createElement(
                    Row,
                    { CssClass: 'm-b-sm' },
                    React.createElement(
                        Col,
                        { Sm: 6 },
                        React.createElement(Country, { Run: this, Id: this.CountryField, OnCountrySelected: this.onCountrySelected.bind(this), HiddenCode: true, OnChange: this.fieldChanged.bind(this) })
                    ),
                    React.createElement(
                        Col,
                        { Sm: 6 },
                        React.createElement(TextBox, { Run: this, Id: this.PostCodeField, Caption: 'PostCode', OnChange: this.fieldChanged.bind(this) })
                    )
                ),
                React.createElement(
                    Row,
                    { CssClass: 'm-b-sm' },
                    React.createElement(
                        Col,
                        { Sm: 6 },
                        React.createElement(TextBox, { Run: this, Id: this.TownField, Caption: 'Town', OnChange: this.fieldChanged.bind(this) })
                    ),
                    React.createElement(
                        Col,
                        { Sm: 6 },
                        React.createElement(TextBox, { Run: this, Id: this.CountyField, Caption: 'County', OnChange: this.fieldChanged.bind(this) })
                    )
                ),
                React.createElement(
                    Row,
                    { CssClass: 'm-b-sm' },
                    React.createElement(
                        Col,
                        { Sm: 6 },
                        React.createElement(TextBox, { Run: this, Id: this.StreetField, Caption: 'Street', OnChange: this.fieldChanged.bind(this) })
                    ),
                    React.createElement(
                        Col,
                        { Sm: 6 },
                        React.createElement(TextBox, { Run: this, Id: this.BuildingNumberField, Caption: 'BuildingNumber', OnChange: this.fieldChanged.bind(this) })
                    )
                ),
                React.createElement(
                    Row,
                    { CssClass: 'm-b-sm' },
                    React.createElement(
                        Col,
                        { Sm: 6 },
                        React.createElement(TextBox, { Run: this, Id: this.BuildingNameField, Caption: 'BuildingName', OnChange: this.fieldChanged.bind(this) })
                    ),
                    React.createElement(
                        Col,
                        { Sm: 6 },
                        React.createElement(TextBox, { Run: this, Id: this.FlatNumberField, Caption: 'FlatNumber', OnChange: this.fieldChanged.bind(this) })
                    )
                )
            );
        }
    }]);

    return AddressForm;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Anchor = function (_ComponentBase) {
    _inherits(Anchor, _ComponentBase);

    function Anchor() {
        _classCallCheck(this, Anchor);

        return _possibleConstructorReturn(this, (Anchor.__proto__ || Object.getPrototypeOf(Anchor)).apply(this, arguments));
    }

    _createClass(Anchor, [{
        key: "init",
        value: function init(props) {
            this.isInput = false;
            this.state.type = bb.inu(this.props.Type) ? "default" : this.props.Type;
            this.state.upper = bb.inu(this.props.Upper) ? false : this.props.Upper;
        }
    }, {
        key: "render",
        value: function render() {
            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    "a",
                    { className: "text-info", onClick: this.state.options.Click.bind(this) },
                    React.createElement(
                        Localize,
                        { Upper: this.state.upper },
                        this.state.value
                    )
                )
            );
        }
    }]);

    return Anchor;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AutoComplete = function (_ComponentBase) {
    _inherits(AutoComplete, _ComponentBase);

    function AutoComplete() {
        _classCallCheck(this, AutoComplete);

        return _possibleConstructorReturn(this, (AutoComplete.__proto__ || Object.getPrototypeOf(AutoComplete)).apply(this, arguments));
    }

    _createClass(AutoComplete, [{
        key: "init",
        value: function init(props, options) {
            this.state.search = "";
            this.state.selected = null;
            this.state.data = bb.inu(this.props.Data) ? [] : this.props.Data;
            this.state.keyField = bb.inu(this.props.KeyField) ? "Code" : this.props.KeyField;
            this.state.valueField = bb.inu(this.props.ValueField) ? "Value" : this.props.ValueField;
            this.state.hoverIndex = -1;
            this.state.number = bb.inu(this.props.Number) ? 5 : this.props.Number;
            this.state.placeholder = bb.inu(this.props.Placeholder) ? "" : this.props.Placeholder;
            this.state.opened = false;

            if (bb.inu(options.Class)) {
                options.Class = "";
            }
            options.Class += " auto-complete-container";

            this.state.isMounted = false;
        }
    }, {
        key: "load",
        value: function load() {
            document.addEventListener('mousedown', this.handlePageClick.bind(this), false);
            this.state.isMounted = true;
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            document.removeEventListener('mousedown', this.handlePageClick.bind(this));
            this.state.isMounted = false;
            _get(AutoComplete.prototype.__proto__ || Object.getPrototypeOf(AutoComplete.prototype), "componentWillUnmount", this).call(this);
        }
    }, {
        key: "handlePageClick",
        value: function handlePageClick(e) {
            if (this.state.isMounted) {
                var el = ReactDOM.findDOMNode(this);
                if (!bb.inu(el) && !el.contains(e.target)) {
                    this.setState({ opened: false });
                }
            }
        }
    }, {
        key: "downPressed",
        value: function downPressed() {
            if (this.state.search == "") {
                return;
            }
            var hoverIndex = this.state.hoverIndex;
            if (hoverIndex == -1) {
                hoverIndex = 0;
            } else if (hoverIndex == this.state.number) {
                return;
            } else {
                hoverIndex++;
            }
            this.setState({ hoverIndex: hoverIndex });
        }
    }, {
        key: "upPressed",
        value: function upPressed() {
            if (this.state.search == "") {
                return;
            }
            var hoverIndex = this.state.hoverIndex;
            if (hoverIndex == -1) {
                return;
            } else {
                hoverIndex--;
            }
            this.setState({ hoverIndex: hoverIndex });
        }
    }, {
        key: "onKeyPress",
        value: function onKeyPress(e) {
            e.persist();
            switch (e.key) {
                case 'Enter':
                    if (this.state.hoverIndex != -1) {
                        var list = this.find(this.state.search);
                        var selected = list[this.state.hoverIndex];
                        this.select(selected, e);
                    }

                    if (!bb.inu(this.props.OnEnterKeyPress)) {
                        this.props.OnEnterKeyPress(e);
                        e.preventDefault();
                    }
                    break;
                case 'Tab':
                    if (!bb.inu(this.props.OnTabKeyPress)) {
                        this.props.OnTabKeyPress(e);
                    }
                    break;
                case 'ArrowDown':
                    this.downPressed();
                    break;
                case 'ArrowUp':
                    this.upPressed();
                    break;
            }
            if (e.key == "Enter") {
                if (!bb.inu(this.props.OnEnterKeyPress)) {
                    this.props.OnEnterKeyPress(e);
                    e.preventDefault();
                }
            } else if (e.key == "Tab") {
                if (!bb.inu(this.props.OnTabKeyPress)) {
                    this.props.OnTabKeyPress(e);
                }
            }
        }
    }, {
        key: "onClick",
        value: function onClick(value, props, e) {
            if (bb.isFunction(this.props.OnClick)) {
                this.props.OnClick();
            }
            this.setState({ opened: !this.state.opened });
        }
    }, {
        key: "onFocus",
        value: function onFocus(e) {
            e.target.select();
        }
    }, {
        key: "onLeave",
        value: function onLeave(value, props, e) {
            var _this2 = this;

            e.persist();
            var finded = null;
            var inputValue = e.target.value;
            inputValue = (inputValue + "").trim().toLowerCase();
            var data = this.state.data;
            data.forEach(function (item, index) {
                if (item[_this2.state.keyField].toLowerCase() == inputValue) {
                    finded = item;
                }
            });
            if (!bb.inu(finded)) {
                this.select(finded, e);
            }
        }
    }, {
        key: "search",
        value: function search(value, props, e) {
            e.persist();
            if (value == '') {
                this.setState({ search: value, selected: null }, function () {
                    this.state.options.Change(e, value);
                }.bind(this));
            } else {
                this.setState({ search: value });
            }
        }
    }, {
        key: "find",
        value: function find(value, isOpened) {
            var _this3 = this;

            var list = [];
            if (!bb.inu(value) && value.trim() != '' && this.state.data.length > 0) {
                var list = this.state.data.filter(function (item, index) {
                    var lowerKey = item[_this3.state.keyField].toString().toLocaleUpperCase('tr-TR');
                    var lowerValue = item[_this3.state.valueField].toString().toLocaleUpperCase('tr-TR');
                    value = value.toString().toLocaleUpperCase('tr-TR');
                    return lowerKey.indexOf(value) !== -1 || lowerValue.indexOf(value) !== -1;
                });
            } else if (value.trim() == '' && this.state.opened === true) {
                list = this.state.data;
            }

            return list;
        }
    }, {
        key: "clear",
        value: function clear() {
            var options = this.state.options;
            options.Errors = [];
            this.setState({ value: '', search: '', selected: null, hoverIndex: -1, options: options });
        }
    }, {
        key: "select",
        value: function select(item, e) {
            e.persist();
            var value = item[this.state.valueField];
            var text = item[this.state.keyField];
            this.setState({ search: text, selected: item, hoverIndex: -1, opened: false }, function () {
                this.state.options.Change(e, value);
            }.bind(this));
        }
    }, {
        key: "selected",
        value: function selected() {
            return this.state.selected;
        }
    }, {
        key: "renderSuggestions",
        value: function renderSuggestions() {
            if (!bb.inu(this.state.selected) && this.state.search == this.state.selected[this.state.keyField]) {
                return null;
            }

            var list = this.find(this.state.search);
            if (!bb.inu(list) && list.length > 0) {
                var result = [];
                var count = list.length > this.state.number ? this.state.number : list.length;
                for (var i = 0; i < count; i++) {
                    var hoverClass = "";
                    if (i == this.state.hoverIndex) {
                        hoverClass = "hover";
                    }
                    var item = list[i];
                    result.push(React.createElement(
                        "li",
                        { className: hoverClass, key: i, onClick: this.select.bind(this, item) },
                        item[this.state.keyField]
                    ));
                }
                return React.createElement(
                    "ul",
                    { className: "auto-complete-result" },
                    result
                );
            }

            return null;
        }
    }, {
        key: "val",
        value: function val(value, callback) {
            if (bb.inu(value)) {
                return this.state.value;
            } else {
                var text = "";
                var item = null;
                if (!bb.inu(this.state.data) && this.state.data.length) {
                    var valuefield = this.state.valueField;
                    item = this.state.data.find(function (item) {
                        return item[valuefield] == value;
                    });
                    if (!bb.inu(item)) {
                        text = item[this.state.keyField];
                    }
                }

                this.setState({ search: text, value: value, selected: item }, callback);
            }
        }
    }, {
        key: "focus",
        value: function focus() {
            this[this.props.Id + "_Complete"].refs.input.focus();
        }
    }, {
        key: "render",
        value: function render() {
            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(TextBox, { Run: this, Id: this.props.Id + "_Complete", Value: this.state.search, Caption: this.props.Caption,
                    OnChange: this.search.bind(this),
                    OnKeyPress: this.onKeyPress.bind(this),
                    OnClick: this.onClick.bind(this),
                    OnLeave: this.onLeave.bind(this),
                    OnFocus: this.onFocus.bind(this),
                    Placeholder: this.state.placeholder,
                    ActionButton: this.props.ActionButton,
                    ActionCaption: this.props.ActionCaption,
                    Action: this.props.Action
                }),
                React.createElement(
                    "div",
                    { className: "suggestion-container" },
                    this.renderSuggestions()
                )
            );
        }
    }]);

    return AutoComplete;
}(ComponentBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AutoCompleteTextarea = function (_ComponentBase) {
    _inherits(AutoCompleteTextarea, _ComponentBase);

    function AutoCompleteTextarea() {
        _classCallCheck(this, AutoCompleteTextarea);

        return _possibleConstructorReturn(this, (AutoCompleteTextarea.__proto__ || Object.getPrototypeOf(AutoCompleteTextarea)).apply(this, arguments));
    }

    _createClass(AutoCompleteTextarea, [{
        key: 'init',
        value: function init() {
            this.state.top = -1;
            this.state.left = -1;
            this.state.show = false;
            this.state.selectedObj = "";
            this.state.objList = {};
        }
    }, {
        key: 'leave',
        value: function leave(event) {
            if (!bb.inu(this.props.OnLeave)) {
                this.props.OnLeave(this.state.value, this.props, event);
            }
        }
    }, {
        key: 'keyHandle',
        value: function keyHandle(e) {
            if (e.key == 'Enter' || e.key == 'Tab' || e.key == 'ArrowDown' || e.key == 'ArrowUp') {
                var container = ReactDOM.findDOMNode(this);
                var active = container.querySelector('.active');
                if (active != null) {
                    if (e.key == 'Enter' || e.key == 'Tab') {
                        var value = this.refs.input.value;
                        var n = value.lastIndexOf('.');
                        value = value.substring(0, n + 1) + active.textContent + ' ';
                        this.refs.input.value = value;
                        this.setState({ value: value, show: false, selectedObj: '' });
                    } else if (e.key == 'ArrowDown') {
                        var next = active.nextSibling;
                        if (next != null) {
                            active.classList.remove('active');
                            next.classList.add('active');
                        }
                    } else if (e.key == 'ArrowUp') {
                        var previous = active.previousSibling;
                        if (previous != null) {
                            active.classList.remove('active');
                            previous.classList.add('active');
                        }
                    }
                }
            } else {
                var value = e.target.value;
                var show = false;
                var last = value.slice(-1);
                var selectedObj = "";
                if (last == '.' || this.state.show && last != ' ' && last != '' && this.lastKeywodHasDot(value)) {
                    show = true;
                    selectedObj = this.getLastKeywordBeforeDot(value);
                }
                var position = getCursorXY(e.target);
                this.setState({ left: position.x, top: position.y, show: show, selectedObj: selectedObj });
            }
        }
    }, {
        key: 'keyDownHandle',
        value: function keyDownHandle(e) {
            if (e.key == 'Enter' || e.key == 'Tab' || e.key == 'ArrowDown' || e.key == 'ArrowUp') {
                e.stopPropagation();
                e.preventDefault();
            }
        }
    }, {
        key: 'focus',
        value: function focus(e) {
            e.persist();
            if (!bb.inu(this.props.OnFocus)) {
                this.props.OnFocus(e);
            }
        }
    }, {
        key: 'getLastKeyword',
        value: function getLastKeyword(value) {
            var n = value.lastIndexOf(" ");
            return value.substring(n + 1);
        }
    }, {
        key: 'getLastKeywordBeforeDot',
        value: function getLastKeywordBeforeDot(value) {
            value = this.getLastKeyword(value);
            var n = value.lastIndexOf(".");
            return value.substring(0, n);
        }
    }, {
        key: 'getLastKeywordAfterDot',
        value: function getLastKeywordAfterDot(value) {
            value = this.getLastKeyword(value);
            var n = value.lastIndexOf(".");
            return value.substring(n + 1);
        }
    }, {
        key: 'lastKeywodHasDot',
        value: function lastKeywodHasDot(value) {
            var last = this.getLastKeyword(value);
            return last.lastIndexOf('.') != -1;
        }
    }, {
        key: 'renderSuggestions',
        value: function renderSuggestions() {
            var arr = [];
            if (this.state.selectedObj != "" && this.state.objList[this.state.selectedObj] != null) {
                var value = this.refs.input.value;
                var hint = this.getLastKeywordAfterDot(value).toLowerCase();
                var list = this.state.objList[this.state.selectedObj];

                if (hint != '') {
                    list = list.filter(function (item) {
                        return item.toLowerCase().startsWith(hint);
                    });
                }

                if (list != null) {
                    list.forEach(function (item, index) {
                        if (index < 3) {
                            var className = index == 0 ? "active" : "";
                            arr.push(React.createElement(
                                'li',
                                { className: className, key: index },
                                item
                            ));
                        }
                    });
                }

                if (arr.length == 0) {
                    return null;
                }
            } else {
                return null;
            }
            return React.createElement(
                'ul',
                null,
                arr
            );
        }
    }, {
        key: 'render',
        value: function render() {
            var rows = this.props.Rows == null ? 2 : this.props.Rows;
            var input = React.createElement('textarea', { className: 'form-control noresize', rows: rows,
                value: this.state.value,
                readOnly: this.state.disabled,
                placeholder: bb.localize(this.props.Placeholder),
                onChange: this.state.options.Change.bind(this),
                onBlur: this.leave.bind(this),
                onClick: this.state.options.Click.bind(this),
                onKeyUpCapture: this.keyHandle.bind(this),
                onKeyDown: this.keyDownHandle.bind(this),
                onFocus: this.focus.bind(this),
                ref: 'input'
            });
            var suggestions = this.renderSuggestions();
            if (suggestions != null) {
                suggestions = React.createElement(
                    'div',
                    { key: bb.guid(), className: 'auto-complete-text-area', style: {
                            top: this.state.top,
                            left: this.state.left,
                            display: this.state.show === true ? "display" : "none"
                        } },
                    suggestions
                );
            }
            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    Label,
                    null,
                    this.props.Caption
                ),
                React.createElement(
                    'div',
                    { className: 'form-group' },
                    input,
                    suggestions
                )
            );
        }
    }]);

    return AutoCompleteTextarea;
}(ComponentBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Box = function (_ComponentBase) {
    _inherits(Box, _ComponentBase);

    function Box() {
        _classCallCheck(this, Box);

        return _possibleConstructorReturn(this, (Box.__proto__ || Object.getPrototypeOf(Box)).apply(this, arguments));
    }

    _createClass(Box, [{
        key: 'init',
        value: function init(props) {
            this.isInput = false;
            this.state.cssClass = '';
            this.state.contentCssClass = '';
            this.state.chevronCssClass = 'fa-chevron-up';
            this.state.settingsCssClass = "hidden";
            this.state.rowSettings = bb.inu(this.props.RowSettings) ? [] : this.props.RowSettings;
            this.state.settingDisable = bb.inu(this.props.SettingDisable) ? false : this.props.SettingDisable;
            this.state.isDisabled = false;

            if (!bb.inu(this.props.IsDisabled)) {
                if (bb.isFunction(this.props.Disable)) {
                    this.state.isDisabled = this.props.IsDisabled(this.props.Id);
                } else {
                    this.state.isDisabled = this.props.IsDisabled;
                }
            }
        }
    }, {
        key: 'close',
        value: function close() {
            this.setState({ cssClass: 'animated fadeOutUp' }, function () {
                setTimeout(function () {
                    this.setState({ cssClass: 'hidden' });
                }.bind(this), 500);
            });
        }
    }, {
        key: 'disable',
        value: function disable() {
            this.setState({ cssClass: 'hidden' });
        }
    }, {
        key: 'toggle',
        value: function toggle() {
            var inClassChevron = "fa-chevron-up";
            var outClassChevron = "fa-chevron-down";
            var outClass = "hidden";
            var isOpen = true;
            if (this.state.contentCssClass == '') {
                this.setState({ contentCssClass: outClass, chevronCssClass: outClassChevron });
                isOpen = false;
            } else {
                this.setState({ contentCssClass: "", chevronCssClass: inClassChevron });
            }
            if (bb.isFunction(this.props.OnToggle)) {
                this.props.OnToggle(isOpen);
            }
        }
    }, {
        key: 'openSettings',
        value: function openSettings() {
            var inClassChevron = "fa-chevron-up";
            var outClassChevron = "fa-chevron-down";

            var inClass = "hidden";
            var outClass = "";

            if (this.state.settingsCssClass == "hidden") {
                this.setState({ settingsCssClass: outClass, contentCssClass: inClass, chevronCssClass: outClassChevron });
            } else {
                this.setState({ settingsCssClass: "hidden", contentCssClass: "", chevronCssClass: inClassChevron });
            }
        }
    }, {
        key: 'componentWillUpdate',
        value: function componentWillUpdate(nextProps, nextState) {
            if (!bb.inu(nextState) && 'rowSettings' in nextState && nextState.rowSettings != this.state.rowSettings) {
                nextProps.RowSettings = nextState.rowSettings;
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var tools = [];
            if (bb.inu(this.props.DisableCollapse) && !this.props.DisableCollapse) {
                tools.push(React.createElement(
                    'a',
                    { key: 'chevron', href: 'javascript:void(0)', className: 'collapse-link', onClick: this.toggle.bind(this) },
                    React.createElement('i', { className: "fa " + this.state.chevronCssClass })
                ));
            }

            if (bb.inu(this.props.SettingDisable) && !this.props.SettingDisable) {
                tools.push(React.createElement(
                    'a',
                    { key: 'wrench', href: 'javascript:void(0)', className: 'dropdown-toggle', onClick: this.openSettings.bind(this) },
                    React.createElement('i', { className: 'fa fa-wrench' })
                ));
            }

            if (bb.inu(this.props.DisableClose) && !this.props.DisableClose) {
                tools.push(React.createElement(
                    'a',
                    { key: 'times', href: 'javascript:void(0)', className: 'close-link', onClick: this.close.bind(this) },
                    React.createElement('i', { className: 'fa fa-times' })
                ));
            }

            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    'div',
                    { className: "ibox ibox-shadow float-e-margins box-container " + this.state.cssClass },
                    React.createElement(
                        'div',
                        { className: 'ibox-title' },
                        React.createElement(
                            'h5',
                            { className: 'box-title', onClick: this.toggle.bind(this) },
                            React.createElement(
                                Localize,
                                null,
                                this.props.Caption
                            )
                        ),
                        React.createElement(
                            'div',
                            { className: 'ibox-tools' },
                            tools
                        )
                    ),
                    React.createElement('div', { className: "ibox-content table-responsive " + this.state.settingsCssClass }),
                    React.createElement(
                        'div',
                        { className: "ibox-content table-responsive " + this.state.contentCssClass },
                        this.props.children
                    )
                )
            );
        }
    }]);

    return Box;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Breadcrumb = function (_ComponentBase) {
    _inherits(Breadcrumb, _ComponentBase);

    function Breadcrumb() {
        _classCallCheck(this, Breadcrumb);

        return _possibleConstructorReturn(this, (Breadcrumb.__proto__ || Object.getPrototypeOf(Breadcrumb)).apply(this, arguments));
    }

    _createClass(Breadcrumb, [{
        key: "init",
        value: function init(props) {
            this.isInput = false;
            this.state.links = [];
            this.state.caption = "";
        }
    }, {
        key: "links",
        value: function links(item) {
            var links = [];
            if (item != null) {
                while (item.parent != null) {
                    links.push(item);
                    item = item.parent;
                }
                links.push(item);
                links.reverse();
            }
            return links;
        }
    }, {
        key: "onClick",
        value: function onClick(item, i) {
            if (!bb.inu(item.Action) && item.Action != "") {
                page.open(item.Action);
            }
        }
    }, {
        key: "reload",
        value: function reload() {
            page.reload();
        }
    }, {
        key: "render",
        value: function render() {
            if (!bb.inu(this.props.Navigation)) {
                this.state.links = this.links(this.props.Navigation);
                this.state.caption = this.props.Navigation.Caption;
            } else if (!bb.inu(this.props.Links)) {
                this.state.links = this.props.Links;
            }

            var links = [];
            for (var i = 0; i < this.state.links.length; i++) {
                var item = this.state.links[i];
                var link = React.createElement(
                    "li",
                    { key: i, onClick: this.onClick.bind(this, item, i) },
                    React.createElement(
                        "a",
                        { href: "javascript:void(0)" },
                        bb.localize(this.state.links[i].Caption)
                    )
                );
                if (i == this.state.links.length - 1) {
                    link = React.createElement(
                        "li",
                        { key: i, className: "active" },
                        React.createElement(
                            "a",
                            { href: "javascript:void(0)" },
                            React.createElement(
                                "strong",
                                null,
                                bb.localize(this.state.links[i].Caption)
                            )
                        )
                    );
                }

                links.push(link);
            }

            var header = null;
            if (!bb.inu(this.state.caption) && this.state.caption != "") {
                header = React.createElement(
                    "h2",
                    null,
                    bb.localize(this.state.caption)
                );
            }

            var breadcrumb = null;
            if (links.length != 0) {
                breadcrumb = React.createElement(
                    "div",
                    { className: "breadcrumb" },
                    React.createElement(
                        "div",
                        { className: "wrapper page-heading" },
                        React.createElement(
                            "div",
                            { className: "pull-left" },
                            header
                        ),
                        React.createElement("div", { className: "clearfix" })
                    )
                );
            }

            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                breadcrumb
            );
        }
    }]);

    return Breadcrumb;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Button = function (_ComponentBase) {
    _inherits(Button, _ComponentBase);

    function Button() {
        _classCallCheck(this, Button);

        return _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).apply(this, arguments));
    }

    _createClass(Button, [{
        key: "init",
        value: function init(props, options) {
            this.isInput = false;
            this.state.upper = bb.inu(this.props.Upper) ? false : this.props.Upper;
        }
    }, {
        key: "click",
        value: function click(e) {
            e.persist();
            if (!bb.inu(this.props.To)) {
                this.props.Run.state.app.open(this.props.To);
            } else {
                this.state.options.Click(e);
            }
        }
    }, {
        key: "render",
        value: function render() {
            var type = bb.inu(this.props.Type) ? "default" : this.props.Type;

            var cssClass = "btn btn-sm btn-" + type + " full-width ";
            if (!bb.inu(this.props.CssClass)) {
                cssClass += this.props.CssClass;
            }

            var icon = null;
            if (!bb.inu(this.props.Icon)) {
                var iconContent = null;

                if (!bb.inu(this.state.value) && this.state.value != "") {
                    iconContent = "\xA0";
                }

                icon = React.createElement(
                    "i",
                    { className: "fa fa-" + this.props.Icon },
                    iconContent
                );
            }

            var width = this.props.Width == null ? "" : this.props.Width + "px";

            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    "div",
                    { style: { width: width } },
                    React.createElement(
                        "button",
                        { className: cssClass, type: "button", onClick: this.click.bind(this) },
                        icon,
                        " ",
                        React.createElement(
                            Localize,
                            { Upper: this.state.upper, Run: this },
                            this.state.value
                        )
                    )
                )
            );
        }
    }]);

    return Button;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ButtonGroup = function (_ComponentBase) {
    _inherits(ButtonGroup, _ComponentBase);

    function ButtonGroup() {
        _classCallCheck(this, ButtonGroup);

        return _possibleConstructorReturn(this, (ButtonGroup.__proto__ || Object.getPrototypeOf(ButtonGroup)).apply(this, arguments));
    }

    _createClass(ButtonGroup, [{
        key: "init",
        value: function init(props, options) {
            this.state.buttons = bb.inu(this.props.Options) ? [] : this.props.Options;
            this.state.keyField = bb.inu(this.props.KeyField) ? "Code" : this.props.KeyField;
            this.state.valueField = bb.inu(this.props.ValueField) ? "Value" : this.props.ValueField;
        }
    }, {
        key: "click",
        value: function click(value, e) {
            this.state.options.Click(e, value);
        }
    }, {
        key: "craeteLabels",
        value: function craeteLabels() {
            var _this2 = this;

            var labels = [];
            this.state.buttons.forEach(function (item, i) {
                var active = "btn-default";
                if (_this2.state.value == item[_this2.state.valueField]) {
                    active = "btn-primary active";
                }
                labels.push(React.createElement("label", { key: i, className: "btn " + active, onClick: _this2.click.bind(_this2, item[_this2.state.valueField]), dangerouslySetInnerHTML: { __html: bb.localize(item[_this2.state.keyField]) } }));
            });
            return labels;
        }
    }, {
        key: "componentWillUpdate",
        value: function componentWillUpdate(nextProps, nextState) {
            if (this.props.Value != nextProps.Value) {
                nextState.value = nextProps.Value;
            }
        }
    }, {
        key: "render",
        value: function render() {
            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    "div",
                    null,
                    React.createElement(
                        Label,
                        null,
                        this.props.Caption
                    )
                ),
                React.createElement(
                    "div",
                    { className: "btn-group colors" },
                    this.craeteLabels()
                )
            );
        }
    }]);

    return ButtonGroup;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CheckBox = function (_ComponentBase) {
    _inherits(CheckBox, _ComponentBase);

    function CheckBox() {
        _classCallCheck(this, CheckBox);

        return _possibleConstructorReturn(this, (CheckBox.__proto__ || Object.getPrototypeOf(CheckBox)).apply(this, arguments));
    }

    _createClass(CheckBox, [{
        key: "init",
        value: function init(props) {
            this.state.value = bb.inu(props.Value) ? false : props.Value;
        }
    }, {
        key: "click",
        value: function click(e) {
            this.state.options.Change(e, !this.state.value);
        }
    }, {
        key: "reset",
        value: function reset() {
            this.setState({ value: false });
        }
    }, {
        key: "clear",
        value: function clear() {
            this.setState({ value: false });
        }
    }, {
        key: "render",
        value: function render() {
            this.state.options.Class += " check-box ";
            var checkedClass = "";
            if (this.state.value) {
                checkedClass = "checked";
            }

            var topCaption = null;
            var leftCaption = null;
            if (!bb.inu(this.props.TopCaption) && this.props.TopCaption) {
                topCaption = React.createElement(
                    "label",
                    { className: "control-label m-b-sm" },
                    bb.localize(this.props.Caption)
                );
            } else {
                leftCaption = bb.localize(this.props.Caption);
            }

            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                topCaption,
                React.createElement(
                    "div",
                    { className: "i-checks" },
                    React.createElement(
                        "label",
                        { className: "control-label" },
                        React.createElement(
                            "div",
                            { className: "icheckbox_square-blue " + checkedClass },
                            React.createElement("ins", { className: "iCheck-helper", onClick: this.click.bind(this) })
                        ),
                        "\xA0\xA0",
                        leftCaption
                    )
                )
            );
        }
    }]);

    return CheckBox;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ComboBox = function (_ComponentBase) {
    _inherits(ComboBox, _ComponentBase);

    function ComboBox() {
        _classCallCheck(this, ComboBox);

        return _possibleConstructorReturn(this, (ComboBox.__proto__ || Object.getPrototypeOf(ComboBox)).apply(this, arguments));
    }

    _createClass(ComboBox, [{
        key: "init",
        value: function init(props, options) {
            this.cssClass = [];
            this.state.data = bb.inu(this.props.Data) ? [] : this.props.Data;
            this.state.selected = null;
            this.state.keyField = bb.inu(this.props.KeyField) ? "Code" : this.props.KeyField;
            this.state.valueField = bb.inu(this.props.ValueField) ? "Value" : this.props.ValueField;
            this.state.size = bb.inu(this.props.Size) ? 0 : this.props.Size;

            if (!bb.inu(this.props.NoSelect) && this.props.NoSelect && !bb.inu(this.state.data) && this.state.data.length > 0) {
                this.state.selected = bb.getFromArray(this.state.data, this.state.value, this.state.valueField);
                this.state.value = this.state.data[0][this.state.valueField];
                this.state.options.Change(null, this.state.value);
            }
        }
    }, {
        key: "componentDidUpdate",
        value: function componentDidUpdate(prevProps, prevState) {
            if (!bb.inu(this.props.NoSelect) && this.props.NoSelect && prevState.data.length == 0 && this.state.data.length > 0) {
                var value = this.state.data[0][this.state.valueField];
                this.val(value, function () {
                    this.state.options.Change(null, value);
                }.bind(this));
            }
        }
    }, {
        key: "change",
        value: function change(e) {
            e.persist();
            var value = e.target.value;
            var selected = bb.getFromArray(this.state.data, value, this.state.valueField);
            this.setState({ selected: selected }, function () {
                this.state.options.Change(e, value);
            }.bind(this));
        }
    }, {
        key: "clear",
        value: function clear(callback) {
            var options = this.state.options;
            options.Errors = [];
            if (!bb.inu(this.props.NoSelect)) {
                var value = this.state.data[0][this.state.valueField];
                this.val(value, function () {
                    this.state.options.Change(null, value);
                }.bind(this));
            } else {
                this.setState({ value: '', selected: null, options: options }, callback);
            }
        }
    }, {
        key: "selected",
        value: function selected() {
            return this.state.selected;
        }
    }, {
        key: "val",
        value: function val(value, callback) {
            if (bb.inu(value)) {
                return this.state.value;
            } else {
                var selected = bb.getFromArray(this.state.data, value, this.state.valueField);
                this.setState({ value: value, selected: selected }, callback);
            }
        }
    }, {
        key: "render",
        value: function render() {
            var options = [];
            var isMultiple = this.state.size != 0;

            if (!isMultiple && !this.props.NoSelect) {
                options.push(React.createElement(
                    "option",
                    { key: -1, value: "" },
                    bb.localize('select')
                ));
            }

            if (!bb.inu(this.state.data)) {
                var view = this.getView();
                for (var i = 0; i < this.state.data.length; i++) {
                    var opt = this.state.data[i];
                    var localized = opt[this.state.keyField];
                    if (view.localize('parameter.' + localized) != 'parameter.' + localized) {
                        localized = view.localize('parameter.' + localized);
                    }
                    if (!bb.inu(opt.Disabled) && opt.Disabled == true) {
                        options.push(React.createElement(
                            "option",
                            { key: i, disabled: true, value: opt[this.state.valueField] },
                            localized
                        ));
                    } else {
                        options.push(React.createElement(
                            "option",
                            { key: i, value: opt[this.state.valueField] },
                            localized
                        ));
                    }
                }
            }

            var selection = React.createElement(
                "select",
                { ref: "componentRef", className: "form-control", onChange: this.change.bind(this), value: this.state.value, readOnly: this.state.options.Disabled },
                options
            );
            if (isMultiple) {
                selection = React.createElement(
                    "select",
                    { multiple: "multiple", size: this.state.size, className: "form-control", onChange: this.change.bind(this), readOnly: this.state.options.Disabled },
                    options
                );
            }

            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    "div",
                    { className: "form-group" },
                    React.createElement(
                        Label,
                        null,
                        this.props.Caption
                    ),
                    selection
                )
            );
        }
    }]);

    return ComboBox;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ComboDatePicker = function (_ComponentBase) {
    _inherits(ComboDatePicker, _ComponentBase);

    function ComboDatePicker() {
        _classCallCheck(this, ComboDatePicker);

        return _possibleConstructorReturn(this, (ComboDatePicker.__proto__ || Object.getPrototypeOf(ComboDatePicker)).apply(this, arguments));
    }

    _createClass(ComboDatePicker, [{
        key: "init",
        value: function init(props) {
            this.state.year = "";
            this.state.month = "";
            this.state.minYear = bb.inu(this.props.MinYear) ? new Date().getFullYear() - 5 : this.props.MinYear;
            this.state.maxYear = bb.inu(this.props.MaxYear) ? new Date().getFullYear() + 5 : this.props.MaxYear;
            this.state.forwardMonthsDisable = !bb.inu(this.props.ForwardMonthsDisable) ? this.props.ForwardMonthsDisable : false;
            this.state.noSelect = !bb.inu(this.props.NoSelect) ? this.props.NoSelect : false;

            this.state.years = [];
            for (var i = this.state.minYear; i < this.state.maxYear; i++) {
                this.state.years.push({
                    name: i,
                    value: i
                });
            }
            this.state.months = [];
            this.state.selectMonth = [];
            this.state.fullMonths = [{ name: bb.localize("January"), value: 1 }, { name: bb.localize("February"), value: 2 }, { name: bb.localize("March"), value: 3 }, { name: bb.localize("April"), value: 4 }, { name: bb.localize("May"), value: 5 }, { name: bb.localize("June"), value: 6 }, { name: bb.localize("July"), value: 7 }, { name: bb.localize("August"), value: 8 }, { name: bb.localize("September"), value: 9 }, { name: bb.localize("October"), value: 10 }, { name: bb.localize("November"), value: 11 }, { name: bb.localize("December"), value: 12 }];
            if (this.state.forwardMonthsDisable) {
                var months = [];
                var date = new Date();
                for (var i = 0; i < date.getMonth() + 1; i++) {
                    months.push(this.state.fullMonths[i]);
                }
                this.state.months = months;
                this.state.selectMonth = months;
            } else {
                this.state.months = this.state.fullMonths;
            }
        }
    }, {
        key: "load",
        value: function load() {
            var date = new Date();
            var year = moment(date).year();
            var month = moment(date).month() + 1;
            this.setState({
                year: year,
                month: month
            });
            this[this.props.Id + "_Month"].val(month);
            this[this.props.Id + "_Year"].val(year);
        }
    }, {
        key: "monthChange",
        value: function monthChange(value, props, e) {
            if (!bb.inu(e)) {
                e.persist();
            }
            this.state.year = this[this.props.Id + "_Year"].val();
            this.state.month = this[this.props.Id + "_Month"].val();
            if (this.state.year != '' && this.state.month != '') {
                var value = this.state.year + "/" + this.state.month;
                var format = moment(new Date(value)).format("L");
                this.state.options.Change(e, format);
            } else {
                this.clear();
            }
        }
    }, {
        key: "yearChange",
        value: function yearChange(value, props, e) {
            if (this.state.forwardMonthsDisable) {
                if (value == new Date().getFullYear()) {
                    this.state.month = this.state.selectMonth;
                } else {
                    this.state.month = this.state.fullMonths;
                }
                this[this.props.Id + "_Month"].setState({ data: this.state.month });
            }
            this.monthChange(value, props, e);
        }
    }, {
        key: "val",
        value: function val(date) {
            if (bb.inu(date)) {
                var value = this.state.year + "/" + this.state.month;
                return moment(new Date(value)).format("L");
            } else {
                var year = moment(date).year();
                var month = moment(date).month() + 1;
                this.setState({
                    year: year,
                    month: month
                });
                this.yearChange(year);
                this[this.props.Id + "_Month"].val(month);
                this[this.props.Id + "_Year"].val(year);
            }
        }
    }, {
        key: "render",
        value: function render() {
            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    "div",
                    { className: "form-group" },
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: "12" },
                            React.createElement(
                                Label,
                                null,
                                this.props.Caption
                            )
                        )
                    ),
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Xs: "6" },
                            React.createElement(ComboBox, { Run: this, Id: this.props.Id + "_Month", Data: this.state.months, KeyField: "name", ValueField: "value", NoSelect: this.state.noSelect, OnChange: this.monthChange.bind(this) })
                        ),
                        React.createElement(
                            Col,
                            { Xs: "6" },
                            React.createElement(ComboBox, { Run: this, Id: this.props.Id + "_Year", Data: this.state.years, KeyField: "name", ValueField: "value", NoSelect: this.state.noSelect, OnChange: this.yearChange.bind(this) })
                        )
                    )
                )
            );
        }
    }]);

    return ComboDatePicker;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Converter = function (_ComponentBase) {
    _inherits(Converter, _ComponentBase);

    function Converter() {
        _classCallCheck(this, Converter);

        return _possibleConstructorReturn(this, (Converter.__proto__ || Object.getPrototypeOf(Converter)).apply(this, arguments));
    }

    _createClass(Converter, [{
        key: "init",
        value: function init(props, options) {
            this.state.isSpotRate = false;
            this.state.sellCurrency = "GBP";
            this.state.buyCurrency = "EUR";
            this.state.sellAmount = 0;
            this.state.buyAmount = 0;
            this.state.rate = 0;
            this.state.fixedCurrency = "";
            this.state.conversionDate = null;
            this.state.disableDate = !bb.inu(this.props.DisableDate) ? this.props.DisableDate : false;
            this.state.loading = false;
            this.state.limitCheck = true;
            this.state.validDate = new Date().setDate(-1);
        }
    }, {
        key: "load",
        value: function load(props, options) {
            this.conversionDateControl();
        }
    }, {
        key: "conversionDateControl",
        value: function conversionDateControl(date) {
            if (!this.state.disableDate) {
                var model = {
                    SellCurrency: this.state.sellCurrency,
                    BuyCurrency: this.state.buyCurrency,
                    FixedCurrency: this.state.fixedCurrency
                };
                if (!bb.inu(date)) {
                    model.ConversionDate = date;
                }
                var action = {
                    controller: "Exchange",
                    action: "ConversionDateControl",
                    params: model,
                    success: function (result) {
                        var momentLocale = moment.locale();
                        var resultDate = result.ConversionDate;
                        var validDate = "";
                        if (momentLocale === "en-gb") {
                            resultDate = moment(resultDate, "DD/MM/YYYY").format("L");
                            validDate = moment(resultDate, "DD/MM/YYYY").toDate();
                        } else {
                            resultDate = moment(resultDate).format("L");
                            validDate = moment(resultDate).toDate();
                        }
                        this.setState({ validDate: validDate });
                        this.ConversionDate.val(resultDate);
                    }.bind(this)
                };
                var view = this.getView();
                view.post(action);
            }
        }
    }, {
        key: "loadRate",
        value: function loadRate(callback, loader) {
            this.setState({ rate: this.state.rate == 0 ? this.state.rate : -1, loading: true }, function () {
                if (!bb.inu(this.props.IsLoading) && bb.isFunction(this.props.IsLoading)) {
                    this.props.IsLoading(true);
                }
                var model = {
                    SellCurrency: this.state.sellCurrency,
                    BuyCurrency: this.state.buyCurrency,
                    SellAmount: this.state.sellAmount,
                    BuyAmount: this.state.buyAmount,
                    FixedCurrency: this.state.fixedCurrency,
                    ConversionDate: this.state.conversionDate,
                    IsSpotRate: this.state.isSpotRate
                };

                if (model.FixedCurrency == model.SellCurrency && model.SellAmount == 0 || model.FixedCurrency == model.BuyCurrency && model.BuyAmount == 0 || model.SellCurrency == '' || model.BuyCurrency == '' || model.ConversionDate == '' || model.FixedCurrency == "") {
                    return;
                }

                model.DisableDate = this.state.disableDate;
                var overlay = false;
                if (!bb.inu(loader)) {
                    overlay = loader;
                }
                model.LimitCheck = this.state.limitCheck;
                var action = {
                    controller: "Rate",
                    action: "GetRate",
                    params: model,
                    overlay: overlay,
                    success: function (result) {
                        var sellValue = this.SellAmount.val();
                        sellValue.Value = result.SellAmount;
                        sellValue.Code = result.SellCurrency;
                        this.SellAmount.val(sellValue);

                        var buyValue = this.BuyAmount.val();
                        buyValue.Value = result.BuyAmount;
                        buyValue.Code = result.BuyCurrency;
                        this.BuyAmount.val(buyValue);

                        this.setState({
                            loading: false,
                            rate: result.Rate,
                            fixedCurrency: result.FixedCurrency,
                            sellCurrency: result.SellCurrency,
                            buyCurrency: result.BuyCurrency,
                            sellAmount: result.SellAmount,
                            buyAmount: result.BuyAmount
                        }, callback);
                        if (!bb.inu(this.props.IsLoading) && bb.isFunction(this.props.IsLoading)) {
                            this.props.IsLoading(false);
                        }
                    }.bind(this),
                    error: function (msg) {
                        this.error(msg);
                        this.setState({ loading: false });
                        if (this.state.limitCheck) {
                            this.reset();
                        }
                        if (!bb.inu(this.props.IsLoading) && bb.isFunction(this.props.IsLoading)) {
                            this.props.IsLoading(false);
                        }
                    }.bind(this)
                };

                var view = this.getView();
                view.post(action);
            }.bind(this));
        }
    }, {
        key: "process",
        value: function process() {
            var sellAmount = this.SellAmount.val();
            var buyAmount = this.BuyAmount.val();
            var conversionDate = this.state.disableDate == true ? null : this.ConversionDate.val();

            this.setState({ loading: true, conversionDate: conversionDate, sellAmount: sellAmount.Value, sellCurrency: sellAmount.Code, buyAmount: buyAmount.Value, buyCurrency: buyAmount.Code }, this.loadRate(this.props.OnChange, false));
        }
    }, {
        key: "sellAmountChanged",
        value: function sellAmountChanged(model) {
            if (model.Value != 0 && this.isChanged()) {
                this.error();
                var onlyCurrencyChanged = this.state.sellAmount == model.Value;
                var sellCurrency = this.SellAmount.currency();
                var buyCurrency = this.BuyAmount.currency();

                if (onlyCurrencyChanged && this.state.fixedCurrency == buyCurrency) {
                    this.process();
                } else {
                    this.setState({ fixedCurrency: sellCurrency }, this.process.bind(this));
                }
            } else if (model.Value == 0) {
                this.BuyAmount.clear();
                this.SellAmount.clear();
                this.setState({ rate: 0 });
            }
        }
    }, {
        key: "isChanged",
        value: function isChanged() {
            var sellAmount = this.SellAmount.val();
            var buyAmount = this.BuyAmount.val();
            var conversionDate = this.state.disableDate == true ? null : this.ConversionDate.val();
            if (this.state.sellAmount != bb.toDecimal(sellAmount.Value) || this.state.sellCurrency != sellAmount.Code || this.state.buyAmount != bb.toDecimal(buyAmount.Value) || this.state.buyCurrency != buyAmount.Code || this.state.conversionDate != conversionDate) {
                return true;
            }
            return false;
        }
    }, {
        key: "buyAmountChanged",
        value: function buyAmountChanged(model) {
            if (model.Value != 0 && this.isChanged()) {
                this.error();
                var onlyCurrencyChanged = this.state.buyAmount == model.Value;
                var buyCurrency = this.BuyAmount.currency();
                var sellCurrency = this.SellAmount.currency();

                if (onlyCurrencyChanged && this.state.fixedCurrency == sellCurrency) {
                    this.process();
                } else {
                    this.setState({ fixedCurrency: buyCurrency }, this.process.bind(this));
                }
            } else if (model.Value == 0) {
                this.BuyAmount.clear();
                this.SellAmount.clear();
                this.setState({ rate: 0 });
            }
        }
    }, {
        key: "conversionDateChanged",
        value: function conversionDateChanged(value) {
            this.error();
            this.setState({ conversionDate: moment(value).format("L") }, this.process.bind(this));
            if (!bb.inu(this.props.DateChange) && bb.isFunction(this.props.DateChange)) {
                this.props.DateChange(value);
            }
        }
    }, {
        key: "reset",
        value: function reset() {
            this.setState({
                sellCurrency: "GBP",
                buyCurrency: "EUR",
                sellAmount: 0,
                buyAmount: 0,
                rate: 0,
                fixedCurrency: ""
            });
            this.SellAmount.clear();
            this.BuyAmount.clear();
        }
    }, {
        key: "val",
        value: function val(value, callback) {
            var _this2 = this;

            if (bb.inu(value)) {
                return {
                    SellCurrency: this.state.sellCurrency,
                    BuyCurrency: this.state.buyCurrency,
                    SellAmount: this.state.sellAmount,
                    BuyAmount: this.state.buyAmount,
                    Rate: this.state.rate,
                    FixedCurrency: this.state.fixedCurrency,
                    ConversionDate: this.state.disableDate == true ? null : this.ConversionDate.val()
                };
            } else {
                this.setState({
                    sellCurrency: value.SellCurrency,
                    buyCurrency: value.BuyCurrency,
                    sellAmount: value.SellAmount,
                    buyAmount: value.BuyAmount,
                    rate: value.Rate,
                    fixedCurrency: value.FixedCurrency,
                    conversionDate: value.ConversionDate
                }, function () {
                    var sellModel = {
                        Value: value.SellAmount,
                        Code: value.SellCurrency
                    };
                    var buyModel = {
                        Value: value.BuyAmount,
                        Code: value.BuyCurrency
                    };
                    _this2.SellAmount.val(sellModel);
                    _this2.BuyAmount.val(buyModel);
                    if (_this2.state.disableDate != true) {
                        _this2.ConversionDate.val(value.ConversionDate);
                    }
                    if (bb.isFunction(callback)) {
                        callback();
                    }
                });
            }
        }
    }, {
        key: "renderDate",
        value: function renderDate() {
            if (this.state.disableDate == true) {
                return null;
            }

            return React.createElement(
                Row,
                { CssClass: "m-b-sm" },
                React.createElement(
                    Col,
                    { Md: 12 },
                    React.createElement(DatePicker, { Run: this, Id: "ConversionDate", ValidDate: this.state.validDate, Caption: "Date", OnlyFuture: true, DisabledWeekend: true, OnChange: this.conversionDateChanged.bind(this) })
                )
            );
        }
    }, {
        key: "render",
        value: function render() {
            var rateClass = "";
            var rateExplanation = "";
            if (this.state.rate == 0 && !this.state.loading) {
                rateClass += " hidden";
            } else if (this.state.rate < 0 || this.state.loading) {
                rateExplanation = bb.localize("thebestrateforyouisbeingcalculated");
                rateClass += " animated pulse";
            } else {
                rateClass += " animated fadeInDown";
                var view = this.getView();
                var currencies = view.appState().Currencies;
                var sCurrency = bb.getFromArray(currencies, this.state.sellCurrency, "Code");
                var bCurrency = bb.getFromArray(currencies, this.state.buyCurrency, "Code");
                rateExplanation = "1 " + sCurrency.Code + ' = ' + this.state.rate + " " + bCurrency.Code;
            }

            var sellCaption = "YouSend";
            if (!bb.inu(this.props.SellCaption)) {
                sellCaption = this.props.SellCaption;
            }

            var buyCaption = "RecipientGets";
            if (!bb.inu(this.props.BuyCaption)) {
                buyCaption = this.props.BuyCaption;
            }

            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                this.renderDate(),
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: 12 },
                        React.createElement(CurrencyBox, { Run: this, Id: "SellAmount", Caption: sellCaption, TabIndex: "1", Precision: 2, Currency: this.state.sellCurrency, OnChange: this.sellAmountChanged.bind(this) })
                    )
                ),
                React.createElement("hr", { className: "hr-text icon-color" }),
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: 12 },
                        React.createElement(CurrencyBox, { Run: this, Id: "BuyAmount", Caption: buyCaption, TabIndex: "2", Precision: 2, Currency: this.state.buyCurrency, OnChange: this.buyAmountChanged.bind(this) })
                    )
                ),
                React.createElement(
                    Row,
                    { CssClass: "m-t-sm" },
                    React.createElement(
                        Col,
                        { Md: "12" },
                        React.createElement(
                            "span",
                            { ref: "explanation", className: "converter-explanation " + rateClass },
                            rateExplanation
                        )
                    )
                )
            );
        }
    }]);

    return Converter;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Country = function (_ComponentBase) {
    _inherits(Country, _ComponentBase);

    function Country() {
        _classCallCheck(this, Country);

        return _possibleConstructorReturn(this, (Country.__proto__ || Object.getPrototypeOf(Country)).apply(this, arguments));
    }

    _createClass(Country, [{
        key: "init",
        value: function init(props, options) {
            this.state.countries = this.getAppState().Countries;
            this.state.selected = null;
            this.state.hiddenCode = bb.inu(this.props.HiddenCode) ? false : this.props.HiddenCode;
            this.state.value = bb.inu(this.props.Value) ? "" : this.props.Value;
        }
    }, {
        key: "load",
        value: function load(props) {
            var appState = this.getAppState();
            var countryList = appState.Countries;

            var code = this[this.props.Id + "_CountryCode"];
            var name = this[this.props.Id + "_CountryName"];
            code.setState({ data: countryList });
            name.setState({ data: countryList });
            if (this.state.value != '') {
                code.val(this.state.value);
                name.val(this.state.value);
            }
        }
    }, {
        key: "selected",
        value: function selected() {
            return this.state.selected;
        }
    }, {
        key: "countryCodeSelected",
        value: function countryCodeSelected(val, props, e) {
            e.persist();
            var selected = this[this.props.Id + "_CountryCode"].state.selected;
            if (bb.inu(selected)) {
                this[this.props.Id + "_CountryName"].setState({ search: '', value: '', selected: null });
                this.setState({ selected: null });
            } else {
                this[this.props.Id + "_CountryName"].setState({ search: selected.Name, value: selected.ISOCode, selected: selected });
                this.state.options.Change(e, selected.ISOCode);
                this.setState({ selected: selected });
            }
        }
    }, {
        key: "countryNameSelected",
        value: function countryNameSelected(val, props, e) {
            e.persist();
            var selected = this[this.props.Id + "_CountryName"].state.selected;
            if (bb.inu(selected)) {
                this[this.props.Id + "_CountryCode"].setState({ search: '', value: '', selected: null });
                this.setState({ selected: null });
            } else {
                this[this.props.Id + "_CountryCode"].setState({ search: selected.ISOCode, value: selected.ISOCode, selected: selected });
                this.state.options.Change(e, selected.ISOCode);
                this.setState({ selected: selected });
            }
        }
    }, {
        key: "val",
        value: function val(value, callback) {
            if (bb.inu(value)) {
                return this.state.value;
            } else {
                this[this.props.Id + "_CountryCode"].val(value, callback);
                this[this.props.Id + "_CountryName"].val(value, callback);
                this.setState({ value: value });
            }
        }
    }, {
        key: "clear",
        value: function clear() {
            this[this.props.Id + "_CountryCode"].clear();
            this[this.props.Id + "_CountryName"].clear();
            this.setState({ value: '' });
        }
    }, {
        key: "render",
        value: function render() {
            var caption = this.props.Caption;
            if (bb.inu(caption)) {
                caption = "Country";
            }
            var captionCode = null;
            var captionName = null;
            var captionCodeClass = null;
            var captionNameClass = null;

            var codeClass = "no-padding-right";
            var nameClass = "no-padding-left";
            var nameWeight = 8;
            if (this.state.hiddenCode) {
                codeClass += " hidden";
                nameClass = "";
                nameWeight = 12;
                captionName = caption;
                captionCodeClass = "without-caption";
            } else {
                captionCode = caption;
                captionNameClass = "without-caption";
            }

            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: "4", CssClass: codeClass },
                        React.createElement(AutoComplete, { Run: this, Id: this.props.Id + "_CountryCode", Caption: captionCode, Class: captionCodeClass, Value: this.state.value, KeyField: "ISOCode", ValueField: "ISOCode", OnChange: this.countryCodeSelected.bind(this), Placeholder: this.props.Placeholder, Data: this.state.countries })
                    ),
                    React.createElement(
                        Col,
                        { Md: nameWeight, CssClass: nameClass },
                        React.createElement(AutoComplete, { Run: this, Id: this.props.Id + "_CountryName", Caption: captionName, Class: captionNameClass, Value: this.state.value, KeyField: "Name", ValueField: "ISOCode", OnChange: this.countryNameSelected.bind(this), Placeholder: this.props.Placeholder, Data: this.state.countries })
                    )
                )
            );
        }
    }]);

    return Country;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Currency = function (_ComponentBase) {
    _inherits(Currency, _ComponentBase);

    function Currency() {
        _classCallCheck(this, Currency);

        return _possibleConstructorReturn(this, (Currency.__proto__ || Object.getPrototypeOf(Currency)).apply(this, arguments));
    }

    _createClass(Currency, [{
        key: "init",
        value: function init(props, options) {
            this.state.currencies = this.getAppState().Currencies;
            this.state.value = bb.inu(this.props.BaseCurrency) ? "" : this.props.BaseCurrency;
            this.state.hiddenCode = bb.inu(this.props.HiddenCode) ? false : this.props.HiddenCode;
            this.state.hiddenName = bb.inu(this.props.HiddenName) ? false : this.props.HiddenName;
            this.state.useIpLocation = !bb.inu(this.props.UseIpLocation) ? this.props.UseIpLocation : false;

            var ipCurrency = null;
            if (this.state.useIpLocation && bb.inu(this.props.BaseCurrency)) {
                ipCurrency = geoplugin_currencyCode();
                if (!bb.inu(ipCurrency)) {
                    this.state.value = ipCurrency;
                }
            }
        }
    }, {
        key: "load",
        value: function load(props, options) {
            var appState = this.getAppState();
            var currencyList = appState.Currencies;

            this.setState({ currencies: currencyList });
            this[this.props.Id + "_CurrencyCode"].setState({ data: currencyList }, function () {
                this[this.props.Id + "_CurrencyCode"].val(this.state.value);
            }.bind(this));
            this[this.props.Id + "_CurrencyName"].setState({ data: currencyList }, function () {
                this[this.props.Id + "_CurrencyName"].val(this.state.value);
            }.bind(this));
        }
    }, {
        key: "currencyCodeChange",
        value: function currencyCodeChange(value, props, e) {
            e.persist();
            var selected = this[this.props.Id + "_CurrencyCode"].state.selected;
            if (bb.inu(selected)) {
                this[this.props.Id + "_CurrencyName"].setState({ search: '', value: '', selected: null });
                this.setState({ value: "" });
            } else {
                this[this.props.Id + "_CurrencyName"].setState({ search: selected.Name, value: selected.Code, selected: selected });
                this.state.options.Change(e, selected.ISOCode);
                this.setState({ value: selected.Code });
            }
        }
    }, {
        key: "currencyNameChange",
        value: function currencyNameChange(value, props, e) {
            e.persist();
            var selected = this[this.props.Id + "_CurrencyName"].state.selected;
            if (bb.inu(selected)) {
                this[this.props.Id + "_CurrencyCode"].setState({ search: '', value: '', selected: null });
                this.setState({ value: "" });
            } else {
                this[this.props.Id + "_CurrencyCode"].setState({ search: selected.Code, value: selected.Code, selected: selected });
                this.state.options.Change(e, selected.ISOCode);
                this.setState({ value: selected.Code });
            }
        }
    }, {
        key: "clear",
        value: function clear() {
            this[this.props.Id + "_CurrencyCode"].clear();
            this[this.props.Id + "_CurrencyName"].clear();
            this.setState({ value: '' });
        }
    }, {
        key: "val",
        value: function val(value, callback) {
            if (bb.inu(value)) {
                return this.state.value;
            } else {
                this[this.props.Id + "_CurrencyCode"].val(value);
                this[this.props.Id + "_CurrencyName"].val(value);
                this.setState({ value: value }, callback);
            }
        }
    }, {
        key: "render",
        value: function render() {
            var caption = this.props.Caption;
            if (bb.inu(caption)) {
                caption = "Currency";
            }

            var codeClass = "no-padding-right";
            var nameClass = "no-padding-left";
            var nameWeight = 8;
            var codeWeight = 4;
            if (this.state.hiddenCode) {
                codeClass += " hidden";
                nameClass = "";
                nameWeight = 12;
            }
            if (this.state.hiddenName) {
                nameClass += " hidden";
                codeClass = "";
                codeWeight = 12;
            }

            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    "div",
                    { className: "form-group" },
                    React.createElement(
                        Label,
                        null,
                        caption
                    ),
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: codeWeight, CssClass: codeClass },
                            React.createElement(AutoComplete, { Run: this, Id: this.props.Id + "_CurrencyCode", Value: this.state.value, KeyField: "Code", ValueField: "Code", OnChange: this.currencyCodeChange.bind(this), Placeholder: "Code", Data: this.state.currencies })
                        ),
                        React.createElement(
                            Col,
                            { Md: nameWeight, CssClass: nameClass },
                            React.createElement(AutoComplete, { Run: this, Id: this.props.Id + "_CurrencyName", Value: this.state.value, KeyField: "Name", ValueField: "Code", OnChange: this.currencyNameChange.bind(this), Placeholder: "Name", Data: this.state.currencies })
                        )
                    )
                )
            );
        }
    }]);

    return Currency;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CurrencyBox = function (_ComponentBase) {
    _inherits(CurrencyBox, _ComponentBase);

    function CurrencyBox() {
        _classCallCheck(this, CurrencyBox);

        return _possibleConstructorReturn(this, (CurrencyBox.__proto__ || Object.getPrototypeOf(CurrencyBox)).apply(this, arguments));
    }

    _createClass(CurrencyBox, [{
        key: "init",
        value: function init() {
            this.state.opened = false;
            this.state.currency = !bb.inu(this.props.Currency) ? this.props.Currency : "";
            this.state.currencyList = this.getAppState().Currencies;
            this.state.selectedCurrency = null;
            this.state.loadCurrencyList = !bb.inu(this.props.LoadCurrencyList) ? this.props.LoadCurrencyList : true;
            this.state.topCurrencies = !bb.inu(this.props.TopCurrencies) ? this.props.TopCurrencies : [];
            this.state.currency = !bb.inu(this.props.Currency) ? this.props.Currency : "";
            this.state.useIpLocation = !bb.inu(this.props.UseIpLocation) ? this.props.UseIpLocation : false;
            this.state.hiddenCurrency = !bb.inu(this.props.HiddenCurrency) ? this.props.HiddenCurrency : false;
            this.state.precisionNumber = !bb.inu(this.props.Precision) ? this.props.Precision : 2;
            this.state.placeholder = "";
            this.state.delimiter = ",";
            this.state.seperator = ".";
            this.state.hideAmount = !bb.inu(this.props.HideAmount) ? this.props.HideAmount : false;

            this.state.searchTimeOut;
            this.state.search = '';
            this.state.tabIndex = !bb.inu(this.props.TabIndex) ? this.props.TabIndex : "";

            this.state.placeholder = "0" + this.state.seperator;
            for (var i = 0; i < this.state.precisionNumber; i++) {
                this.state.placeholder += "0";
            }
        }
    }, {
        key: "load",
        value: function load() {
            var _this2 = this;

            if (this.state.loadCurrencyList) {
                var appState = this.getAppState();
                var currencyList = appState.Currencies;
                var selectedCurrency = null;

                if (!bb.inu(this.state.currency) && this.state.currency != '') {
                    selectedCurrency = currencyList.find(function (currency) {
                        return currency.Code === _this2.state.currency;
                    });
                }

                if (this.state.useIpLocation && bb.inu(this.props.Country)) {
                    var ipCurrencyCode = geoplugin_currencyCode();

                    if (!bb.inu(ipCurrencyCode)) {
                        selectedCurrency = currencyList.find(function (currency) {
                            return currency.Code === ipCurrencyCode;
                        });
                    }
                }

                this.setState({ currencyList: currencyList, selectedCurrency: selectedCurrency }, function () {
                    this.val(this.state.value);
                }.bind(this));
            }
            document.addEventListener('mousedown', this.handleClickOutside.bind(this));
            document.addEventListener('keydown', this.handleKeyDown.bind(this));
            document.addEventListener('keypress', this.handleKeyPress.bind(this));
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            document.removeEventListener('mousedown', this.handleClickOutside.bind(this));
            document.removeEventListener('keydown', this.handleClickOutside.bind(this));
            document.removeEventListener('keypress', this.handleClickOutside.bind(this));
        }
    }, {
        key: "handleClickOutside",
        value: function handleClickOutside(event) {
            if (this.wrapperRef && !this.wrapperRef.contains(event.target)) {
                this.setState({ opened: false });
            }
        }
    }, {
        key: "handleKeyDown",
        value: function handleKeyDown(event) {
            if (this.state.opened) {
                switch (event.key) {
                    case 'ArrowDown':
                        break;
                    case 'ArrowUp':
                        break;
                    case 'Enter':
                        event.preventDefault();
                        var el = ReactDOM.findDOMNode(this);
                        var item = el.querySelector('.hover');
                        if (item != null) {
                            this.setState({ opened: false }, function () {
                                item.classList.remove('hover');
                                item.click();
                            });
                        }
                        break;
                }
            }
        }
    }, {
        key: "handleKeyPress",
        value: function handleKeyPress(event) {
            if (this.state.opened) {
                this.state.search += event.key;
                var key = this.state.search.toLowerCase();
                var index = this.state.currencyList.findIndex(function (currency, index) {
                    return currency.Code.toLowerCase().startsWith(key);
                });
                if (index != -1) {
                    this.clearHovers();
                    var item = this.refs['item_' + index];
                    var offsetTop = item.offsetTop;
                    this.refs.container.scrollTop = offsetTop;
                    item.classList.add('hover');
                }

                clearTimeout(this.state.searchTimeOut);

                this.state.searchTimeOut = setTimeout(function () {
                    this.state.search = '';
                }.bind(this), 1000);
            }
        }
    }, {
        key: "clearHovers",
        value: function clearHovers() {
            var container = ReactDOM.findDOMNode(this);
            var elems = container.querySelectorAll(".hover");
            elems.forEach(function (item) {
                item.classList.remove('hover');
            });
        }
    }, {
        key: "setWrapperRef",
        value: function setWrapperRef(node) {
            this.wrapperRef = node;
        }
    }, {
        key: "val",
        value: function val(value, callback) {
            if (bb.inu(value)) {
                var selectedCurrency = this.state.selectedCurrency;
                return {
                    CountryISOCode: !bb.inu(selectedCurrency) ? selectedCurrency.CountryISOCode : "",
                    Code: !bb.inu(selectedCurrency) ? selectedCurrency.Code : "",
                    Name: !bb.inu(selectedCurrency) ? selectedCurrency.Name : "",
                    Value: this.state.value == "" ? 0 : this.state.value
                };
            } else {
                if (value == '') {
                    return;
                }
                if (this.state.currencyList.length > 0) {
                    var selectedCurrency = this.state.currencyList.find(function (currency) {
                        return currency.Code === value.Code;
                    });

                    if (bb.inu(selectedCurrency)) {
                        return null;
                    }

                    this.refs.input.value = value.Value;
                    this.setState({
                        currency: selectedCurrency.Code,
                        selectedCurrency: selectedCurrency,
                        value: value.Value
                    }, callback);
                } else {
                    this.setState({
                        currency: value.Code,
                        value: value.Value,
                        selectedCurrency: null
                    }, callback);
                }
                this.formatAmount(null, true);
            }
        }
    }, {
        key: "currency",
        value: function currency(_currency, callback) {
            if (bb.inu(_currency)) {
                return this.state.selectedCurrency.Code;
            } else {
                var currencyList = this.state.currencyList;
                var selectedCurrency = null;
                if (currencyList.length > 0) {
                    selectedCurrency = currencyList.find(function (item) {
                        return item.Code === _currency;
                    });
                }
                if (selectedCurrency != null) {
                    this.setState({ selectedCurrency: selectedCurrency }, callback);
                }
            }

            if (selectedCurrency != null) {
                return selectedCurrency.Code;
            } else {
                return _currency;
            }
        }
    }, {
        key: "toggle",
        value: function toggle() {
            this.clearHovers();
            this.setState({ opened: !this.state.opened });
        }
    }, {
        key: "clear",
        value: function clear() {
            var _this3 = this;

            this.setState({ value: '' }, function () {
                _this3.refs.input.value = "";
                _this3.refs.input.placeholder = _this3.state.placeholder;
            });
        }
    }, {
        key: "onCurrencySelected",
        value: function onCurrencySelected(currency, index) {
            var _this4 = this;

            if (this.state.selectedCurrency != null && this.state.selectedCurrency.Code == currency) {
                this.setState({
                    opened: false
                });
                return;
            }

            this.setState({ opened: false, selectedCurrency: currency }, function () {
                if (bb.isFunction(_this4.props.OnChange)) {
                    _this4.props.OnChange(_this4.val());
                }
            });
        }
    }, {
        key: "onAmountChange",
        value: function onAmountChange(event) {
            this.error("");
            //var amountValue = VMasker.toMoney(event.target.value, { precision: 0, delimiter: this.state.delimiter, seperator: this.state.seperator });
            var amountValue = "0";

            var val = event.target.value;
            if (val != '') {
                val = val.replace('/' + this.state.delimiter + '/g', "");
                if (val.indexOf(this.state.seperator) > 0) {
                    var tmp = val.split(this.state.seperator);
                    var precision = tmp[1];

                    if (precision.length > this.state.precisionNumber) {
                        precision = precision.substr(0, this.state.precisionNumber);
                    }
                    var masked = VMasker.toMoney(tmp[0], { precision: 0, delimiter: this.state.delimiter, seperator: this.state.seperator });
                    amountValue = masked + this.state.seperator + precision;
                } else {
                    var masked = VMasker.toMoney(val, { precision: 0, delimiter: this.state.delimiter, seperator: this.state.seperator });
                    amountValue = masked;
                }
            }

            event.target.value = amountValue;

            var value = VMasker.toNumber(amountValue);

            if (!bb.inu(this.props.OnAmountChange)) {
                this.props.OnAmountChange(amountValue);
            }
        }
    }, {
        key: "formatAmount",
        value: function formatAmount(e, noChange) {
            var _this5 = this;

            var precision = "";
            for (var i = 0; i < this.state.precisionNumber; i++) {
                precision += "0";
            }
            var val = this.refs.input.value;
            if (val != '') {
                val = val.replace('/' + this.state.delimiter + '/g', "");
                if (val.indexOf(this.state.seperator) > 0) {
                    var tmp = val.split(this.state.seperator);
                    precision = bb.padRight(tmp[1], precision);
                    if (precision.length > this.state.precisionNumber) {
                        precision = precision.substr(0, this.state.precisionNumber);
                    }
                    var masked = VMasker.toMoney(tmp[0], { precision: 0, delimiter: this.state.delimiter, seperator: this.state.seperator });
                    this.refs.input.value = masked + this.state.seperator + precision;
                } else {
                    var masked = VMasker.toMoney(val, { precision: 0, delimiter: this.state.delimiter, seperator: this.state.seperator });
                    this.refs.input.value = masked + this.state.seperator + precision;
                }

                if (this.state.value !== val) {
                    this.setState({ value: val }, function () {
                        if (noChange != true && bb.isFunction(_this5.props.OnChange)) {
                            _this5.props.OnChange(_this5.val());
                        }
                    });
                }
            } else {
                if (this.state.value !== val) {
                    this.setState({ value: val }, function () {
                        if (noChange != true && bb.isFunction(_this5.props.OnChange)) {
                            _this5.props.OnChange(_this5.val());
                        }
                    });
                }
            }
            if (this.refs.input.value == "") {
                this.refs.input.placeholder = this.state.placeholder;
            }
        }
    }, {
        key: "reFormatAmount",
        value: function reFormatAmount(e) {
            this.refs.input.placeholder = "";
            if (!bb.inu(this.state.value.Value)) {
                this.refs.input.value = this.state.value.Value;
            } else {
                this.refs.input.value = this.state.value;
            }
            e.target.select();
        }
    }, {
        key: "renderCurrencyList",
        value: function renderCurrencyList() {
            var _this6 = this;

            var result = [];

            this.state.topCurrencies.forEach(function (top, index) {
                var currency = bb.getFromArray(_this6.state.currencyList, top, "Code");
                if (!bb.inu(currency)) {
                    var countryFlagClass = "flag-icon-" + currency.CountryISOCode.toLowerCase();
                    var flag = React.createElement("div", { className: "flag-icon-background phone-flag pull-right " + countryFlagClass + " currency-field-flag " });
                    result.push(React.createElement(
                        "li",
                        { ref: 'top_' + index, className: "text-right", key: 'top_' + index, onClick: _this6.onCurrencySelected.bind(_this6, currency, index) },
                        flag,
                        " ",
                        React.createElement(
                            "span",
                            { className: "text-muted" },
                            currency.Code,
                            " - "
                        ),
                        " ",
                        currency.Name,
                        " "
                    ));
                }
            });

            if (result.length > 0) {
                result.push(React.createElement("hr", { key: "hr" }));
            }

            this.state.currencyList.forEach(function (currency, index) {
                var countryFlagClass = "flag-icon-" + currency.CountryISOCode.toLowerCase();
                var flag = React.createElement("div", { className: "flag-icon-background phone-flag pull-right " + countryFlagClass + " currency-field-flag " });
                result.push(React.createElement(
                    "li",
                    { ref: 'item_' + index, className: "text-right", key: index, onClick: _this6.onCurrencySelected.bind(_this6, currency, index) },
                    flag,
                    " ",
                    React.createElement(
                        "span",
                        { className: "text-muted" },
                        " ",
                        currency.Code,
                        " - "
                    ),
                    " ",
                    currency.Name
                ));
            });
            var className = this.state.opened ? "" : "hidden";
            return React.createElement(
                "div",
                { className: "currency-list-container" },
                React.createElement(
                    "ul",
                    { ref: "container", className: "auto-complete-result phone-result " + className },
                    result
                )
            );
        }
    }, {
        key: "renderSelected",
        value: function renderSelected() {
            if (bb.inu(this.state.selectedCurrency)) {
                return React.createElement(
                    "div",
                    null,
                    React.createElement(
                        Localize,
                        null,
                        "Currency"
                    ),
                    " ",
                    React.createElement("span", { className: "caret" })
                );
            } else {
                var currency = this.state.selectedCurrency;
                var countryFlagClass = "flag-icon-" + currency.CountryISOCode.toLowerCase();
                var flag = React.createElement("div", { className: "flag-icon-background phone-flag " + countryFlagClass });
                return React.createElement(
                    "div",
                    { className: "currency-selected" },
                    flag,
                    " ",
                    React.createElement(
                        "span",
                        { className: "currency-selected-code m-l-xs" },
                        currency.Code
                    ),
                    " ",
                    React.createElement("span", { className: "caret" })
                );
            }
        }
    }, {
        key: "render",
        value: function render() {
            var _React$createElement;

            var currencyDisabledClass = '';
            if (!bb.inu(this.props.DisableCurrency) && this.props.DisableCurrency) {
                currencyDisabledClass = "disabled";
            }
            var amountClass = "currency-input-container";
            var buttonClass = "";
            if (this.state.hideAmount) {
                amountClass += " hidden";
                buttonClass = " currency-button-group";
            }
            var currencyBoxClass = this.state.hiddenCurrency ? 'hidden' : '';
            var rightRadiusClass = this.state.hiddenCurrency ? "border-right-radius" : "";
            var groupClass = this.state.hiddenCurrency ? "form-group currency-input-group" : "input-group currency-input-group";
            return React.createElement(
                "div",
                { ref: this.setWrapperRef.bind(this) },
                React.createElement(
                    Wrapper,
                    { Options: this.state.options },
                    React.createElement(
                        Label,
                        null,
                        this.props.Caption
                    ),
                    React.createElement(
                        "div",
                        { className: groupClass },
                        React.createElement(
                            "div",
                            { className: amountClass },
                            React.createElement("input", (_React$createElement = { ref: "input", type: "text", tabIndex: this.state.tabIndex, className: "text-right form-control border-left-radius " + rightRadiusClass,
                                placeholder: this.props.Placeholder,
                                onBlur: this.formatAmount.bind(this),
                                onFocus: this.reFormatAmount.bind(this)
                            }, _defineProperty(_React$createElement, "placeholder", this.state.placeholder), _defineProperty(_React$createElement, "onChange", this.onAmountChange.bind(this)), _React$createElement))
                        ),
                        React.createElement(
                            "span",
                            { className: "input-group-btn " + currencyBoxClass + ' ' + currencyDisabledClass, readOnly: this.state.options.Disabled },
                            React.createElement(
                                "button",
                                { className: "btn btn-default border-right-radius" + buttonClass, type: "button", onClick: this.toggle.bind(this), readOnly: this.state.options.Disabled },
                                this.renderSelected()
                            )
                        )
                    ),
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: "12" },
                            this.renderCurrencyList()
                        )
                    )
                )
            );
        }
    }]);

    return CurrencyBox;
}(ComponentBase);
"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DataGridColumn = function (_React$Component) {
    _inherits(DataGridColumn, _React$Component);

    function DataGridColumn() {
        _classCallCheck(this, DataGridColumn);

        return _possibleConstructorReturn(this, (DataGridColumn.__proto__ || Object.getPrototypeOf(DataGridColumn)).apply(this, arguments));
    }

    _createClass(DataGridColumn, [{
        key: "render",
        value: function render() {
            return null;
        }
    }]);

    return DataGridColumn;
}(React.Component);

var DataGridToolbarButton = function (_React$Component2) {
    _inherits(DataGridToolbarButton, _React$Component2);

    function DataGridToolbarButton() {
        _classCallCheck(this, DataGridToolbarButton);

        return _possibleConstructorReturn(this, (DataGridToolbarButton.__proto__ || Object.getPrototypeOf(DataGridToolbarButton)).apply(this, arguments));
    }

    _createClass(DataGridToolbarButton, [{
        key: "render",
        value: function render() {
            return React.createElement(Button, { Run: this.props.Run, key: this.props.Id + "Button", Id: this.props.Id, Type: "primary", Class: "btn-toolbar pull-right", Icon: this.props.Icon, Value: this.props.Caption, OnClick: this.props.OnClick.bind(this, this.props.Id) });
        }
    }]);

    return DataGridToolbarButton;
}(React.Component);

var DataGrid = function (_ComponentBase) {
    _inherits(DataGrid, _ComponentBase);

    function DataGrid() {
        _classCallCheck(this, DataGrid);

        return _possibleConstructorReturn(this, (DataGrid.__proto__ || Object.getPrototypeOf(DataGrid)).apply(this, arguments));
    }

    _createClass(DataGrid, [{
        key: "init",
        value: function init(props) {
            this.prepareGrid();
            this.state.value = bb.inu(this.props.Value) ? [] : this.props.Value;
            this.state.selected = null;
            this.state.selectedIndex = -1;
            this.state.rowStyles = {};
            this.state.showPageSizeOptions = bb.inu(this.props.ShowPageSizeOptions) ? false : this.props.ShowPageSizeOptions;
            this.state.pageSizeOptions = bb.inu(this.props.PageSizeOptions) ? [] : this.props.PageSizeOptions;
            this.state.defaultPageSize = bb.inu(this.props.DefaultPageSize) ? undefined : this.props.DefaultPageSize;
            this.state.selectAll = !bb.inu(this.props.SelectAll) ? this.props.SelectAll : false;
            this.state.manual = !bb.inu(this.props.Pages) ? "manual" : undefined;
        }
    }, {
        key: "prepareGrid",
        value: function prepareGrid() {
            var _this4 = this;

            var columns = [];
            var unique = [];
            if (!bb.inu(this.props.children.forEach)) {
                this.props.children.forEach(function (child) {
                    if (child.type.name == "DataGridColumn") {
                        var col = _this4.createCol(child.props);
                        columns.push(col);
                        if (col.unique) {
                            unique.push(col);
                        }
                    }
                });
            } else {
                if (this.props.children.type.name == "DataGridColumn") {
                    var col = this.createCol(this.props.children.props);
                    columns.push(col);
                    if (col.unique) {
                        unique.push(col);
                    }
                }
            }

            this.state.columns = columns;
            this.state.unique = unique;
        }
    }, {
        key: "load",
        value: function load(props) {
            if (!bb.inu(props.OnReady)) {
                props.OnReady(this);
            }
        }
    }, {
        key: "componentDidUpdate",
        value: function componentDidUpdate(prevProps, prevState) {
            if (!bb.inu(this.props.OnUpdated)) {
                this.props.OnUpdated(this);
            }
        }
    }, {
        key: "selected",
        value: function selected() {
            return this.state.selected;
        }
    }, {
        key: "selectedIndex",
        value: function selectedIndex() {
            return this.state.selectedIndex;
        }
    }, {
        key: "select",
        value: function select(rowIndex) {
            if (this.state.value != null && this.state.value.length > rowIndex) {
                var selected = this.state.value[rowIndex];
                if (selected != null) {
                    ReactDOM.findDOMNode(this).querySelectorAll('.rt-tr-group').forEach(function (i, index) {
                        if (index == rowIndex) {
                            i.classList.add('bordered-row');
                        } else {
                            i.classList.remove('bordered-row');
                        }
                    });
                    this.setState({ selected: selected, selectedIndex: rowIndex });
                }
            }
        }
    }, {
        key: "hideButton",
        value: function hideButton(name) {
            if (!bb.inu(this[name])) {
                this[name].hide();
            }
        }
    }, {
        key: "showButton",
        value: function showButton(name) {
            if (!bb.inu(this[name])) {
                this[name].show();
            }
        }
    }, {
        key: "setHeader",
        value: function setHeader(colIndex, value) {
            var columns = this.state.columns;
            var props = this.props.children[colIndex].props;
            columns[colIndex].Header = this.createCell(props, value, true);
            this.setState({ columns: columns });
        }
    }, {
        key: "setRowStyle",
        value: function setRowStyle(index, className) {
            var styles = this.state.rowStyles;
            styles[index] = className;
            this.setState({ rowStyles: styles });
        }
    }, {
        key: "createEditor",
        value: function createEditor(editor, cellInfo) {
            cellInfo.classes.push('editor');
            var render = null;
            var id = "Editor" + cellInfo.column.id + cellInfo.index;
            var value = this.state.value[cellInfo.index][cellInfo.column.id];

            var onChange = function onChange(index, id, props, val) {
                var row = this.state.value[index];
                row[id] = val;
                this.update(row, index);

                if (!bb.inu(props) && bb.isFunction(props.OnChange)) {
                    props.OnChange(val);
                }
            };

            var onClick = function onClick(index, id, props, val) {
                if (!bb.inu(props) && bb.isFunction(props.OnClick)) {
                    props.OnClick(index);
                }
            };

            var onAmountChange = function onAmountChange(index, id, props, val) {
                if (!bb.inu(props) && bb.isFunction(props.OnAmountChange)) {
                    props.OnAmountChange(val, index);
                }
            };

            var onTextBoxAction = function onTextBoxAction(index, id, props, val) {
                if (!bb.inu(props) && bb.isFunction(props.Action)) {
                    props.Action(val, index);
                }
            };

            var editorProps = {};
            if (!bb.inu(editor.Props)) {
                editorProps = bb.clone(editor.Props);
            }

            var key = this.state.value.length - cellInfo.index;
            if (!bb.inu(this.props.AppendToLast) && this.props.AppendToLast === true) {
                key = cellInfo.index;
            }

            var props = null;
            if (editor.Type === Button) {
                props = Object.assign(editorProps, { Run: this, key: key, Id: id, OnChange: onChange.bind(this, cellInfo.index, cellInfo.column.id, editor.Props), OnClick: onClick.bind(this, cellInfo.index, cellInfo.column.id, editor.Props) });
            } else if (editor.Type === CurrencyBox) {
                var currency = bb.inu(editor.Props) ? "" : bb.inu(editor.Props.CurrencyField) ? "" : this.state.value[cellInfo.index][editor.Props.CurrencyField];
                props = Object.assign(editorProps, { Run: this, key: key, Id: id, Value: value, Currency: currency, OnChange: onChange.bind(this, cellInfo.index, cellInfo.column.id, editor.Props), OnAmountChange: onAmountChange.bind(this, cellInfo.index, cellInfo.column.id, editor.Props), OnClick: onClick.bind(this, cellInfo.index, cellInfo.column.id, editor.Props) });
            } else if (editor.Type === TextBox) {
                props = Object.assign(editorProps, { Run: this, key: key, Id: id, Value: value, OnChange: onChange.bind(this, cellInfo.index, cellInfo.column.id, editor.Props), Action: onTextBoxAction.bind(this, cellInfo.index, cellInfo.column.id, editor.Props), OnClick: onClick.bind(this, cellInfo.index, cellInfo.column.id, editor.Props) });
            } else {
                props = Object.assign(editorProps, { Run: this, key: key, Id: id, Value: value, OnChange: onChange.bind(this, cellInfo.index, cellInfo.column.id, editor.Props), OnClick: onClick.bind(this, cellInfo.index, cellInfo.column.id, editor.Props) });
            }

            return React.createElement(editor.Type, props);
        }
    }, {
        key: "createFormatter",
        value: function createFormatter(props, format, cellInfo) {
            var render = null;
            var alignClass = "pull-left";
            var align = props['Align'];
            if (!bb.inu(align)) {
                switch (align) {
                    case 'Right':
                        alignClass = "pull-right";
                        break;
                    case 'Center':
                        alignClass = "text-center";
                        break;
                }
            }

            switch (format) {
                case 'Bool':
                    var icon = "fa-check true-bool-cell";
                    if (!cellInfo.value) {
                        icon = "fa-times false-bool-cell";
                    }
                    render = React.createElement(
                        "div",
                        { className: "text-center" },
                        React.createElement("i", { className: "fa " + icon })
                    );
                    break;
                case 'Progress':

                    cellInfo.value = cellInfo.value > 100 ? 100 : cellInfo.value < 0 ? 0 : cellInfo.value;

                    var barWidth = cellInfo.value + "%";
                    var barColor = cellInfo.value > 66 ? '#85cc00' : cellInfo.value > 33 ? '#ffbf00' : '#ff2e00';

                    var dynamicStyle = { width: barWidth, backgroundColor: barColor };

                    render = React.createElement(
                        "div",
                        { className: "grid-progress-box" },
                        React.createElement("div", { className: "grid-progress-bar", style: dynamicStyle }),
                        React.createElement(
                            "div",
                            { className: "grid-progress-text" },
                            barWidth
                        )
                    );
                    break;
                case 'UpDownLabel':
                    var labelClass = cellInfo.value > 0 ? "label label-primary" : cellInfo.value == 0 ? "label" : "label label-danger";
                    render = React.createElement(
                        "div",
                        { className: "text-center" },
                        React.createElement(
                            "span",
                            { className: labelClass },
                            cellInfo.value
                        )
                    );
                    break;
                case 'Currency':
                    var precision = props['Precision'];
                    render = React.createElement(
                        "div",
                        { className: alignClass + " text-currency" },
                        bb.formatCurrency(bb.toDecimal(cellInfo.value), precision)
                    );
                    break;
                case 'Decimal':
                    render = React.createElement(
                        "div",
                        { className: alignClass + " text-currency" },
                        cellInfo.value.toLocaleString()
                    );
                    break;
                case 'ShortDate':
                    if (cellInfo.value != null && cellInfo.value != "") {
                        var dateParts = cellInfo.value.split(' ');
                        render = React.createElement(
                            "div",
                            { className: alignClass },
                            dateParts[0]
                        );
                    }
                    break;
                case 'CreditDebitLabel':
                    var labelClass = cellInfo.value == 'credit' ? "fa-chevron-up text-success" : "fa-chevron-down text-danger";
                    render = React.createElement("i", { className: "fa " + labelClass, title: bb.localize(cellInfo.value) });
                    break;
            }
            return render;
        }
    }, {
        key: "createCell",
        value: function createCell(props, value, isHeader) {
            var alignClass = "pull-left";
            var align = props['Align'];
            if (!bb.inu(align)) {
                switch (align) {
                    case 'Right':
                        alignClass = "pull-right";
                        break;
                    case 'Center':
                        alignClass = "text-center";
                        break;
                }
            }
            if (isHeader) {
                alignClass += " strong";
            }

            var localizedValue = bb.localize('Grid.' + value);
            if (localizedValue == 'Grid.' + value) {
                localizedValue = value;
            }

            return React.createElement(
                "span",
                { className: alignClass },
                localizedValue
            );
        }
    }, {
        key: "toggleSelectAll",
        value: function toggleSelectAll(column) {
            var newSelectedList = [];

            if (this.state.selectAll === false) {
                this.state.value.forEach(function (x, index) {
                    x[column] = true;
                    newSelectedList.push(x);
                });
            } else {
                this.state.value.forEach(function (x, index) {
                    x[column] = false;
                    newSelectedList.push(x);
                });
            }

            this.setState({
                selectAll: this.state.selectAll === false ? true : false,
                value: newSelectedList
            });
            if (!bb.inu(this.props.OnChangeSelect)) {
                this.props.OnChangeSelect(!this.state.selectAll);
            }
        }
    }, {
        key: "createCol",
        value: function createCol(props, reRender) {
            var _this5 = this;

            var column = {};

            column.accessor = props['Name'];
            column.Header = this.createCell(props, bb.localize(props['Caption']), true);
            column.HeaderText = bb.localize(props['Caption']);
            column.width = props['Width'];
            column.unique = props['Unique'];
            if (!bb.inu(props['Editor']) && props.Editor.Type.name == CheckBox.name && props["SelectAll"] !== false) {
                column.Header = function (x) {
                    return React.createElement(CheckBox, {
                        Id: "SelectAllCheck",
                        Class: "data-grid-select",
                        Value: _this5.state.selectAll === true,
                        ref: function ref(input) {
                            if (input) {
                                input.indeterminate = _this5.state.selectAll === 2;
                            }
                        },
                        OnChange: function OnChange() {
                            return _this5.toggleSelectAll(column.accessor);
                        }
                    });
                };
                column.sortable = false;
                column.width = 40;
            }

            if (!bb.inu(props['Editor'])) {
                column.Cell = this.createEditor.bind(this, props['Editor']);
                column.IsEditor = true;
            } else if (!bb.inu(props['Formatter'])) {
                column.Cell = this.createFormatter.bind(this, props, props['Formatter']);
            } else {
                column.Cell = function (row) {
                    return _this5.createCell(props, row.value);
                };
            }

            return column;
        }
    }, {
        key: "updateColumnValue",
        value: function updateColumnValue(rowIndex, colName, value, data) {
            var colDef = this.state.columns.find(function (column) {
                return column.accessor == colName;
            });

            if (colDef.IsEditor === true && !bb.inu(value)) {
                var id = "Editor" + colName + rowIndex;
                var col = this[id];
                if (bb.inu(data)) {
                    col.val(value);
                    //col.setState({ value: value });
                } else {
                    col.setState({ data: data }, function () {
                        this.val(value);
                    });
                }
            }
        }
    }, {
        key: "getEditor",
        value: function getEditor(rowIndex, colName) {
            var colDef = this.state.columns.find(function (column) {
                return column.accessor == colName;
            });
            if (colDef.IsEditor === true) {
                var id = "Editor" + colName + rowIndex;
                var col = this[id];
                return col;
            }
            return null;
        }
    }, {
        key: "createToolbar",
        value: function createToolbar() {
            var _this6 = this;

            var buttons = [];
            var icons = { Add: 'plus', Update: 'edit', Remove: 'trash', Clear: 'refresh', Excel: 'table', List: 'list', DownloadCSV: 'download', Cancel: 'times', Done: 'check', Copy: 'copy' };

            if (!bb.inu(this.props.Buttons)) {
                this.props.Buttons.split(',').reverse().forEach(function (name) {
                    if (_this6.state.selectedIndex != -1 && (name == "Update" || name == "Remove")) {
                        buttons.push(React.createElement(DataGridToolbarButton, { Run: _this6, key: name, Id: name, Caption: name, Icon: icons[name], OnClick: _this6.onToolbarAction.bind(_this6) }));
                    } else if (name != "Update" && name != "Remove") {
                        buttons.push(React.createElement(DataGridToolbarButton, { Run: _this6, key: name, Id: name, Caption: name, Icon: icons[name], OnClick: _this6.onToolbarAction.bind(_this6) }));
                    }
                });
            }

            return buttons;
        }
    }, {
        key: "createRowComponent",
        value: function createRowComponent(row) {
            var content = null;
            if (bb.isFunction(this.props.RowContent)) {
                content = React.createElement(
                    "div",
                    { className: "p-sm m-xs data-table-row-content" },
                    this.props.RowContent(row.original, row.index)
                );
            }

            return content;
        }
    }, {
        key: "onToolbarAction",
        value: function onToolbarAction(button) {

            if (bb.isFunction(this.props["On" + button])) {
                this.props["On" + button](this.state.selected, this.state.selectedIndex);
            }

            if (button == "Clear") {
                var rows = this.state.value;
                rows.forEach(function (row) {
                    row.RecordStatus = "None";
                });
                this.setState({ value: rows, selected: null, selectedIndex: -1 });
            }
            if (button == "Copy") {
                var rows = this.state.value;
                var table = document.createElement("table");
                var header = document.createElement("tr");
                var columns = this.state.columns;
                for (var i = 0; i < columns.length; i++) {
                    var text = columns[i].HeaderText;
                    var col = document.createElement('td');
                    col.innerText = text;
                    header.appendChild(col);
                }
                table.appendChild(header);

                for (var d = 0; d < rows.length; d++) {
                    var data = rows[d];
                    var row = document.createElement("tr");
                    for (var i = 0; i < columns.length; i++) {
                        var text = data[columns[i].accessor];
                        var col = document.createElement('td');
                        col.innerText = text;
                        row.appendChild(col);
                    }
                    table.appendChild(row);
                }

                this.copyTextToClipboard(table.outerHTML);
            }
        }
    }, {
        key: "fallbackCopyTextToClipboard",
        value: function fallbackCopyTextToClipboard(text) {
            var textArea = document.createElement("textarea");
            textArea.value = text;
            document.body.appendChild(textArea);
            textArea.focus();
            textArea.select();

            try {
                var successful = document.execCommand('copy');
                var msg = successful ? 'successful' : 'unsuccessful';
            } catch (err) {
                console.error('Fallback: Oops, unable to copy', err);
            }

            document.body.removeChild(textArea);
        }
    }, {
        key: "copyTextToClipboard",
        value: function copyTextToClipboard(text) {
            if (!navigator.clipboard) {
                fallbackCopyTextToClipboard(text);
                return;
            }
            navigator.clipboard.writeText(text).then(function () {
                console.log('Async: Copying to clipboard was successful!');
            }, function (err) {
                console.error('Async: Could not copy text: ', err);
            });
        }
    }, {
        key: "onRowSelect",
        value: function onRowSelect(row, index) {
            this.setState({ selected: row, selectedIndex: index });

            if (bb.isFunction(this.props.OnRowSelect)) {
                this.props.OnRowSelect(row, index);
            }
        }
    }, {
        key: "checkDublicate",
        value: function checkDublicate(row) {
            var rows = this.state.value;
            var filter = this.state.unique;
            var finded = [];
            if (filter.length > 0) {
                finded = rows.filter(function (item) {
                    for (var i = 0; i < filter.length; i++) {
                        var unique = filter[i];
                        if (item[unique.accessor] === undefined || item[unique.accessor] != row[unique.accessor]) {
                            return false;
                        }
                    }
                    return true;
                });
            }

            return finded.length == 0;
        }
    }, {
        key: "add",
        value: function add(row, toLast, callback) {
            //toLast deprecated please use AppendToLast on component props.
            if (this.checkDublicate(row)) {
                this.error();
                var rows = [].concat(_toConsumableArray(this.state.value));
                row.RecordStatus = "New";
                if (this.props.AppendToLast === true) {
                    rows.push(row);
                } else {
                    rows.unshift(row);
                }
                this.setState({ value: rows }, callback);
                return true;
            } else {
                this.error("uniquedatarowaddatattempt");
                return false;
            }
        }
    }, {
        key: "addRange",
        value: function addRange(rows, callback) {
            var _this7 = this;

            rows.forEach(function (row) {
                if (_this7.checkDublicate(row) == false) {
                    _this7.error("uniquedatarowaddatattempt");
                    return false;
                }
            });

            var gridRows = [].concat(_toConsumableArray(this.state.value));
            rows.forEach(function (row) {
                row.RecordStatus = "New";
                if (_this7.props.AppendToLast === true) {
                    gridRows.push(row);
                } else {
                    gridRows.unshift(row);
                }
            });

            this.setState({ value: gridRows }, callback);
            return true;
        }
    }, {
        key: "update",
        value: function update(row, index, callback) {
            var expanded = _extends({}, this.refs.reacttable.state.expanded);
            var rows = [].concat(_toConsumableArray(this.state.value));
            var current = rows[index];
            if (bb.inu(current["RecordStatus"]) || current.RecordStatus != "New") {
                row.RecordStatus = "Updated";
            } else {
                row.RecordStatus = current.RecordStatus;
            }
            rows[index] = row;
            this.setState({ value: rows }, function () {
                if (bb.isFunction(callback)) {
                    callback();
                }
                this.refs.reacttable.setState({ expanded: expanded });
            });
        }
    }, {
        key: "remove",
        value: function remove(index, callback) {
            var rows = [].concat(_toConsumableArray(this.state.value));
            var row = rows[index];
            if (bb.inu(row["RecordStatus"]) || row.RecordStatus != "New") {
                row.RecordStatus = "Deleted";
            } else {
                rows.splice(index, 1);
            }
            this.setState({ value: rows }, callback);
        }
    }, {
        key: "clear",
        value: function clear(callback) {
            var options = this.state.options;
            options.Errors = [];
            this.setState({ value: [], options: options, selected: null, selectedIndex: -1 }, callback);
        }
    }, {
        key: "onPageChange",
        value: function onPageChange(pageIndex) {
            if (!bb.inu(this.props.OnPageChange)) {
                this.props.OnPageChange(pageIndex);
            }
        }
    }, {
        key: "paginationFetch",
        value: function paginationFetch(state, instance) {
            var view = this.getView();
            var id = this.state.options.Id;
            if (!bb.inu(this.props.OnPaginationFetch) && !bb.inu(view[id])) {
                this.props.OnPaginationFetch(state.page, state.pageSize);
            }
        }
    }, {
        key: "expandRowContent",
        value: function expandRowContent(index) {
            if (index >= 0) {
                var expanded = _extends({}, this.refs.reacttable.state.expanded);
                expanded[index] = {};
                this.refs.reacttable.setState({ expanded: expanded });
            } else {
                this.refs.reacttable.setState({ expanded: {} });
            }
        }
    }, {
        key: "render",
        value: function render() {
            var _this8 = this;

            var self = this;
            var rowContent = null;
            if (bb.isFunction(this.props.RowContent)) {
                rowContent = this.createRowComponent.bind(this);
            }

            var pageSize = bb.inu(this.props.PageSize) ? 10 : this.props.PageSize;
            var height = bb.inu(this.props.Height) ? "" : this.props.Height + "px";

            if (!bb.inu(this.props.ShowPagination) && !this.props.ShowPagination) {
                pageSize = this.state.value.length;
                if (pageSize < 6) {
                    height = null;
                }
            }

            var label = null;
            if (!bb.inu(this.props.Caption) && this.props.Caption != "") {
                label = React.createElement(
                    "h4",
                    null,
                    bb.localize(this.props.Caption)
                );
            }

            var toolbar = null;
            if (!bb.inu(label) || !bb.inu(this.props.Buttons)) {
                toolbar = React.createElement(
                    "div",
                    { className: "data-table-toolbar" },
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: 12, CssClass: "m-b-sm" },
                            React.createElement(
                                "div",
                                { className: "pull-left" },
                                label
                            ),
                            React.createElement(
                                "div",
                                { className: "pull-right" },
                                this.createToolbar()
                            ),
                            React.createElement("div", { className: "clearfix" })
                        )
                    )
                );
            }
            var pages = undefined;
            if (!bb.inu(this.props.Pages)) {
                pages = this.props.Pages;
            }
            var page = undefined;
            if (!bb.inu(this.props.Page)) {
                page = this.props.Page;
            }

            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    "div",
                    { className: "data-table" },
                    toolbar,
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: 12 },
                            React.createElement(ReactTable, {
                                manual: this.state.manual,
                                data: this.state.value,
                                columns: this.state.columns,
                                pageSize: this.state.showPageSizeOptions ? undefined : pageSize,
                                style: { height: height },
                                className: "-striped -highlight",
                                getTdProps: function getTdProps(state, rowInfo, column, instance) {
                                    return {
                                        onClick: function onClick(e, handleOriginal) {
                                            if (!bb.inu(rowInfo)) {
                                                _this8.onRowSelect.call(_this8, rowInfo.original, rowInfo.index);
                                            }
                                            ReactDOM.findDOMNode(_this8).querySelectorAll('.bordered-row').forEach(function (i) {
                                                i.classList.remove('bordered-row');
                                            });
                                            if (e.target.closest('.rt-tr-group') != null) {
                                                e.target.closest('.rt-tr-group').classList.add('bordered-row');
                                            }

                                            if (handleOriginal) {
                                                handleOriginal();
                                            }
                                        }
                                    };
                                },
                                getTrProps: function getTrProps(state, rowInfo, column) {
                                    var props = { style: {} };
                                    if (!bb.inu(rowInfo)) {
                                        if (rowInfo.index == _this8.state.selectedIndex) {
                                            props.style.background = "#dbecfa";
                                        }

                                        switch (rowInfo.original.RecordStatus) {
                                            case 'New':
                                                props.style.background = "#dff0d8";
                                                break;
                                            case 'Updated':
                                                props.style.background = "#fcf8e3";
                                                break;
                                            case 'Deleted':
                                                props.style.background = "#f2dede";
                                                break;
                                        }

                                        var rowStyle = _this8.state.rowStyles[rowInfo.index];
                                        if (!bb.inu(rowStyle)) {
                                            props.className = rowStyle;
                                        }
                                    }

                                    return props;
                                },
                                pages: pages,
                                page: page,
                                SubComponent: rowContent,
                                onFetchData: this.paginationFetch.bind(this),
                                onPageChange: this.onPageChange.bind(this),
                                showPageSizeOptions: this.state.showPageSizeOptions,
                                pageSizeOptions: this.state.pageSizeOptions,
                                showPagination: bb.inu(this.props.ShowPagination) ? true : this.props.ShowPagination,
                                defaultPageSize: this.state.defaultPageSize,
                                previousText: bb.localize('Previous'),
                                nextText: bb.localize('Next'),
                                loadingText: bb.localize('loading'),
                                noDataText: bb.inu(this.props.NoRowsFoundText) ? bb.localize('norowsfound') : bb.localize(this.props.NoRowsFoundText),
                                pageText: bb.localize('Page'),
                                ofText: "",
                                rowsText: bb.localize('Rows'),
                                ref: "reacttable"
                            })
                        )
                    )
                )
            );
        }
    }]);

    return DataGrid;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DatePicker = function (_ComponentBase) {
    _inherits(DatePicker, _ComponentBase);

    function DatePicker() {
        _classCallCheck(this, DatePicker);

        return _possibleConstructorReturn(this, (DatePicker.__proto__ || Object.getPrototypeOf(DatePicker)).apply(this, arguments));
    }

    _createClass(DatePicker, [{
        key: "init",
        value: function init(props, options) {
            var pattern = "L";
            if (!bb.inu(this.props.HasTime) && this.props.HasTime) {
                pattern += " LT";
            }
            if (!bb.inu(this.props.HasSecond) && this.props.HasSecond) {
                pattern += " LTS";
            }

            this.state.value = !bb.inu(this.props.Value) ? moment(this.props.Value, "DD/MM/YYYY").format(pattern) : moment(new Date()).format(pattern);
            this.state.onlyFuture = bb.inu(this.props.OnlyFuture) ? false : true;
            this.state.onlyPast = bb.inu(this.props.OnlyPast) ? false : true;
            this.state.validateBirthDay = bb.inu(this.props.ValidateBirthDay) ? false : true;
            this.state.disabledWeekend = bb.inu(this.props.DisabledWeekend) ? false : true;
            this.state.placeHolder = !bb.inu(this.props.Placeholder) ? this.props.Placeholder : null;
            options.Class = "date-picker";
        }
    }, {
        key: "onKeyDown",
        value: function onKeyDown(e) {
            if (e.keyCode !== 8 && e.target.value.length >= 10) {
                e.stopPropagation();
                e.preventDefault();
            }
        }
    }, {
        key: "change",
        value: function change(date) {
            if (!bb.inu(date.format)) {
                this.error("");
                var pattern = "L";
                if (!bb.inu(this.props.HasTime) && this.props.HasTime) {
                    pattern += " LT";
                }
                if (!bb.inu(this.props.HasSecond) && this.props.HasSecond) {
                    pattern += " LTS";
                }
                var format = date.format(pattern);
                this.setState({ value: format }, function () {
                    this.state.options.Change(null, format);
                }.bind(this));
            } else if (date.length == 10) {
                this.error("InvalidDate");
            } else {
                this.error("");
                this.setState({ value: VMasker.toPattern(date, "99/99/9999") });
            }
        }
    }, {
        key: "valid",
        value: function valid(current) {
            if (this.state.onlyFuture) {
                if (!bb.inu(this.props.ValidDate)) {
                    var validDate = moment(this.props.ValidDate).subtract(1, 'day');
                    if (this.state.disabledWeekend) {
                        return current.isAfter(validDate) && current.day() != 0 && current.day() != 6;
                    } else {
                        return current.isAfter(validDate);
                    }
                } else {
                    var yesterday = Datetime.moment().subtract(1, 'day');
                    if (this.state.disabledWeekend) {
                        return current.isAfter(yesterday) && current.day() != 0 && current.day() != 6;
                    } else {
                        return current.isAfter(yesterday);
                    }
                }
            } else if (this.state.validateBirthDay) {
                var yesterday = Datetime.moment().subtract(18, 'year');
                return current.isBefore(yesterday);
            } else if (this.state.disabledWeekend) {
                return current.day() != 0 && current.day() != 6;
            } else if (this.state.onlyPast) {
                var yesterday = Datetime.moment().subtract(1, 'day');
                if (this.state.disabledWeekend) {
                    return current.isBefore(yesterday) && current.day() != 0 && current.day() != 6;
                } else {
                    return current.isBefore(yesterday);
                }
            }
            return true;
        }
    }, {
        key: "onClick",
        value: function onClick() {
            if (this.refs.input.state.open) {
                this.refs.input.closeCalendar();
            } else {
                this.refs.input.openCalendar();
            }
        }
    }, {
        key: "render",
        value: function render() {
            var timeFormat = false;
            if (!bb.inu(this.props.HasTime) && this.props.HasTime) {
                timeFormat = true;
            }

            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    Label,
                    null,
                    this.props.Caption
                ),
                React.createElement(
                    "div",
                    { className: "input-group" },
                    React.createElement(Datetime, {
                        ref: "input",
                        value: this.state.value,
                        onChange: this.change.bind(this),
                        closeOnSelect: true,
                        timeFormat: timeFormat,
                        dateFormat: "L",
                        isValidDate: this.valid.bind(this),
                        inputProps: {
                            readOnly: this.state.options.Disabled,
                            disabled: this.state.options.Disabled,
                            onKeyDown: this.onKeyDown.bind(this),
                            placeholder: this.state.placeHolder
                        }
                    }),
                    React.createElement(
                        "span",
                        { className: "input-group-btn" },
                        React.createElement(
                            "button",
                            { className: "btn btn-default textbox-action-button", type: "button", onClick: this.onClick.bind(this) },
                            React.createElement("i", { className: "fa fa-calendar" })
                        )
                    ),
                    React.createElement("span", { className: "help-block m-b-none", dangerouslySetInnerHTML: { __html: this.props.HelpText } }),
                    React.createElement("span", { className: "text-danger", dangerouslySetInnerHTML: { __html: this.state.error } })
                )
            );
        }
    }]);

    return DatePicker;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Dropdown = function (_ComponentBase) {
    _inherits(Dropdown, _ComponentBase);

    function Dropdown() {
        _classCallCheck(this, Dropdown);

        return _possibleConstructorReturn(this, (Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).apply(this, arguments));
    }

    _createClass(Dropdown, [{
        key: "init",
        value: function init(props, options) {
            this.cssClass = [];
            this.state.data = bb.inu(this.props.Data) ? [] : this.props.Data;
            this.state.selected = null;
            this.state.keyField = bb.inu(this.props.KeyField) ? "Code" : this.props.KeyField;
            this.state.valueField = bb.inu(this.props.ValueField) ? "Value" : this.props.ValueField;
            this.state.size = bb.inu(this.props.Size) ? 0 : this.props.Size;
            this.state.isOpen = false;

            if (!bb.inu(this.props.NoSelect) && this.props.NoSelect && !bb.inu(this.state.data) && this.state.data.length > 0) {
                this.state.value = this.state.data[0][this.state.valueField];
                this.state.selected = this.state.data[0];
            }
        }
    }, {
        key: "change",
        value: function change(value) {
            var selected = bb.getFromArray(this.state.data, value, this.state.valueField);
            this.setState({ selected: selected, isOpen: false }, function () {
                this.state.options.Change(null, value);
            }.bind(this));
        }
    }, {
        key: "selected",
        value: function selected() {
            return this.state.selected;
        }
    }, {
        key: "openDropdown",
        value: function openDropdown() {
            this.setState({ isOpen: !this.state.isOpen });
        }
    }, {
        key: "load",
        value: function load() {
            var self = this;
            document.addEventListener("mouseup", function (e) {
                var container = document.getElementById(self.state.options.Id + "_Wrapper");
                if (container && !container.contains(e.target) && self.state.isOpen) {
                    self.setState({ isOpen: false });
                }
            });
        }
    }, {
        key: "val",
        value: function val(value, callback) {
            if (bb.inu(value)) {
                return this.state.value;
            } else {
                var selected = bb.getFromArray(this.state.data, value, this.state.valueField);
                this.setState({ value: value, selected: selected, isOpen: false }, function () {
                    if (bb.isFunction(callback)) {
                        callback();
                    }
                }.bind(this));
            }
        }
    }, {
        key: "render",
        value: function render() {
            var options = [];
            var openCssClass = "";
            var openSpanCssClass = "caret";
            if (this.state.isOpen) {
                openCssClass = " show";
                openSpanCssClass = "caret";
            }

            if (this.props.NoSelect !== true) {
                options.push(React.createElement(
                    "li",
                    { key: "select" },
                    React.createElement(
                        "a",
                        { className: "dropdown-item", onClick: this.change.bind(this, '') },
                        bb.localize('select')
                    )
                ));
            }

            for (var i = 0; i < this.state.data.length; i++) {
                var opt = this.state.data[i];
                var pre = bb.isFunction(this.props.Prefix) ? this.props.Prefix(opt) : null;
                var suffix = bb.isFunction(this.props.Suffix) ? this.props.Suffix(opt) : null;
                options.push(React.createElement(
                    "li",
                    { key: opt[this.state.valueField] },
                    React.createElement(
                        "a",
                        { className: "dropdown-item", onClick: this.change.bind(this, opt[this.state.valueField]) },
                        pre,
                        " ",
                        opt[this.state.keyField],
                        " ",
                        suffix
                    )
                ));
            }

            var valueText = this.state.selected == null ? bb.localize('select') : this.state.selected[this.state.keyField];
            var selection = React.createElement(
                "ul",
                { className: "dropdown-menu" + openCssClass },
                options
            );

            var prefix = null;
            if (bb.isFunction(this.props.Prefix)) {
                prefix = this.props.Prefix(this.state.selected);
            }
            var suffix = null;
            if (bb.isFunction(this.props.Suffix)) {
                suffix = this.props.Suffix(this.state.selected);
            }

            var buttonClass = "btn dropdown-toggle btn-" + (bb.inu(this.props.Type) ? "default" : this.props.Type);

            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    "div",
                    { className: "form-group" },
                    React.createElement(
                        Label,
                        null,
                        this.props.Caption
                    ),
                    React.createElement(
                        "div",
                        { className: "dropdown" + openCssClass },
                        React.createElement(
                            "a",
                            { className: buttonClass, onClick: this.openDropdown.bind(this) },
                            prefix,
                            " ",
                            valueText,
                            " ",
                            suffix,
                            this.state.options.Disabled ? null : React.createElement("span", { className: openSpanCssClass, style: { marginLeft: 5 } })
                        ),
                        selection
                    )
                )
            );
        }
    }]);

    return Dropdown;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var EmailForm = function (_ComponentBase) {
    _inherits(EmailForm, _ComponentBase);

    function EmailForm() {
        _classCallCheck(this, EmailForm);

        return _possibleConstructorReturn(this, (EmailForm.__proto__ || Object.getPrototypeOf(EmailForm)).apply(this, arguments));
    }

    _createClass(EmailForm, [{
        key: "init",
        value: function init() {
            this.view = this.getView();
        }
    }, {
        key: "clear",
        value: function clear() {
            this.Id.clear();
            this.EmailType.clear();
            this.EmailAddress.clear();

            if (this.props.RenderOptional === true) {
                this.ActivePassive.clear();
                this.IsDefault.clear();
            }
        }
    }, {
        key: "val",
        value: function val(value) {
            if (bb.inu(value)) {
                var val = {};
                val.Id = this.Id.val();
                val.EmailType = this.EmailType.val();
                val.EmailAddress = this.EmailAddress.val();
                if (this.props.RenderOptional === true) {
                    val.ActivePassive = this.ActivePassive.val();
                    val.IsDefault = this.IsDefault.val();
                }

                return val;
            } else {
                this.Id.val(value.Id);
                this.EmailType.val(value.EmailType);
                this.EmailAddress.val(value.EmailAddress);

                if (this.props.RenderOptional === true) {
                    this.ActivePassive.val(value.ActivePassive);
                    this.IsDefault.val(value.IsDefault);
                }
            }
        }
    }, {
        key: "renderOptionals",
        value: function renderOptionals() {
            if (!this.props.RenderOptional === true) {
                return null;
            }

            return React.createElement(
                Row,
                null,
                React.createElement(
                    Col,
                    { Md: 4 },
                    React.createElement(ComboBox, { Run: this, Id: "ActivePassive", Caption: "ActivePassive", Data: this.view.parameters('ActivePassive'), KeyField: "Name", ValueField: "Value", NoSelect: true, Value: "Active" })
                ),
                React.createElement(
                    Col,
                    { Md: 4 },
                    React.createElement(CheckBox, { Run: this, Id: "IsDefault", Caption: "isDefault", Class: "without-caption" })
                ),
                React.createElement(Col, { Md: 4 })
            );
        }
    }, {
        key: "render",
        value: function render() {
            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(TextBox, { Run: this, Id: "Id", Hidden: true }),
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: 4 },
                        React.createElement(ComboBox, { Run: this, Id: "EmailType", Caption: "EmailType", Data: this.view.parameters('EmailType'), KeyField: "Definition", ValueField: "Value" })
                    ),
                    React.createElement(
                        Col,
                        { Md: 8 },
                        React.createElement(TextBox, { Run: this, Id: "EmailAddress", Caption: "EmailAddress" })
                    )
                ),
                this.renderOptionals()
            );
        }
    }]);

    return EmailForm;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FieldCondition = function (_React$Component) {
    _inherits(FieldCondition, _React$Component);

    function FieldCondition(props) {
        _classCallCheck(this, FieldCondition);

        var _this = _possibleConstructorReturn(this, (FieldCondition.__proto__ || Object.getPrototypeOf(FieldCondition)).call(this, props));

        page.addElement(_this);
        _this.state = { Fields: _this.props.Fields, Operators: _this.props.Fields[0].Operators, Values: [] };
        _this.logicalOperators = [{ Code: "And", Value: "&&" }, { Code: "Or", Value: "||" }];
        return _this;
    }

    _createClass(FieldCondition, [{
        key: "fieldChanged",
        value: function fieldChanged(value) {
            var selected = bb.getFromArray(this.state.Fields, value, "Name");
            page.state.content["Operator" + this.props.Id].setState({ options: selected.Operators });
            /*page.state.content["Value" + this.props.Id].setState({ data: selected.Values });*/
        }
    }, {
        key: "operatorChanged",
        value: function operatorChanged(value) {}
    }, {
        key: "deleteCondition",
        value: function deleteCondition(index) {
            if (!bb.inu(this.props.OnDelete)) {
                this.props.OnDelete(this.props.Group, this.props.Index);
            }
        }
    }, {
        key: "render",
        value: function render() {
            var logicalOperator = null;
            var buttonClass = "m-t-md";
            if (!this.props.IsFirst) {
                logicalOperator = React.createElement(ComboBox, { Id: "LogicalOperator" + this.props.Id, Caption: this.props.LogicalOperatorCaption, Options: this.logicalOperators });
                buttonClass = "";
            }
            return React.createElement(
                Row,
                null,
                React.createElement(
                    Col,
                    { Md: 2 },
                    logicalOperator
                ),
                React.createElement(
                    Col,
                    { Md: 4 },
                    React.createElement(ComboBox, { Id: "Field" + this.props.Id, Caption: this.props.FieldCaption, Options: this.state.Fields, KeyField: "Name", ValueField: "Name", OnChange: this.fieldChanged.bind(this) })
                ),
                React.createElement(
                    Col,
                    { Md: 2 },
                    React.createElement(ComboBox, { Id: "Operator" + this.props.Id, Caption: this.props.OperatorCaption, Options: this.state.Operators, OnChange: this.operatorChanged.bind(this) })
                ),
                React.createElement(
                    Col,
                    { Md: 2 },
                    React.createElement(TextBox, { Id: "Value" + this.props.Id, Caption: this.props.ValueCaption })
                ),
                React.createElement(
                    Col,
                    { Md: 2 },
                    React.createElement(Button, { Id: "DeleteButton" + this.props.Id, Type: "danger", Icon: "times", CssClass: buttonClass, OnClick: this.deleteCondition.bind(this, this.props.Id) })
                )
            );
        }
    }]);

    return FieldCondition;
}(React.Component);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FileUpload = function (_ComponentBase) {
    _inherits(FileUpload, _ComponentBase);

    function FileUpload() {
        _classCallCheck(this, FileUpload);

        return _possibleConstructorReturn(this, (FileUpload.__proto__ || Object.getPrototypeOf(FileUpload)).apply(this, arguments));
    }

    _createClass(FileUpload, [{
        key: "init",
        value: function init(props) {
            this.state.name = null;
            this.state.value = null;
            this.state.selectedFile = bb.inu(this.props.selectedFile) ? "" : this.props.selectedFile;
            this.state.uploadFolder = bb.inu(this.props.UploadFolder) ? "files" : this.props.UploadFolder;
            this.state.autoUpload = bb.inu(this.props.AutoUpload) ? false : this.props.AutoUpload;
            this.state.fileserver = bb.inu(this.props.SaveToFileServer) ? "" : "fileserver";

            this.state.acceptType = "";
            if (!bb.inu(this.props.AcceptType)) {
                switch (this.props.AcceptType) {
                    case "Image":
                        this.state.acceptType = "image/*";
                        break;
                    case "Excel":
                        this.state.acceptType = ".xls,.xlsx";
                }
            }
        }
    }, {
        key: "uploadFile",
        value: function uploadFile() {
            var files = document.getElementById(this.props.Id + '_input').files;
            var data = new FormData();
            for (var i = 0; i < files.length; i++) {
                if (this.state.fileserver === "fileserver") {
                    data.append(files[i].name, files[i], "fileserver");
                } else {
                    data.append(files[i].name, files[i], this.state.uploadFolder);
                }
            }

            var view = this.getView();
            view.upload(data, function (data) {
                this.uploadSuccess(data);
            }.bind(this), function (msg) {
                this.uploadError(msg);
            }.bind(this), bb.getStore("AccessToken"));
        }
    }, {
        key: "uploadSuccess",
        value: function uploadSuccess(response) {
            var _this2 = this;

            if (!bb.inu(response.Result)) {
                this.setState({ value: response.Result.Path, name: response.Result.Name, webPath: response.Result.WebPath }, function () {
                    _this2.state.options.Change(null, _this2.state.value);
                });
                if (!bb.inu(this.props.Success)) {
                    this.props.Success(response.Result);
                    this.successMessage();
                } else {
                    var view = this.getView();
                    view.success(response.Message);
                    this.successMessage();
                }
            } else {
                this.uploadError(response.responseMessage);
            }
        }
    }, {
        key: "uploadError",
        value: function uploadError(error) {
            this.removeFile();
            if (!bb.inu(this.props.Error)) {
                this.props.Error(error);
                this.errorMessage();
            } else {
                this.errorMessage();
            }
        }
    }, {
        key: "successMessage",
        value: function successMessage() {
            var fileAlert = this.refs.fileSuccessAlert;
            fileAlert.innerHTML = bb.localize("fileuploadedsuccessfully");
            setTimeout(function () {
                fileAlert.innerHTML = "";
            }, 2000);
        }
    }, {
        key: "errorMessage",
        value: function errorMessage() {
            var fileAlert = this.refs.fileErrorAlert;
            fileAlert.innerHTML = bb.localize("fileuploadfailed");
            setTimeout(function () {
                fileAlert.innerHTML = "";
            }, 2000);
        }
    }, {
        key: "removeFile",
        value: function removeFile() {
            this.setState({ selectedFile: "", value: null, name: null, webPath: null });
            document.getElementById(this.props.Id + '_input').value = "";

            if (!bb.inu(this.props.OnRemove) && typeof this.props.OnRemove === 'function') {
                this.props.OnRemove();
            }
        }
    }, {
        key: "fileSelectionChange",
        value: function fileSelectionChange(e) {
            var _this3 = this;

            this.error();
            var fileName = "";
            if (!bb.inu(e) && !bb.inu(e.target) && !bb.inu(e.target.files) && e.target.files.length > 0) {
                fileName = e.target.files[0].name;
            }
            this.setState({ selectedFile: fileName, value: null, name: null, webPath: null }, function () {
                if (_this3.state.autoUpload) _this3.uploadFile();
            });
        }
    }, {
        key: "render",
        value: function render() {
            var removeCss = "input-group-addon btn btn-default file-btn-responsive";
            var uploadCss = "input-group-addon btn btn-default file-btn-responsive";
            if (bb.inu(this.state.selectedFile) || this.state.selectedFile == "") {
                removeCss += " hidden";
                uploadCss += " hidden";
            } else if (this.state.autoUpload) {
                uploadCss += " hidden";
            }

            var fileInput = React.createElement("input", { type: "file", id: this.props.Id + '_input', onChange: this.fileSelectionChange.bind(this), accept: this.state.acceptType });
            var label = null;
            if (!bb.inu(this.props.Caption)) {
                label = React.createElement(
                    "label",
                    { className: "control-label" },
                    bb.localize(this.props.Caption)
                );
            }

            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                label,
                React.createElement(
                    "div",
                    { className: "fileinput fileinput-new input-group file-input-group-responsive" },
                    React.createElement(
                        "div",
                        { className: "form-control" },
                        React.createElement(
                            "div",
                            null,
                            React.createElement("i", { className: "fa fa-upload" }),
                            React.createElement(
                                "span",
                                { className: "fileinput-filename" },
                                this.state.selectedFile
                            )
                        ),
                        React.createElement("div", { ref: "fileSuccessAlert", className: "file-alert alert alert-success animated fadeInDown ibox-shadow" }),
                        React.createElement("div", { ref: "fileErrorAlert", className: "file-alert alert alert-danger animated fadeInDown ibox-shadow" })
                    ),
                    React.createElement(
                        "span",
                        { className: "input-group-addon btn btn-default btn-file file-btn-responsive" },
                        React.createElement(
                            "span",
                            null,
                            bb.localize('SelectFile')
                        ),
                        fileInput
                    ),
                    React.createElement(
                        "a",
                        { className: removeCss, onClick: this.removeFile.bind(this) },
                        bb.localize('Remove')
                    ),
                    React.createElement(
                        "a",
                        { className: uploadCss, onClick: this.uploadFile.bind(this) },
                        bb.localize('Upload')
                    )
                )
            );
        }
    }]);

    return FileUpload;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ImageUpload = function (_ComponentBase) {
    _inherits(ImageUpload, _ComponentBase);

    function ImageUpload() {
        _classCallCheck(this, ImageUpload);

        return _possibleConstructorReturn(this, (ImageUpload.__proto__ || Object.getPrototypeOf(ImageUpload)).apply(this, arguments));
    }

    _createClass(ImageUpload, [{
        key: "init",
        value: function init() {
            this.state.value = bb.inu(this.props.Images) ? [] : this.props.Images;
            this.state.max = bb.inu(this.props.Max) ? 9999 : this.props.Max;
            this.state.uploadFolder = bb.inu(this.props.UploadFolder) ? "files" : this.props.UploadFolder;
            this.state.fileserver = bb.inu(this.props.SaveToFileServer) ? "" : "fileserver";

            this.state.width = "150px";
            this.state.height = "150px";

            if (!bb.inu(this.props.Width)) {
                this.state.width = this.props.Width + "px";
            }

            if (!bb.inu(this.props.Height)) {
                this.state.height = this.props.Height + "px";
            }
        }
    }, {
        key: "load",
        value: function load() {}
    }, {
        key: "clear",
        value: function clear(callback) {
            var options = this.state.options;
            options.Errors = [];
            this.setState({ value: [], options: options }, callback);
        }
    }, {
        key: "addImage",
        value: function addImage() {
            this.refs.input.click();
        }
    }, {
        key: "fileSelectionChange",
        value: function fileSelectionChange(e) {
            var files = this.refs.input.files;
            if (bb.inu(files) || files.length == 0) {
                return;
            }
            var data = new FormData();
            for (var i = 0; i < files.length; i++) {
                if (this.state.fileserver === "fileserver") {
                    data.append(files[i].name, files[i], "fileserver");
                } else {
                    data.append(files[i].name, files[i], this.state.uploadFolder);
                }
            }
            var view = this.getView();
            view.upload(data, function (data) {
                this.uploadSuccess(data);
            }.bind(this), function (msg) {
                this.uploadError(msg);
            }.bind(this), bb.getStore("AccessToken"));
        }
    }, {
        key: "uploadSuccess",
        value: function uploadSuccess(response) {
            if (!bb.inu(response.Result)) {
                var images = this.state.value;
                var image = response.Result;
                if (images.length == 0) {
                    image.Selected = true;
                }
                images.push(image);
                this.setState({ value: images }, function () {
                    this.state.options.Change(null, this.state.value);
                    if (!bb.inu(this.props.OnImageUpload)) {
                        this.props.OnImageUpload(image);
                    }
                }.bind(this));
            } else {
                this.uploadError(response.Message);
            }
        }
    }, {
        key: "uploadError",
        value: function uploadError(error) {
            this.error(error);
        }
    }, {
        key: "imageSelected",
        value: function imageSelected(image, index, e) {
            var images = this.state.value;
            images.forEach(function (item) {
                item.Selected = false;
            });
            image.Selected = true;
            images[index] = image;
            this.setState({ value: images }, function () {
                this.state.options.Change(null, this.state.value);
            }.bind(this));
        }
    }, {
        key: "remove",
        value: function remove(image, index, e) {
            this.refs.input.value = '';
            var images = this.state.value;
            images.splice(index, 1);
            this.setState({ value: images }, function () {
                this.state.options.Change(null, this.state.value);
            }.bind(this));
        }
    }, {
        key: "moveleft",
        value: function moveleft(index) {
            if (index != 0) {
                var images = this.state.value;
                var tmp = images[index - 1];
                images[index - 1] = images[index];
                images[index] = tmp;
                this.setState({ value: images });
            }
        }
    }, {
        key: "moveright",
        value: function moveright(index) {
            var images = this.state.value;
            if (index != images.length - 1) {
                var tmp = images[index + 1];
                images[index + 1] = images[index];
                images[index] = tmp;
                this.setState({ value: images });
            }
        }
    }, {
        key: "renderImages",
        value: function renderImages() {
            var _this2 = this;

            var arr = [];
            this.state.value.forEach(function (image, index) {
                var activeClass = image.Selected ? "active" : "";
                var activeButton = image.Selected ? "hidden" : "";
                var moveLeftButton = index == 0 ? "hidden" : "";
                var moveRightButton = index == _this2.state.value.length - 1 ? "hidden" : "";

                if (_this2.state.max == 1 && activeButton !== "hidden") {
                    activeButton = "hidden";
                }

                arr.push(React.createElement(
                    "div",
                    { key: index, className: "file-box", style: { width: _this2.state.width } },
                    React.createElement(
                        "div",
                        { className: "file " + activeClass },
                        React.createElement("span", { className: "corner" }),
                        React.createElement(
                            "div",
                            { className: "icon", style: { height: _this2.state.height, width: _this2.state.width } },
                            React.createElement("img", { src: image.WebPath, className: "img-responsive", style: { width: _this2.state.width } })
                        ),
                        React.createElement(
                            "div",
                            { className: "file-name file-info animated fadeInUp text-left" },
                            React.createElement(
                                "button",
                                { className: "btn btn-white btn-sm pull-left m-r-xs " + moveLeftButton, onClick: _this2.moveleft.bind(_this2, index), title: bb.localize('moveleft') },
                                React.createElement("i", { className: "fa fa-caret-left" })
                            ),
                            React.createElement(
                                "button",
                                { className: "btn btn-white btn-sm pull-left " + activeButton, title: bb.localize('setasdefault'), onClick: _this2.imageSelected.bind(_this2, image, index) },
                                React.createElement("i", { className: "fa fa-check" })
                            ),
                            React.createElement(
                                "button",
                                { className: "btn btn-white btn-sm pull-right m-l-xs " + moveRightButton, onClick: _this2.moveright.bind(_this2, index), title: bb.localize('moveright') },
                                React.createElement("i", { className: "fa fa-caret-right" })
                            ),
                            React.createElement(
                                "button",
                                { className: "btn btn-white btn-sm pull-right", title: bb.localize('remove'), onClick: _this2.remove.bind(_this2, image, index) },
                                React.createElement("i", { className: "fa fa-trash" })
                            )
                        )
                    )
                ));
            });
            if (this.state.value.length < this.state.max) {
                arr.push(React.createElement(
                    "div",
                    { key: "add", className: "file-box", style: { width: this.state.width } },
                    React.createElement(
                        "div",
                        { className: "file" },
                        React.createElement(
                            "a",
                            { href: "#" },
                            React.createElement("span", { className: "corner" }),
                            React.createElement(
                                "div",
                                { className: "icon", onClick: this.addImage.bind(this), style: { height: this.state.height, width: this.state.width } },
                                React.createElement("i", { className: "fa fa-upload" })
                            )
                        )
                    )
                ));
            }

            return arr;
        }
    }, {
        key: "render",
        value: function render() {

            var accept = 'image/*';

            if (!bb.inu(this.props.Accept)) {
                accept = this.props.Accept;
            }

            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    Label,
                    null,
                    this.props.Caption
                ),
                React.createElement("input", { type: "file", ref: "input", className: "hidden", onChange: this.fileSelectionChange.bind(this), accept: accept }),
                React.createElement(
                    "div",
                    { className: "attachment" },
                    this.renderImages()
                )
            );
        }
    }]);

    return ImageUpload;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LabelValue = function (_ComponentBase) {
    _inherits(LabelValue, _ComponentBase);

    function LabelValue() {
        _classCallCheck(this, LabelValue);

        return _possibleConstructorReturn(this, (LabelValue.__proto__ || Object.getPrototypeOf(LabelValue)).apply(this, arguments));
    }

    _createClass(LabelValue, [{
        key: "init",
        value: function init(props, options) {
            this.state.position = !bb.inu(this.props.Position) ? this.props.Position : "Right";

            this.state.labelSize = this.props.LabelSize || 4;
            this.state.valueSize = 12 - parseInt(this.state.labelSize);
        }
    }, {
        key: "render",
        value: function render() {
            var cssClass = "";
            switch (this.state.position) {
                case "Right":
                    cssClass = "label-value-right";
                    break;
                case "Left":
                    cssClass = "label-value-left";
                    break;
            }
            var value = !bb.inu(this.props.Value) ? this.props.Value : this.state.value;
            var formatter = this.props["Formatter"];
            if (!bb.inu(formatter)) {
                switch (formatter) {
                    case 'Currency':
                        value = bb.inu(value) ? "0" : value;
                        value = bb.formatCurrency(bb.toDecimal(value));
                        break;
                }
            }
            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    Row,
                    { CssClass: "m-b-xs" },
                    React.createElement(
                        Col,
                        { Sm: this.state.labelSize },
                        React.createElement(
                            "strong",
                            null,
                            bb.localize(this.props.Caption)
                        )
                    ),
                    React.createElement(
                        Col,
                        { Sm: this.state.valueSize },
                        React.createElement(
                            "span",
                            { className: cssClass + " text-muted" },
                            value
                        )
                    )
                )
            );
        }
    }]);

    return LabelValue;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Loading = function (_React$Component) {
    _inherits(Loading, _React$Component);

    function Loading() {
        _classCallCheck(this, Loading);

        return _possibleConstructorReturn(this, (Loading.__proto__ || Object.getPrototypeOf(Loading)).apply(this, arguments));
    }

    _createClass(Loading, [{
        key: "show",
        value: function show() {
            var element = document.getElementById(this.props.Id);
            var container = bb.closest(element, ".ibox-content");
            if (!bb.inu(container)) {
                container.classList.add("sk-loading");
            }
        }
    }, {
        key: "hide",
        value: function hide() {
            var element = document.getElementById(this.props.Id);
            var container = bb.closest(element, ".ibox-content");
            if (!bb.inu(container)) {
                container.classList.remove("sk-loading");
            }
        }
    }, {
        key: "componentDidMount",
        value: function componentDidMount() {
            window[this.props.Id] = this;
            page.loader = this;
        }
    }, {
        key: "render",
        value: function render() {
            return React.createElement(
                "div",
                { id: this.props.Id, className: "sk-spinner sk-spinner-cube-grid" },
                React.createElement("div", { className: "sk-cube" }),
                React.createElement("div", { className: "sk-cube" }),
                React.createElement("div", { className: "sk-cube" }),
                React.createElement("div", { className: "sk-cube" }),
                React.createElement("div", { className: "sk-cube" }),
                React.createElement("div", { className: "sk-cube" }),
                React.createElement("div", { className: "sk-cube" }),
                React.createElement("div", { className: "sk-cube" }),
                React.createElement("div", { className: "sk-cube" })
            );
        }
    }]);

    return Loading;
}(React.Component);
"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Modal = function (_React$Component) {
    _inherits(Modal, _React$Component);

    function Modal() {
        _classCallCheck(this, Modal);

        return _possibleConstructorReturn(this, (Modal.__proto__ || Object.getPrototypeOf(Modal)).apply(this, arguments));
    }

    _createClass(Modal, [{
        key: "componentWillUpdate",
        value: function componentWillUpdate(nextProps, nextState) {
            var currentContainer = document.getElementById(this.props.Id + "Container");
            if (currentContainer != null) {
                ReactDOM.render(React.createElement(ModalBox, _extends({}, this.props)), document.getElementById(currentContainer.id));
            }
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            var currentContainer = document.getElementById(this.props.Id + "Container");
            if (currentContainer != null) {
                currentContainer.parentElement.removeChild(currentContainer);
            }
        }
    }, {
        key: "componentDidMount",
        value: function componentDidMount() {
            var modalContainer = document.getElementById("modals");
            var newContainer = document.createElement("div");
            newContainer.id = this.props.Id + "Container";

            var currentContainer = document.getElementById(newContainer.id);
            if (currentContainer == null) {
                modalContainer.appendChild(newContainer);
                ReactDOM.render(React.createElement(ModalBox, _extends({}, this.props)), document.getElementById(newContainer.id));
            }
        }
    }, {
        key: "render",
        value: function render() {
            return null;
        }
    }]);

    return Modal;
}(React.Component);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ModalBox = function (_ComponentBase) {
    _inherits(ModalBox, _ComponentBase);

    function ModalBox() {
        _classCallCheck(this, ModalBox);

        return _possibleConstructorReturn(this, (ModalBox.__proto__ || Object.getPrototypeOf(ModalBox)).apply(this, arguments));
    }

    _createClass(ModalBox, [{
        key: "init",
        value: function init(props) {
            this.isInput = false;
            this.state.isOpen = false;
            this.state.size = "modal-lg";
            this.state.buttons = bb.inu(this.props.Buttons) ? [] : this.props.Buttons.split(',');
            this.state.bodyClass = bb.inu(this.props.BodyClass) ? "" : this.props.BodyClass;
            this.state.loaderClass = null;
            this.state.width = null;
            this.state.content = null;
            this.state.hideButton = !bb.inu(this.props.HideButton) ? this.props.HideButton : false;

            if (!bb.inu(this.props.Size) && this.props.Size == "Medium") {
                this.state.size = "modal-md";
            }

            if (!bb.inu(this.props.Size) && this.props.Size == "Large") {
                this.state.size = "modal-lg";
            }

            if (!bb.inu(this.props.Size) && this.props.Size == "Small") {
                this.state.size = "modal-sm";
            }

            if (!bb.inu(this.props.Width)) {
                this.state.width = this.props.Width + "px";
            }
        }
    }, {
        key: "open",
        value: function open() {
            this.setState({ isOpen: true }, function () {
                //this.getView().state.app.overlay(true);
            });
            window.scrollTo(0, 0);
        }
    }, {
        key: "close",
        value: function close() {
            var callBack = function callBack() {
                this.setState({ isOpen: false }, function () {
                    //this.getView().state.app.overlay(false);
                });
            };

            if (!bb.inu(this.props.OnCancel) && typeof this.props.OnCancel === 'function') {
                this.props.OnCancel(callBack.bind(this));
            } else {
                this.setState({ isOpen: false }, function () {
                    //this.getView().state.app.overlay(false);
                });
            }
        }
    }, {
        key: "done",
        value: function done() {
            var callBack = function callBack() {
                this.setState({ isOpen: false }, function () {
                    //this.getView().state.app.overlay(false);
                });
            };

            if (!bb.inu(this.props.OnClose) && typeof this.props.OnClose === 'function') {

                this.props.OnClose(callBack.bind(this));
            } else {
                this.setState({ isOpen: false }, function () {
                    //this.getView().state.app.overlay(false);
                });
            }
        }
    }, {
        key: "content",
        value: function content(str) {
            this.setState({ content: str });
        }
    }, {
        key: "customButtonEvent",
        value: function customButtonEvent(name) {
            if (!bb.inu(this.props['On' + name])) {
                this.props['On' + name]();
            }
        }
    }, {
        key: "render",
        value: function render() {
            var _this2 = this;

            var view = this.getView();
            var cssClass = "";
            var backdropClass = "";
            if (this.state.isOpen) {
                cssClass = "show in";
                backdropClass = "modal-backdrop in";
            }
            var style = {};
            if (!bb.inu(this.props.Height)) {
                style.height = this.props.Height;
            }

            var buttonClass = "btn-wizard m-t-md m-l-xs";
            if (this.state.hideButton) {
                buttonClass = "hidden";
            }

            var buttons = [];
            var doneText = this.props.DoneText != null ? this.props.DoneText : "Done";
            this.state.buttons.forEach(function (item, index) {
                buttons.push(React.createElement(Button, { Width: "100", key: index, Id: _this2.props.Id + item, OnClick: _this2.customButtonEvent.bind(_this2, item), Value: item, Class: buttonClass }));
            });
            buttons.push(React.createElement(Button, { Width: "100", key: "CloseButton", Id: this.props.Id + "CloseButton", Type: "primary", OnClick: this.done.bind(this), Value: doneText, Class: buttonClass }));

            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    "div",
                    { className: "inmodal in" },
                    React.createElement(
                        "div",
                        { className: "modal fade " + cssClass },
                        React.createElement(
                            "div",
                            { className: "modal-dialog " + this.state.size },
                            React.createElement(
                                "div",
                                { className: "modal-content", style: { width: this.state.width } },
                                React.createElement(
                                    "div",
                                    { className: "modal-header" },
                                    React.createElement(
                                        "button",
                                        { type: "button", className: "close", onClick: this.close.bind(this) },
                                        React.createElement(
                                            "span",
                                            null,
                                            "\xD7"
                                        )
                                    ),
                                    React.createElement(
                                        "h4",
                                        { className: "modal-title" },
                                        bb.localize(this.state.options.Caption)
                                    )
                                ),
                                React.createElement(
                                    "div",
                                    { className: "modal-body overflow-modal-y " + this.state.bodyClass, style: style },
                                    this.state.content == null ? this.props.children : this.state.content
                                ),
                                React.createElement(
                                    "div",
                                    { className: "modal-footer" },
                                    React.createElement(
                                        "div",
                                        { className: "text-center" },
                                        buttons
                                    )
                                ),
                                React.createElement("div", { className: "clearfix" })
                            )
                        )
                    ),
                    React.createElement("div", { className: backdropClass })
                )
            );
        }
    }]);

    return ModalBox;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var MultipleComplete = function (_ComponentBase) {
    _inherits(MultipleComplete, _ComponentBase);

    function MultipleComplete() {
        _classCallCheck(this, MultipleComplete);

        return _possibleConstructorReturn(this, (MultipleComplete.__proto__ || Object.getPrototypeOf(MultipleComplete)).apply(this, arguments));
    }

    _createClass(MultipleComplete, [{
        key: "init",
        value: function init(props, options) {
            this.state.disabled = false;
            this.state.value = [];
            this.state.items = [];
            this.state.keyField = bb.inu(this.props.KeyField) ? "Code" : this.props.KeyField;
            this.state.valueField = bb.inu(this.props.ValueField) ? "Value" : this.props.ValueField;
            this.state.maximumItem = bb.inu(this.props.Maximum) ? 9999 : this.props.Maximum;
            this.state.data = bb.inu(this.props.Data) ? [] : this.props.Data;
        }
    }, {
        key: "load",
        value: function load() {
            if (this.state.items.length == this.state.maximumItem) {
                this.setState({ disabled: true });
            }
        }
    }, {
        key: "selected",
        value: function selected() {
            return this.state.items;
        }
    }, {
        key: "change",
        value: function change(value, props, e) {
            e.persist();
            if (value == '') {
                return;
            }
            var complete = this[this.state.options.Id + "_MultipleComlpete"];
            var selected = complete.selected();
            var items = this.state.items;
            var values = this.state.value;

            if (!bb.inArray(items, selected, this.state.ValueField)) {

                items.push(selected);
                values.push(selected[this.state.valueField]);
                var isDisabled = false;
                if (items.length == this.state.maximumItem) {
                    isDisabled = true;
                }
                this.setState({ items: items, value: values, disabled: isDisabled }, function () {
                    this.setCursorPosition();

                    if (bb.isFunction(this.props.OnChange)) {
                        this.props.OnChange(value, props, e);
                    }

                    if (!bb.inu(values) && values.length > 0) {
                        complete.setState({ placeholder: '' });
                    }
                }.bind(this));
            }
            complete.clear();
        }
    }, {
        key: "remove",
        value: function remove(index, e) {
            e.persist();
            var items = this.state.items;
            var values = this.state.value;
            var item = items[index];
            var value = item[this.state.valueField];
            items.splice(index, 1);
            values.splice(index, 1);

            var complete = this[this.state.options.Id + "_MultipleComlpete"];

            var isDisabled = true;
            if (items.length < this.state.maximumItem) {
                isDisabled = false;
            }
            this.setState({ items: items, value: values, disabled: isDisabled }, function () {
                this.setCursorPosition();
                if (bb.isFunction(this.props.OnRemove)) {
                    this.props.OnRemove(value, e);
                }

                if (!bb.inu(values) && values.length == 0) {
                    complete.setState({ placeholder: this.props.Placeholder });
                }
            }.bind(this));
        }
    }, {
        key: "setCursorPosition",
        value: function setCursorPosition() {
            var container = this.refs.item_container;
            var width = container.clientWidth;
            var input = this[this.state.options.Id + "_MultipleComlpete"][this.state.options.Id + "_MultipleComlpete_Complete"].refs.input;
            input.style.paddingLeft = width + 5 + 'px';
        }
    }, {
        key: "renderItems",
        value: function renderItems() {
            var _this2 = this;

            var arr = [];

            this.state.items.forEach(function (item, index) {
                arr.push(React.createElement(
                    "a",
                    { key: index, onClick: _this2.remove.bind(_this2, index), className: "btn btn-xs btn-primary m-r-xs" },
                    item[_this2.state.keyField],
                    " \xA0",
                    React.createElement("i", { className: "fa fa-times" })
                ));
            });

            return React.createElement(
                "div",
                { ref: "item_container", className: "multiple-select-items" },
                arr
            );
        }
    }, {
        key: "clear",
        value: function clear(callback) {
            var options = this.state.options;
            options.Errors = [];
            this.setState({ value: [], options: options }, callback);
        }
    }, {
        key: "val",
        value: function val(value, callback) {
            var _this3 = this;

            if (!bb.inu(value) && Array.isArray(value)) {
                var complete = this[this.state.options.Id + "_MultipleComlpete"];
                var items = [];
                var values = [];
                value.forEach(function (val, index) {
                    var item = bb.getFromArray(complete.state.data, val, _this3.state.valueField);
                    if (!bb.inu(item)) {
                        values.push(val);
                        items.push(item);
                    }
                });
                var isDisabled = items.length == this.state.maximumItem;

                this.setState({ items: items, value: values, disabled: isDisabled }, function () {
                    if (!bb.inu(values) && values.length > 0) {
                        complete.setState({ placeholder: '' });
                    }
                });
            } else {
                return this.state.value;
            }
        }
    }, {
        key: "render",
        value: function render() {
            var className = this.state.disabled ? "disabled" : "";
            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: "12" },
                        React.createElement(
                            "div",
                            { className: className },
                            React.createElement(AutoComplete, {
                                Run: this, Id: this.state.options.Id + "_MultipleComlpete",
                                Caption: this.props.Caption,
                                Data: this.state.data,
                                KeyField: this.state.keyField,
                                ValueField: this.state.valueField,
                                Number: this.props.Number,
                                Placeholder: this.props.Placeholder,
                                OnEnterKeyPress: this.props.OnEnterKeyPress,
                                OnTabKeyPress: this.props.OnTabKeyPress,
                                OnChange: this.change.bind(this),
                                Disabled: this.props.Disabled
                            })
                        ),
                        this.renderItems()
                    )
                )
            );
        }
    }]);

    return MultipleComplete;
}(ComponentBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Navbar = function (_ComponentBase) {
    _inherits(Navbar, _ComponentBase);

    function Navbar() {
        _classCallCheck(this, Navbar);

        return _possibleConstructorReturn(this, (Navbar.__proto__ || Object.getPrototypeOf(Navbar)).apply(this, arguments));
    }

    _createClass(Navbar, [{
        key: 'init',
        value: function init() {
            this.state.lastOpen = null;
        }
    }, {
        key: 'load',
        value: function load() {
            var _this2 = this;

            document.addEventListener('mousedown', this.handlePageClick.bind(this), false);
            var list = [];
            this.props.Navigation.forEach(function (item) {
                _this2.getSearchList(item, list);
            });

            this.MenuSearch.setState({ data: list });

            var last = bb.getStore("last");
            //var lastElement = document.getElementById(last);
            //if (!bb.inu(lastElement)) {
            //    var closestDropDown = lastElement.closest(".dropdown");
            //    if (!bb.inu(closestDropDown)) {
            //        closestDropDown.classList.toggle("open");
            //    }

            //    var link = lastElement.children[0];
            //    if (!bb.inu(link)) {
            //        link.classList.add("active");
            //    }
            //}

            this.props.Run.adjustNavigationMenu(last);
        }
    }, {
        key: 'getSearchList',
        value: function getSearchList(item, list) {
            var _this3 = this;

            if (!bb.inu(item.Page) && item.Page != '' && item.IsVisible) {
                var searchItem = {
                    Caption: bb.localize(item.Caption),
                    Page: item.Page
                };
                list.push(searchItem);
            }
            if (!bb.inu(item.Items) && item.Items.length > 0) {
                item.Items.forEach(function (item) {
                    _this3.getSearchList(item, list);
                });
            }
        }
    }, {
        key: 'handlePageClick',
        value: function handlePageClick(e) {
            var el = this.refs.nav;
            if (!bb.inu(el) && !el.contains(e.target)) {
                this.closeAll();
            }
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            document.removeEventListener('mousedown', this.handlePageClick.bind(this));
        }
    }, {
        key: 'createNavItem',
        value: function createNavItem(item, index) {
            var _this4 = this;

            if (!item.IsVisible) {
                return null;
            }
            var haveChild = item.Items != null && item.Items.length > 0;
            var caret = null;
            var child = null;
            var className = "";
            var liClass = "";
            if (haveChild) {
                className += "dropdown-toggle";
                liClass = "dropdown";
                caret = React.createElement('span', { className: 'caret' });
                var items = [];
                item.Items.forEach(function (childItem, i) {
                    items.push(_this4.createNavItem(childItem, index + '_' + i));
                });
                child = React.createElement(
                    'ul',
                    { className: 'dropdown-menu' },
                    items
                );
            }
            var icon = null;
            if (!bb.inu(item.Icon) && item.Icon != '') {
                icon = React.createElement('i', { className: "fa " + item.Icon });
            }
            var item = React.createElement(
                'li',
                { id: item.Page, onClick: this.click.bind(this, item), key: index, className: liClass },
                React.createElement(
                    'a',
                    { href: 'javascript:void(0)', className: className },
                    icon,
                    ' ',
                    React.createElement(
                        Localize,
                        null,
                        item.Caption
                    ),
                    ' ',
                    caret
                ),
                child
            );
            return item;
        }
    }, {
        key: 'closeAll',
        value: function closeAll() {
            var dropdowns = this.refs.nav.querySelectorAll(".dropdown");
            dropdowns.forEach(function (item) {
                item.classList.remove("open");
            });
        }
    }, {
        key: 'click',
        value: function click(item, e) {
            e.stopPropagation();
            e.cancelBubble = true;
            e.preventDefault();

            if (e.currentTarget.classList.contains("dropdown")) {
                this.closeAll();
                if (this.state.lastOpen != e.currentTarget) {
                    this.setState({ lastOpen: e.currentTarget });
                    e.currentTarget.classList.toggle('open');
                } else {
                    this.setState({ lastOpen: null });
                }
            }
            if (!bb.inu(item.Page) && item.Page != "") {
                //this.closeAll();
                if (!bb.inu(window[item.Page])) {
                    if (this.props.Run.state.name != item.Page) {
                        this.props.Run.open(item.Page);
                        this.toggleNav(true);

                        this.props.Run.adjustNavigationMenu(item.Page);
                    }
                }
            }
        }
    }, {
        key: 'searched',
        value: function searched(value, e) {
            var item = this.MenuSearch.selected();
            if (!bb.inu(item) && !bb.inu(item.Page) && item.Page != "") {
                this.MenuSearch.clear();

                if (!bb.inu(window[item.Page])) {
                    this.closeAll();
                    if (this.props.Run.state.name != item.Page) {
                        this.props.Run.open(item.Page);
                    }
                }
            }
        }
    }, {
        key: 'toggleNav',
        value: function toggleNav(forceClose) {
            var collapse = document.querySelector('.navbar-collapse');
            if (forceClose == true) {
                collapse.classList.remove('in');
                return;
            }
            collapse.classList.toggle('in');
        }
    }, {
        key: 'render',
        value: function render() {
            var _this5 = this;

            var navigation = this.props.Navigation;
            var roots = [];
            navigation.forEach(function (item, index) {
                roots.push(_this5.createNavItem(item, index));
            });

            var className = 'navbar box-shadow m-b-sm p-h-md';
            var logo = this.props.BrandLogo != null && this.props.BrandLogo != '' ? React.createElement('img', { src: "/images/" + this.props.BrandLogo, className: 'header-logo m-sm' }) : null;
            return React.createElement(
                'div',
                { style: { width: '100%' } },
                React.createElement(
                    'nav',
                    { ref: 'nav', className: className, role: 'navigation' },
                    logo,
                    React.createElement(AutoComplete, { Number: 1000, Run: this, Id: 'MenuSearch', OnChange: this.searched.bind(this), Placeholder: 'searchinmenu', KeyField: 'Caption', ValueField: 'Page', Class: 'no-margins p-w-md' }),
                    React.createElement(
                        'div',
                        { className: 'navbar-header m-t-md m-l-md' },
                        React.createElement(Button, { Run: this, Id: 'NavBarButton', Icon: 'bars', Class: 'navbar-toggle no-padding no-borders m-l-xs', OnClick: this.toggleNav.bind(this) })
                    ),
                    React.createElement(
                        'div',
                        { className: 'navbar-collapse collapse', id: 'navbar' },
                        React.createElement(
                            'ul',
                            { className: 'nav navbar-nav' },
                            roots
                        )
                    )
                )
            );
        }
    }]);

    return Navbar;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Navigation = function (_React$Component) {
    _inherits(Navigation, _React$Component);

    function Navigation(props) {
        _classCallCheck(this, Navigation);

        var _this = _possibleConstructorReturn(this, (Navigation.__proto__ || Object.getPrototypeOf(Navigation)).call(this, props));

        var pages = bb.dictionaryToList(_this.props.Map);
        _this.state = { data: [], searchedData: [], pages: pages };
        return _this;
    }

    _createClass(Navigation, [{
        key: "navigationSearch",
        value: function navigationSearch(event) {
            var key = document.getElementById("NavigationSearch").value;
            if (key == "") {
                this.setState({ searchedData: [] });
                return;
            }

            var list = this.state.pages.filter(function (item, index) {
                var el = bb.localize(item["Caption"]).toLowerCase();
                key = key.toLowerCase();
                return el.search(key) >= 0;
            }, this);

            this.setState({ searchedData: list });
        }
    }, {
        key: "render",
        value: function render() {

            var data = [];
            if (this.state.searchedData.length > 0) {
                data = this.state.searchedData;
            } else if (!bb.inu(document.getElementById("NavigationSearch")) && !bb.inu(document.getElementById("NavigationSearch").value) && document.getElementById("NavigationSearch").value != "") {
                data = [];
            } else {
                if (!bb.inu(this.props.Data)) {
                    this.state.data = this.props.Data;
                    data = this.state.data;
                }
                if (!bb.inu(this.props.Map)) {
                    this.state.map = this.props.Map;
                }
            }

            var items = [];
            for (var i = 0; i < data.length; i++) {
                var nav = data[i];
                if (nav.Page != "" && nav.IsVisible || nav.IsRoot && nav.Items != null && nav.Items.length > 0) {
                    items.push(React.createElement(NavigationItem, { key: i, level: "second", item: data[i], Map: this.state.map }));
                }
            }

            if (data.length == 0) {
                var item = React.createElement(
                    "li",
                    null,
                    React.createElement(
                        "a",
                        null,
                        React.createElement(
                            "span",
                            { className: "nav-label" },
                            bb.localize("noresultsfound")
                        )
                    )
                );
                items.push(item);
            }

            return React.createElement(
                "div",
                { className: "navigation-class" },
                React.createElement(
                    "nav",
                    { className: "navbar-default navbar-static-side" },
                    React.createElement(
                        "div",
                        { className: "sidebar-collapse" },
                        React.createElement(
                            "div",
                            { className: "nav-header" },
                            React.createElement(
                                "div",
                                { className: "logo" },
                                React.createElement("img", { src: "/images/logo.png", className: "img-responsive" })
                            ),
                            React.createElement(
                                "div",
                                { className: "logo-icon" },
                                React.createElement("img", { src: "/images/icon.png", className: "img-responsive" })
                            )
                        ),
                        React.createElement(
                            "div",
                            { className: "navigation-search" },
                            React.createElement(
                                "div",
                                { className: "form-group" },
                                React.createElement(
                                    "div",
                                    { className: "text-box" },
                                    React.createElement("label", { className: "control-label" }),
                                    React.createElement("input", { id: "NavigationSearch", type: "text", className: "form-control quick-search", placeholder: bb.localize("quicksearch"), onKeyUp: this.navigationSearch.bind(this) })
                                )
                            )
                        ),
                        React.createElement(
                            "ul",
                            { className: "nav", id: "side-menu" },
                            items
                        )
                    )
                )
            );
        }
    }]);

    return Navigation;
}(React.Component);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NavigationItem = function (_React$Component) {
    _inherits(NavigationItem, _React$Component);

    function NavigationItem(props) {
        _classCallCheck(this, NavigationItem);

        var _this = _possibleConstructorReturn(this, (NavigationItem.__proto__ || Object.getPrototypeOf(NavigationItem)).call(this, props));

        _this.state = { item: _this.props.item };
        return _this;
    }

    _createClass(NavigationItem, [{
        key: "handleClick",
        value: function handleClick(item) {
            if (typeof this.props.onClick === 'function') {
                this.props.onClick(item);
            }
            if (!bb.inu(item.Page) && item.Page != "") {
                page.open(item.Page);
            } else {
                var item = this.state.item;
                item.Selected = !item.Selected;
                this.setState({ item: item });
            }
        }
    }, {
        key: "render",
        value: function render() {
            var item = this.props.item;
            item.Selected = this.state.item.Selected;

            var children = [];
            var icon = null;
            var arrow = null;
            var active = item.Selected ? "active" : "";
            var open = item.Selected ? "in" : "";

            if (item.Icon != null && item.Icon != "") {
                icon = React.createElement("i", { className: "fa " + item.Icon + " main-color" });
            }

            if (bb.inu(item.Page) && item.Items.length == 0) {
                return null;
            }

            if (item.Items != null) {
                for (var i = 0; i < item.Items.length; i++) {
                    var nav = item.Items[i];
                    if (nav.Page != "" && nav.IsVisible || nav.Page == "" && nav.Items != null && nav.Items.length > 0) {
                        children.push(React.createElement(NavigationItem, { level: "third", key: i, item: nav, Map: this.props.Map }));
                    }
                }
                if (children.length > 0) {
                    arrow = React.createElement("span", { className: "fa arrow" });
                }
            }
            var navLabel = bb.localize(item.Caption);
            if (this.props.level == 'second') {
                navLabel = React.createElement(
                    "span",
                    { className: "nav-label" },
                    navLabel
                );
            }

            var subMenu = null;
            if (children.length > 0) {
                subMenu = React.createElement(
                    "ul",
                    { className: "nav nav-" + this.props.level + "-level collapse " + open },
                    children
                );
            }

            return React.createElement(
                "li",
                { className: active },
                React.createElement(
                    "a",
                    { href: "javascript:void(0)", onClick: this.handleClick.bind(this, item) },
                    icon,
                    navLabel,
                    arrow
                ),
                subMenu
            );
        }
    }]);

    return NavigationItem;
}(React.Component);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PageButtons = function (_ComponentBase) {
    _inherits(PageButtons, _ComponentBase);

    function PageButtons() {
        _classCallCheck(this, PageButtons);

        return _possibleConstructorReturn(this, (PageButtons.__proto__ || Object.getPrototypeOf(PageButtons)).apply(this, arguments));
    }

    _createClass(PageButtons, [{
        key: "init",
        value: function init(props) {
            this.isInput = false;
            this.state.buttons = [];
            this.state.disabled = false;
            this.state.hideRefresh = !bb.inu(this.props.HideRefresh) ? this.props.HideRefresh : false;
        }
    }, {
        key: "createButtons",
        value: function createButtons() {
            var buttons = [];
            buttons["Print"] = React.createElement(Button, { Disabled: this.state.disabled, Run: this, key: "PrintButton", Id: "PrintButton", Type: "primary", Class: "btn-toolbar", Icon: "print", Value: bb.localize('Print'), OnClick: this.onClick.bind(this, "Print") });
            buttons["List"] = React.createElement(Button, { Disabled: this.state.disabled, Run: this, key: "ListButton", Id: "ListButton", Type: "primary", Class: "btn-toolbar", Icon: "list", Value: bb.localize('List'), OnClick: this.onClick.bind(this, "List") });
            buttons["Done"] = React.createElement(Button, { Disabled: this.state.disabled, Run: this, key: "DoneButton", Id: "DoneButton", Type: "primary", Class: "btn-toolbar", Icon: "check", Value: bb.localize('Done'), OnClick: this.onClick.bind(this, "Done") });
            buttons["Clear"] = React.createElement(Button, { Disabled: this.state.disabled, Run: this, key: "ClearButton", Id: "ClearButton", Type: "primary", Class: "btn-toolbar", Icon: "times", Value: bb.localize('Clear'), OnClick: this.onClick.bind(this, "Clear") });
            if (!this.state.hideRefresh) {
                buttons["_Refresh"] = React.createElement(Button, { Run: this, key: "RefreshButton", Id: "RefreshButton", Type: "primary", Class: "btn-toolbar", Icon: "refresh", Value: bb.localize('Refresh'), OnClick: this.onClick.bind(this, "Refresh") });
            }
            buttons["_Cancel"] = React.createElement(Button, { Run: this, key: "CancelButton", Id: "CancelButton", Class: "pull-right", Icon: "times fa-lg", OnClick: this.onClick.bind(this, "Cancel") });
            return buttons;
        }
    }, {
        key: "onClick",
        value: function onClick(type) {
            if (!bb.inu(this.props["On" + type])) {
                this.props["On" + type]();
            } else if (type == "Cancel") {
                var view = this.getView();
                view.state.app.back();
            } else if (type == "Refresh") {
                var view = this.getView();
                view.state.app.reload();
            }
        }
    }, {
        key: "disable",
        value: function disable() {
            this.setState({ disabled: true });
        }
    }, {
        key: "enable",
        value: function enable() {
            this.setState({ disabled: false });
        }
    }, {
        key: "render",
        value: function render() {
            if (!bb.inu(this.props.Buttons)) {
                this.state.buttons = this.props.Buttons;
            }
            var templates = this.createButtons();
            var buttons = [];
            for (var i = 0; i < this.state.buttons.length; i++) {
                var name = this.state.buttons[i];
                if (!bb.inu(templates[name])) {
                    buttons.push(templates[name]);
                } else {
                    var button = React.createElement(Button, { Run: this, key: "CustomButton" + i,
                        Id: "CustomButton" + i,
                        Class: "btn-toolbar",
                        Type: "success",
                        Value: name,
                        Disabled: this.state.disabled,
                        OnClick: this.onClick.bind(this, name) });
                    buttons.push(button);
                }
            }
            buttons.push(templates["_Refresh"]);
            buttons.push(templates["_Cancel"]);

            return React.createElement(
                "div",
                { className: "toolbar" },
                React.createElement("div", { className: "clearfix" }),
                buttons,
                React.createElement("div", { className: "clearfix" })
            );
        }
    }]);

    return PageButtons;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PageNotFound = function (_ViewBase) {
    _inherits(PageNotFound, _ViewBase);

    function PageNotFound() {
        _classCallCheck(this, PageNotFound);

        return _possibleConstructorReturn(this, (PageNotFound.__proto__ || Object.getPrototypeOf(PageNotFound)).apply(this, arguments));
    }

    _createClass(PageNotFound, [{
        key: "title",
        value: function title() {
            return false;
        }
    }, {
        key: "render",
        value: function render() {
            return React.createElement(
                "div",
                { className: "middle-box text-center page-404 no-padding" },
                React.createElement(
                    "h1",
                    null,
                    "404"
                ),
                React.createElement("i", { className: "fa fa-grav fa-5x" }),
                React.createElement(
                    "h3",
                    { className: "font-bold" },
                    bb.localize("pagenotfound")
                ),
                React.createElement(
                    "div",
                    { className: "error-desc" },
                    "Sorry, but the page you are looking for has not been found. Try checking the URL for error, then hit the refresh button on your browser or try found something else in our app."
                )
            );
        }
    }]);

    return PageNotFound;
}(ViewBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Password = function (_ComponentBase) {
    _inherits(Password, _ComponentBase);

    function Password() {
        _classCallCheck(this, Password);

        return _possibleConstructorReturn(this, (Password.__proto__ || Object.getPrototypeOf(Password)).apply(this, arguments));
    }

    _createClass(Password, [{
        key: 'init',
        value: function init(props, options) {
            this.state.line = null;
            this.state.score = 9;
            this.passwordGrades = {
                9: { text: '', color: '' },
                0: { text: 'Very weak', color: '#ed5565' },
                1: { text: 'Weak', color: '#f8ac59' },
                2: { text: 'Average', color: '#23c6c8' },
                3: { text: 'Strong', color: '#75beeb' },
                4: { text: 'Very strong', color: '#007ecc' }
            };
        }
    }, {
        key: 'load',
        value: function load() {
            var line = new ProgressBar.Line('#' + this.props.Id, { color: '#36b5df', strokeWidth: 1, duration: 100 });
            this.setState({ line: line });
        }
    }, {
        key: 'leave',
        value: function leave(event) {
            if (!bb.inu(this.props.OnLeave)) {
                this.props.OnLeave(this.state.value, this.props, event);
            }
        }
    }, {
        key: 'keyPress',
        value: function keyPress(e) {
            e.persist();
            if (!bb.inu(this.props.OnKeyPress)) {
                this.props.OnKeyPress(e);
            } else {
                if (e.key == "Enter") {
                    if (!bb.inu(this.props.OnEnterKeyPress)) {
                        this.props.OnEnterKeyPress(e);
                        e.preventDefault();
                    }
                } else if (e.key == "Tab") {
                    if (!bb.inu(this.props.OnTabKeyPress)) {
                        this.props.OnTabKeyPress(e);
                    }
                }
            }
        }
    }, {
        key: 'change',
        value: function change(e) {
            e.persist();

            var value = e.target.value;
            var strength = zxcvbn(value);
            var score = strength.score / 4;
            if (score == 0) {
                score = 0.1;
            }

            this.state.line.animate(score, {
                step: function (state, bar) {
                    var color = this.passwordGrades[strength.score].color;
                    bar.path.setAttribute('stroke', color);
                    this.refs.grades.style.color = color;
                    this.setState({ score: strength.score });
                }.bind(this)
            });

            this.state.options.Change(e);
        }
    }, {
        key: 'focus',
        value: function focus(e) {
            e.persist();
            if (!bb.inu(this.props.OnFocus)) {
                this.props.OnFocus(e);
            }
        }
    }, {
        key: 'mouseDown',
        value: function mouseDown() {
            var input = this.refs.input;
            input.type = 'text';
        }
    }, {
        key: 'mouseUp',
        value: function mouseUp() {
            var input = this.refs.input;
            input.type = 'password';
        }
    }, {
        key: 'render',
        value: function render() {
            var input = React.createElement('input', { type: 'password', className: 'form-control', ref: 'input',
                autoComplete: 'off',
                readOnly: this.state.options.Disabled,
                value: this.state.value,
                placeholder: bb.localize(this.props.Placeholder),
                onChange: this.change.bind(this),
                onClick: this.state.options.Click.bind(this),
                onBlur: this.leave.bind(this),
                onKeyDown: this.keyPress.bind(this),
                onFocus: this.focus.bind(this)
            });

            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    Label,
                    null,
                    this.props.Caption
                ),
                React.createElement(
                    'div',
                    { className: 'input-group' },
                    input,
                    React.createElement(
                        'div',
                        { className: 'input-group-addon password-eye', onMouseDown: this.mouseDown.bind(this), onMouseUp: this.mouseUp.bind(this) },
                        React.createElement('i', { className: 'fa fa-eye' })
                    )
                ),
                React.createElement('div', { className: 'password-strength', id: this.props.Id }),
                React.createElement(
                    'div',
                    { ref: 'grades' },
                    this.passwordGrades[this.state.score].text
                )
            );
        }
    }]);

    return Password;
}(ComponentBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Phone = function (_ComponentBase) {
    _inherits(Phone, _ComponentBase);

    function Phone() {
        _classCallCheck(this, Phone);

        return _possibleConstructorReturn(this, (Phone.__proto__ || Object.getPrototypeOf(Phone)).apply(this, arguments));
    }

    _createClass(Phone, [{
        key: 'init',
        value: function init(props, options) {
            this.state.countries = this.getAppState().Countries;
            this.state.tops = bb.inu(this.props.TopCountries) ? [] : this.props.TopCountries;
            this.state.country = bb.inu(this.props.Country) ? '' : this.props.Country;
            this.state.areaCode = '';
            this.state.opened = false;
            this.state.selected = null;
            this.state.search = '';
            this.state.searchTimeOut;
            this.state.useIpLocation = !bb.inu(this.props.UseIpLocation) ? this.props.UseIpLocation : false;

            options.Class += " auto-complete-container";
        }
    }, {
        key: 'load',
        value: function load() {
            document.addEventListener('mousedown', this.handleClickOutside.bind(this));
            document.addEventListener('keypress', this.handleKeyDown.bind(this));
            var selected = null;
            var view = this.getView();
            var appState = view.appState();
            var data = appState.Countries;

            //if (this.state.useIpLocation && bb.inu(this.props.Country)) {
            //    var ipCountry = geoplugin_countryCode();

            //    if (!bb.inu(ipCountry)) {
            //        selected = data.find(c => {
            //            return c.ISOCode === ipCountry;
            //        });
            //    }
            //}

            if (bb.inu(selected) && !bb.inu(this.state.country) && this.state.country != '') {
                selected = bb.getFromArray(data, this.state.country, "ISOCode");
            }

            this.setState({ countries: data, selected: selected });
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            document.removeEventListener('mousedown', this.handleClickOutside.bind(this));
            document.removeEventListener('keypress', this.handleKeyDown.bind(this));
        }
    }, {
        key: 'handleClickOutside',
        value: function handleClickOutside(event) {
            if (this.wrapperRef && !this.wrapperRef.contains(event.target)) {
                this.setState({ opened: false });
            }
        }
    }, {
        key: 'handleKeyDown',
        value: function handleKeyDown(event) {
            if (this.state.opened) {
                this.state.search += event.key;
                var key = this.state.search.toLowerCase();
                var index = this.state.countries.findIndex(function (country) {
                    return country.Name.toLowerCase().startsWith(key);
                });
                if (index != -1) {
                    var item = this.refs['item_' + index];
                    var offsetTop = item.offsetTop;
                    this.refs.container.scrollTop = offsetTop;
                }

                clearTimeout(this.state.searchTimeOut);

                this.state.searchTimeOut = setTimeout(function () {
                    this.state.search = '';
                }.bind(this), 1000);
            }
        }
    }, {
        key: 'setWrapperRef',
        value: function setWrapperRef(node) {
            this.wrapperRef = node;
        }
    }, {
        key: 'val',
        value: function val(value, callback) {
            if (bb.inu(value)) {
                if (bb.inu(this.state.selected) || this.state.value == '') {
                    return null;
                }

                return {
                    Country: this.state.selected.ISOCode,
                    AreaCode: this.state.selected.AreaCode.trim(),
                    Number: this.state.value
                };
            } else {
                if (this.state.countries.length > 0) {
                    var selected = bb.getFromArray(this.state.countries, value.Country, "ISOCode");
                    if (bb.inu(selected)) {
                        return null;
                    }
                    this.setState({
                        value: value.Number,
                        country: value.Country,
                        selected: selected
                    });
                } else {
                    this.setState({
                        value: value.Number,
                        country: value.Country,
                        selected: null
                    });
                }
            }
        }
    }, {
        key: 'clear',
        value: function clear() {
            var selected = null;

            //if (this.state.useIpLocation && bb.inu(this.props.Country)) {
            //    var ipCountry = geoplugin_countryCode();

            //    if (!bb.inu(ipCountry)) {
            //        selected = bb.getFromArray(this.state.countries, ipCountry, "ISOCode");
            //    }
            //}

            var country = bb.inu(this.props.Country) ? '' : this.props.Country;
            if (country != '') {
                selected = bb.getFromArray(this.state.countries, country, "ISOCode");
            }
            this.setState({ value: '', country: country, selected: selected });
        }
    }, {
        key: 'renderCountries',
        value: function renderCountries() {
            var _this2 = this;

            var result = [];
            this.state.tops.forEach(function (top, index) {
                var country = bb.getFromArray(_this2.state.countries, top, "ISOCode");
                if (!bb.inu(country)) {
                    var countryFlagClass = "flag-icon-" + country.ISOCode.toLowerCase();
                    var flag = React.createElement('div', { className: "flag-icon-background phone-flag " + countryFlagClass });
                    result.push(React.createElement(
                        'li',
                        _defineProperty({ key: 'top_' + index, onClick: _this2.select.bind(_this2, country, index) }, 'key', 'top-' + index),
                        flag,
                        ' ',
                        country.Name,
                        ' ',
                        React.createElement(
                            'span',
                            { className: 'text-muted' },
                            ' +',
                            country.AreaCode
                        )
                    ));
                }
            });

            if (result.length > 0) {
                result.push(React.createElement('hr', { key: 'hr' }));
            }

            this.state.countries.forEach(function (country, index) {
                var countryFlagClass = "flag-icon-" + country.ISOCode.toLowerCase();
                var flag = React.createElement('div', { className: "flag-icon-background phone-flag " + countryFlagClass });
                result.push(React.createElement(
                    'li',
                    _defineProperty({ ref: 'item_' + index, key: index, onClick: _this2.select.bind(_this2, country, index) }, 'key', index),
                    flag,
                    ' ',
                    country.Name,
                    ' ',
                    React.createElement(
                        'span',
                        { className: 'text-muted' },
                        ' +',
                        country.AreaCode
                    )
                ));
            });
            var className = this.state.opened ? "" : "hidden";
            return React.createElement(
                'ul',
                { ref: 'container', className: "auto-complete-result phone-result " + className },
                result
            );
        }
    }, {
        key: 'toggle',
        value: function toggle() {
            this.setState({ opened: !this.state.opened });
        }
    }, {
        key: 'select',
        value: function select(country, index, e) {
            this.setState({ selected: country, opened: false });
        }
    }, {
        key: 'renderSelected',
        value: function renderSelected() {
            if (bb.inu(this.state.selected)) {
                return React.createElement(
                    'div',
                    null,
                    React.createElement(
                        Localize,
                        null,
                        'Country'
                    ),
                    ' ',
                    React.createElement('span', { className: 'caret' })
                );
            } else {
                var country = this.state.selected;
                var countryFlagClass = "flag-icon-" + country.ISOCode.toLowerCase();
                var flag = React.createElement('div', { className: "flag-icon-background phone-flag " + countryFlagClass });
                return React.createElement(
                    'div',
                    { className: 'phone-selected' },
                    flag,
                    ' ',
                    React.createElement(
                        'span',
                        { className: 'text-muted' },
                        ' +',
                        country.AreaCode
                    ),
                    ' ',
                    React.createElement('span', { className: 'caret' })
                );
            }
        }
    }, {
        key: 'change',
        value: function change(e) {
            e.persist();
            var value = VMasker.toNumber(e.target.value);
            this.state.options.Change(e, value);
        }
    }, {
        key: 'render',
        value: function render() {
            return React.createElement(
                'div',
                { ref: this.setWrapperRef.bind(this) },
                React.createElement(
                    Wrapper,
                    { Options: this.state.options },
                    React.createElement(
                        Label,
                        null,
                        this.props.Caption
                    ),
                    React.createElement(
                        'div',
                        { className: 'input-group phone-fields' },
                        React.createElement(
                            'span',
                            { className: 'input-group-btn' },
                            React.createElement(
                                'button',
                                { className: 'btn btn-default', type: 'button', onClick: this.toggle.bind(this), readOnly: this.state.options.Disabled },
                                this.renderSelected()
                            )
                        ),
                        React.createElement('input', { type: 'text', className: 'form-control', value: this.state.value, placeholder: bb.localize('PhoneNumber'), onChange: this.change.bind(this), readOnly: this.state.options.Disabled })
                    ),
                    this.renderCountries()
                )
            );
        }
    }]);

    return Phone;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PhoneForm = function (_ComponentBase) {
    _inherits(PhoneForm, _ComponentBase);

    function PhoneForm() {
        _classCallCheck(this, PhoneForm);

        return _possibleConstructorReturn(this, (PhoneForm.__proto__ || Object.getPrototypeOf(PhoneForm)).apply(this, arguments));
    }

    _createClass(PhoneForm, [{
        key: "init",
        value: function init() {
            this.view = this.getView();
        }
    }, {
        key: "clear",
        value: function clear() {
            this.Id.clear();
            this.PhoneType.clear();
            this.Phone.clear();

            if (this.props.RenderOptional === true) {
                this.ActivePassive.clear();
                this.IsDefault.clear();
            }
        }
    }, {
        key: "val",
        value: function val(value) {
            if (bb.inu(value)) {
                var val = {};
                val.Id = this["Id"].val();
                val.PhoneType = this["PhoneType"].val();
                val.Phone = this["Phone"].val();
                if (this.props.RenderOptional === true) {
                    val.ActivePassive = this["ActivePassive"].val();
                    val.IsDefault = this["IsDefault"].val();
                }

                return val;
            } else {
                this.Id.val(value.Id);
                this.PhoneType.val(value.PhoneType);
                this.Phone.val(value.Phone);

                if (this.props.RenderOptional === true) {
                    this.ActivePassive.val(value.ActivePassive);
                    this.IsDefault.val(value.IsDefault);
                }
            }
        }
    }, {
        key: "renderOptionals",
        value: function renderOptionals() {
            if (!this.props.RenderOptional === true) {
                return null;
            }

            return React.createElement(
                Row,
                null,
                React.createElement(
                    Col,
                    { Md: 4 },
                    React.createElement(ComboBox, { Run: this, Id: "ActivePassive", Caption: "ActivePassive", Data: this.view.parameters('ActivePassive'), KeyField: "Name", ValueField: "Value", NoSelect: true })
                ),
                React.createElement(
                    Col,
                    { Md: 4 },
                    React.createElement(CheckBox, { Run: this, Id: "IsDefault", Caption: "isDefault", Class: "without-caption" })
                ),
                React.createElement(Col, { Md: 4 })
            );
        }
    }, {
        key: "render",
        value: function render() {
            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(TextBox, { Run: this, Id: "Id", Hidden: true }),
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: 4 },
                        React.createElement(ComboBox, { Run: this, Id: "PhoneType", Caption: "PhoneType", Data: this.view.parameters('PhoneType'), KeyField: "Definition", ValueField: "Value" })
                    ),
                    React.createElement(
                        Col,
                        { Md: 8 },
                        React.createElement(Phone, { Run: this, Id: "Phone", Caption: "PhoneNumber", TopCountries: ["TR", "GB", "DE", "RU", "FR", "US"] })
                    )
                ),
                this.renderOptionals()
            );
        }
    }]);

    return PhoneForm;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ProgressBox = function (_ComponentBase) {
    _inherits(ProgressBox, _ComponentBase);

    function ProgressBox() {
        _classCallCheck(this, ProgressBox);

        return _possibleConstructorReturn(this, (ProgressBox.__proto__ || Object.getPrototypeOf(ProgressBox)).apply(this, arguments));
    }

    _createClass(ProgressBox, [{
        key: "init",
        value: function init(props) {
            this.state.stepCount = 10;
            this.state.stepWeight = 0;
            this.state.currentCount = 0;
            this.state.currentWidth = "";
            this.state.textClasses = "progress-box-text default";
        }
    }, {
        key: "componentWillMount",
        value: function componentWillMount() {
            if (!bb.inu(this.props.StepCount)) {
                this.state.stepCount = this.props.StepCount;
                this.state.stepWeight = Math.round(100 / parseInt(this.props.StepCount));
            }
        }
    }, {
        key: "update",
        value: function update() {
            if (this.state.stepCount > this.state.currentCount) {
                var currentCount = ++this.state.currentCount;
                var currentWidth = currentCount * this.state.stepWeight + "%";

                if (this.state.stepCount - currentCount == 0) {
                    currentWidth = 100 - currentCount * this.state.stepWeight + currentCount * this.state.stepWeight + '%';
                }

                if (this.state.stepCount / this.state.currentCount < 2) {
                    var textClasses = "progress-box-text loaded";
                    this.setState({ currentWidth: currentWidth, currentCount: currentCount, textClasses: textClasses });
                } else {
                    this.setState({ currentWidth: currentWidth, currentCount: currentCount });
                }
            } else if (this.state.stepCount == this.state.currentCount) {
                if (bb.isFunction(this.props.OnDone)) {
                    this.props.OnDone();
                }
            }
        }
    }, {
        key: "render",
        value: function render() {
            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    "div",
                    { className: "progress-box progress progress-striped active", ref: "progressContainer" },
                    React.createElement(
                        "span",
                        { className: this.state.textClasses },
                        this.state.currentWidth
                    ),
                    React.createElement("div", { style: { width: this.state.currentWidth }, className: "progress-bar progress-bar-success" })
                )
            );
        }
    }]);

    return ProgressBox;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RadioButton = function (_ComponentBase) {
    _inherits(RadioButton, _ComponentBase);

    function RadioButton() {
        _classCallCheck(this, RadioButton);

        return _possibleConstructorReturn(this, (RadioButton.__proto__ || Object.getPrototypeOf(RadioButton)).apply(this, arguments));
    }

    _createClass(RadioButton, [{
        key: "init",
        value: function init(props, options) {
            this.state.options.Class += " radio-box ";
            this.state.keyField = bb.inu(this.props.KeyField) ? "Code" : this.props.KeyField;
            this.state.valueField = bb.inu(this.props.ValueField) ? "Value" : this.props.ValueField;
            this.state.value = bb.inu(props.Value) ? false : props.Value;
            this.state.data = bb.inu(props.Data) ? [] : props.Data;
            this.state.direction = bb.inu(props.Direction) ? "Left" : "";
        }
    }, {
        key: "click",
        value: function click(value, e) {
            this.state.options.Change(e, value);
        }
    }, {
        key: "renderRadios",
        value: function renderRadios() {
            var _this2 = this;

            var list = [];
            this.state.data.forEach(function (item, index) {
                var checked = _this2.state.value == item[_this2.state.valueField] ? "checked" : "";
                var direction = _this2.state.direction == "Left" ? "pull-left" : "";
                list.push(React.createElement(
                    "div",
                    { key: index, className: "i-checks " + direction + " border-top-bottom border-left-right b-r-md p-xs flex-item white-bg" },
                    React.createElement(
                        "label",
                        { onClick: _this2.click.bind(_this2, item[_this2.state.valueField]) },
                        React.createElement(
                            "div",
                            { className: "iradio_square-blue " + checked },
                            React.createElement("ins", { className: "iCheck-helper" })
                        ),
                        "\xA0\xA0",
                        React.createElement(
                            Localize,
                            null,
                            item[_this2.state.keyField]
                        )
                    )
                ));
            });
            return list;
        }
    }, {
        key: "render",
        value: function render() {
            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    "div",
                    { className: "flex-container" },
                    this.renderRadios()
                )
            );
        }
    }]);

    return RadioButton;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Spinner = function (_ComponentBase) {
    _inherits(Spinner, _ComponentBase);

    function Spinner() {
        _classCallCheck(this, Spinner);

        return _possibleConstructorReturn(this, (Spinner.__proto__ || Object.getPrototypeOf(Spinner)).apply(this, arguments));
    }

    _createClass(Spinner, [{
        key: "render",
        value: function render() {
            return React.createElement(
                "div",
                { className: "spinner" },
                React.createElement("img", { src: "/images/spinner.svg", className: "spinner-img" })
            );
        }
    }]);

    return Spinner;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Step = function (_React$Component) {
    _inherits(Step, _React$Component);

    function Step() {
        _classCallCheck(this, Step);

        return _possibleConstructorReturn(this, (Step.__proto__ || Object.getPrototypeOf(Step)).apply(this, arguments));
    }

    _createClass(Step, [{
        key: "render",
        value: function render() {
            return null;
        }
    }]);

    return Step;
}(React.Component);

var StepProgress = function (_ComponentBase) {
    _inherits(StepProgress, _ComponentBase);

    function StepProgress() {
        _classCallCheck(this, StepProgress);

        return _possibleConstructorReturn(this, (StepProgress.__proto__ || Object.getPrototypeOf(StepProgress)).apply(this, arguments));
    }

    _createClass(StepProgress, [{
        key: "init",
        value: function init(props) {
            var _this3 = this;

            this.isInput = false;

            this.state.steps = [];
            this.state.reachedStepIndex = 0;
            this.state.clickEnable = true;
            this.state.canMoveForward = false;

            if (!bb.inu(this.props.Steps)) {
                this.props.Steps.forEach(function (child, index) {
                    var step = {
                        Caption: child.Caption,
                        Value: child.Value,
                        Index: index
                    };
                    _this3.state.steps.push(step);
                });
            } else {
                this.state.steps = [];
            }

            if (!bb.inu(this.props.Value)) {

                var index = this.state.steps.findIndex(function (item) {
                    return item.Value == _this3.props.Value;
                });

                this.state.reachedStepIndex = index;
            }

            if (!bb.inu(this.props.ClickEnable)) {

                this.state.clickEnable = this.props.ClickEnable;
            }

            if (!bb.inu(this.props.CanMoveForward)) {
                this.state.canMoveForward = this.props.CanMoveForward;
            }
        }
    }, {
        key: "click",
        value: function click(step, e) {
            e.persist();

            if (!this.state.clickEnable) {
                return;
            }

            var targetIndex = this.state.steps.findIndex(function (item) {
                return item.Value == step.Value;
            });

            var reachedStepIndex = this.state.reachedStepIndex;
            if (!bb.inu(reachedStepIndex) && reachedStepIndex < targetIndex) {
                return;
            }

            this.setState({ value: step.Value }, function () {
                this.state.options.Click(e, step.Value);
            }.bind(this));
        }
    }, {
        key: "renderSteps",
        value: function renderSteps() {
            var _this4 = this;

            var stepElements = [];
            var valueIndex = 0;
            var reachedToValue = false;
            var stepNumber = 0;
            this.state.steps.forEach(function (step, index, arr) {
                var containerClassName = "flex-item text-center active";
                var textClassName = "step-text active ";
                var stepClassName = "step-container active";
                var progressBoxClassName = "step-progress-box active";
                if (step.Value == _this4.state.value) {
                    valueIndex = index;
                    reachedToValue = true;
                }

                if (index > valueIndex && reachedToValue) {
                    containerClassName = "flex-item text-center";
                    textClassName = "step-text";
                    stepClassName = "step-container";
                    progressBoxClassName = "step-progress-box";
                }

                if (!bb.inu(step.Type)) {

                    if (step.Type == "Warning") {
                        containerClassName += " warning";
                        textClassName += " warning";
                    } else if (step.Type == "Danger") {
                        containerClassName += " danger";
                        textClassName += " danger";
                    }
                }

                stepNumber++;
                stepElements.push(React.createElement(
                    "div",
                    { key: index, className: containerClassName, onClick: _this4.click.bind(_this4, step) },
                    React.createElement(
                        "div",
                        { className: stepClassName },
                        stepNumber
                    ),
                    React.createElement(
                        "div",
                        { className: textClassName },
                        bb.localize(step.Caption)
                    ),
                    React.createElement("div", { className: progressBoxClassName })
                ));
            });

            return stepElements;
        }
    }, {
        key: "componentWillUpdate",
        value: function componentWillUpdate(nextProps, nextState) {

            var valueIndex = this.state.steps.findIndex(function (item) {
                return item.Value == nextState.value;
            });

            if (nextState.reachedStepIndex == valueIndex) {
                nextState.reachedStepIndex = -1;
            } else if (!nextState.canMoveForward || nextState.canMoveForward && valueIndex > nextState.reachedStepIndex) {
                nextState.reachedStepIndex = valueIndex;
            }
        }
    }, {
        key: "render",
        value: function render() {
            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    "div",
                    { className: "flex-container" },
                    this.renderSteps()
                )
            );
        }
    }]);

    return StepProgress;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TextBox = function (_ComponentBase) {
    _inherits(TextBox, _ComponentBase);

    function TextBox() {
        _classCallCheck(this, TextBox);

        return _possibleConstructorReturn(this, (TextBox.__proto__ || Object.getPrototypeOf(TextBox)).apply(this, arguments));
    }

    _createClass(TextBox, [{
        key: "init",
        value: function init(props, options) {
            if (!bb.inu(this.props.Mask)) {
                this.state.mask = this.props.Mask;
                switch (this.state.mask) {
                    case 'Number':
                        options.Class += " mask-number";
                        break;
                }
                this.state.actionDisabled = false;
                this.state.disabled = false;
            }
        }
    }, {
        key: "load",
        value: function load() {
            if (!bb.inu(this.props.ActionCaption)) {
                this.setState({ actionDisabled: this.props.ActionDisabled });
            }
            if (!bb.inu(this.props.TextDisabled)) {
                this.setState({ disabled: this.props.TextDisabled });
            }
        }
    }, {
        key: "leave",
        value: function leave(event) {
            if (!bb.inu(this.props.OnLeave)) {
                this.props.OnLeave(this.state.value, this.props, event);
            }
        }
    }, {
        key: "keyPress",
        value: function keyPress(e) {
            e.persist();
            if (!bb.inu(this.props.OnKeyPress)) {
                this.props.OnKeyPress(e);
            } else {
                if (e.key == "Enter") {
                    if (!bb.inu(this.props.OnEnterKeyPress)) {
                        this.props.OnEnterKeyPress(e);
                        e.preventDefault();
                    }
                } else if (e.key == "Tab") {
                    if (!bb.inu(this.props.OnTabKeyPress)) {
                        this.props.OnTabKeyPress(e);
                    }
                }
            }
        }
    }, {
        key: "change",
        value: function change(e) {
            e.persist();

            if (!bb.inu(this.state.mask)) {
                switch (this.state.mask) {
                    case 'Number':
                        var value = VMasker.toNumber(e.target.value);
                        this.state.options.Change(e, value);
                        break;
                }
            } else {
                this.state.options.Change(e);
            }
        }
    }, {
        key: "focus",
        value: function focus(e) {
            e.persist();
            if (!bb.inu(this.props.OnFocus)) {
                this.props.OnFocus(e);
            }
        }
    }, {
        key: "disableActionButton",
        value: function disableActionButton(value) {
            this.setState({ actionDisabled: value });
        }
    }, {
        key: "actionTextDisabled",
        value: function actionTextDisabled(value) {
            this.setState({ disabled: value });
        }
    }, {
        key: "focus",
        value: function focus() {
            this.refs.input.focus();
        }
    }, {
        key: "render",
        value: function render() {
            var type = bb.inu(this.props.Type) ? "text" : this.props.Type;
            var className = "form-group";
            var formatter = this.props["Formatter"];
            if (!bb.inu(formatter)) {
                switch (formatter) {
                    case 'Currency':
                        this.state.value = bb.inu(this.state.value) ? "0" : this.state.value;
                        this.state.value = bb.formatCurrency(bb.toDecimal(this.state.value));
                        break;
                }
            }

            var actionButton = null;
            if (!bb.inu(this.props.ActionButton) && this.props.ActionButton === true) {
                className = "input-group";
                var caption = bb.localize(this.props.ActionCaption);

                //var actionButtonDisabled = this.state.actionDisabled;
                //if (!bb.inu(this.props.ActionDisabled)) {
                //    actionButtonDisabled = this.props.ActionDisabled;
                //}
                //var disabled = false;
                //if (!bb.inu(this.state.options.Disabled)) {
                //    disabled = this.state.options.Disabled;
                //    this.state.options.Disabled = false;
                //}


                actionButton = React.createElement(
                    "span",
                    { className: "input-group-btn" },
                    React.createElement(
                        "button",
                        { className: "btn btn-primary textbox-action-button", type: "button", value: caption, onClick: this.props.Action, disabled: this.state.actionDisabled },
                        React.createElement(
                            Localize,
                            null,
                            this.props.ActionCaption
                        )
                    )
                );
            }

            var input = React.createElement("input", { type: type, className: "form-control",
                value: this.state.value,
                readOnly: this.state.disabled,
                placeholder: bb.localize(this.props.Placeholder),
                onChange: this.change.bind(this),
                onClick: this.state.options.Click.bind(this),
                onBlur: this.leave.bind(this),
                onKeyDown: this.keyPress.bind(this),
                onFocus: this.focus.bind(this),
                ref: "input"
            });
            if (!bb.inu(this.props.Rows)) {
                input = React.createElement("textarea", { className: "form-control noresize", rows: this.props.Rows,
                    value: this.state.value,
                    readOnly: this.state.disabled,
                    placeholder: bb.localize(this.props.Placeholder),
                    onChange: this.state.options.Change.bind(this),
                    onBlur: this.leave.bind(this),
                    onClick: this.state.options.Click.bind(this),
                    onKeyPress: this.keyPress.bind(this),
                    onFocus: this.focus.bind(this),
                    ref: "input"
                });
            }

            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    Label,
                    null,
                    this.props.Caption
                ),
                React.createElement(
                    "div",
                    { className: className },
                    input,
                    actionButton
                )
            );
        }
    }]);

    return TextBox;
}(ComponentBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Timer = function (_ComponentBase) {
    _inherits(Timer, _ComponentBase);

    function Timer() {
        _classCallCheck(this, Timer);

        return _possibleConstructorReturn(this, (Timer.__proto__ || Object.getPrototypeOf(Timer)).apply(this, arguments));
    }

    _createClass(Timer, [{
        key: 'init',
        value: function init() {
            this.state.duration = this.props.Duration == null ? 10000 : parseInt(this.props.Duration);
            this.state.color = this.props.Color == null ? "#c2c2c2" : this.props.Color;
            this.state.bar = null;
        }
    }, {
        key: 'start',
        value: function start() {
            var _this2 = this;

            if (this.state.bar != null) {
                this.state.bar.destroy();
            }

            this.state.bar = new ProgressBar.Circle(this.refs.timerRef, {
                color: this.state.color,
                strokeWidth: 4,
                trailWidth: 1,
                duration: this.state.duration,
                text: {
                    autoStyleContainer: false
                },
                from: { color: this.state.color, width: 1 },
                to: { color: this.state.color, width: 4 },
                step: function (state, circle) {
                    circle.path.setAttribute('stroke', state.color);
                    circle.path.setAttribute('stroke-width', state.width);

                    var time = this.state.duration / 1000 * circle.value();
                    var time = Math.round(time, 0);
                    circle.setText(time);
                }.bind(this)
            });
            this.state.bar.text.style.fontFamily = '"Raleway", Helvetica, sans-serif';
            this.state.bar.text.style.fontSize = '2rem';
            this.state.bar.set(1.0);
            this.state.bar.animate(0.0, { duration: this.state.duration }, function () {
                if (bb.isFunction(_this2.props.OnComplete)) {
                    _this2.props.OnComplete();
                }
            });
        }
    }, {
        key: 'stop',
        value: function stop() {
            this.state.bar.stop();
        }
    }, {
        key: 'continue',
        value: function _continue() {
            var _this3 = this;

            this.state.bar.animate(0, function () {
                if (bb.isFunction(_this3.props.OnComplete)) {
                    _this3.props.OnComplete();
                }
            });
        }
    }, {
        key: 'render',
        value: function render() {
            var width = this.props.Width == null ? "100px" : this.props.Width + "px";
            var height = this.props.Height == null ? "100px" : this.props.Height + "px";
            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement('div', { ref: 'timerRef', className: 'timer', style: { width: width, height: height } })
            );
        }
    }]);

    return Timer;
}(ComponentBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Toast = function (_ComponentBase) {
    _inherits(Toast, _ComponentBase);

    function Toast() {
        _classCallCheck(this, Toast);

        return _possibleConstructorReturn(this, (Toast.__proto__ || Object.getPrototypeOf(Toast)).apply(this, arguments));
    }

    _createClass(Toast, [{
        key: 'init',
        value: function init(props) {
            this.isInput = false;
            this.state.duration = bb.inu(this.props.Duration) ? 5000 : this.props.Duration;
            this.state.type = bb.inu(this.props.Type) ? "default" : this.props.Type;
            this.state.timeout = null;
            this.state.line = null;
        }
    }, {
        key: 'load',
        value: function load() {
            var line = new ProgressBar.Line('.toast-line', { color: '#36b5df', duration: this.state.duration });
            this.setState({ line: line });
        }
    }, {
        key: 'show',
        value: function show(msg, type) {
            if (bb.inu(type)) {
                type = this.state.type;
            }
            if (!bb.inu(this.state.timeout)) {
                clearTimeout(this.state.timeout);
            }

            var timeout = setTimeout(this.hide.bind(this).bind(this), this.state.duration);

            this.setState({ value: bb.localize(msg), type: type, timeout: timeout }, function () {
                if (!bb.inu(this.state.line)) {
                    this.state.line.set(1);
                    this.state.line.animate(0);
                }
                var el = ReactDOM.findDOMNode(this);
                el.classList.remove('fadeOutUp');
                el.classList.add("fadeInDown");
            });
        }
    }, {
        key: 'warning',
        value: function warning(msg) {
            this.show(msg, "warning");
        }
    }, {
        key: 'error',
        value: function error(msg) {
            this.show(msg, "error");
        }
    }, {
        key: 'success',
        value: function success(msg) {
            this.show(msg, "success");
        }
    }, {
        key: 'hide',
        value: function hide() {
            var el = ReactDOM.findDOMNode(this);
            el.classList.remove('fadeInDown');
            el.classList.add('fadeOutUp');
            this.state.timeout = null;
        }
    }, {
        key: 'render',
        value: function render() {
            var message = null;
            switch (this.state.type) {
                case 'warning':
                    message = React.createElement(
                        'div',
                        null,
                        React.createElement(
                            'span',
                            { className: 'fa-stack' },
                            React.createElement('i', { className: 'fa fa-exclamation-triangle fa-2x text-warning' })
                        ),
                        ' ',
                        this.state.value
                    );
                    break;
                case 'error':
                    message = React.createElement(
                        'div',
                        null,
                        React.createElement(
                            'span',
                            { className: 'fa-stack' },
                            React.createElement('i', { className: 'fa fa-exclamation-circle fa-2x text-danger' })
                        ),
                        ' ',
                        this.state.value
                    );
                    break;
                case 'success':
                    message = React.createElement(
                        'div',
                        null,
                        React.createElement(
                            'span',
                            { className: 'fa-stack' },
                            React.createElement('i', { className: 'fa fa-check fa-2x main-color' })
                        ),
                        ' ',
                        this.state.value
                    );
                    break;
                case 'default':
                    message = React.createElement(
                        'div',
                        null,
                        this.state.value
                    );
                    break;
            }

            return React.createElement(
                'div',
                { className: 'toast text-center box-shadow animated', onClick: this.hide.bind(this) },
                message,
                React.createElement('div', { className: 'toast-line' })
            );
        }
    }]);

    return Toast;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ToolTip = function (_ComponentBase) {
    _inherits(ToolTip, _ComponentBase);

    function ToolTip() {
        _classCallCheck(this, ToolTip);

        return _possibleConstructorReturn(this, (ToolTip.__proto__ || Object.getPrototypeOf(ToolTip)).apply(this, arguments));
    }

    _createClass(ToolTip, [{
        key: "init",
        value: function init(props) {
            this.isInput = false;
            this.state.content = bb.inu(this.props.Content) ? null : this.props.Content;
            this.state.displayOnClick = bb.inu(this.props.DisplayOnClick) ? false : this.props.DisplayOnClick;
            this.state.toolTipClasses = "";

            if (this.props.DestroyOnClickOutside) {
                document.addEventListener('click', this.handlePageClick.bind(this), false);
            }
        }
    }, {
        key: "componentWillMount",
        value: function componentWillMount() {
            var toolTipClasses = "tooltip-container popover bottom in";
            if (!bb.inu(this.props.Position)) {
                switch (this.props.Position) {
                    case "Left":
                        toolTipClasses = "tooltip-container popover left in";
                        break;
                    case "Right":
                        toolTipClasses = "tooltip-container popover right in";
                        break;
                    case "Top":
                        toolTipClasses = "tooltip-container popover top in";
                        break;
                }
            }

            this.state.toolTipClasses = toolTipClasses;
        }
    }, {
        key: "onMouseEnter",
        value: function onMouseEnter() {
            if (!this.state.displayOnClick) {
                this.refs.toolTipContainer.classList.add("visible");
                this.setState({ toolTipClasses: this.refs.toolTipContainer.classList.toString() });
            }
        }
    }, {
        key: "onMouseLeave",
        value: function onMouseLeave() {
            if (!this.props.DestroyOnClickOutside) {
                this.refs.toolTipContainer.classList.remove("visible");
                this.setState({ toolTipClasses: this.refs.toolTipContainer.classList.toString() });
            }
        }
    }, {
        key: "handlePageClick",
        value: function handlePageClick(e) {
            var el = ReactDOM.findDOMNode(this);
            if (!bb.inu(el) && !el.contains(e.target)) {
                this.refs.toolTipContainer.classList.remove("visible");
                this.setState({ toolTipClasses: this.refs.toolTipContainer.classList.toString() });
            }
        }
    }, {
        key: "onClick",
        value: function onClick(e) {
            if (this.state.displayOnClick) {
                this.refs.toolTipContainer.classList.add("visible");
                this.setState({ toolTipClasses: this.refs.toolTipContainer.classList.toString() });

                e.stopPropagation();
                e.cancelBubble = true;
            }
        }
    }, {
        key: "render",
        value: function render() {
            var content = this.state.content;
            if (typeof content === 'function') {
                content = content();
            }
            var className = this.state.toolTipClasses;
            if (!bb.inu(this.state.options.Class)) {
                className = className + ' ' + this.state.options.Class;
            }

            return React.createElement(
                "div",
                { className: "tooltip-main-container", onClick: this.onClick.bind(this), onMouseEnter: this.onMouseEnter.bind(this), onMouseLeave: this.onMouseLeave.bind(this) },
                React.createElement(
                    "div",
                    { className: "tooltip-element-container" },
                    this.props.children
                ),
                React.createElement(
                    "div",
                    { className: className, ref: "toolTipContainer" },
                    React.createElement("div", { className: "arrow" }),
                    React.createElement(
                        "div",
                        { className: "popover-content" },
                        content
                    )
                )
            );
        }
    }]);

    return ToolTip;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WebSocketManager = function (_ComponentBase) {
    _inherits(WebSocketManager, _ComponentBase);

    function WebSocketManager() {
        _classCallCheck(this, WebSocketManager);

        return _possibleConstructorReturn(this, (WebSocketManager.__proto__ || Object.getPrototypeOf(WebSocketManager)).apply(this, arguments));
    }

    _createClass(WebSocketManager, [{
        key: "init",
        value: function init(props) {
            var _this2 = this;

            this.state.instance = {};

            if (window['sockets'] == null) {
                window.sockets = [];
            }

            if (bb.inu(sockets[this.props.Id])) {
                var scheme = document.location.protocol == "https:" ? "wss" : "ws";
                var port = document.location.port ? ":" + document.location.port : "";
                var connectionUrl = scheme + "://" + document.location.hostname + port + "/ws?type=" + props.Type + "&clientid=" + props.Id;

                if (!bb.inu(this.props.Params)) {
                    var search = new URLSearchParams();

                    Object.keys(this.props.Params).forEach(function (key) {
                        search.append(key, _this2.props.Params[key]);
                    });

                    connectionUrl += "&" + search.toString();
                }

                var instance = {
                    type: props.Type
                };

                this.state.instance.socket = new WebSocket(connectionUrl);
                this.state.instance.socket.onopen = function (event) {
                    try {
                        if (bb.isFunction(this.props.OnOpen)) {
                            this.props.OnOpen();
                        }
                    } catch (err) {}
                }.bind(this);

                this.state.instance.socket.onclose = function (event) {
                    if (bb.isFunction(this.props.OnClose)) {
                        this.props.OnClose(event);
                    }
                }.bind(this);
                this.state.instance.socket.onerror = function (event) {
                    if (bb.isFunction(this.props.OnError)) {
                        this.props.OnError(event);
                    }
                }.bind(this);
                this.state.instance.socket.onmessage = function (event) {
                    try {
                        if (bb.isFunction(this.props.OnReceive)) {
                            var data = JSON.parse(event.data);
                            this.props.OnReceive(data);
                        }
                    } catch (err) {}
                }.bind(this);

                sockets[props.Id] = instance;
            }
        }
    }, {
        key: "sendMessage",
        value: function sendMessage(data) {
            var message = JSON.stringify(data);
            if (!bb.inu(this.state.instance.socket)) {
                try {
                    this.state.instance.socket.send(message);
                } catch (e) {}
            }
        }
    }, {
        key: "close",
        value: function close() {
            if (!bb.inu(this.state.instance.socket)) {
                window.sockets[this.props.Id] = null;
                this.state.instance.socket.close();
            }
        }
    }, {
        key: "render",
        value: function render() {
            return null;
        }
    }]);

    return WebSocketManager;
}(ComponentBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var WizardStep = function (_React$Component) {
    _inherits(WizardStep, _React$Component);

    function WizardStep() {
        _classCallCheck(this, WizardStep);

        return _possibleConstructorReturn(this, (WizardStep.__proto__ || Object.getPrototypeOf(WizardStep)).apply(this, arguments));
    }

    _createClass(WizardStep, [{
        key: "render",
        value: function render() {
            return null;
        }
    }]);

    return WizardStep;
}(React.Component);

var Wizard = function (_ComponentBase) {
    _inherits(Wizard, _ComponentBase);

    function Wizard() {
        _classCallCheck(this, Wizard);

        return _possibleConstructorReturn(this, (Wizard.__proto__ || Object.getPrototypeOf(Wizard)).apply(this, arguments));
    }

    _createClass(Wizard, [{
        key: "init",
        value: function init(props) {
            var _this3 = this;

            this.isInput = false;
            this.state.value = 0;
            this.state.stepNumber = 0;
            this.state.steps = [];
            this.state.doneProgress = false;
            this.state.doneStarted = false;
            this.state.active = "";
            this.state.hideProgress = false;

            this.props.children.forEach(function (child) {
                var step = {
                    Name: child.props.Name,
                    Caption: child.props.Caption,
                    Hidden: child.props.Hidden,
                    RequiredFields: child.props.RequiredFields,
                    OnValidate: child.props.OnValidate
                };

                _this3.state.steps.push(step);
                if (!child.props.Result) {
                    _this3.state.stepNumber++;
                }
            });
        }
    }, {
        key: "createHeader",
        value: function createHeader() {
            var _this4 = this;

            var steps = [];

            this.state.steps.forEach(function (step, i) {
                if (i == _this4.state.value && !step.Hidden) {
                    _this4.state.active = step.Name;
                }

                if (!step.Hidden) {
                    steps.push({ Caption: step.Caption, Value: step.Name });
                }
            });

            var progess = React.createElement(StepProgress, { key: bb.guid(), Run: this, Id: this.props.Id + "_Header", Value: this.state.active, Steps: steps, OnClick: this.stepClick.bind(this) });
            var headerContainer = [];
            if (!bb.inu(this.props.CollapsableHeader) && this.props.CollapsableHeader === true) {
                headerContainer.push(React.createElement(
                    Box,
                    { key: "box", Class: "wizard-progress", SettingDisable: true, Run: this, Id: "WizardStepProgressBox" },
                    progess
                ));
            } else {
                headerContainer.push(progess);
            }

            var className = this.state.hideProgress === true ? "hidden" : "";

            var main = React.createElement(
                Row,
                { CssClass: className },
                React.createElement(
                    "div",
                    { className: "m-t-md" },
                    React.createElement(
                        Row,
                        null,
                        React.createElement(Col, { Md: "1" }),
                        React.createElement(
                            Col,
                            { Md: "10" },
                            headerContainer
                        ),
                        React.createElement(Col, { Md: "1" })
                    )
                )
            );

            return main;
        }
    }, {
        key: "stepClick",
        value: function stepClick(val) {

            var stepIndex = this.state.steps.findIndex(function (item) {
                return item.Name == val;
            });

            this.recursiveBack(this.state.value - stepIndex);
        }
    }, {
        key: "recursiveBack",
        value: function recursiveBack(repeat) {
            if (repeat > 0) {
                var self = this;
                this.prev(function () {
                    self.recursiveBack(repeat - 1);
                });
            }
        }
    }, {
        key: "createContent",
        value: function createContent() {
            var _this5 = this;

            var render = [];
            this.state.steps.forEach(function (step, i) {
                var cssClass = "wizard-content p-sm ";
                if (i != _this5.state.value) {
                    cssClass += "hidden";
                }
                var content = _this5.props.children[i].props.children;
                render.push(React.createElement(
                    Col,
                    { key: i, CssClass: cssClass, Md: 12, Height: _this5.props.Height },
                    content
                ));
            });
            return React.createElement(
                Row,
                null,
                render
            );
        }
    }, {
        key: "createButtons",
        value: function createButtons() {
            if (this.props.HideButton) {
                return null;
            }
            var buttons = [];
            var nextClass = "btn-wizard m-t-xs-i m-r-sm ";
            var prevClass = "btn-wizard m-t-xs-i m-r-sm ";
            var doneClass = "btn-wizard m-t-xs-i m-r-sm ";
            var doneText = "Done";
            if (!bb.inu(this.props.DoneText)) {
                doneText = this.props.DoneText;
            }

            if (this.state.value == this.state.stepNumber - 1) {
                nextClass += "hidden";
            } else {
                doneClass += "hidden";
            }

            if (this.state.value == 0) {
                prevClass += "disabled";
            }

            buttons.push(React.createElement(Button, { Width: "80", Run: this, key: "WizardPrevious", Id: "WizardPrevious", Value: "Back", Class: prevClass, OnClick: this.prev.bind(this) }));
            buttons.push(React.createElement(Button, { Width: "80", Run: this, key: "WizardNext", Id: "WizardNext", Value: "Next", Type: "primary", Class: nextClass, OnClick: this.next.bind(this) }));
            buttons.push(React.createElement(Button, { Width: "80", Run: this, key: "WizardDone", Id: "WizardDone", Value: doneText, Type: "primary", Class: doneClass, OnClick: this.done.bind(this) }));

            return React.createElement(
                Row,
                null,
                React.createElement(
                    Col,
                    { Xs: 12, CssClass: "text-center" },
                    buttons
                )
            );
        }
    }, {
        key: "validate",
        value: function validate(index, callback) {
            if (!bb.inu(this.state.steps[index].RequiredFields)) {
                var modelName = this.props.ModelName;

                var view = this.getView();
                var current = view;

                var fields = this.state.steps[index].RequiredFields.split(',');
                var model = view.model();
                var stepModel = {};
                fields.forEach(function (field) {
                    stepModel[field] = model[field];
                });

                var stepValidate = this.state.steps[index].OnValidate;

                view.validate(stepModel, modelName, function () {
                    if (bb.isFunction(stepValidate)) {
                        stepValidate(callback);
                    } else {
                        if (bb.isFunction(callback)) {
                            callback(true);
                        }
                    }
                }.bind(this), function () {
                    if (bb.isFunction(stepValidate)) {
                        stepValidate(callback);
                    } else {
                        if (bb.isFunction(callback)) {
                            callback(false);
                        }
                    }
                }.bind(this));
            } else {
                if (bb.isFunction(callback)) {
                    callback(true);
                }
            }
        }
    }, {
        key: "next",
        value: function next() {
            var nextAvailableStep = this.state.value + 1;
            for (var i = 0; i < this.state.steps.length; i++) {
                var step = this.state.steps[i];
                if (i > this.state.value && !step.Hidden) {
                    nextAvailableStep = i;
                    break;
                }
            }

            this.validate(this.state.value, function (isValid) {
                if (isValid) {
                    var step = nextAvailableStep;
                    if (bb.isFunction(this.props.OnNext)) {
                        this.props.OnNext(this.state.value, step);
                    }
                    this.setState({ value: step });

                    window.scrollTo(0, 0);
                }
            }.bind(this));
        }
    }, {
        key: "prev",
        value: function prev(completedCallback) {
            var previousAvailableStep = this.state.value - 1;
            for (var i = this.state.value; i >= 0; i--) {
                var step = this.state.steps[i];
                if (i < this.state.value && (bb.inu(step.Hidden) || !step.Hidden)) {
                    previousAvailableStep = i;
                    break;
                }
            }
            var step = previousAvailableStep;
            if (bb.isFunction(this.props.OnPrevious)) {
                this.props.OnPrevious(this.state.value, step);
            }
            this.setState({ value: step }, function () {
                if (!bb.inu(completedCallback) && completedCallback instanceof Function) {
                    completedCallback();
                }
            });
            window.scrollTo(0, 0);
        }
    }, {
        key: "done",
        value: function done() {
            this.validate(this.state.value, function (isValid) {
                if (isValid) {
                    this.complete();
                }
            }.bind(this));
        }
    }, {
        key: "complete",
        value: function complete() {
            var current = this.getView();
            current.onDone();
        }
    }, {
        key: "open",
        value: function open(name) {
            var index = -1;
            this.state.steps.forEach(function (step, i) {
                if (step.Name == name) {
                    index = i;
                }
            });
            if (index != -1) {
                this.setState({ value: index });
            }
        }
    }, {
        key: "showStep",
        value: function showStep(name) {
            var index = -1;
            this.state.steps.forEach(function (step, i) {
                if (step.Name == name) {
                    index = i;
                }
            });
            if (index != -1) {
                this.state.steps[index].Hidden = false;
                this.forceUpdate();
            }
        }
    }, {
        key: "hideStep",
        value: function hideStep(name) {
            var index = -1;
            this.state.steps.forEach(function (step, i) {
                if (step.Name == name) {
                    index = i;
                }
            });
            if (index != -1) {
                this.state.steps[index].Hidden = true;
                this.forceUpdate();
            }
        }
    }, {
        key: "hideProgress",
        value: function hideProgress() {
            this.setState({ hideProgress: true });
        }
    }, {
        key: "showProgress",
        value: function showProgress() {
            this.setState({ hideProgress: false });
        }
    }, {
        key: "componentWillUpdate",
        value: function componentWillUpdate(nextProps, nextState) {
            nextProps.children.forEach(function (child) {

                var step = nextState.steps.find(function (item) {
                    return item.Name == child.props.Name;
                });
                if (!bb.inu(step) && step.RequiredFields != child.props.RequiredFields) {
                    step.RequiredFields = child.props.RequiredFields;
                }
            });
        }
    }, {
        key: "render",
        value: function render() {
            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    "div",
                    { className: "wizard container-fluid" },
                    this.createHeader(),
                    this.createContent(),
                    this.createButtons()
                )
            );
        }
    }]);

    return Wizard;
}(ComponentBase);
'use strict';

var ReactTable = window.ReactTable.default;
var getCursorXY = function getCursorXY(input, selectionPoint) {
    var inputX = input.offsetLeft,
        inputY = input.offsetTop;

    var div = document.createElement('div');
    var copyStyle = getComputedStyle(input);

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
        for (var _iterator = copyStyle[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var prop = _step.value;

            div.style[prop] = copyStyle[prop];
        }

        // we need a character that will replace whitespace when filling our dummy element if it's a single line <input/>
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
            }
        } finally {
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }

    var swap = '.';
    var inputValue = input.tagName === 'INPUT' ? input.value.replace(/ /g, swap) : input.value;

    // set the div content to that of the textarea up until selection
    var textContent = inputValue.substr(0, selectionPoint);

    // set the text content of the dummy element div
    div.textContent = textContent;

    if (input.tagName === 'TEXTAREA') div.style.height = 'auto';

    // if a single line input then the div needs to be single line and not break out like a text area
    if (input.tagName === 'INPUT') div.style.width = 'auto';

    // create a marker element to obtain caret position
    var span = document.createElement('span');

    // give the span the textContent of remaining content so that the recreated dummy element is as close as possible
    span.textContent = inputValue.substr(selectionPoint) || '.';

    // append the span marker to the div
    div.appendChild(span);

    // append the dummy element to the body
    document.body.appendChild(div);

    // get the marker position, this is the caret position top and left relative to the input
    var spanX = span.offsetLeft;
    var spanY = span.offsetTop - div.offsetTop;

    // lastly, remove that dummy element
    // NOTE:: can comment this out for debugging purposes if you want to see where that span is rendered
    document.body.removeChild(div);

    // return an object with the x and y of the caret. account for input positioning so that you don't need to wrap the input
    return {
        x: inputX + spanX,
        y: inputY + spanY
    };
};
"use strict";

function AddressGrid(props) {
    var addressGrid = {
        hideAllButtons: function hideAllButtons() {
            var grid = props.Run[props.Id];
            grid.hideButton("Done");
            grid.hideButton("Cancel");
            grid.hideButton("New");
            grid.hideButton("Update");
            grid.hideButton("Remove");
            grid.hideButton("Clear");
        },
        onReady: function onReady(grid) {
            var form = props.Run[props.Id + "Form"];
            grid.hideButton("Done");
            grid.hideButton("Cancel");
            form.hide();
        },
        newAddress: function newAddress() {
            var form = props.Run[props.Id + "Form"];
            var grid = props.Run[props.Id];
            grid.state.selected = null;
            addressGrid.hideAllButtons();
            form.clear();
            form.show();
            grid.showButton("Done");
            grid.showButton("Cancel");
        },
        doneAddress: function doneAddress() {
            var form = props.Run[props.Id + "Form"];
            var grid = props.Run[props.Id];

            props.Run.validate(form.val(), "AddressModel", function (model) {
                var selected = grid.selected();
                var selectedIndex = grid.selectedIndex();

                var currentValues = grid.val();

                if (currentValues.length == 0) {
                    model.IsDefault = true;
                } else {
                    if (model.IsDefault) {
                        currentValues.forEach(function (value) {
                            value.IsDefault = false;
                        });

                        grid.val(currentValues);
                    }
                }

                if (bb.inu(selected)) {
                    grid.add(model, true);
                } else {
                    grid.update(model, selectedIndex);
                }
                addressGrid.hideAllButtons();
                form.hide();

                grid.showButton("New");
                grid.showButton("Update");
                grid.showButton("Clear");
                grid.showButton("Remove");
            }, null, form);
        },
        updateAddress: function updateAddress() {
            var form = props.Run[props.Id + "Form"];
            var grid = props.Run[props.Id];
            addressGrid.hideAllButtons();
            var selected = grid.selected();
            form.val(selected);
            form.show();
            grid.showButton("Done");
            grid.showButton("Cancel");
        },
        removeAddress: function removeAddress() {
            var form = props.Run[props.Id + "Form"];
            var grid = props.Run[props.Id];

            var selectedIndex = grid.selectedIndex();
            var currentValues = grid.val();

            if (currentValues[selectedIndex].IsDefault === true) {
                for (var i = 0; i < currentValues.length; i++) {
                    if (i != selectedIndex) {
                        currentValues[i].IsDefault = true;
                        break;
                    }
                }
            }

            grid.val(currentValues);

            grid.remove(selectedIndex);
        },
        onCancel: function onCancel() {
            var form = props.Run[props.Id + "Form"];
            var grid = props.Run[props.Id];
            addressGrid.hideAllButtons();
            form.hide();
            var selectedIndex = grid.selectedIndex();

            grid.showButton("New");
            if (selectedIndex >= 0) {
                grid.showButton("Update");
                grid.showButton("Remove");
                grid.showButton("Clear");
            }
        }
    };

    return React.createElement(
        "div",
        null,
        React.createElement(
            Row,
            null,
            React.createElement(
                Col,
                { Md: "12" },
                React.createElement(AddressForm, { Id: props.Id + "Form", Run: props.Run, RenderOptional: true, Class: "well" })
            )
        ),
        React.createElement(
            Row,
            null,
            React.createElement(
                Col,
                { Md: "12" },
                React.createElement(
                    DataGrid,
                    {
                        Caption: props.Caption,
                        Run: props.Run,
                        ShowPagination: props.ShowPagination,
                        Id: props.Id,
                        Buttons: "Done,New,Update,Remove,Cancel,Clear",
                        Height: 150,
                        OnNew: addressGrid.newAddress.bind(this),
                        OnDone: addressGrid.doneAddress.bind(this),
                        OnCancel: addressGrid.onCancel.bind(this),
                        OnRemove: addressGrid.removeAddress.bind(this),
                        OnUpdate: addressGrid.updateAddress.bind(this),
                        OnReady: addressGrid.onReady.bind(this) },
                    React.createElement(DataGridColumn, { Name: "AddressType", Caption: "AddressType" }),
                    React.createElement(DataGridColumn, { Name: "Country", Caption: "Country" }),
                    React.createElement(DataGridColumn, { Name: "Town", Caption: "Town" }),
                    React.createElement(DataGridColumn, { Name: "PostCode", Caption: "PostCode" }),
                    React.createElement(DataGridColumn, { Name: "County", Caption: "County" }),
                    React.createElement(DataGridColumn, { Name: "Street", Caption: "Street" }),
                    React.createElement(DataGridColumn, { Name: "IsDefault", Caption: "IsDefault", Formatter: "Bool" })
                )
            )
        )
    );
}
"use strict";

function Col(props) {
    var classes = [];

    if (!bb.inu(props.Xs)) {
        classes.push("col-xs-" + props.Xs);
    }
    if (!bb.inu(props.Sm)) {
        classes.push("col-sm-" + props.Sm);
    }
    if (!bb.inu(props.Md)) {
        classes.push("col-md-" + props.Md);
    }
    if (!bb.inu(props.Lg)) {
        classes.push("col-lg-" + props.Lg);
    }

    if (!bb.inu(props.CssClass)) {
        classes.push(props.CssClass);
    }
    return React.createElement(
        "div",
        { className: classes.join(' '), style: { height: props.Height } },
        props.children
    );
}
"use strict";

function ConfirmBox(props) {
    var onCancel = function () {
        this.ConfirmBox.close();
    }.bind(props.Run);

    var onConfirm = function () {
        if (bb.isFunction(props.OnConfirm)) {
            props.OnConfirm();
        }
        this.ConfirmBox.close();
    }.bind(props.Run);

    return React.createElement(
        Modal,
        { Run: props.Run, Id: "ConfirmBox", Size: "Medium", DoneText: "Confirm", Caption: "Confirm", OnClose: onConfirm, Buttons: "Deny", OnDeny: onCancel },
        props.Message
    );
}
"use strict";

function EmailGrid(props) {
    var emailGrid = {
        hideAllButtons: function hideAllButtons() {
            var grid = props.Run[props.Id];
            grid.hideButton("Done");
            grid.hideButton("Cancel");
            grid.hideButton("New");
            grid.hideButton("Update");
            grid.hideButton("Remove");
            grid.hideButton("Clear");
        },
        onReady: function onReady(grid) {
            var form = props.Run[props.Id + "Form"];
            grid.hideButton("Done");
            grid.hideButton("Cancel");
            form.hide();
        },
        onClear: function onClear() {
            var grid = props.Run[props.Id];
            grid.clear();
        },
        newPhone: function newPhone() {
            var form = props.Run[props.Id + "Form"];
            var grid = props.Run[props.Id];
            grid.state.selected = null;
            emailGrid.hideAllButtons();
            form.clear();
            form.show();
            grid.showButton("Done");
            grid.showButton("Cancel");
        },
        donePhone: function donePhone() {
            var form = props.Run[props.Id + "Form"];
            var grid = props.Run[props.Id];

            props.Run.validate(form.val(), "EmailModel", function (model) {
                var selected = grid.selected();
                var selectedIndex = grid.selectedIndex();
                var currentValues = grid.val();
                if (currentValues.length == 0) {
                    model.IsDefault = true;
                } else {
                    if (model.IsDefault) {
                        currentValues.forEach(function (value) {
                            value.IsDefault = false;
                        });

                        grid.val(currentValues);
                    }
                }

                if (bb.inu(selected)) {
                    grid.add(model, true);
                } else {
                    grid.update(model, selectedIndex);
                }
                emailGrid.hideAllButtons();
                form.hide();
                grid.showButton("New");
                grid.showButton("Update");
                grid.showButton("Clear");
                grid.showButton("Remove");
            }, null, form);
        },
        updatePhone: function updatePhone(phoneData) {
            var form = props.Run[props.Id + "Form"];
            var grid = props.Run[props.Id];
            var selected = grid.selected();
            var selectedIndex = grid.selectedIndex();
            emailGrid.hideAllButtons();
            form.val(selected);
            form.show();
            grid.showButton("Done");
            grid.showButton("Cancel");
        },
        removePhone: function removePhone(rowData, rowIndex) {
            var form = props.Run[props.Id + "Form"];
            var grid = props.Run[props.Id];
            var selectedIndex = grid.selectedIndex();
            var currentValues = grid.val();
            var selected = grid.selected();

            if (currentValues[selectedIndex].IsDefault === true) {
                for (var i = 0; i < currentValues.length; i++) {
                    if (i != selectedIndex) {
                        currentValues[i].IsDefault = true;
                        break;
                    }
                }
            }
            grid.val(currentValues);
            grid.remove(selectedIndex);
        },
        onCancel: function onCancel() {
            var form = props.Run[props.Id + "Form"];
            var grid = props.Run[props.Id];
            grid.error("");
            emailGrid.hideAllButtons();
            form.hide();
            var selectedIndex = grid.selectedIndex();
            grid.showButton("New");
            grid.showButton("Clear");
            if (selectedIndex >= 0) {
                grid.showButton("Update");
                grid.showButton("Remove");
            }
        }
    };

    return React.createElement(
        "div",
        null,
        React.createElement(
            Row,
            null,
            React.createElement(
                Col,
                { Md: "12" },
                React.createElement(EmailForm, { Id: props.Id + "Form", Run: props.Run, RenderOptional: true, Class: "well" })
            )
        ),
        React.createElement(
            Row,
            null,
            React.createElement(
                Col,
                { Md: "12" },
                React.createElement(
                    DataGrid,
                    {
                        Run: props.Run,
                        Caption: props.Caption,
                        AppendToLast: props.AppendToLast,
                        Id: props.Id,
                        ShowPagination: props.ShowPagination,
                        Buttons: "Done,New,Update,Remove,Cancel,Clear",
                        Height: 150,
                        OnNew: emailGrid.newPhone.bind(this),
                        OnDone: emailGrid.donePhone.bind(this),
                        OnCancel: emailGrid.onCancel.bind(this),
                        OnRemove: emailGrid.removePhone.bind(this),
                        OnUpdate: emailGrid.updatePhone.bind(this),
                        OnClear: emailGrid.onClear.bind(this),
                        OnReady: emailGrid.onReady.bind(this) },
                    React.createElement(DataGridColumn, { Name: "EmailAddress", Caption: "Email", Unique: true }),
                    React.createElement(DataGridColumn, { Name: "EmailType", Caption: "EmailType" }),
                    React.createElement(DataGridColumn, { Name: "IsDefault", Caption: "IsDefault", Formatter: "Bool" })
                )
            )
        )
    );
}
"use strict";

function Label(props) {
    if (bb.inu(props.children) || props.children == ' ') {
        return null;
    };
    var className = "control-label ";
    if (!bb.inu(props.Class)) {
        className += props.Class;
    }

    return React.createElement(
        "label",
        { className: className },
        React.createElement(
            Localize,
            null,
            props.children
        )
    );
}
"use strict";

function Localize(props) {
    if (bb.inu(props.children)) {
        return null;
    };
    var localized = bb.localize(props.children);
    if (props.Upper === true && localized != null) {
        localized = localized.toUpperCase();
    }
    return localized;
}
"use strict";

function Panel(props) {
    var label = null;
    if (!bb.inu(props.Caption)) {
        var labelClass = "panel-label " + (props.CaptionClass == null ? "" : props.CaptionClass);
        label = React.createElement(
            Label,
            { Class: labelClass },
            props.Caption
        );
    }
    var className = "box-shadow box-radius white-bg ";
    if (!bb.inu(props.CssClass)) {
        className += props.CssClass;
    }
    return React.createElement(
        "div",
        { className: className },
        React.createElement(
            "div",
            { className: "panel-container" },
            label,
            props.children,
            React.createElement("div", { className: "clearfix" })
        )
    );
}
"use strict";

function PhoneGrid(props) {

    var phoneGrid = {
        hideAllButtons: function hideAllButtons() {
            var grid = props.Run[props.Id];
            grid.hideButton("Done");
            grid.hideButton("Cancel");
            grid.hideButton("New");
            grid.hideButton("Update");
            grid.hideButton("Remove");
            grid.hideButton("Clear");
        },
        onReady: function onReady(grid) {
            var form = props.Run[props.Id + "Form"];
            grid.hideButton("Done");
            grid.hideButton("Cancel");
            form.hide();
        },
        onClear: function onClear() {
            var grid = props.Run[props.Id];
            grid.clear();
        },
        newPhone: function newPhone() {
            var form = props.Run[props.Id + "Form"];
            var grid = props.Run[props.Id];
            grid.state.selected = null;
            phoneGrid.hideAllButtons();
            form.clear();
            form.show();
            grid.showButton("Done");
            grid.showButton("Cancel");
        },
        donePhone: function donePhone() {
            var form = props.Run[props.Id + "Form"];
            var grid = props.Run[props.Id];

            props.Run.validate(form.val(), "PhoneFormModel", function (model) {
                var selected = grid.selected();
                var selectedIndex = grid.selectedIndex();

                var currentValues = grid.val();

                var phoneData = form.val();
                phoneData.Country = bb.clone(phoneData.Phone.Country);
                phoneData.AreaCode = bb.clone(phoneData.Phone.AreaCode);
                phoneData.Number = bb.clone(phoneData.Phone.Number);

                if (currentValues.length == 0) {
                    phoneData.IsDefault = true;
                } else {
                    if (phoneData.IsDefault) {
                        currentValues.forEach(function (value) {
                            value.IsDefault = false;
                        });

                        grid.val(currentValues);
                    }
                }

                if (bb.inu(selected)) {
                    grid.add(phoneData, true);
                } else {
                    grid.update(phoneData, selectedIndex);
                }
                phoneGrid.hideAllButtons();
                form.hide();

                grid.showButton("New");
                grid.showButton("Update");
                grid.showButton("Clear");
                grid.showButton("Remove");
            }, null, form);
        },
        updatePhone: function updatePhone(phoneData) {
            var form = props.Run[props.Id + "Form"];
            var grid = props.Run[props.Id];
            phoneGrid.hideAllButtons();
            var selected = grid.selected();
            form.val(selected);
            form.show();
            grid.showButton("Done");
            grid.showButton("Cancel");
        },
        removePhone: function removePhone(rowData, rowIndex) {
            var form = props.Run[props.Id + "Form"];
            var grid = props.Run[props.Id];

            var selectedIndex = grid.selectedIndex();
            var currentValues = grid.val();
            if (currentValues.length > 1) {
                if (currentValues[selectedIndex].IsDefault === true) {
                    for (var i = 0; i < currentValues.length; i++) {
                        if (i != selectedIndex) {
                            currentValues[i].IsDefault = true;
                            break;
                        }
                    }
                }
                grid.val(currentValues);

                grid.remove(selectedIndex);
            } else {
                grid.error("uniquedatarowdeleteorchangeatattempt");
            }
        },
        onCancel: function onCancel() {
            var form = props.Run[props.Id + "Form"];
            var grid = props.Run[props.Id];
            phoneGrid.hideAllButtons();
            form.hide();
            var selectedIndex = grid.selectedIndex();

            grid.showButton("New");
            if (selectedIndex >= 0) {
                grid.showButton("Update");
                grid.showButton("Remove");
                grid.showButton("Clear");
            }
        }
    };

    return React.createElement(
        "div",
        null,
        React.createElement(
            Row,
            null,
            React.createElement(
                Col,
                { Md: "12" },
                React.createElement(PhoneForm, { Id: props.Id + "Form", Run: props.Run, RenderOptional: true, Class: "well" })
            )
        ),
        React.createElement(
            Row,
            null,
            React.createElement(
                Col,
                { Md: "12" },
                React.createElement(
                    DataGrid,
                    {
                        Run: props.Run,
                        Caption: props.Caption,
                        ShowPagination: props.ShowPagination,
                        Id: props.Id,
                        Buttons: "Done,New,Update,Remove,Cancel,Clear",
                        Height: 150,
                        OnNew: phoneGrid.newPhone.bind(this),
                        OnDone: phoneGrid.donePhone.bind(this),
                        OnCancel: phoneGrid.onCancel.bind(this),
                        OnRemove: phoneGrid.removePhone.bind(this),
                        OnUpdate: phoneGrid.updatePhone.bind(this),
                        OnReady: phoneGrid.onReady.bind(this),
                        OnClear: phoneGrid.onClear.bind(this) },
                    React.createElement(DataGridColumn, { Name: "AreaCode", Caption: "AreaCode" }),
                    React.createElement(DataGridColumn, { Name: "Number", Caption: "Number" }),
                    React.createElement(DataGridColumn, { Name: "PhoneType", Caption: "PhoneType" }),
                    React.createElement(DataGridColumn, { Name: "IsDefault", Caption: "IsDefault", Formatter: "Bool" })
                )
            )
        )
    );
}
"use strict";

function RealTimeDataReceiver(props) {
    if (window['sockets'] == null) {
        window.sockets = [];
    }
    if (bb.inu(props.Id) || bb.inu(props.Type)) {
        return React.createElement(
            "div",
            { className: "text-danger" },
            "Missing RealTimeDataReceiver Options! Please check definition of RealTimeDataReceiver component."
        );
    }

    if (bb.inu(sockets[props.Id])) {
        var scheme = document.location.protocol == "https:" ? "wss" : "ws";
        var port = document.location.port ? ":" + document.location.port : "";
        var connectionUrl = scheme + "://" + document.location.hostname + port + "/ws?type=" + props.Type + "&clientid=" + props.Id;

        var instance = {
            type: props.Type
        };

        instance.socket = new WebSocket(connectionUrl);
        instance.socket.onopen = function (event) {
            try {
                if (bb.isFunction(props.OnOpen)) {
                    props.OnOpen();
                }
            } catch (err) {}
        };
        instance.socket.onclose = function (event) {
            if (bb.isFunction(props.OnClose)) {
                props.OnClose(event);
            }
        };
        instance.socket.onerror = function (event) {
            if (bb.isFunction(props.OnError)) {
                props.OnError(event);
            }
        };
        instance.socket.onmessage = function (event) {
            try {
                if (bb.isFunction(props.OnReceive)) {
                    var data = JSON.parse(event.data);
                    props.OnReceive(data);
                }
            } catch (err) {}
        };

        sockets[props.Id] = instance;
    }

    return null;
}
"use strict";

function Row(props) {
    var classes = ["row"];

    if (!bb.inu(props.CssClass)) {
        classes.push(props.CssClass);
    }

    return React.createElement(
        "div",
        { className: classes.join(' ') },
        props.children
    );
}
'use strict';

function TabContent(props) {
    return React.createElement(
        'div',
        null,
        props.children
    );
}

function Tab(props) {
    var tab = {
        disabled: bb.inu(props.Disabled) ? false : props.Disabled,
        selected: bb.inu(props.Selected) ? 0 : props.Selected,
        tabs: [],
        contents: [],
        cancelClick: function cancelClick(i) {
            var child = props.children[i];
            var page = child.props.Page.CurrentView.state.app;
            page.back();
            var currentIndex = page.state.currentPageIndex;
            if (page.state.currentPageIndex > 0) {
                currentIndex--;
            }
            page.state.currentPageIndex = currentIndex;
        },
        handleClick: function handleClick(index) {
            var buttons = tab.tabs;
            var contents = tab.contents;
            var button = buttons[index];
            var container = document.getElementById(props.Id);
            container.querySelectorAll('.tab-button').forEach(function (i, it) {
                if (it == index) {
                    tab.selected = index;
                    i.classList.add('active');
                } else {
                    i.classList.remove('active');
                }
            });
            container.querySelectorAll('.tab-pane').forEach(function (i, it) {
                if (it == index) {
                    i.classList.add('active');
                } else {
                    i.classList.remove('active');
                }
            });

            if (!bb.inu(props.OnChange)) {
                props.OnChange(tab.selected);
            }

            bb.resize();
        }
    };

    window.addEventListener("InvalidFormEvent", function () {
        var container = document.getElementById(props.Id);
        if (!bb.inu(container)) {
            var tabs = container.querySelectorAll(".tab-pane");
            for (var i = 0; i < tabs.length; i++) {
                var tab = tabs[i];
                if (tab.querySelector('.has-error')) {
                    var tabButton = document.getElementById(tab.id + '-button');
                    tabButton.classList.add("tab-button-error");
                }
            }
        }
    });

    if (props.children.length != undefined) {
        for (var i = 0; i < props.children.length; i++) {
            var child = props.children[i];
            var key = child.props.Name == null ? i : child.props.Name;
            var active = i == tab.selected ? "active" : "";
            var hideCancel = i == tab.selected ? "" : "hidden";
            var closeButton = null;
            if (!bb.inu(props.CloseButton) && props.CloseButton == true) {
                closeButton = React.createElement('i', { className: "fa fa-times tab-close-btn " + hideCancel, onClick: tab.cancelClick.bind(this, i) });
            }
            var hidden = !bb.inu(child.props.Hidden) && child.props.Hidden ? "hidden" : null;
            tab.tabs.push(React.createElement(
                'li',
                { key: key, className: "tab-button " + active + " " + hidden },
                React.createElement(
                    'a',
                    { href: 'javascript:void(0)' },
                    React.createElement(
                        'a',
                        { href: 'javascript:void(0)', onClick: tab.handleClick.bind(this, i) },
                        bb.localize(child.props.Caption)
                    ),
                    React.createElement(
                        'a',
                        null,
                        ' ',
                        closeButton
                    )
                ),
                ' '
            ));
            tab.contents.push(React.createElement(
                'div',
                { key: key, className: "tab-pane " + active + " " + hidden },
                React.createElement(
                    'div',
                    { className: 'panel-body' },
                    React.createElement(
                        'div',
                        { className: 'container-fluid' },
                        React.createElement(
                            Row,
                            null,
                            React.createElement(
                                Col,
                                { Md: 12, CssClass: 'no-padding' },
                                child
                            )
                        )
                    )
                )
            ));
        }
    } else {
        var child = props.children;
        var key = child.props.Name == null ? "single" : child.props.Name;
        var active = "active";
        var closeButton = null;
        if (!bb.inu(props.CloseButton) && props.CloseButton == true) {
            closeButton = React.createElement('i', { className: "fa fa-times tab-close-btn ", onClick: tab.cancelClick.bind(this, i) });
        }
        var hidden = !bb.inu(child.props.Hidden) && child.props.Hidden ? "hidden" : null;
        tab.tabs.push(React.createElement(
            'li',
            { key: key, className: "tab-button " + active + " " + hidden },
            React.createElement(
                'a',
                { href: 'javascript:void(0)' },
                React.createElement(
                    'a',
                    { href: 'javascript:void(0)' },
                    bb.localize(child.props.Caption)
                ),
                React.createElement(
                    'a',
                    null,
                    ' ',
                    closeButton
                )
            )
        ));
        tab.contents.push(React.createElement(
            'div',
            { key: key, className: "tab-pane " + active + " " + hidden },
            React.createElement(
                'div',
                { className: 'panel-body' },
                React.createElement(
                    'div',
                    { className: 'container-fluid' },
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: 12, CssClass: 'no-padding' },
                            child
                        )
                    )
                )
            )
        ));
    }

    var tabPosition = "";
    switch (props.Position) {
        case 'Left':
            tabPosition = "tabs-left";break;
        case 'Right':
            tabPosition = "tabs-right";break;
    }
    var headerClass = props.HeaderClass == null ? "" : props.HeaderClass;
    var content = React.createElement(
        'div',
        { className: tabPosition },
        React.createElement(
            'ul',
            { className: "nav nav-tabs " + headerClass },
            tab.tabs
        ),
        React.createElement(
            'div',
            { className: 'tab-content' },
            tab.contents
        )
    );

    var cssClass = "";
    if (!bb.inu(props.CssClass)) {
        cssClass = props.CssClass;
    }
    if (tab.disabled) {
        cssClass += " disabled";
    }

    return React.createElement(
        'div',
        { id: props.Id, className: "tabs-container " + cssClass },
        content
    );
}
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TableColumn = function (_React$Component) {
    _inherits(TableColumn, _React$Component);

    function TableColumn() {
        _classCallCheck(this, TableColumn);

        return _possibleConstructorReturn(this, (TableColumn.__proto__ || Object.getPrototypeOf(TableColumn)).apply(this, arguments));
    }

    _createClass(TableColumn, [{
        key: "render",
        value: function render() {
            return null;
        }
    }]);

    return TableColumn;
}(React.Component);

var TableToolbarButton = function (_React$Component2) {
    _inherits(TableToolbarButton, _React$Component2);

    function TableToolbarButton() {
        _classCallCheck(this, TableToolbarButton);

        return _possibleConstructorReturn(this, (TableToolbarButton.__proto__ || Object.getPrototypeOf(TableToolbarButton)).apply(this, arguments));
    }

    _createClass(TableToolbarButton, [{
        key: "render",
        value: function render() {
            return React.createElement(Button, { Run: this.props.Run, key: this.props.Id + "Button", Id: this.props.Id, Type: "primary", Class: "btn-toolbar pull-right", Icon: this.props.Icon, Value: this.props.Caption, OnClick: this.props.OnClick.bind(this, this.props.Id) });
        }
    }]);

    return TableToolbarButton;
}(React.Component);

var Table = function (_ComponentBase) {
    _inherits(Table, _ComponentBase);

    function Table() {
        _classCallCheck(this, Table);

        return _possibleConstructorReturn(this, (Table.__proto__ || Object.getPrototypeOf(Table)).apply(this, arguments));
    }

    _createClass(Table, [{
        key: "init",
        value: function init(props) {
            this.state.value = bb.inu(this.props.Value) ? [] : this.props.Value;
            this.state.columns = [];
            this.state.selectedIndex = -1;
            this.state.selected = null;
            this.state.disableSelect = this.props.DisableSelect;
            this.state.editors = {};
            this.state.unique = [];
            if (!bb.inu(props.children)) {
                var unique = [];
                if (Array.isArray(props.children)) {
                    for (var i = 0; i < props.children.length; i++) {
                        var col = props.children[i];
                        var def = {
                            Name: col.props.Name,
                            Caption: col.props.Caption,
                            CssClass: col.props.CssClass,
                            Label: col.props.Label,
                            Align: col.props.Align,
                            Editor: col.props.Editor,
                            Width: col.props.Width
                        };
                        this.state.columns.push(def);
                        if (col.props.Unique) {
                            unique.push(def);
                        }
                    }
                } else {
                    var col = props.children;
                    var def = {
                        Name: col.props.Name,
                        Caption: col.props.Caption,
                        CssClass: col.props.CssClass,
                        Label: col.props.Label,
                        Align: col.props.Align,
                        Editor: col.props.Editor,
                        Width: col.props.Width
                    };
                    this.state.columns.push(def);
                    if (col.props.Unique) {
                        unique.push(def);
                    }
                }
                this.state.unique = unique;
            }
        }
    }, {
        key: "select",
        value: function select(rowIndex) {
            if (this.state.value != null && this.state.value.length > rowIndex) {
                var selected = this.state.value[rowIndex];
                if (selected != null) {
                    this.setState({ selected: selected, selectedIndex: rowIndex });
                }
            }
        }
    }, {
        key: "selected",
        value: function selected() {
            return this.state.selected;
        }
    }, {
        key: "selectedIndex",
        value: function selectedIndex() {
            return this.state.selectedIndex;
        }
    }, {
        key: "getEditor",
        value: function getEditor(rowIndex, colName) {
            var colDef = this.state.columns.find(function (column) {
                return column.Name == colName;
            });
            if (!bb.inu(colDef.Editor)) {
                var id = "Editor" + colName + rowIndex;
                var col = this[id];
                return col;
            }
            return null;
        }
    }, {
        key: "onRowSelected",
        value: function onRowSelected(index) {
            if (this.state.disableSelect !== true) {
                var container = ReactDOM.findDOMNode(this);
                var list = container.querySelectorAll('.selected');
                list.forEach(function (item) {
                    item.classList.remove('selected');
                });
                this.refs["row" + index].classList.add("selected");
                var selected = this.state.value[index];
                this.state.selected = selected;
                this.state.selectedIndex = index;

                if (bb.isFunction(this.props.OnRowSelected)) {
                    this.props.OnRowSelected(selected, index);
                }
            }
        }
    }, {
        key: "onSelectAll",
        value: function onSelectAll(columnName, value) {
            var list = [].concat(_toConsumableArray(this.state.value));
            if (list != null) {
                for (var i = 0; i < list.length; i++) {
                    list[i][columnName] = value;
                }
            }
            this.setState({ value: list });
        }
    }, {
        key: "onToolbarAction",
        value: function onToolbarAction(button) {
            if (bb.isFunction(this.props["On" + button])) {
                this.props["On" + button](this.state.selected, this.state.selectedIndex);
            }

            if (button == "Clear") {
                var rows = this.state.value;
                rows.forEach(function (row) {
                    row.RecordStatus = "None";
                });
                this.setState({ value: rows, selected: null, selectedIndex: -1 });
            }
        }
    }, {
        key: "add",
        value: function add(row, toLast, callback) {
            if (this.checkDublicate(row)) {
                this.error();
                var rows = [].concat(_toConsumableArray(this.state.value));
                row.RecordStatus = "New";
                if (this.props.AppendToLast === true) {
                    rows.push(row);
                } else {
                    rows.unshift(row);
                }
                this.setState({ value: rows }, callback);
                return true;
            } else {
                this.error("uniquedatarowaddatattempt");
                return false;
            }
        }
    }, {
        key: "addRange",
        value: function addRange(rows, callback) {
            var _this4 = this;

            var gridRows = [].concat(_toConsumableArray(this.state.value));
            rows.forEach(function (row) {
                row.RecordStatus = "New";
                if (_this4.props.AppendToLast === true) {
                    gridRows.push(row);
                } else {
                    gridRows.unshift(row);
                }
            });

            this.setState({ value: gridRows }, callback);
            return true;
        }
    }, {
        key: "update",
        value: function update(row, index, callback) {
            var rows = [].concat(_toConsumableArray(this.state.value));
            var current = rows[index];
            if (bb.inu(current["RecordStatus"]) || current.RecordStatus != "New") {
                row.RecordStatus = "Updated";
            } else {
                row.RecordStatus = current.RecordStatus;
            }
            rows[index] = row;
            this.setState({ value: rows }, callback);
        }
    }, {
        key: "remove",
        value: function remove(index, callback) {
            var rows = [].concat(_toConsumableArray(this.state.value));
            var row = rows[index];
            if (bb.inu(row["RecordStatus"]) || row.RecordStatus != "New") {
                row.RecordStatus = "Deleted";
            } else {
                rows.splice(index, 1);
            }
            this.setState({ value: rows }, callback);
        }
    }, {
        key: "clear",
        value: function clear(callback) {
            var options = this.state.options;
            options.Errors = [];
            this.setState({ value: [], options: options, selected: null, selectedIndex: -1 }, callback);
        }
    }, {
        key: "toolbar",
        value: function toolbar() {
            var _this5 = this;

            var buttons = [];
            var icons = { Add: 'plus', Update: 'edit', Remove: 'trash', Clear: 'refresh', Excel: 'table', List: 'list', DownloadCSV: 'download', Cancel: 'times', Done: 'check' };

            if (!bb.inu(this.props.Buttons)) {
                this.props.Buttons.split(',').reverse().forEach(function (name) {
                    if (_this5.state.selectedIndex != -1 && (name == "Update" || name == "Remove")) {
                        buttons.push(React.createElement(TableToolbarButton, { Run: _this5, key: name, Id: name, Caption: name, Icon: icons[name], OnClick: _this5.onToolbarAction.bind(_this5) }));
                    } else if (name != "Update" && name != "Remove") {
                        buttons.push(React.createElement(TableToolbarButton, { Run: _this5, key: name, Id: name, Caption: name, Icon: icons[name], OnClick: _this5.onToolbarAction.bind(_this5) }));
                    }
                });
            }

            if (buttons.length == 0) {
                return null;
            }

            return React.createElement(
                "div",
                { className: "m-b-sm" },
                React.createElement(
                    Label,
                    { Class: "table-title" },
                    this.props.Caption
                ),
                buttons,
                React.createElement("div", { className: "clearfix" })
            );
        }
    }, {
        key: "headers",
        value: function headers() {
            var headers = [];
            for (var i = 0; i < this.state.columns.length; i++) {
                var header = this.state.columns[i];
                var headerClass = "pull-left";
                switch (header.Align) {
                    case 'Right':
                        headerClass = "pull-right";break;
                    case 'Center':
                        headerClass = "text-center";break;
                }

                var cell = null;
                if (!bb.inu(header.Editor) && !bb.inu(header.Editor.Type) && header.Editor.Type === CheckBox) {
                    cell = React.createElement(CheckBox, { Id: "SelectAll", Run: this, OnChange: this.onSelectAll.bind(this, header.Name) });
                } else {
                    cell = React.createElement(
                        Localize,
                        { Run: this },
                        header.Caption
                    );
                }

                var style = {};
                if (header.Width != null) {
                    style.width = header.Width + 'px';
                }

                headers.push(React.createElement(
                    "th",
                    { style: style, key: i },
                    React.createElement(
                        "span",
                        { className: headerClass },
                        cell
                    )
                ));
            }
            return headers;
        }
    }, {
        key: "editor",
        value: function editor(col, rowIndex, value) {
            var id = "Editor" + col.Name + rowIndex;
            if (!bb.inu(this.state.editors[id])) {
                var current = this.state.editors[id];
                if (current.val != null) {
                    current.val(value);
                }
                return current;
            }

            var onChange = function onChange(index, columnName, props, value) {
                var data = this.state.value[index];
                data[columnName] = value;
                if (!bb.inu(props) && bb.isFunction(props.OnChange)) {
                    props.OnChange(value);
                }
            };
            var onClick = function onClick(index, columnName, props, value) {
                if (!bb.inu(props) && bb.isFunction(props.OnClick)) {
                    props.OnClick(index);
                }
            };
            var onAmountChange = function onAmountChange(index, columnName, props, value) {
                if (!bb.inu(props) && bb.isFunction(props.OnAmountChange)) {
                    props.OnAmountChange(value, index);
                }
            };
            var onTextBoxAction = function onTextBoxAction(index, columnName, props, value) {
                if (!bb.inu(props) && bb.isFunction(props.Action)) {
                    props.Action(value, index);
                }
            };

            var cell = null;

            var editor = col.Editor;
            var editorProps = {};
            if (!bb.inu(editor.Props)) {
                editorProps = bb.clone(editor.Props);
            }

            var props = Object.assign(editorProps, {
                key: id,
                Run: this,
                Id: id,
                OnChange: onChange.bind(this, rowIndex, col.Name, editor.Props),
                OnClick: onClick.bind(this, rowIndex, col.Name, editor.Props)
            });

            if (editor.Type === CurrencyBox) {
                var currency = bb.inu(editor.Props) ? "" : bb.inu(editor.Props.CurrencyField) ? "" : this.state.value[cellInfo.index][editor.Props.CurrencyField];
                props = Object.assign(props, {
                    Value: value,
                    Currency: currency,
                    OnAmountChange: onAmountChange.bind(this, rowIndex, col.Name, editor.Props)
                });
            } else if (editor.Type === TextBox) {
                props = Object.assign(props, {
                    Value: value,
                    OnChange: null,
                    OnLeave: onChange.bind(this, rowIndex, col.Name, editor.Props),
                    Action: onTextBoxAction.bind(this, rowIndex, col.Name, editor.Props)
                });
            } else if (editor.Type === CheckBox) {
                props = Object.assign(props, {
                    Value: value
                });
            }

            this.state.editors[id] = React.createElement(editor.Type, props);
            return this.state.editors[id];
        }
    }, {
        key: "checkDublicate",
        value: function checkDublicate(row) {
            var rows = this.state.value;
            var filter = this.state.unique;
            var finded = [];
            if (filter.length > 0) {
                finded = rows.filter(function (item) {
                    for (var i = 0; i < filter.length; i++) {
                        var unique = filter[i];
                        if (item[unique.Name] === undefined || item[unique.Name] != row[unique.Name]) {
                            return false;
                        }
                    }
                    return true;
                });
            }

            return finded.length == 0;
        }
    }, {
        key: "row",
        value: function row(data, rowIndex) {
            var row = [];
            for (var i = 0; i < this.state.columns.length; i++) {
                var col = this.state.columns[i];
                var colClass = "pull-left";
                switch (col.Align) {
                    case 'Right':
                        colClass = "pull-right";break;
                    case 'Center':
                        colClass = "text-center";break;
                }
                var value = data[col.Name];
                switch (col.Label) {
                    case 'Currency':
                        value = bb.formatCurrency(bb.toDecimal(value));
                        break;
                    case 'ShortDate':
                        value = moment(value).toFormat("L");
                }

                var cell = null;
                if (!bb.inu(col.Editor)) {
                    colClass += " m-t-xs";
                    cell = this.editor(col, rowIndex, value);
                } else {
                    var localizedValue = bb.localize('Grid.' + value);
                    if (localizedValue == 'Grid.' + value) {
                        localizedValue = value;
                    }
                    cell = localizedValue;
                }
                var style = {};
                switch (data.RecordStatus) {
                    case 'New':
                        style.background = "#dff0d8";
                        break;
                    case 'Updated':
                        style.background = "#fcf8e3";
                        break;
                    case 'Deleted':
                        style.background = "#f2dede";
                        break;
                }

                var td = React.createElement(
                    "td",
                    { key: bb.guid(), style: style, className: "table-col " + col.CssClass },
                    React.createElement(
                        "span",
                        { className: colClass },
                        cell
                    )
                );
                row.push(td);
            }
            return row;
        }
    }, {
        key: "body",
        value: function body() {
            var rows = [];
            if (!bb.inu(this.state.value)) {
                for (var i = 0; i < this.state.value.length; i++) {
                    var className = this.state.selectedIndex == i ? "selected" : "";
                    rows.push(React.createElement(
                        "tr",
                        { ref: "row" + i, className: className, key: i, onClick: this.onRowSelected.bind(this, i) },
                        this.row(this.state.value[i], i)
                    ));
                    if (bb.isFunction(this.props.OnRender)) {
                        this.props.OnRender(i, this.state.value[i]);
                    }
                }
            }
            return rows;
        }
    }, {
        key: "render",
        value: function render() {
            var headers = [];
            var style = {};
            if (!bb.inu(this.props.MaxHeight)) {
                style.maxHeight = this.props.MaxHeight;
            }
            if (!bb.inu(this.props.Height)) {
                style.height = this.props.Height + 'px';
            }

            return React.createElement(
                Wrapper,
                { Options: this.state.options },
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: "12" },
                        React.createElement(
                            "div",
                            { className: "border-left-right border-top" },
                            this.toolbar(),
                            React.createElement("div", { className: "clearfix" })
                        )
                    )
                ),
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: "12" },
                        React.createElement(
                            "div",
                            { className: "table-container border-bottom border-left border-right", style: style },
                            React.createElement(
                                "table",
                                { className: "table table-hover table-bordered table-striped table-responsive" },
                                React.createElement(
                                    "thead",
                                    null,
                                    React.createElement(
                                        "tr",
                                        null,
                                        this.headers()
                                    )
                                ),
                                React.createElement(
                                    "tbody",
                                    null,
                                    this.body()
                                )
                            )
                        )
                    )
                )
            );
        }
    }]);

    return Table;
}(ComponentBase);
"use strict";

function Wrapper(props) {
    var el = {};
    var classList = ["field-wrapper"];
    if (bb.inu(props.Options)) {
        return null;
    }

    if (bb.itrue(props.Options.Disabled)) {
        classList.push("disabled");
    }

    if (bb.itrue(props.Options.Hidden)) {
        classList.push("hidden");
    }

    if (!bb.inu(props.Options.Class)) {
        classList.push(props.Options.Class);
    }
    var error = null;
    if (!bb.iempty(props.Options.Errors)) {
        error = React.createElement(
            "div",
            { className: "text-danger" },
            props.Options.Errors.join(',')
        );
    }

    if (error != null) {
        classList.push("has-error");
    }
    var infoIcon = null;
    if (props.Options.InfoClick != null) {
        infoIcon = React.createElement("i", { className: "fa fa-info-circle field-info", onClick: function onClick() {
                props.Options.InfoClick();
            } });
    }

    if (!bb.inu(props.Options.Tooltip)) {
        return React.createElement(
            "div",
            { name: props.Options.Id, id: props.Options.Id + '_Wrapper', className: classList.join(' ') },
            React.createElement(
                ToolTip,
                { Run: el, Id: props.Options.Id + "_ToolTip", Content: props.Options.Tooltip },
                props.children,
                error
            )
        );
    } else {
        return React.createElement(
            "div",
            { name: props.Options.Id, id: props.Options.Id + '_Wrapper', className: classList.join(' ') },
            infoIcon,
            props.children,
            error
        );
    }
}
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CacheManagement = function (_ViewBase) {
    _inherits(CacheManagement, _ViewBase);

    function CacheManagement() {
        _classCallCheck(this, CacheManagement);

        return _possibleConstructorReturn(this, (CacheManagement.__proto__ || Object.getPrototypeOf(CacheManagement)).apply(this, arguments));
    }

    _createClass(CacheManagement, [{
        key: 'loadCache',
        value: function loadCache() {
            var action = {
                controller: 'Cache',
                action: 'GetCacheList',
                success: function (data) {
                    this.CacheList.setState({ value: data });
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'clearCache',
        value: function clearCache(index) {
            var cacheItem = this.CacheList.state.value[index];
            var action = {
                controller: 'Cache',
                action: 'ClearCache',
                params: cacheItem.Name,
                success: function (data) {
                    this.loadCache();
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'clearAllCashe',
        value: function clearAllCashe() {
            var action = {
                controller: 'Cache',
                action: 'ClearAllCache',
                success: function (data) {
                    this.loadCache();
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'load',
        value: function load() {
            this.loadCache();
        }
    }, {
        key: 'render',
        value: function render() {
            return React.createElement(
                Row,
                null,
                React.createElement(
                    Col,
                    { Md: 12 },
                    React.createElement(
                        Panel,
                        null,
                        React.createElement(PageButtons, { Id: 'PageButtons', HideRefresh: true, Run: this }),
                        React.createElement(
                            DataGrid,
                            { Run: this, Caption: 'CacheList', Id: 'CacheList', ShowPagination: false },
                            React.createElement(DataGridColumn, { Name: 'Name', Caption: 'Name' }),
                            React.createElement(DataGridColumn, { Name: 'Size', Caption: 'Size' }),
                            React.createElement(DataGridColumn, { Name: 'ExpireDate', Caption: 'ExpireDate' }),
                            React.createElement(DataGridColumn, { Name: 'CreateDate', Caption: 'CreateDate' }),
                            React.createElement(DataGridColumn, { Name: 'Clear', Caption: 'Clear',
                                Editor: { Type: Button, Props: { Icon: 'power-off', CssClass: "btn-data-table", OnClick: this.clearCache.bind(this) } }, Width: 60 })
                        ),
                        React.createElement(
                            Col,
                            { Md: '12', CssClass: 'text-center m-t-md' },
                            React.createElement(Button, { Disabled: this.state.disabled, Run: this, key: 'ClearAllCashe', Id: 'ClearAllCashe', Width: 200, Type: 'primary', Class: 'btn-wizard', Value: bb.localize('ClearAllCache'), OnClick: this.clearAllCashe.bind(this) })
                        )
                    )
                )
            );
        }
    }]);

    return CacheManagement;
}(ViewBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CredentialManagement = function (_ViewBase) {
    _inherits(CredentialManagement, _ViewBase);

    function CredentialManagement() {
        _classCallCheck(this, CredentialManagement);

        return _possibleConstructorReturn(this, (CredentialManagement.__proto__ || Object.getPrototypeOf(CredentialManagement)).apply(this, arguments));
    }

    _createClass(CredentialManagement, [{
        key: "init",
        value: function init() {
            this.state.updateFlag = false;
            this.state.addFlag = false;
            this.state.searchList = [];
        }
    }, {
        key: "load",
        value: function load() {
            this.CredentialType.setState({ data: this.parameters("CredentialType"), keyField: "Definition", valueField: "Value" });
            this.loadCredentials();
        }
    }, {
        key: "loadCredentials",
        value: function loadCredentials() {
            var action = {
                controller: 'User',
                action: 'GetCredentials',
                success: function (data) {
                    this.setCredentials(data);
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: "onDone",
        value: function onDone() {
            var action = {
                controller: 'User',
                action: 'CredentialCreateOrUpdate',
                params: this.model(),
                success: function (result, msg) {
                    this.success(msg);
                }.bind(this),
                error: function (msg) {
                    this.error(msg);
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: "credentialSelected",
        value: function credentialSelected(item) {
            this.CredentialValues.val([]);
            this.setState({ searchList: [] });
            if (item.Id != "") {
                var controller = "";
                var methodName = "";
                switch (item.CredentialType) {
                    case 'Navigation':
                        controller = "Navigation";
                        methodName = "GetNavigationForCredential";
                        break;
                    case 'Transaction':
                        controller = "Transaction";
                        methodName = "GetTransactionListFromSystem";
                        break;
                }

                if (controller != "" && methodName != "") {
                    var action = {
                        controller: controller,
                        action: methodName,
                        success: function (data) {
                            if (item.CredentialType == "Navigation") {
                                for (var i = 0; i < data.length; i++) {
                                    data[i].Name = data[i].Code;
                                }
                            } else {
                                for (var i = 0; i < data.length; i++) {
                                    data[i].Value = data[i].Name;
                                }
                            }

                            var values = [];
                            if (!bb.inu(item.Values) && item.Values.length > 0 && !bb.inu(item.Values[0].Select)) {
                                values = item.Values.filter(function (item) {
                                    return item.Select == true;
                                });
                            }
                            for (var i = 0; i < values.length; i++) {
                                for (var j = 0; j < data.length; j++) {
                                    if (data[j].Value == values[i].Value) {
                                        data[j].Select = true;
                                    }
                                }
                            }

                            item.CredentialValues = data;
                            this.setState({ searchList: item.CredentialValues });
                            this.model(item);
                        }.bind(this)
                    };
                    this.post(action);
                } else {
                    this.model(item);
                }
            } else {
                this.clearPage();
                this.model(item);
            }
        }
    }, {
        key: "searchScreen",
        value: function searchScreen(key) {
            if (key != "") {
                var list = this.state.searchList.filter(function (item, index) {
                    var el = bb.localize(item["Name"]).toLowerCase();
                    key = key.toLowerCase();
                    return el.search(key) >= 0;
                }, this);
                this.CredentialValues.val(list);
                for (var i = 0; i < list.length; i++) {
                    for (var j = 0; j < this.state.searchList.length; j++) {
                        if (this.state.searchList[j].Value == list[i].Value) {
                            this.state.searchList[j].Select = list[i].Select;
                        }
                    }
                }
            } else {
                this.CredentialValues.val(this.state.searchList);
            }
        }
    }, {
        key: "credentialAdd",
        value: function credentialAdd() {
            var model = this.model();
            this.validate(model, "CredentialModel", function () {
                this.credentialTypeChanged(this.CredentialType.val());
                this.state.updateFlag = false;
                this.state.addFlag = true;
                if (model.CredentialType != "Anonymous") {
                    this.CredentialModal.open();
                } else {
                    this.anonymusAdd();
                }
            }.bind(this));
        }
    }, {
        key: "credentialUpdate",
        value: function credentialUpdate(select, selectedIndex) {
            this.validate(this.model(), "CredentialModel", function () {
                this.state.updateFlag = true;
                this.state.addFlag = false;
                if (select.CredentialType != "Anonymous") {
                    this.CredentialModal.open();
                } else {
                    this.anonymusUpdate();
                }
            }.bind(this));
        }
    }, {
        key: "anonymusUpdate",
        value: function anonymusUpdate() {
            var selectedIndex = this.Credentials.selectedIndex();
            var model = this.model();
            var newItem = {
                Id: model.Id,
                Name: model.Name,
                CredentialType: model.CredentialType,
                Explanation: model.Explanation,
                Values: []
            };
            this.Credentials.update(newItem, selectedIndex);
            this.state.updateFlag = false;
            this.state.addFlag = false;
            this.clearPage();
        }
    }, {
        key: "anonymusAdd",
        value: function anonymusAdd() {
            var model = this.model();
            var newItem = {
                Id: "",
                Name: model.Name,
                CredentialType: model.CredentialType,
                Explanation: model.Explanation,
                Values: []
            };
            this.state.updateFlag = false;
            this.state.addFlag = false;
            this.Credentials.add(newItem);
            this.clearPage();
        }
    }, {
        key: "credentialRemove",
        value: function credentialRemove(selected, selectedIndex) {
            this.Credentials.remove(selectedIndex);
            this.clearPage();
        }
    }, {
        key: "clearPage",
        value: function clearPage() {
            this.Search.reset();
            this.Name.reset();
            this.CredentialType.reset();
            this.Explanation.reset();
            this.CredentialValues.val([]);
        }
    }, {
        key: "setValues",
        value: function setValues(data, value) {
            if (value != "Transaction") {
                for (var i = 0; i < data.length; i++) {
                    data[i].Name = data[i].Code;
                    data[i].Select = false;
                }
            }
            this.CredentialValues.setState({ value: data });
        }
    }, {
        key: "credentialTypeChanged",
        value: function credentialTypeChanged(value) {
            var controller = "";
            var methodName = "";
            switch (value) {
                case 'Navigation':
                    controller = "Navigation";
                    methodName = "GetNavigationForCredential";
                    break;
                case 'Transaction':
                    controller = "Transaction";
                    methodName = "GetTransactionListFromSystem";
                    break;
            }

            if (controller != "" && methodName != "") {
                var action = {
                    controller: controller,
                    action: methodName,
                    success: function (data) {
                        if (data.length > 0) {
                            data.forEach(function (item) {
                                if (value == "Transaction") {
                                    item.Value = item.Name;
                                } else {
                                    item.Value = item.Code;
                                }
                            });
                            this.setState({ searchList: data });
                            this.setValues(data, value);
                        }
                    }.bind(this)
                };
                this.post(action);
            }
        }
    }, {
        key: "setCredentials",
        value: function setCredentials(data) {
            for (var i = 0; i < data.length; i++) {
                var values = data[i].Values;
                var tmp = [];
                for (var x = 0; x < values.length; x++) {
                    var item = values[x];
                    tmp.push({ Name: bb.localize(item.Name), Value: item.Name, Select: true });
                }
                data[i].Values = tmp;
            }

            this.Credentials.setState({ value: data });
        }
    }, {
        key: "addOrUpdateCredentials",
        value: function addOrUpdateCredentials(callback) {
            if (this.state.addFlag) {
                var model = this.model();
                var credentialValues = bb.clone(this.CredentialValues.val());

                for (var i = 0; i < credentialValues.length; i++) {
                    for (var j = 0; j < this.state.searchList.length; j++) {
                        if (this.state.searchList[j].Value == credentialValues[i].Value) {
                            this.state.searchList[j].Select = credentialValues[i].Select;
                        }
                    }
                }

                var newItem = {
                    Id: "",
                    Name: model.Name,
                    CredentialType: model.CredentialType,
                    Explanation: model.Explanation,
                    Values: this.state.searchList.filter(function (item) {
                        return item.Select == true;
                    })
                };

                this.Credentials.add(newItem);
                this.clearPage();
                callback();
            }
            if (this.state.updateFlag) {
                var selectedIndex = this.Credentials.selectedIndex();
                var model = this.model();
                var credentialValues = bb.clone(this.CredentialValues.val());
                for (var i = 0; i < credentialValues.length; i++) {
                    for (var j = 0; j < this.state.searchList.length; j++) {
                        if (this.state.searchList[j].Value == credentialValues[i].Value) {
                            this.state.searchList[j].Select = credentialValues[i].Select;
                        }
                    }
                }
                var newItem = {
                    Id: model.Id,
                    Name: model.Name,
                    CredentialType: model.CredentialType,
                    Explanation: model.Explanation,
                    Values: this.state.searchList.filter(function (item) {
                        return item.Select == true;
                    })
                };
                this.Credentials.update(newItem, selectedIndex);
                this.clearPage();
                callback();
            }
        }
    }, {
        key: "cancelModal",
        value: function cancelModal(callback) {
            this.clearPage();
            callback();
        }
    }, {
        key: "render",
        value: function render() {
            return React.createElement(
                "div",
                null,
                React.createElement(
                    Panel,
                    null,
                    React.createElement(PageButtons, { Id: "PageButtons", Run: this, Buttons: ['Done'], OnDone: this.onDone.bind(this) }),
                    React.createElement(TextBox, { Run: this, Id: "Id", Hidden: true }),
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: 4 },
                            React.createElement(TextBox, { Run: this, Id: "Name", Caption: "Name", Rules: "presence: true" })
                        ),
                        React.createElement(
                            Col,
                            { Md: 4 },
                            React.createElement(ComboBox, { Run: this, Id: "CredentialType", Caption: "CredentialType", OnChange: this.credentialTypeChanged.bind(this), Rules: "presence: true" })
                        ),
                        React.createElement(
                            Col,
                            { Md: 4 },
                            React.createElement(TextBox, { Run: this, Id: "Explanation", Caption: "Explanation" })
                        )
                    ),
                    React.createElement(
                        Modal,
                        { Run: this, Id: "CredentialModal", Caption: "CredentialValues", OnClose: this.addOrUpdateCredentials.bind(this), OnCancel: this.cancelModal.bind(this), Height: 300 },
                        React.createElement(
                            Row,
                            null,
                            React.createElement(
                                Col,
                                { Md: 12 },
                                React.createElement(TextBox, { Run: this, Id: "CredentialName", Caption: "CredentialName", Hidden: true })
                            )
                        ),
                        React.createElement(
                            Row,
                            null,
                            React.createElement(
                                Col,
                                { Md: 12 },
                                React.createElement(TextBox, { Id: "Search", Run: this, Placeholder: "SearchScreen", OnChange: this.searchScreen.bind(this) })
                            )
                        ),
                        React.createElement(
                            Row,
                            null,
                            React.createElement(
                                Col,
                                { Md: 12 },
                                React.createElement(
                                    DataGrid,
                                    {
                                        Run: this,
                                        ShowPagination: false,
                                        Id: "CredentialValues",
                                        PageSize: 5 },
                                    React.createElement(DataGridColumn, { Name: "Select", SelectAll: true, Editor: { Type: CheckBox } }),
                                    React.createElement(DataGridColumn, { Name: "Name", Caption: "Name" })
                                )
                            )
                        )
                    )
                ),
                React.createElement(
                    Panel,
                    { Caption: "Credentials", CssClass: "m-t-md" },
                    React.createElement(
                        DataGrid,
                        {
                            Run: this,
                            ShowPagination: false,
                            Id: "Credentials",
                            Buttons: "Add,Update,Remove,Clear",
                            OnRowSelect: this.credentialSelected.bind(this),
                            OnAdd: this.credentialAdd.bind(this),
                            OnUpdate: this.credentialUpdate.bind(this),
                            OnClear: this.clearPage.bind(this),
                            OnRemove: this.credentialRemove.bind(this) },
                        React.createElement(DataGridColumn, { Name: "Name", Caption: "Name" }),
                        React.createElement(DataGridColumn, { Name: "CredentialType", Caption: "CredentialType" }),
                        React.createElement(DataGridColumn, { Name: "Explanation", Caption: "Explanation" })
                    )
                )
            );
        }
    }]);

    return CredentialManagement;
}(ViewBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Development = function (_ViewBase) {
    _inherits(Development, _ViewBase);

    function Development() {
        _classCallCheck(this, Development);

        return _possibleConstructorReturn(this, (Development.__proto__ || Object.getPrototypeOf(Development)).apply(this, arguments));
    }

    _createClass(Development, [{
        key: 'init',
        value: function init() {
            var _React$createElement,
                _this2 = this;

            //this.state = { id: 'a' + bb.guid(), component: 'TextBox' };

            this.state.id = 'a' + bb.guid();
            this.state.component = 'AutoCompleteTextarea';
            this.CurrentView = this.getView();
            this.createSteps();
            this.createChildrenComponentList();
            this.createPageNavs();
            this.shared = {
                props: [{ Key: "Id", Value: "Uniq identifier for each component." }, { Key: "Caption", Value: "Component caption for each component." }, { Key: "Disabled", Value: "True if component will be disabled initially, otherwise false." }, { Key: "Hidden", Value: "True if component will be invisible initially, otherwise false." }, { Key: "ToolTip", Value: "Set a ToolTip to the component." }, { Key: "InitValue", Value: "Set an inital value for component, if not given InitValue will be ''." }, { Key: "Value", Value: "Value of the component." }, { Key: "Class", Value: "Class of the component." }],
                methods: [{ Key: "val", Value: "Gets or sets value." }, { Key: "error", Value: "Set error message to component." }, { Key: "reset", Value: "Resets the error messages of component and sets component's initial value." }, { Key: "clear", Value: "Clears both error messages and value of the component." }, { Key: "hide", Value: "Makes component invisible." }, { Key: "show", Value: "Make component visible." }, { Key: "disable", Value: "Disables component." }, { Key: "enable", Value: "Enables component." }, { Key: "getAppState", Value: "Gets the state of the page that component is mounted to." }, { Key: "getView", Value: "Gets the page itself that component is mounted to. " }, { Key: "getViewBase", Value: "Gets the base view of the given page. If given page is already a view then function returns view itself." }],
                events: [{ Key: "OnChange", Value: "Triggered when field is changed." }, { Key: "OnClick", Value: "Triggered when field is clicked." }, { Key: "OnError", Value: "Triggered when an error occured on component." }]
            };
            this.components = {
                AutoCompleteTextarea: {
                    sample: React.createElement(AutoCompleteTextarea, { Rows: 5, Run: this, Id: this.state.id, Caption: 'TextBox' }),
                    sampleCode: '<AutoCompleteTextarea Run={this} Id="ID" Caption="CAPTION" />',
                    props: [{ Key: "Rows", Value: "Text area rows" }, { Key: "OnKeyPress", Value: "To Set a custom KeyPress Event to textarea." }, { Key: "OnFocus", Value: "To Set a custom OnFocus Event to textarea" }],
                    events: [{ Key: "OnLeave", Value: "When cursor leave from input." }, { Key: "KeyPress", Value: "Triggered when a key pressed." }, { Key: "OnFocus", Value: "Triggered when TextBox is focused" }],
                    methods: []
                },
                TextBox: {
                    sample: React.createElement(TextBox, { Run: this, Id: this.state.id, Caption: 'TextBox', ActionButton: true, ActionCaption: 'Test', Action: this.eventFunction.bind(this) }),
                    sampleCode: '<TextBox Run={this} Id="ID" Caption="CAPTION" />',
                    props: [{ Key: "Mask", Value: "Gets or sets mask definition. For implementation please check VanillaMasker." }, { Key: "ActionButton", Value: "Add an action button right side of input. Value can be true or false." }, { Key: "ActionCaption", Value: "Action button caption" }, { Key: "OnKeyPress", Value: "To Set a custom KeyPress Event to TextBox." }, { Key: "OnFocus", Value: "To Set a custom OnFocus Event to TextBox" }, { Key: "Formatter", Value: "The input value will be formatted as given formatter." }],
                    events: [{ Key: "OnLeave", Value: "When cursor leave from input." }, { Key: "Action", Value: "An action when action button triggered. Value can be only function." }, { Key: "KeyPress", Value: "Triggered when a key pressed." }, { Key: "OnFocus", Value: "Triggered when TextBox is focused" }],
                    methods: [{ Key: "disableActionButton", Value: "Disables the action button of the TextBox." }]
                },
                ComboBox: {
                    sample: React.createElement(ComboBox, { Run: this, Id: this.state.id, Caption: 'ComboBox', Data: this.state.data }),
                    sampleCode: '<ComboBox Run={this} Id="ID" Caption="CAPTION" Data={this.state.data} />',
                    events: [],
                    props: [{ Key: "Data", Value: "The array that populates combobox" }, { Key: "Keyfield", Value: "The property to be shown in the list" }, { Key: "ValueField", Value: "Gets or sets the path of the property to use as the actual value for the items in the list" }, { Key: "NoSelect", Value: "If True: user have to select an item(the first listitem will be selected as default). Otherwise user is not forced to select an item." }, { Key: "Size", Value: "Shows given number of elements in the list and makes combobox multiple select." }],
                    methods: [{ Key: "selected", Value: "Returns the selected object from list." }]
                },
                MultipleComplete: {
                    sample: React.createElement(MultipleComplete, (_React$createElement = { Run: this, Maximum: 3 }, _defineProperty(_React$createElement, 'Run', this), _defineProperty(_React$createElement, 'Id', this.state.id), _defineProperty(_React$createElement, 'Caption', 'MultipleComplete'), _defineProperty(_React$createElement, 'Data', this.state.data), _React$createElement)),
                    sampleCode: '<MultipleComplete Run={this} Id="ID" Caption="CAPTION" Data={this.state.data} />',
                    events: [],
                    props: [{ Key: "Keyfield", Value: "The property to be shown in the list" }, { Key: "ValueField", Value: "Gets or sets the path of the property to use as the actual value for the items in the list" }, { Key: "Maximum", Value: "The maximum number of elements that list can have.If not given 9999 default." }],
                    methods: [{ Key: "remove", Value: "Removes the selected item from list" }, { Key: "setCursorPosition", Value: "Sets the mouse cursor position." }]
                },
                Phone: {
                    sample: React.createElement(Phone, { Run: this, Id: this.state.id, Caption: 'Phone', Country: 'TR', TopCountries: ['TR', 'GB', 'US'] }),
                    sampleCode: '<Phone Run={this} Id="ID" Caption="CAPTION" Country="TR"/>',
                    events: [{ Key: "handleKeyDown", Value: "Triggered when a key pressed." }, { Key: "toggle", Value: "Toggles the country list open and closed." }, { Key: "handleClickOutside", Value: "Triggered when anywhere outside the component is clicked. Closes lists." }],
                    props: [{ Key: "TopCountries", Value: "The countries that will be shown top at the list." }, { Key: "Country", Value: "The default selected country in the list." }, { Key: "UseIpLocation", Value: "True to use Ip Location, otherwise false. If not given, default is false." }],
                    methods: [{ Key: " select", Value: "Sets selected country and closes the list." }]
                },
                Password: {
                    sample: React.createElement(Password, { Run: this, Id: this.state.id, Caption: 'Password' }),
                    sampleCode: '<Password Run={this} Id="ID" Caption="CAPTION" />',
                    events: [{ Key: "onBlur", Value: "Triggered when mouse cursor left the component." }, { Key: "onKeyDown", Value: "Triggered when a key pressed." }, { Key: "onFocus", Value: "Triggered when component is focused." }, { Key: "onMouseDown", Value: "Shows password while mouse is clicked." }, { Key: "onMouseUp", Value: "Makes the text password again when mouse is not being clicked." }],
                    props: [{ Key: "OnLeave", Value: "To set a custom mouse leave event to component." }, { Key: "OnKeyPress", Value: "To set a custom key press event to component." }, { Key: "OnKeyPress", Value: "To set a custom focus event to component." }, { Key: "PlaceHolder", Value: "To set a placeholder for text area." }],
                    methods: []
                },
                CurrencyBox: {
                    sample: React.createElement(CurrencyBox, { Run: this, Id: this.state.id, Caption: 'CurrencyBox', Currency: 'GBP', TopCurrencies: ['GBP', 'EUR', 'USD'] }),
                    sampleCode: '<CurrencyBox  Id="ID" Caption="CAPTION" Currency="GBP" />',
                    events: [{ Key: "onCurrencyInputFocused", Value: "Triggered when currency input is focused." }, { Key: "onCurrencyInputBlured", Value: "Triggered when currency input is blured." }, { Key: "onAmountChange", Value: "Triggered when the entered amount changed." }, { Key: "onAmountKeyDown", Value: "Triggered when a key pressed while focused on amount." }, { Key: "onPrecisionChange", Value: "Triggered when the entered precision changed." }, { Key: "onPrecisionKeyDown", Value: "Triggered when a key pressed while focused on precision." }],
                    props: [{ Key: "TopCurrencies", Value: "The currencies that will be shown top at the list." }, { Key: "Currency", Value: "The default selected currency in the list." }, { Key: "UseIpLocation", Value: "True to use Ip Location, otherwise false. If not given, default is false." }, { Key: "HiddenCurrency", Value: "To hide currencies." }, { Key: "LoadCurrencyList", Value: "" }, { Key: "Precision", Value: "Number of digits of precision, if not set default is 2." }, { Key: "Country", Value: "Current country." }, { Key: "OnChange", Value: "To set a custom change event to component." }, { Key: "OnAmountChange", Value: "To set a custom OnAmountChange event to component" }, { Key: "Onchange", Value: "To set a custom OnChange event to component." }, { Key: "DisableCurrency", Value: "Disables currency selection." }],
                    methods: [{ Key: "currency", Value: "Gets or sets currency." }]
                },
                AddressForm: {
                    sample: React.createElement(AddressForm, { Run: this, Id: this.state.id, Caption: 'AddressForm' }),
                    sampleCode: '<AddressForm Run={this}  Id="ID" Caption="CAPTION" />',
                    events: [{ Key: "onCountrySelected", Value: "Occurs when a country selected from list." }, { Key: "onFieldChanged", Value: "Occurs when any field changed." }, { Key: "selectAddress", Value: "Occurs when an address selected from list" }],
                    props: [{ Key: "RenderOptional", Value: "To determine if optional fields will be rendered. Takes true or false." }],
                    methods: []
                },
                AutoComplete: {
                    sample: React.createElement(AutoComplete, { Run: this, Id: this.state.id, Caption: 'AutoComplete', Data: this.state.data }),
                    sampleCode: '<AutoComplete Run={this} Id="ID" Caption="CAPTION" Data={this.state.data} />',
                    events: [{ Key: "OnKeyPress", Value: "Occurs when a key pressed." }, { Key: "OnLeave", Value: "When cursor leave from input." }, { Key: "OnFocus", Value: "Occurs when component is focused." }],
                    props: [{ Key: "Data", Value: "The array that populates list" }, { Key: "Keyfield", Value: "The property to be shown in the list" }, { Key: "ValueField", Value: "Gets or sets the path of the property to use as the actual value for the items in the list" }, { Key: "Number", Value: "Number of maximum suggested results in the list." }, { Key: "PlaceHolder", Value: "Set a placeholder for input area." }, { Key: "OnEnterKeyPress", Value: "To set a custom enter key press event." }, { Key: "OnTabKeyPress", Value: "To set a custom tab key press event." }, { Key: "OnClick", Value: "To set a custom click event." }],
                    methods: [{ Key: "selected", Value: "returns the selected item from list." }, { Key: "find", Value: "Find the results that matches given value." }, { Key: "search", Value: "Searches the value from the list." }, { Key: " select", Value: "Sets the selected item and search text by selected item in the list then closes list." }]
                },
                Box: {
                    sample: React.createElement(Box, { Run: this, Id: this.state.id, Caption: 'Box' }),
                    sampleCode: '<Box Run={this} Id="ID" Caption="CAPTION" />',
                    events: [{ Key: "OnToggle", Value: "Opens Box content." }, { Key: "OnClose", Value: "Closes the Box." }, { Key: "OnOpenSettings", Value: "Opens Settings." }],
                    props: [{ Key: "RowSettings", Value: "Set the row settings with a setting array." }, { Key: "SettingDisable", Value: "Enable or disable settings" }, { Key: "IsDisabled", Value: "Enable or Disable Box" }, { Key: "DisableCollapse", Value: "Enable or disable collapse. " }, { Key: "DisableClose", Value: "Enable or disable close." }],
                    methods: []
                },
                Button: {
                    sample: React.createElement(Button, { Run: this, Id: this.state.id, Caption: 'Button', Type: 'primary', Value: 'Button', OnClick: this.eventFunction.bind(this) }),
                    sampleCode: '<Button Run={this} Id="ID" Caption="CAPTION" />',
                    events: [],
                    props: [{ Key: "Type", Value: "Bootstrap type of the button." }, { Key: "Value", Value: "Text of the button." }, { Key: "Icon", Value: "Display an icon on button." }, { Key: "To", Value: "To navigate other pages. Takes view name and params as parameters." }],
                    methods: []
                },
                ButtonGroup: {
                    sample: React.createElement(ButtonGroup, { Run: this, Id: this.state.id, Caption: 'ButtonGroup', Options: this.state.data }),
                    sampleCode: '<ButtonGroup Run={this} Id="ID" Caption="CAPTION" Options={this.returnSomeDataArray.bind(this)} />',
                    events: [],
                    props: [{ Key: "Options", Value: "The array that populates component's buttons" }],
                    methods: []
                },
                CheckBox: {
                    sample: React.createElement(CheckBox, { Run: this, Id: this.state.id, Caption: 'CheckBox' }),
                    sampleCode: '<CheckBox Run={this} Id="ID" Caption="CAPTION" />',
                    events: [],
                    props: [{ Key: "Value", Value: "True if checkbox is checked initially, otherwise false. The default is false." }, { Key: "TopCaption", Value: "True if the Caption will be located top of the box, otherwise the caption will be located right of the box." }],
                    methods: []
                },
                ComboDatePicker: {
                    sample: React.createElement(ComboDatePicker, { Run: this, Id: this.state.id, Caption: 'ComboDatePicker' }),
                    sampleCode: '<ComboDatePicker Run={this} Id="ID" Caption="CAPTION" />',
                    events: [],
                    props: [{ Key: "MinYear", Value: "The minimum year of the picker." }, { Key: "MaxYear", Value: "The maximum year of the picker." }],
                    methods: []
                },
                Country: {
                    sample: React.createElement(Country, { Run: this, Id: this.state.id, Caption: 'Country' }),
                    sampleCode: '<Country Run={this} Id="ID" Caption="CAPTION" />',
                    events: [{ Key: "OnCountryCodeSelected", Value: "Triggered when country code selected." }, { Key: "OnCountryNameSelected", Value: "Triggered when country name selected." }],
                    props: [{ Key: "HiddenCode", Value: "Set true if country code will be hidden." }],
                    methods: [{ Key: "selected", Value: "Returns the country that is selected from list." }]
                },
                Currency: {
                    sample: React.createElement(Currency, { Run: this, Id: this.state.id, Caption: 'Currency', UseIpLocation: true }),
                    sampleCode: '<Currency Run={this} Id="ID" Caption="CAPTION" />',
                    events: [{ Key: "OnCurrencyCodeChange", Value: "Triggered when currency code changes and sets the matched currency name to the Currency Name input." }, { Key: "OnCurrencyNameChange", Value: "Triggered when currency name changes and sets the matched currency code to the Currency Code input." }],
                    props: [{ Key: "UseIpLocation", Value: "True to use Ip Location, otherwise false. If not given, default is false." }, { Key: "HiddenCode", Value: "To hide currency code set true, otherwise false. Default is false." }, { Key: "HiddenName", Value: "To hide currency name set true,otherwise false. Default is false." }, { Key: "BaseCurrency", Value: "The default selected currency. If not set and UseIpLocation={true}, gets the currency of your location." }],
                    methods: []
                },
                DataGrid: {
                    sample: React.createElement(
                        DataGrid,
                        { Run: this, Id: this.state.id, Caption: 'DataGrid', Value: this.state.data, Buttons: 'Add,Update,Remove' },
                        React.createElement(DataGridColumn, { Name: 'CheckBox', Caption: 'CheckBox', Editor: { Type: CheckBox } }),
                        React.createElement(DataGridColumn, { Name: 'Code', Caption: 'Name' }),
                        React.createElement(DataGridColumn, { Name: 'Value', Caption: 'Value' })
                    ),
                    sampleCode: '<DataGrid Run={this} Id="ID" Caption="CAPTION" Value={this.state.data}><DataGridColumn Name="Code" Caption="Name" /><DataGridColumn Name="Value" Caption="Value" /> </DataGrid>',
                    events: [{ Key: "onToolbarAction", Value: "Triggered when a grid button clicked." }, { Key: "onRowSelect", Value: "Triggered when a row selected on grid." }],
                    props: [{ Key: "Value", Value: "The array that fills DataGrid. If DataGridColumn Names matches the property names of objects that fill the grid, the grid populates automatically." }, { Key: "ShowPageSizeOptions", Value: "To show page size options set true." }, { Key: "PageSizeOptions", Value: "An array that contains number of items to show in one page." }, { Key: "DefaultPageSize", Value: "Default number of items to show in one page." }, { Key: "ShowPagination", Value: "Show or hide pagination. Takes true or false." }, { Key: "PageSize", Value: "Set how many rows will be shown in one page." }, { Key: "Height", Value: "Set height of the grid page." }, { Key: "Buttons", Value: "Creates grid buttons. To create buttons use prop like this: Buttons='Button1,Button2,...' " }, { Key: "On+'ButtonName'", Value: "To set actions to grid buttons." }, { Key: "RowContent", Value: "To create row content. Takes only functions." }, { Key: "AppendToLast", Value: "True if new elements will be added end of the grid, otherwise false." }, { Key: "NoRowsFoundText", Value: "The text will be shown in the grid when no rows found." }, { Key: "OnRowSelect", Value: "To set custom row select event to component." }, { Key: "OnReady", Value: "To set custom ready event to component." }, { Key: "OnUpdated", Value: "To set custom update event to component." }, { Key: "OnPageChange", Value: "To set custom row select event to component." }, { Key: "Unique (DataGridColumn Prop)", Value: "Sets a column as unique key. The all items in the grid must have different unique keys." }, { Key: "Editor (DataGridColumn Prop)", Value: "Create an editor on data grid column." }, { Key: "Width (DataGridColumn Prop)", Value: "Set width of the column." }],
                    methods: [{ Key: "selected", Value: "Returns the selected datagrid item itself." }, { Key: "selectedIndex", Value: "Returns the selected datagrid index." }, { Key: "hideButton", Value: "Hides the given datagrid button." }, { Key: "showButton", Value: "Shows the given datagrid button." }, { Key: "setHeader", Value: "Set a header." }, { Key: "setRowStyle", Value: "Set a row's style." }, { Key: "updateColumnValue", Value: "Updates the value of the given editor column." }, { Key: "getEditor", Value: "if given cell is an editor returns it." }, { Key: "checkDublicate", Value: "Checks if grid has the item with same unique key. Returns true or false." }, { Key: "add", Value: "Adds a new row to the grid.Sets row's recordStatus as 'New'." }, { Key: "addRange", Value: "Adds a set of new rows to the grid." }, { Key: "update", Value: "Updates selected row. Sets row's recordStatus as 'Updated'." }, { Key: "remove", Value: "Marks the selected row as removed.Sets row's recordStatus as 'Deleted' " }, { Key: "expandRowContent", Value: "Expands selected row's content." }]
                },
                DatePicker: {
                    sample: React.createElement(DatePicker, { Run: this, Id: this.state.id, Caption: 'DatePicker' }),
                    sampleCode: '<DatePicker Run={this} Id="ID" Caption="CAPTION" />',
                    events: [{ Key: "OnKeyDown", Value: "Triggered when a down on component." }],
                    props: [{ Key: "OnlyFuture", Value: "Allows only to pick future dates." }, { Key: "OnlyPast", Value: "Allows only to pick past dates." }, { Key: "DisableWeekend", Value: "Prevents picking weekend days." }, { Key: "Placeholder", Value: "Set a placeholder for picker." }, { Key: "HasTime", Value: "If true, additional time picker appears." }, { Key: "ValidateBirthDay", Value: "Allows only to pick dates that 18 and over years ago." }, { Key: "ValidDate", Value: "Set a date as valid date. The dates that before that valid date will be invalid. " }, { Key: "HelpText", Value: "Set a help text." }],
                    methods: [{ Key: "valid", Value: "Validates given date." }]
                },
                DropDown: {
                    sample: React.createElement(Dropdown, { Run: this, Id: this.state.id, Caption: 'DropDown', Data: this.state.data, Size: '5' }),
                    sampleCode: '<DropDown Run={this} Id="ID" Caption="CAPTION" Data={this.state.data} />',
                    events: [],
                    props: [{ Key: "Data", Value: "The array that populates combobox" }, { Key: "Keyfield", Value: "The property to be shown in the list" }, { Key: "ValueField", Value: "Gets or sets the path of the property to use as the actual value for the items in the list" }, { Key: "Size", Value: "Set size of the dropdown list." }, { Key: "NoSelect", Value: "If True: user have to select an item(the first listitem will be selected as default). Otherwise user is not forced to select an item." }, { Key: "Prefix", Value: "Set a prefix for every item in the list. Takes function." }, { Key: "Type", Value: "Set bootstrap class to dropdown toggle button." }],
                    methods: [{ Key: "selected", Value: "returns the selected item itself from list." }]
                },
                EmailForm: {
                    sample: React.createElement(EmailForm, { Run: this, Id: this.state.id, Caption: 'E-mail Form' }),
                    sampleCode: '<EmailForm Run={this} Id="ID" Caption="CAPTION" />',
                    events: [],
                    props: [{ Key: "RenderOptional", Value: "To determine if optional fields will be rendered. Takes true or false." }],
                    methods: []
                },
                FileUpload: {
                    sample: React.createElement(FileUpload, { Run: this, Id: this.state.id, Caption: 'FileUpload', Success: function () {
                            setTimeout(function () {
                                this.Success('');
                            }, 5000);
                        }.bind(this) }),
                    sampleCode: '<FileUpload Run={this} Id="ID" Caption="CAPTION" />',
                    events: [{ Key: "uploadFile", Value: "Uploads selected file to the target folder." }, { Key: "fileSelectionChange", Value: "Triggered when selected file changes." }, { Key: "removeFile", Value: "Removes selected file from uploader." }],
                    props: [{ Key: "SelectedFile", Value: "Set an initial selected file." }, { Key: "UploadFolder", Value: "The path of the folder where items will be updated. If not given, default is: 'files'." }, { Key: "AutoUpload", Value: "Determine if the file will be uploaded automatically when selected." }, { Key: "AcceptType", Value: "Set accept type of uploader." }, { Key: "Success", Value: "Set the method that will be executed when uploading file succeeded." }, { Key: "Error", Value: "Set the method that will be executed when uploading file failed." }, { Key: "OnRemove", Value: "The method that will be executed when uploaded file removed from uploader." }],
                    methods: [{ Key: "uploadFile", Value: "Uploads selected file to the target folder." }]
                },
                ImageUpload: {
                    sample: React.createElement(ImageUpload, { Run: this, Id: this.state.id, Caption: 'ImageUpload' }),
                    sampleCode: '<ImageUpload Run={this} Id="ID" Caption="CAPTION" />',
                    events: [{ Key: "addImage", Value: "Adds selected image to selected folder." }, { Key: "fileSelectionChange", Value: "Triggered when selected files change." }, { Key: "imageSelected", Value: "Triggered when an image selected" }, { Key: "remove", Value: "Removes selected image." }, { Key: "moveLeft", Value: "Move image to left." }, { Key: "moveRight", Value: "Move image to right." }],
                    props: [{ Key: "Images", Values: "Set images initially." }, { Key: "Max", Values: "Maximum number of Images the uploader can have. If not given default is 9999." }, { Key: "UploadFolder", Value: "The path of the folder where items will be updated. If not given, default is: 'files'." }],
                    methods: [{ Key: "remove", Value: "Removes selected image." }, { Key: "moveLeft", Value: "Move image to left." }, { Key: "moveRight", Value: "Move image to right." }]
                },
                LabelValue: {
                    sample: React.createElement(LabelValue, { Run: this, Id: this.state.id, Caption: 'LabelValue', Formetter: 'Currency', Value: '50.0000' }),
                    sampleCode: '<LabelValue Run={this} Id="ID" Caption="CAPTION"  Formetter="Currency" />',
                    events: [],
                    props: [{ Key: "Formatter", Value: "The input value will be formatted as given formatter." }],
                    methods: []
                },
                ModalBox: {
                    sample: React.createElement(
                        'div',
                        null,
                        React.createElement(Modal, { Run: this, Id: 'ModalBox', Caption: 'ModalBox' }),
                        ' ',
                        React.createElement(Button, { Run: this, Id: 'ModalOpener', Value: 'Open Modal', OnClick: function () {
                                this.ModalBox.open();
                            }.bind(this) })
                    ),
                    sampleCode: '<Modal Run={this} Id="ID" Caption="CAPTION" />',
                    events: [{ Key: "OnDone", Value: "Triggered when done or close button is clicked." }, { Key: "OnCancel", Value: "Triggered when cancel button is clicked." }],
                    props: [{ Key: "Buttons", Value: "Creates modal box buttons. To create buttons use prop like this: Buttons='Button1,Button2,...' " }, { Key: "BodyClass", Value: "Bootstrap class name of body(<div> tag)." }, { Key: "Size", Value: "Determine the size of the modal. Small, Medium or Large." }, { Key: "HideButton", Value: "To hide button. Takes true or false." }, { Key: "OnCancel", Value: "The function that will be executed when modal box is closed." }, { Key: "OnClose", Value: "The fuModalnction that will be executed when 'done' button pushed." }, { Key: "On+'ButtonName'", Value: "To set actions to modal buttons." }],
                    methods: [{ Key: "open", Value: "Opens the modal box." }, { Key: "close", Value: "Closes the modal box with state of cancel." }, { Key: "done", Value: "Closes the modal box with state of done." }]
                },
                Navbar: {
                    sample: React.createElement(Navbar, { Run: this, Id: this.state.id, Caption: 'Navbar', Navigation: this.state.navs }),
                    sampleCode: '<Navbar Run={this} Id="ID" Caption="CAPTION" Navigation={this.state.navs} />',
                    events: [{ Key: "handlePageClick", Value: "Occured when outside of the component clicked. Closes all dropdowns." }],
                    props: [{ Key: "Navigation", Value: "The array that contains page navigations." }],
                    methods: [{ Key: "closeAll", Value: "Closes all opened dropdowns." }]
                },
                PhoneForm: {
                    sample: React.createElement(PhoneForm, { Run: this, Id: this.state.id, Caption: 'PhoneForm' }),
                    sampleCode: '<PhoneForm Run={this} Id="ID" Caption="CAPTION" />',
                    events: [],
                    props: [{ Key: "RenderOptional", Value: "To determine if optional fields will be rendered. Takes true or false." }],
                    methods: []
                },
                ProgressBox: {
                    sample: React.createElement(
                        'div',
                        null,
                        React.createElement(ProgressBox, { Run: this, Id: 'ProgressBox', Caption: 'ProgressBox', StepCount: 10 }),
                        ' ',
                        React.createElement(Button, { Run: this, Id: 'StepUp', Value: 'Step Up', OnClick: function () {
                                this.ProgressBox.update();
                            }.bind(this) })
                    ),
                    sampleCode: '<ProgressBox Run={this} Id="ID" Caption="CAPTION" StepCount={10} />',
                    events: [],
                    props: [{ Key: "StepCount", Value: "Number of steps that progress take." }, { Key: "Ondone", Value: "Set custom event that will be triggered when process is done." }],
                    methods: [{ Key: "update", Value: "Updates the value of progress box." }]
                },
                RadioButton: {
                    sample: React.createElement(RadioButton, { Run: this, Id: this.state.id, Caption: 'RadioButton', Data: this.state.data }),
                    sampleCode: '<RadioButton Run={this} Id="ID" Caption="CAPTION" Data={[data1,data2,...]} />',
                    events: [],
                    props: [{ Key: "Data", Value: "For each data in array creates a radio button." }, { Key: "Keyfield", Value: "The property to be shown as capiton" }, { Key: "ValueField", Value: "Gets or sets the path of the property to use as the actual value for the item." }, { Key: "Direction", Value: "Set right to left or left to right direction of boxes." }],
                    methods: []
                },
                StepProgress: {
                    sample: React.createElement(StepProgress, { Run: this, Id: this.state.id, Caption: 'StepProgress', Steps: this.state.steps }),
                    sampleCode: '<StepProgress Run={this} Id="ID" Caption="CAPTION" />',
                    events: [],
                    props: [{ Key: "Steps", Value: "Steps of the progress." }, { Key: "ClickEnable", Value: "Enable or disable moving on steps by clicking on step bar." }],
                    methods: []
                },
                Toast: {
                    sample: React.createElement(
                        'div',
                        null,
                        ' ',
                        React.createElement(Toast, { Run: this, Id: 'Toast', Caption: 'Toast', Type: 'warning' }),
                        ' ',
                        React.createElement(Button, { Run: this, Id: 'ShowToast', Value: 'Show Toast', OnClick: function () {
                                this.Toast.warning('This is a warning!');
                            }.bind(this) })
                    ),
                    sampleCode: '<Toast Run={this} Id="ID" Caption="CAPTION" Type="warning" />',
                    events: [],
                    props: [{ Key: "Type", Value: "Type of the component; warning, success, fail." }, { Key: "Duration", Value: "The duration that the component will be shown(miliseconds)." }],
                    methods: [{ Key: "warning", Value: "Shows component with warning theme and given message." }, { Key: "error", Value: "Shows component with error theme and given message." }, { Key: "success", Value: "Shows component with success theme and given message." }, { Key: "hide", Value: "Hides the component." }]
                },
                ToolTip: {
                    sample: React.createElement(
                        'div',
                        null,
                        React.createElement(
                            'span',
                            null,
                            'Drag mouse lime colored line!'
                        ),
                        React.createElement(
                            'div',
                            { style: { backgroundColor: '#e6ffcc', margin: '10px' } },
                            React.createElement(ToolTip, { Run: this, Id: this.state.id, Caption: 'Drag mouse below!', Content: function () {
                                    return 'Hello this is a ToolTip';
                                }.bind(this) })
                        )
                    ),
                    sampleCode: '<ToolTip Run={this} Id="ID" Caption="CAPTION" />',
                    events: [{ Key: "onMouseEnter", Value: "Triggered when mouse entered tooltip area. Opens Tooltip." }, { Key: "onMouseLeave", Value: "Triggered when moouse left tooltip area. Closes Tooltip depending the props." }, { Key: "handlePageClick", Value: "Triggered when outside of the component clicked. Closes the Tooltip." }],
                    props: [{ Key: "Content", Value: "The content of the tooltip. Takes function." }, { Key: "DisplayOnClick", Value: "Show tooltip not on hover but on click." }, { Key: "Position", Value: "The position of tooltip. Can take, 'Left', 'Right', 'Top'. If not given default is bottom." }, { Key: "DestroyOnClickOutside", Value: "Determine if tooltip will be hidden on click outside or not." }],
                    methods: []
                },
                Wizard: {
                    sample: React.createElement(
                        Wizard,
                        { Run: this, Id: this.state.id, Caption: 'Wizard' },
                        this.state.childrenComponents
                    ),

                    sampleCode: '<Wizard Run={this} Id="ID" Caption="CAPTION">{childrenComponents}</Wizard>',
                    events: [{ Key: "StepClick", Value: "Triggered when a step on progress bar is clicked. Only past steps are allowed." }, { Key: "OnNext", Value: "The method that will be executed when next button is clicked." }, { Key: "OnPrevious", Value: "The method that will be executed when previous button is clicked." }],
                    props: [{ Key: "CollapsableHeader", Value: "If true makes header collapsable and closable." }, { Key: "HideButton", Value: "Hides buttons." }, { Key: "DoneText", Value: "Custom button text for last step 'done' button." }, { Key: "ModelName", Value: "The name of the model to validate." }, { Key: "OnNext", Value: "The method that will be executed when next button is clicked." }, { Key: "OnPrevious", Value: "The method that will be executed when previous button is clicked." }, { Key: "DoneCallBack", Value: "When done button is clicked; instead of posting page this function will be executed. If user clicks done button in given done time; this time page posts." }, { Key: "DoneTime", Value: "The time that given for posting page." }, { Key: "ReturnCallback", Value: "Executed when done time finishes." }],
                    methods: [{ Key: "validate", Value: "Validates the model of the component." }, { Key: "next", Value: "Jumps next step." }, { Key: "prev", Value: "Jumps previous step." }, { Key: "done", Value: "Completes the wizard." }, { Key: "open", Value: "Opens the given step(by name)." }, { Key: "showStep", Value: "Makes visible the given step(by name) if it's invisible." }, { Key: "hideStep", Value: "Makes invisible the given step(by name)." }, { Key: "stopProgress", Value: "Stops the running progress." }]
                },
                Timer: {
                    sample: React.createElement(
                        'div',
                        null,
                        React.createElement(Timer, { Run: this, Id: 'TimerTest', Caption: 'Timer', Duration: '3000' }),
                        React.createElement(Button, { Id: 'TimerTestStop', Value: 'Stop', OnClick: function OnClick() {
                                _this2.TimerTest.stop();
                            }, Class: 'm-l-md pull-right' }),
                        React.createElement(Button, { Id: 'TimerTestStart', Value: 'Start', OnClick: function OnClick() {
                                _this2.TimerTest.start();
                            }, Class: 'm-l-md pull-right' })
                    ),

                    sampleCode: '<Timer Run={this} Id="ID" Caption="CAPTION" />',
                    events: [{ Key: "OnComplete", Value: "Triggered when count completed." }],
                    props: [{ Key: "Duration", Value: "Timer duration." }, { Key: "Width", Value: "Timer width. default is 100px." }, { Key: "Height", Value: "Timer height. default is 100px." }, { Key: "Color", Value: "Timer color. default is #c2c2c2" }],
                    methods: [{ Key: "start", Value: "Start timer." }, { Key: "stop", Value: "stop timer." }]
                }
            };
        }
    }, {
        key: 'createSteps',
        value: function createSteps() {
            var steps = [];
            for (var i = 0; i < 3; i++) {
                steps.push({ Caption: 'Caption' + i, Value: 'Value' + i });
            }
            this.state.steps = steps;
        }
        //For Wizard

    }, {
        key: 'createChildrenComponentList',
        value: function createChildrenComponentList() {
            var arr = [];
            for (var i = 0; i < 3; i++) {
                arr.push(React.createElement(
                    Panel,
                    { key: bb.guid(), Id: 'TestPanel' + i, Name: 'TestPanel' + i },
                    React.createElement(TextBox, { Run: this, Id: 'txt' + i, Caption: 'Test text ' + i }),
                    React.createElement(CheckBox, { Run: this, Id: 'chk' + i, Caption: 'Test check ' + i, TopCaption: true })
                ));
            }
            this.state.childrenComponents = arr;
        }
        //For NavBar

    }, {
        key: 'createPageNavs',
        value: function createPageNavs() {
            var childNavs = [{ Page: 'child1', Caption: 'child1', IsVisible: true }, { Page: 'child2', Caption: 'child2', IsVisible: true }];
            var navs = [{ Page: 'Page1', Caption: 'Page1', Items: childNavs, IsVisible: true }, { Page: 'Page2', Caption: 'Page2', Items: childNavs, IsVisible: true }, { Page: 'Page2', Caption: 'Page2', IsVisible: true }];
            this.state.navs = navs;
        }
    }, {
        key: 'eventFunction',
        value: function eventFunction() {
            alert("Event fired by " + this.state.component);
        }
    }, {
        key: 'componentSelected',
        value: function componentSelected(value, props) {
            var id = 'a' + bb.guid();
            this.setState({ id: id, component: props.Id });
        }
    }, {
        key: 'renderMenu',
        value: function renderMenu() {
            var _this3 = this;

            var components = Object.getOwnPropertyNames(this.components);
            var arr = [];

            components.forEach(function (item, index) {
                var className = item == _this3.state.component ? "active-menu" : "";
                arr.push(React.createElement(
                    'div',
                    { key: index, className: className },
                    React.createElement(Anchor, { Id: item, Value: item, OnClick: _this3.componentSelected.bind(_this3) })
                ));
            });

            return arr;
        }
    }, {
        key: 'onDone',
        value: function onDone() {}
    }, {
        key: 'renderComponentSection',
        value: function renderComponentSection() {
            var component = this.components[this.state.component];
            var props = this.shared.props.concat(component.props);
            var methods = this.shared.methods.concat(component.methods);
            var events = this.shared.events.concat(component.events);

            var propset = [];
            var methodset = [];
            var eventset = [];

            props.forEach(function (item, i) {
                propset.push(React.createElement(LabelValue, { key: i, Id: bb.guid(), Caption: item.Key, Value: item.Value }));
            });
            methods.forEach(function (item, i) {
                methodset.push(React.createElement(LabelValue, { key: i, Id: bb.guid(), Caption: item.Key, Value: item.Value }));
            });
            events.forEach(function (item, i) {
                eventset.push(React.createElement(LabelValue, { key: i, Id: bb.guid(), Caption: item.Key, Value: item.Value }));
            });

            return React.createElement(
                'div',
                null,
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: '12' },
                        React.createElement(PageButtons, { Id: 'PageButtons', Run: this, HideRefresh: true })
                    )
                ),
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: '12', CssClass: 'm-b-md border-bottom' },
                        component.sample
                    )
                ),
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: '12', CssClass: 'border-bottom' },
                        React.createElement(
                            'h4',
                            null,
                            ' Usage'
                        ),
                        React.createElement(
                            'pre',
                            null,
                            component.sampleCode
                        )
                    )
                ),
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: '12', CssClass: 'border-bottom' },
                        React.createElement(
                            'h4',
                            null,
                            'Properties'
                        ),
                        propset
                    )
                ),
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: '12', CssClass: 'border-bottom' },
                        React.createElement(
                            'h4',
                            null,
                            'Methods'
                        ),
                        methodset
                    )
                ),
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: '12' },
                        React.createElement(
                            'h4',
                            null,
                            'Events'
                        ),
                        eventset
                    )
                )
            );
        }
    }, {
        key: 'render',
        value: function render() {

            return React.createElement(
                Panel,
                null,
                React.createElement(
                    Tab,
                    { Id: 'ContentTab' },
                    React.createElement(
                        TabContent,
                        { Caption: 'UX Documentation' },
                        React.createElement(
                            Row,
                            null,
                            React.createElement(
                                Col,
                                { Md: '2' },
                                this.renderMenu()
                            ),
                            React.createElement(
                                Col,
                                { Md: '10' },
                                React.createElement(
                                    'h3',
                                    null,
                                    this.state.component
                                ),
                                React.createElement('hr', null),
                                this.renderComponentSection()
                            )
                        )
                    ),
                    React.createElement(
                        TabContent,
                        { Caption: 'Framework Documentation' },
                        React.createElement(
                            Row,
                            null,
                            React.createElement(
                                Col,
                                { Md: '2' },
                                React.createElement(Anchor, { Id: bb.guid(), Value: 'Introduction' }),
                                React.createElement(Anchor, { Id: bb.guid(), Value: 'Setup and Configuration' }),
                                React.createElement(Anchor, { Id: bb.guid(), Value: 'Database' }),
                                React.createElement(Anchor, { Id: bb.guid(), Value: 'Authentication' }),
                                React.createElement(Anchor, { Id: bb.guid(), Value: 'Api' }),
                                React.createElement(Anchor, { Id: bb.guid(), Value: 'Logging' }),
                                React.createElement(Anchor, { Id: bb.guid(), Value: 'Scheduled Task' }),
                                React.createElement(Anchor, { Id: bb.guid(), Value: 'IIS and Kestrel Setup' }),
                                React.createElement(Anchor, { Id: bb.guid(), Value: 'Deploy and Publish' })
                            ),
                            React.createElement(
                                Col,
                                { Md: '10', CssClass: 'well' },
                                'Content'
                            )
                        )
                    )
                )
            );
        }
    }]);

    return Development;
}(ViewBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ForgotPassword = function (_ViewBase) {
    _inherits(ForgotPassword, _ViewBase);

    function ForgotPassword() {
        _classCallCheck(this, ForgotPassword);

        return _possibleConstructorReturn(this, (ForgotPassword.__proto__ || Object.getPrototypeOf(ForgotPassword)).apply(this, arguments));
    }

    _createClass(ForgotPassword, [{
        key: 'title',
        value: function title() {
            return false;
        }
    }, {
        key: 'sendPasswordResetEmail',
        value: function sendPasswordResetEmail() {
            var _this2 = this;

            var model = this.model();
            this.validate(model, "PasswordResetData", function () {
                var action = {
                    controller: 'User',
                    action: 'SendPasswordResetEmail',
                    params: model,
                    success: function (result, msg) {
                        this.success(msg);
                    }.bind(_this2)
                };
                _this2.post(action);
            });
        }
    }, {
        key: 'render',
        value: function render() {
            return React.createElement(
                'div',
                null,
                React.createElement(
                    'div',
                    { className: 'container' },
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Xs: '12' },
                            React.createElement(
                                Panel,
                                { Caption: 'dontworryyouraccountissafe', CssClass: 'middle-box', CaptionClass: 'full-width text-center' },
                                React.createElement('div', { ref: 'error', className: 'alert alert-danger page-alert animated fadeInDown ibox-shadow' }),
                                React.createElement(
                                    Row,
                                    { CssClass: 'm-t-lg' },
                                    React.createElement(
                                        Col,
                                        { Md: '12' },
                                        React.createElement(TextBox, { Run: this, Id: 'Email', Caption: 'Email' })
                                    )
                                ),
                                React.createElement(
                                    Row,
                                    { CssClass: 'm-t-sm' },
                                    React.createElement(
                                        Col,
                                        { Xs: 6 },
                                        React.createElement(Button, { Run: this, Id: 'CancelButton', Value: 'Cancel', To: 'Login' })
                                    ),
                                    React.createElement(
                                        Col,
                                        { Xs: 6 },
                                        React.createElement(Button, { Run: this, Id: 'MessageButton', Value: 'SendNewPassword', Type: 'primary', OnClick: this.sendPasswordResetEmail.bind(this) })
                                    )
                                )
                            )
                        )
                    )
                )
            );
        }
    }]);

    return ForgotPassword;
}(ViewBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Login = function (_ViewBase) {
    _inherits(Login, _ViewBase);

    function Login() {
        _classCallCheck(this, Login);

        return _possibleConstructorReturn(this, (Login.__proto__ || Object.getPrototypeOf(Login)).apply(this, arguments));
    }

    _createClass(Login, [{
        key: "load",
        value: function load() {
            var user = this.user();
            if (user != null) {
                this.open('Dashboard');
            }

            document.addEventListener("keydown", this.keypressFunc.bind(this));
            var message = bb.getStore("message");
            bb.clearStore();
            if (message != null) {
                this.error(message);
            }
        }
    }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
            document.removeEventListener('keydown', this.keypressFunc.bind(this));
        }
    }, {
        key: "keypressFunc",
        value: function keypressFunc(event) {
            switch (event.key) {
                case "Enter":
                    this.login();
                    break;
                default:
                    break;
            }
        }
    }, {
        key: "title",
        value: function title() {
            return false;
        }
    }, {
        key: "login",
        value: function login() {
            var _this2 = this;

            var model = this.model();
            if (!bb.inu(brand)) {
                model.Brand = brand;
            }
            this.validate(model, 'LoginModel', function (serverModel) {
                var action = {
                    controller: "Authorization",
                    action: "Authenticate",
                    params: serverModel,
                    success: function (result) {
                        if (result.HasTempPassword === false) {
                            var user = result.User;
                            var navAction = {
                                controller: "Navigation",
                                action: "GetUserNavigation",
                                success: function (navResult) {
                                    this.props.App.login(user, navResult);
                                }.bind(this)
                            };
                            this.post(navAction);
                        } else {
                            var resetParams = {
                                userId: result.UserId,
                                resetToken: result.PasswordResetToken
                            };

                            this.open('ResetPassword', resetParams);
                        }
                    }.bind(_this2)
                };
                _this2.post(action);
            });
        }
    }, {
        key: "gotoSignup",
        value: function gotoSignup() {
            this.open("Signup");
        }
    }, {
        key: "error",
        value: function error(msg) {
            this.refs.error.innerHTML = this.localize(msg);
        }
    }, {
        key: "render",
        value: function render() {

            return React.createElement(
                "div",
                { id: "LoginBox" },
                React.createElement(
                    "div",
                    { className: "container" },
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Xs: "12" },
                            React.createElement(
                                Panel,
                                { Caption: "LoginSlogan", CssClass: "middle-box", CaptionClass: "full-width text-center" },
                                this.state.app.props.SignUpDisable == false ? React.createElement(
                                    "div",
                                    { className: "text-center purple-color" },
                                    React.createElement(
                                        Localize,
                                        null,
                                        "doyouhaveanaccount"
                                    ),
                                    " ",
                                    React.createElement(
                                        "a",
                                        { href: "javascript:void(0)", onClick: this.gotoSignup.bind(this) },
                                        React.createElement(
                                            "strong",
                                            null,
                                            React.createElement(
                                                Localize,
                                                { Upper: true },
                                                "Signup"
                                            )
                                        )
                                    )
                                ) : null,
                                React.createElement("div", { ref: "error", className: "alert alert-danger page-alert animated fadeInDown ibox-shadow" }),
                                React.createElement(
                                    Row,
                                    { CssClass: "m-t-lg" },
                                    React.createElement(
                                        Col,
                                        { Md: "12" },
                                        React.createElement(TextBox, { Run: this, Id: "UserName", Caption: "Email" })
                                    )
                                ),
                                React.createElement(
                                    Row,
                                    null,
                                    React.createElement(
                                        Col,
                                        { Md: "12" },
                                        React.createElement(TextBox, { Run: this, Id: "Password", Caption: "Password", Type: "password" })
                                    )
                                ),
                                React.createElement(
                                    Row,
                                    null,
                                    React.createElement(
                                        Col,
                                        { Md: "12" },
                                        React.createElement(Button, { Run: this, Id: "ForgetPasswordButton", Value: "ForgetPassword", Type: "link", Class: "pull-right", To: "ForgotPassword" })
                                    )
                                ),
                                React.createElement(
                                    Row,
                                    { CssClass: "m-t-md" },
                                    React.createElement(Col, { Md: "3" }),
                                    React.createElement(
                                        Col,
                                        { Md: "6" },
                                        React.createElement(Button, { Run: this, Id: "LoginButton", Value: "Login", Type: "primary", OnClick: this.login.bind(this) })
                                    )
                                )
                            )
                        )
                    )
                )
            );
        }
    }]);

    return Login;
}(ViewBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LogsManagement = function (_ViewBase) {
    _inherits(LogsManagement, _ViewBase);

    function LogsManagement() {
        _classCallCheck(this, LogsManagement);

        return _possibleConstructorReturn(this, (LogsManagement.__proto__ || Object.getPrototypeOf(LogsManagement)).apply(this, arguments));
    }

    _createClass(LogsManagement, [{
        key: "init",
        value: function init() {
            this.state.folders = [];
        }
    }, {
        key: "load",
        value: function load() {
            this.getFolder();
            this.Level.setState({ data: this.parameters("LogLevelType"), keyField: "Definition", valueField: "Value" });
            this.getLastLogFolder();
        }
    }, {
        key: "getFolder",
        value: function getFolder() {
            var action = {
                controller: 'Logs',
                action: 'GetLogsFile',
                success: function (data) {
                    var _this2 = this;

                    this.getLastLogFolder(data, function (folder) {
                        _this2.Folder.setState({ data: data, keyField: "Code", valueField: "Value", value: folder });
                    });
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: "folderChange",
        value: function folderChange(item) {
            this.error("");
            this.Logger.setState({ value: "" });
            this.Message.setState({ value: "" });
            this.setState({ folder: item });

            var action = {
                controller: 'Logs',
                action: 'GetLogs',
                params: {
                    Folder: item,
                    FromServer: false
                },
                success: function (data) {
                    this.LogList.setState({ value: data });
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: "getLastLogFolder",
        value: function getLastLogFolder(data, callBack) {
            if (!bb.inu(data)) {

                var dataArray = [];

                for (var i = 0; i < data.length; i++) {
                    dataArray.push(data[i].Value.toString().match("\\d{4}-\\d{2}-\\d{2}"));
                }
                dataArray.sort();

                var folder = "all-" + dataArray[dataArray.length - 1] + ".log";

                this.folderChange(folder);
                callBack(folder);
            }
        }
    }, {
        key: "logOpen",
        value: function logOpen(item) {
            var _this3 = this;

            this.setState({ detail: item.Message }, function () {
                _this3.forceUpdate();
            });

            this.LogModal.open();
        }
    }, {
        key: "LogSearch",
        value: function LogSearch() {
            this.error("");
            var model = this.model();

            if (model.StartTime == "") {
                model.StartTime = "00:00:00";
            }
            if (model.EndTime == "") {
                model.EndTime = "23:59:59";
            }

            var d = new moment(model.StartTime, 'HH:mm:ss');
            var e = new moment(model.EndTime, 'HH:mm:ss');

            var requestObject = {
                Folder: this.state.folder,
                Level: model.Level,
                Logger: model.Logger,
                Message: model.Message,
                StartTime: moment(d).format("HH:mm:ss"),
                EndTime: moment(e).format("HH:mm:ss")
            };

            if (requestObject.Folder == "") {
                this.error("notselectfile");
            } else {
                var action = {
                    controller: 'Logs',
                    action: 'GetLogSearhResult',
                    params: requestObject,
                    success: function (data) {
                        this.LogList.setState({ value: data });
                    }.bind(this)
                };
                this.post(action);
            }
        }
    }, {
        key: "logClear",
        value: function logClear() {
            this.error("");
            this.clear();
        }
    }, {
        key: "render",
        value: function render() {
            return React.createElement(
                "div",
                null,
                React.createElement(
                    Modal,
                    { Run: this, Id: "LogModal", Caption: "Log Message Detail", Height: 450 },
                    this.state.detail,
                    React.createElement("br", null)
                ),
                React.createElement(
                    Panel,
                    null,
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: 12 },
                            React.createElement(PageButtons, { Id: "PageButtons", Run: this, HideRefresh: true })
                        )
                    ),
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: 6 },
                            React.createElement(ComboBox, { Run: this, Id: "Folder", Caption: "Folder", OnChange: this.folderChange.bind(this) })
                        ),
                        React.createElement(
                            Col,
                            { Md: 6 },
                            React.createElement(ComboBox, { Run: this, Id: "Level", Caption: "Level" })
                        )
                    ),
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: 6 },
                            React.createElement(TextBox, { Run: this, Id: "Logger", Caption: "Logger" })
                        ),
                        React.createElement(
                            Col,
                            { Md: 6 },
                            React.createElement(TextBox, { Run: this, Id: "Message", Caption: "Message" })
                        )
                    ),
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: 6 },
                            React.createElement(TextBox, { Run: this, Id: "StartTime", Caption: "StartTime", Mask: "Time" })
                        ),
                        React.createElement(
                            Col,
                            { Md: 6 },
                            React.createElement(TextBox, { Run: this, Id: "EndTime", Caption: "EndTime", Mask: "Time" })
                        )
                    )
                ),
                React.createElement(
                    Panel,
                    { CssClass: "m-t-md" },
                    React.createElement(
                        DataGrid,
                        {
                            Run: this,
                            Id: "LogList",
                            Height: 500,
                            Buttons: "Clear,List",
                            OnClear: this.logClear.bind(this),
                            OnRowSelect: this.logOpen.bind(this),
                            OnList: this.LogSearch.bind(this) },
                        React.createElement(DataGridColumn, { Name: "Date", Caption: "Date", Width: 200 }),
                        React.createElement(DataGridColumn, { Name: "Logger", Caption: "Logger" }),
                        React.createElement(DataGridColumn, { Name: "Level", Caption: "Level", Width: 100 }),
                        React.createElement(DataGridColumn, { Name: "Message", Caption: "Message" })
                    )
                )
            );
        }
    }]);

    return LogsManagement;
}(ViewBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NavigationManagement = function (_ViewBase) {
    _inherits(NavigationManagement, _ViewBase);

    function NavigationManagement() {
        _classCallCheck(this, NavigationManagement);

        return _possibleConstructorReturn(this, (NavigationManagement.__proto__ || Object.getPrototypeOf(NavigationManagement)).apply(this, arguments));
    }

    _createClass(NavigationManagement, [{
        key: 'load',
        value: function load() {
            var action = {
                controller: 'Navigation',
                action: 'GetNavigation',
                success: function (data) {
                    this.NavigationRootGrid.setState({ value: data });
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'rootGridClear',
        value: function rootGridClear() {
            this.NavigationFirstChildGrid.setState({ value: [] });
        }
    }, {
        key: 'rootGridRowSelected',
        value: function rootGridRowSelected(row) {
            if (!bb.inu(row.Items)) {
                this.NavigationFirstChildGrid.setState({ value: row.Items });
            } else {
                this.NavigationFirstChildGrid.setState({ value: [] });
            }
        }
    }, {
        key: 'rootGridNew',
        value: function rootGridNew() {
            this.open("NavigationManagementDetail", {});
        }
    }, {
        key: 'rootGridUpdate',
        value: function rootGridUpdate() {
            var item = this.NavigationRootGrid.selected();
            if (!bb.inu(item)) {
                var params = { item: item };
                this.open("NavigationManagementDetail", params);
            }
        }
    }, {
        key: 'firstChildGridUpdate',
        value: function firstChildGridUpdate() {
            var item = this.NavigationFirstChildGrid.selected();
            if (!bb.inu(item)) {
                var params = { item: item };
                this.open("NavigationManagementDetail", params);
            }
        }
    }, {
        key: 'firstChildGridNew',
        value: function firstChildGridNew() {
            var root = this.NavigationRootGrid.selected();
            if (!bb.inu(root)) {
                var params = { root: root };
                this.open("NavigationManagementDetail", params);
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var msg = this.params();
            if (!bb.inu(msg)) {
                this.success(msg);
            }
            return React.createElement(
                'div',
                null,
                React.createElement(
                    Panel,
                    null,
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: 12 },
                            React.createElement(PageButtons, { Id: 'PageButtons', Run: this, HideRefresh: true })
                        )
                    ),
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: 12 },
                            React.createElement(
                                Label,
                                { Class: 'panel-label' },
                                'Root'
                            )
                        )
                    ),
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: 12 },
                            React.createElement(
                                DataGrid,
                                {
                                    Run: this,
                                    Id: 'NavigationRootGrid',
                                    Buttons: 'New,Update,Clear',
                                    OnRowSelect: this.rootGridRowSelected.bind(this),
                                    OnClear: this.rootGridClear.bind(this),
                                    OnNew: this.rootGridNew.bind(this),
                                    OnUpdate: this.rootGridUpdate.bind(this),
                                    ShowPagination: false },
                                React.createElement(DataGridColumn, { Name: 'Caption', Caption: 'Caption' }),
                                React.createElement(DataGridColumn, { Name: 'Page', Caption: 'Page' }),
                                React.createElement(DataGridColumn, { Name: 'Controller', Caption: 'Controller' }),
                                React.createElement(DataGridColumn, { Name: 'Icon', Caption: 'Icon' }),
                                React.createElement(DataGridColumn, { Name: 'IsVisible', Caption: 'IsVisible', Formatter: 'Bool' }),
                                React.createElement(DataGridColumn, { Name: 'Order', Caption: 'Order' }),
                                React.createElement(DataGridColumn, { Name: 'DateCreated', Caption: 'DateCreated' }),
                                React.createElement(DataGridColumn, { Name: 'DateModified', Caption: 'DateModified' })
                            )
                        )
                    )
                ),
                React.createElement(
                    Panel,
                    { Caption: 'FirstChild', CssClass: 'm-t-md' },
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: 12 },
                            React.createElement(
                                DataGrid,
                                {
                                    Run: this,
                                    Id: 'NavigationFirstChildGrid',
                                    Buttons: 'New,Update,Clear',
                                    OnNew: this.firstChildGridNew.bind(this),
                                    OnUpdate: this.firstChildGridUpdate.bind(this),
                                    ShowPagination: false },
                                React.createElement(DataGridColumn, { Name: 'Caption', Caption: 'Caption' }),
                                React.createElement(DataGridColumn, { Name: 'Page', Caption: 'Page' }),
                                React.createElement(DataGridColumn, { Name: 'Controller', Caption: 'Controller' }),
                                React.createElement(DataGridColumn, { Name: 'Icon', Caption: 'Icon' }),
                                React.createElement(DataGridColumn, { Name: 'IsVisible', Caption: 'IsVisible', Formatter: 'Bool' }),
                                React.createElement(DataGridColumn, { Name: 'Order', Caption: 'Order' }),
                                React.createElement(DataGridColumn, { Name: 'DateCreated', Caption: 'DateCreated' }),
                                React.createElement(DataGridColumn, { Name: 'DateModified', Caption: 'DateModified' })
                            )
                        )
                    )
                )
            );
        }
    }]);

    return NavigationManagement;
}(ViewBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NavigationManagementDetail = function (_ViewBase) {
    _inherits(NavigationManagementDetail, _ViewBase);

    function NavigationManagementDetail() {
        _classCallCheck(this, NavigationManagementDetail);

        return _possibleConstructorReturn(this, (NavigationManagementDetail.__proto__ || Object.getPrototypeOf(NavigationManagementDetail)).apply(this, arguments));
    }

    _createClass(NavigationManagementDetail, [{
        key: 'onDone',
        value: function onDone() {
            var model = this.model();
            this.validate(model, "NavigationModel", function () {
                var action = {
                    controller: 'Navigation',
                    action: 'AddOrUpdateNavigationItem',
                    params: model,
                    success: function (result, msg) {
                        this.open("NavigationManagement", msg);
                    }.bind(this)
                };
                this.post(action);
            }.bind(this));
        }
    }, {
        key: 'load',
        value: function load() {
            this.loadIcon();
        }
    }, {
        key: 'onCancel',
        value: function onCancel() {
            this.state.app.back();
        }
    }, {
        key: 'loadIcon',
        value: function loadIcon() {
            this.Icon.setState({ data: this.parameters("FontAwesome"), keyField: "Definition", valueField: "Value" }, function () {
                var params = this.params();
                if (!bb.inu(params)) {
                    if (!bb.inu(params.item)) {
                        this.Icon.val(params.item.Icon);
                    }
                }
            }.bind(this));
        }
    }, {
        key: 'render',
        value: function render() {
            var params = this.params();
            var isRoot = true;
            var parentId = 0;
            var item = {};

            if (!bb.inu(params)) {
                if (!bb.inu(params.root)) {
                    parentId = params.root.Id;
                    isRoot = false;
                } else if (!bb.inu(params.item)) {
                    item = params.item;
                    parentId = item.ParentId;
                    isRoot = item.IsRoot;
                }
            }

            return React.createElement(
                'div',
                null,
                React.createElement(
                    Panel,
                    null,
                    React.createElement(PageButtons, { Id: 'PageButtons', Run: this, Buttons: ['Done'], OnDone: this.onDone.bind(this) }),
                    React.createElement(TextBox, { Run: this, Id: 'Id', Value: item.Id, Hidden: true }),
                    React.createElement(TextBox, { Run: this, Id: 'ParentId', Value: parentId, Hidden: true }),
                    React.createElement(CheckBox, { Run: this, Id: 'IsRoot', Value: isRoot, Hidden: true }),
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: 4 },
                            React.createElement(TextBox, { Run: this, Id: 'Page', Caption: 'Page', Value: item.Page })
                        ),
                        React.createElement(
                            Col,
                            { Md: 4 },
                            React.createElement(TextBox, { Run: this, Id: 'Caption', Caption: 'Caption', Value: item.Caption, Rules: 'presence: true' })
                        ),
                        React.createElement(
                            Col,
                            { Md: 4 },
                            React.createElement(
                                'div',
                                { className: 'm-md' },
                                React.createElement(CheckBox, { Run: this, Id: 'IsVisible', Caption: 'isVisible', Value: item.IsVisible })
                            )
                        )
                    ),
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: 4 },
                            React.createElement(TextBox, { Run: this, Id: 'Order', Caption: 'Order', Value: item.Order, Rules: 'numericality: true' })
                        ),
                        React.createElement(
                            Col,
                            { Md: 4 },
                            React.createElement(AutoComplete, { Run: this, Id: 'Icon', Caption: 'Icon', Value: item.Icon })
                        ),
                        React.createElement(Col, { Md: 4 })
                    )
                )
            );
        }
    }]);

    return NavigationManagementDetail;
}(ViewBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ParameterGroup = function (_ViewBase) {
    _inherits(ParameterGroup, _ViewBase);

    function ParameterGroup() {
        _classCallCheck(this, ParameterGroup);

        return _possibleConstructorReturn(this, (ParameterGroup.__proto__ || Object.getPrototypeOf(ParameterGroup)).apply(this, arguments));
    }

    _createClass(ParameterGroup, [{
        key: 'onDone',
        value: function onDone() {
            var action = {
                controller: 'Parameter',
                action: 'ParametersGroupCreateOrUpdate',
                params: this.model(),
                success: function (data, msg) {
                    this.success(msg);
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'load',
        value: function load() {
            this.loadParameterGroup();
        }
    }, {
        key: 'loadParameterGroup',
        value: function loadParameterGroup() {
            var action = {
                controller: 'Parameter',
                action: 'GetParameterGroups',
                success: function (data) {
                    this.ParameterGroupList.setState({
                        value: data
                    });
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'parameterGroupSelected',
        value: function parameterGroupSelected(item) {
            this.parameterGroupClear();
            this.model(item);
        }
    }, {
        key: 'parameterGroupAdd',
        value: function parameterGroupAdd() {
            var model = this.model();
            var self = this;
            this.validate(model, "ParameterGroupModel", function () {
                var item = {
                    GroupId: '',
                    GroupName: model.GroupName,
                    GroupDefinition: model.GroupDefinition,
                    ParameterValueList: []
                };

                self.ParameterGroupList.add(item);
                self.parameterGroupClear();
            });
        }
    }, {
        key: 'parameterGroupUpdate',
        value: function parameterGroupUpdate(selected, selectedIndex) {
            var model = this.model();
            var self = this;
            this.validate(model, "ParameterGroupModel", function () {
                var item = {
                    GroupId: model.GroupId,
                    GroupName: model.GroupName,
                    GroupDefinition: model.GroupDefinition,
                    ParameterValueList: selected.ParameterValueList,
                    RecordStatus: selected.RecordStatus
                };

                self.ParameterGroupList.update(item, selectedIndex);
                self.parameterGroupClear();
            });
        }
    }, {
        key: 'parameterGroupRemove',
        value: function parameterGroupRemove(selected, selectedIndex) {
            this.ParameterGroupList.remove(selectedIndex);
            this.parameterGroupClear();
        }
    }, {
        key: 'parameterGroupClear',
        value: function parameterGroupClear() {
            this.GroupId.reset();
            this.GroupName.reset();
            this.GroupDefinition.reset();
        }
    }, {
        key: 'parameterGroupSearch',
        value: function parameterGroupSearch() {
            var action = {
                controller: 'Parameter',
                action: 'ParameterGroupSearch',
                params: this.model(),
                success: function (data) {
                    this.ParameterGroupList.setState({ value: data });
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'addParameterValue',
        value: function addParameterValue(index) {
            var selected = this.ParameterGroupList.state.value[index];
            if (bb.inu(selected) || bb.inu(selected.GroupId) || selected.GroupId == "") return;
            this.open("ParameterValue", this.ParameterGroupList.state.value[index].GroupId);
        }
    }, {
        key: 'render',
        value: function render() {
            return React.createElement(
                'div',
                null,
                React.createElement(
                    Panel,
                    null,
                    React.createElement(PageButtons, { Run: this, Id: 'PageButtons', Buttons: ['Done'], OnDone: this.onDone.bind(this) }),
                    React.createElement(
                        Row,
                        null,
                        React.createElement(TextBox, { Run: this, Id: 'GroupId', Hidden: true }),
                        React.createElement(
                            Col,
                            { Md: 6 },
                            React.createElement(TextBox, { Run: this, Id: 'GroupName', Caption: 'ParameterGroupName' })
                        ),
                        React.createElement(
                            Col,
                            { Md: 6 },
                            React.createElement(TextBox, { Run: this, Id: 'GroupDefinition', Caption: 'ParameterGroupDefinition' })
                        )
                    )
                ),
                React.createElement(
                    Panel,
                    { CssClass: 'm-t-md' },
                    React.createElement(
                        DataGrid,
                        {
                            Run: this,
                            Id: 'ParameterGroupList',
                            Buttons: 'Add,Update,Remove,Clear,List',
                            OnRowSelect: this.parameterGroupSelected.bind(this),
                            OnAdd: this.parameterGroupAdd.bind(this),
                            OnUpdate: this.parameterGroupUpdate.bind(this),
                            OnClear: this.parameterGroupClear.bind(this),
                            OnList: this.parameterGroupSearch.bind(this),
                            OnRemove: this.parameterGroupRemove.bind(this) },
                        React.createElement(DataGridColumn, { Name: 'GroupId', Caption: 'Id' }),
                        React.createElement(DataGridColumn, { Name: 'GroupName', Caption: 'GroupName' }),
                        React.createElement(DataGridColumn, { Name: 'GroupDefinition', Caption: 'GroupDefinition' }),
                        React.createElement(DataGridColumn, { Name: 'AddValue', Caption: 'AddValue', Width: 90, Editor: { Type: Button, Props: { Icon: 'plus', Caption: "AddParameterValue", OnClick: this.addParameterValue.bind(this), CssClass: "btn-data-table" } } })
                    )
                )
            );
        }
    }]);

    return ParameterGroup;
}(ViewBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ParameterValue = function (_ViewBase) {
    _inherits(ParameterValue, _ViewBase);

    function ParameterValue() {
        _classCallCheck(this, ParameterValue);

        return _possibleConstructorReturn(this, (ParameterValue.__proto__ || Object.getPrototypeOf(ParameterValue)).apply(this, arguments));
    }

    _createClass(ParameterValue, [{
        key: 'onDone',
        value: function onDone() {
            var model = this.model();
            this.validate(model, 'ParameterValueCreateOrUpdateModel', function (serverModel) {
                var action = {
                    controller: 'Parameter',
                    action: 'ParametersValueCreateOrUpdate',
                    params: serverModel,
                    success: function (data, msg) {
                        this.success(msg);
                        this.disable();
                    }.bind(this)
                };
                this.post(action);
            }.bind(this));
        }
    }, {
        key: 'load',
        value: function load() {
            this.loadParameterGroup();
        }
    }, {
        key: 'loadParameterGroup',
        value: function loadParameterGroup() {
            var param = this.params();
            this.ParameterGroup.val(param);
            var action = {
                controller: 'Parameter',
                action: 'GetParameterValue',
                params: param,
                success: function (data) {
                    var values = [];
                    if (data.length > 0) {
                        data.forEach(function (item) {
                            var value = {
                                ValueId: item.Id,
                                ValueName: item.Name,
                                Value: item.Value,
                                ValueDefinition: item.Definition
                            };
                            values.push(value);
                        });
                    }
                    this.ParameterValueList.setState({ value: values });
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'parameterValueSelected',
        value: function parameterValueSelected(item) {
            this.model(item);
        }
    }, {
        key: 'parameterValueAdd',
        value: function parameterValueAdd() {
            var model = this.model();
            var self = this;
            this.validate(model, "ParameterValueModel", function () {
                var item = {
                    ValueId: '',
                    ValueName: model.ValueName,
                    Value: model.Value,
                    ValueDefinition: model.ValueDefinition
                };

                self.ParameterValueList.add(item);

                groupItem.ParameterValueList = self.ParameterValueList.state.value;
                self.parameterValueClear();
            });
        }
    }, {
        key: 'parameterValueUpdate',
        value: function parameterValueUpdate(selected, selectedIndex) {
            var model = this.model();
            var self = this;
            this.validate(model, "ParameterValueModel", function () {
                var item = {
                    ValueId: model.ValueId,
                    ValueName: model.ValueName,
                    Value: model.Value,
                    ValueDefinition: model.ValueDefinition,
                    RecordStatus: selected.RecordStatus
                };

                self.ParameterValueList.update(item, selectedIndex);
                groupItem.ParameterValueList = self.ParameterValueList.state.value;

                self.parameterValueClear();
            });
        }
    }, {
        key: 'parameterValueRemove',
        value: function parameterValueRemove(selected, selectedIndex) {
            this.ParameterValueList.remove(selectedIndex);
            this.parameterValueClear();
        }
    }, {
        key: 'parameterValueClear',
        value: function parameterValueClear() {
            this.ValueId.reset();
            this.ValueName.reset();
            this.Value.reset();
            this.ValueDefinition.reset();
        }
    }, {
        key: 'render',
        value: function render() {
            return React.createElement(
                'div',
                null,
                React.createElement(TextBox, { Run: this, Id: 'ParameterGroup', Hidden: true }),
                React.createElement(
                    Panel,
                    null,
                    React.createElement(PageButtons, { Run: this, Id: 'PageButtons', Buttons: ['Done'], OnDone: this.onDone.bind(this) }),
                    React.createElement(
                        Row,
                        null,
                        React.createElement(TextBox, { Run: this, Id: 'ValueId', Hidden: true }),
                        React.createElement(
                            Col,
                            { Md: 4 },
                            React.createElement(TextBox, { Run: this, Id: 'ValueName', Caption: 'ParameterValueName' })
                        ),
                        React.createElement(
                            Col,
                            { Md: 4 },
                            React.createElement(TextBox, { Run: this, Id: 'Value', Caption: 'ParameterValue' })
                        ),
                        React.createElement(
                            Col,
                            { Md: 4 },
                            React.createElement(TextBox, { Run: this, Id: 'ValueDefinition', Caption: 'ParameterValueDefinition' })
                        )
                    )
                ),
                React.createElement(
                    Panel,
                    { CssClass: 'm-t-md' },
                    React.createElement(
                        DataGrid,
                        {
                            Run: this,
                            Id: 'ParameterValueList',
                            Height: 250,
                            Buttons: 'Add,Update,Remove,Clear',
                            OnRowSelect: this.parameterValueSelected.bind(this),
                            OnAdd: this.parameterValueAdd.bind(this),
                            OnUpdate: this.parameterValueUpdate.bind(this),
                            OnClear: this.parameterValueClear.bind(this),
                            OnRemove: this.parameterValueRemove.bind(this) },
                        React.createElement(DataGridColumn, { Name: 'ValueId', Caption: 'Id' }),
                        React.createElement(DataGridColumn, { Name: 'ValueName', Caption: 'ValueName' }),
                        React.createElement(DataGridColumn, { Name: 'Value', Caption: 'ParameterValue' }),
                        React.createElement(DataGridColumn, { Name: 'ValueDefinition', Caption: 'ParameterValueDefinition' })
                    )
                )
            );
        }
    }]);

    return ParameterValue;
}(ViewBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RealTimeSocketManagement = function (_ViewBase) {
    _inherits(RealTimeSocketManagement, _ViewBase);

    function RealTimeSocketManagement() {
        _classCallCheck(this, RealTimeSocketManagement);

        return _possibleConstructorReturn(this, (RealTimeSocketManagement.__proto__ || Object.getPrototypeOf(RealTimeSocketManagement)).apply(this, arguments));
    }

    _createClass(RealTimeSocketManagement, [{
        key: 'load',
        value: function load() {
            this.loadSockets();
        }
    }, {
        key: 'loadSockets',
        value: function loadSockets() {
            var action = {
                controller: 'System',
                action: 'GetSocketList',
                success: function (data) {
                    this.RealTimeSockets.setState({ value: data });
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'killSocket',
        value: function killSocket(index) {
            var rowItem = this.RealTimeSockets.state.value[index];
            var action = {
                controller: 'System',
                action: 'KillSocket',
                params: rowItem.Id,
                success: function (data, msg) {
                    this.success(msg);
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'render',
        value: function render() {
            return React.createElement(
                Panel,
                null,
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: 12 },
                        React.createElement(PageButtons, { Id: 'PageButtons', Run: this, HideRefresh: true })
                    )
                ),
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: 12 },
                        React.createElement(
                            DataGrid,
                            { Run: this, Id: 'RealTimeSockets' },
                            React.createElement(DataGridColumn, { Name: 'ClientId', Caption: 'ClientId' }),
                            React.createElement(DataGridColumn, { Name: 'SocketType', Caption: 'SocketType' }),
                            React.createElement(DataGridColumn, { Name: 'UserName', Caption: 'UserName' }),
                            React.createElement(DataGridColumn, { Name: 'IpAddress', Caption: 'IpAddress' }),
                            React.createElement(DataGridColumn, { Name: 'State', Caption: 'State' }),
                            React.createElement(DataGridColumn, { Name: 'Kill', Caption: 'Kill',
                                Editor: { Type: Button, Props: { Icon: 'power-off', CssClass: "btn-data-table", OnClick: this.killSocket.bind(this) } }, Width: 60 })
                        )
                    )
                )
            );
        }
    }]);

    return RealTimeSocketManagement;
}(ViewBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ResetPassword = function (_ViewBase) {
    _inherits(ResetPassword, _ViewBase);

    function ResetPassword() {
        _classCallCheck(this, ResetPassword);

        return _possibleConstructorReturn(this, (ResetPassword.__proto__ || Object.getPrototypeOf(ResetPassword)).apply(this, arguments));
    }

    _createClass(ResetPassword, [{
        key: 'title',
        value: function title() {
            return false;
        }
    }, {
        key: 'resetPassword',
        value: function resetPassword() {
            var model = this.model();
            this.validate(model, "ResetPasswordModel", function (serverModel) {
                var action = {
                    controller: 'User',
                    action: 'ResetPassword',
                    params: serverModel,
                    success: function (result, msg) {
                        this.success(msg);
                        setTimeout(function () {
                            this.open('Login');
                        }.bind(this), 1000);
                    }.bind(this)
                };
                this.post(action);
            }.bind(this));
        }
    }, {
        key: 'render',
        value: function render() {
            return React.createElement(
                'div',
                null,
                React.createElement(TextBox, { Run: this, Id: 'Id', Hidden: true, Value: this.params().userId }),
                React.createElement(TextBox, { Run: this, Id: 'PasswordResetToken', Hidden: true, Value: this.params().resetToken }),
                React.createElement(
                    'div',
                    { className: 'container' },
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Xs: '12' },
                            React.createElement(
                                Panel,
                                { Caption: 'dontworryyouraccountissafe', CssClass: 'middle-box', CaptionClass: 'full-width text-center' },
                                React.createElement('div', { ref: 'error', className: 'alert alert-danger page-alert animated fadeInDown ibox-shadow' }),
                                React.createElement(
                                    'div',
                                    { className: 'text-center' },
                                    React.createElement(
                                        Localize,
                                        null,
                                        'yourpasswordisatemporaryone'
                                    )
                                ),
                                React.createElement(
                                    Row,
                                    { CssClass: 'm-t-lg' },
                                    React.createElement(
                                        Col,
                                        { Md: '12' },
                                        React.createElement(Password, { Run: this, Id: 'Password', Caption: 'Password' })
                                    )
                                ),
                                React.createElement(
                                    Row,
                                    null,
                                    React.createElement(
                                        Col,
                                        { Md: '12' },
                                        React.createElement(Password, { Run: this, Id: 'PasswordConfirm', Caption: 'PasswordConfirm' })
                                    )
                                ),
                                React.createElement(
                                    Row,
                                    { CssClass: 'm-t-sm' },
                                    React.createElement(
                                        Col,
                                        { Md: 6 },
                                        React.createElement(Button, { Run: this, Id: 'CancelButton', Value: 'Cancel', To: 'Login' })
                                    ),
                                    React.createElement(
                                        Col,
                                        { Md: 6 },
                                        React.createElement(Button, { Run: this, Id: 'ResetButton', Value: 'Change', Type: 'primary', OnClick: this.resetPassword.bind(this) })
                                    )
                                )
                            )
                        )
                    )
                )
            );
        }
    }]);

    return ResetPassword;
}(ViewBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RoleManagement = function (_ViewBase) {
    _inherits(RoleManagement, _ViewBase);

    function RoleManagement() {
        _classCallCheck(this, RoleManagement);

        return _possibleConstructorReturn(this, (RoleManagement.__proto__ || Object.getPrototypeOf(RoleManagement)).apply(this, arguments));
    }

    _createClass(RoleManagement, [{
        key: 'init',
        value: function init() {
            this.AllCredentialData = [];
            this.state.addFlag = false;
            this.state.updateFlag = false;
        }
    }, {
        key: 'onDone',
        value: function onDone() {
            var action = {
                controller: 'User',
                action: 'AddOrUpdateRoles',
                params: this.model(),
                success: function (data, msg) {
                    this.success(msg);
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'setRoles',
        value: function setRoles(data) {
            var roleList = [];
            for (var i = 0; i < data.length; i++) {
                var roleItem = {};
                roleItem.Id = data[i].Role.Id;
                roleItem.Name = data[i].Role.Name;
                if (!bb.inu(data[i].RoleCredentials) && data[i].RoleCredentials.length > 0) {
                    var tmp = [];
                    for (var j = 0; j < data[i].RoleCredentials.length; j++) {
                        var item = {
                            Selected: true,
                            Name: data[i].RoleCredentials[j].Credential.Name,
                            Value: data[i].RoleCredentials[j].CredentialId
                        };
                        tmp.push(item);
                    }
                    roleItem.RoleCredentials = tmp;
                }
                roleList.push(roleItem);
            }
            this.Roles.setState({ value: roleList });
        }
    }, {
        key: 'loadRoles',
        value: function loadRoles() {

            var action = {
                controller: 'User',
                action: 'GetRoles',
                success: this.setRoles.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'addRole',
        value: function addRole() {
            this.validate(this.model(), "RoleAddOrUpdateModel", function (item) {
                this.state.updateFlag = false;
                this.state.addFlag = true;
                this.CredentialModal.open();
            }.bind(this));
        }
    }, {
        key: 'updateRole',
        value: function updateRole(role, roleIndex) {
            this.state.updateFlag = true;
            this.state.addFlag = false;
            this.CredentialModal.open();
        }
    }, {
        key: 'addOrUpdateRoleCredentials',
        value: function addOrUpdateRoleCredentials(callback) {
            var model = this.model();
            var selectedIndex = this.Roles.selectedIndex();
            if (this.state.updateFlag) {
                var gridObject = {
                    Id: model.Id,
                    Name: model.Name,
                    RoleCredentials: model.RoleCredentials.filter(function (item) {
                        return item.Selected == true;
                    })
                };
                this.Roles.update(gridObject, selectedIndex);
                this.state.updateFlag = false;
                this.state.addFlag = false;
                this.dataSelectedClear();
                callback();
            } else if (this.state.addFlag) {
                var model = this.model();
                var gridObject = {
                    Id: 0,
                    Name: model.Name,
                    RoleCredentials: model.RoleCredentials.filter(function (item) {
                        return item.Selected == true;
                    })
                };
                this.Roles.add(gridObject);
                this.state.updateFlag = false;
                this.state.addFlag = false;
                this.dataSelectedClear();
                callback();
            }
        }
    }, {
        key: 'cancelModal',
        value: function cancelModal(callback) {
            this.state.updateFlag = false;
            this.state.addFlag = false;
            this.dataSelectedClear();
            callback();
        }
    }, {
        key: 'roleAdd',
        value: function roleAdd() {
            var model = this.model();
            var self = this;

            var roleItem = {
                Id: 0,
                Name: model.Name
            };

            var newItem = {
                Role: roleItem,
                RoleCredentials: []
            };

            if (!bb.inu(self.RoleCredentials.state.value) && self.RoleCredentials.state.value.length > 0) {
                for (var i = 0; i < self.RoleCredentials.state.value.length; i++) {
                    var credentialItem = {
                        RoleId: 0,
                        CredentialId: self.RoleCredentials.state.value[i].Value
                    };
                    newItem.RoleCredentials.push(credentialItem);
                }
            }

            this.validate(newItem, "RolesModel", function () {
                var action = {
                    controller: 'User',
                    action: 'AddRole',
                    params: newItem,
                    success: function (result) {
                        var data = this.Roles.state.value;
                        var roleItem = {
                            Id: result.Role.Id,
                            Name: result.Role.Name,
                            RoleCredentials: []
                        };

                        if (!bb.inu(result.RoleCredentials) && result.RoleCredentials.length > 0) {
                            var tmp = [];
                            for (var j = 0; j < result.RoleCredentials.length; j++) {
                                var item = {
                                    Code: result.RoleCredentials[j].Credential.Name,
                                    Value: result.RoleCredentials[j].CredentialId
                                };
                                tmp.push(item);
                            }
                            roleItem.RoleCredentials = tmp;
                        }

                        data.unshift(roleItem);
                        this.Roles.setState({ value: data });
                        this.clear();
                        this.RoleCredentials.setState({ value: this.AllCredentialData });
                    }.bind(self)
                };
                this.post(action);
            });
        }
    }, {
        key: 'dataSelectedClear',
        value: function dataSelectedClear() {
            var allCredentias = this.AllCredentialData;
            for (var i = 0; i < allCredentias.length; i++) {
                allCredentias[i].Selected = false;
            }
            this.RoleCredentials.setState({ value: allCredentias });
        }
    }, {
        key: 'roleSelected',
        value: function roleSelected(item) {
            this.model(item);
            var selectedCredentials = item.RoleCredentials;
            var allCredentias = this.AllCredentialData;
            for (var i = 0; i < allCredentias.length; i++) {
                allCredentias[i].Selected = false;
            }
            for (var i = 0; i < selectedCredentials.length; i++) {
                for (var j = 0; j < allCredentias.length; j++) {
                    if (allCredentias[j].Value == selectedCredentials[i].Value) {
                        allCredentias[j].Selected = true;
                    }
                }
            }
            this.RoleCredentials.setState({ value: allCredentias });
        }
    }, {
        key: 'roleUpdateResult',
        value: function roleUpdateResult(selectedIndex, result) {
            var data = this.Roles.state.value;

            var roleItem = {
                Id: result.Role.Id,
                Name: result.Role.Name,
                RoleCredentials: []
            };

            if (!bb.inu(result.RoleCredentials) && result.RoleCredentials.length > 0) {
                var tmp = [];
                for (var j = 0; j < result.RoleCredentials.length; j++) {
                    var item = {
                        Code: result.RoleCredentials[j].Credential.Name,
                        Value: result.RoleCredentials[j].CredentialId
                    };
                    tmp.push(item);
                }
                roleItem.RoleCredentials = tmp;
            }

            data[selectedIndex] = roleItem;
            this.Roles.setState({ value: data });
            this.clear();
            this.RoleCredentials.setState({ options: this.AllCredentialData, direction: "Target" });
        }
    }, {
        key: 'roleUpdate',
        value: function roleUpdate(selected, selectedIndex) {
            var model = this.model();
            var self = this;

            var roleItem = {
                Id: model.Id,
                Name: model.Name
            };

            var item = {
                Role: roleItem,
                RoleCredentials: []
            };

            if (!bb.inu(self.RoleCredentials.state.value) && self.RoleCredentials.state.value.length > 0) {
                for (var i = 0; i < self.RoleCredentials.state.value.length; i++) {
                    var credentialItem = {
                        RoleId: model.Id,
                        CredentialId: self.RoleCredentials.state.value[i].Value
                    };
                    item.RoleCredentials.push(credentialItem);
                }
            }

            this.validate(item, "RolesModel", function () {
                var action = {
                    controller: 'User',
                    action: 'UpdateRole',
                    params: item,
                    success: function (data) {
                        self.roleUpdateResult.bind(self, selectedIndex);
                    }.bind(this)
                };
                this.post(action);
            });
        }
    }, {
        key: 'roleClear',
        value: function roleClear() {
            this.clear();
        }
    }, {
        key: 'load',
        value: function load() {
            this.loadRoles();
            this.getAllCredentialData();
        }
    }, {
        key: 'setAllCredentialData',
        value: function setAllCredentialData(data) {
            if (!bb.inu(data)) {
                var tmp = [];
                for (var i = 0; i < data.length; i++) {
                    var item = {
                        Selected: false,
                        Value: data[i].Id,
                        Name: data[i].Name
                    };
                    tmp.push(item);
                }
                this.AllCredentialData = tmp;
                this.RoleCredentials.setState({ value: this.AllCredentialData });
            }
        }
    }, {
        key: 'getAllCredentialData',
        value: function getAllCredentialData() {

            var action = {
                controller: 'User',
                action: 'GetCredentials',
                success: function (data) {
                    this.setAllCredentialData(data);
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'render',
        value: function render() {
            return React.createElement(
                'div',
                null,
                React.createElement(
                    Panel,
                    null,
                    React.createElement(PageButtons, { Run: this, Id: 'PageButtons', Buttons: ['Done'], OnDone: this.onDone.bind(this) }),
                    React.createElement(TextBox, { Run: this, Id: 'Id', Hidden: true, Value: '0' }),
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: 6 },
                            React.createElement(TextBox, { Run: this, Id: 'Name', Caption: 'Name', Rules: 'presence: true' })
                        )
                    ),
                    React.createElement(
                        Modal,
                        { Run: this, Id: 'CredentialModal', Caption: 'Credentials', OnClose: this.addOrUpdateRoleCredentials.bind(this), OnCancel: this.cancelModal.bind(this) },
                        React.createElement(
                            Row,
                            null,
                            React.createElement(
                                Col,
                                { Md: 12 },
                                React.createElement(
                                    DataGrid,
                                    {
                                        Run: this,
                                        Id: 'RoleCredentials',
                                        Caption: 'RoleCredentials',
                                        ShowPagination: false },
                                    React.createElement(DataGridColumn, { Name: 'Selected', SelectAll: true, Editor: { Type: CheckBox } }),
                                    React.createElement(DataGridColumn, { Name: 'Name', Caption: 'RoleCredential' })
                                )
                            )
                        )
                    )
                ),
                React.createElement(
                    Panel,
                    { CssClass: 'm-t-md' },
                    React.createElement(
                        DataGrid,
                        {
                            Run: this,
                            Id: 'Roles',
                            Caption: 'Roles',
                            Buttons: 'Add,Update,Clear',
                            ShowPagination: false,
                            OnAdd: this.addRole.bind(this),
                            OnRowSelect: this.roleSelected.bind(this),
                            OnUpdate: this.updateRole.bind(this),
                            OnClear: this.roleClear.bind(this) },
                        React.createElement(DataGridColumn, { Name: 'Name', Caption: 'Name' })
                    )
                )
            );
        }
    }]);

    return RoleManagement;
}(ViewBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ScheduledTaskManagement = function (_ViewBase) {
    _inherits(ScheduledTaskManagement, _ViewBase);

    function ScheduledTaskManagement() {
        _classCallCheck(this, ScheduledTaskManagement);

        return _possibleConstructorReturn(this, (ScheduledTaskManagement.__proto__ || Object.getPrototypeOf(ScheduledTaskManagement)).apply(this, arguments));
    }

    _createClass(ScheduledTaskManagement, [{
        key: 'init',
        value: function init() {
            this.state.croneDescription = "";
        }
    }, {
        key: 'load',
        value: function load() {
            this.loadTasks();
            this.loadSchedules();
        }
    }, {
        key: 'onDone',
        value: function onDone() {
            var action = {
                controller: 'System',
                action: 'AddOrUpdateScheduledTasks',
                params: this.model(),
                success: function (data, msg) {
                    this.success(msg);
                }.bind(this),
                error: function (msg) {
                    this.error(msg);
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'validateCroneSchedule',
        value: function validateCroneSchedule(callback) {
            var schedule = this.Schedule.val();
            var action = {
                controller: 'System',
                action: 'CroneScheduleDescription',
                params: schedule,
                success: function (data) {
                    this.setState({ croneDescription: data }, function () {
                        if (bb.isFunction(callback)) {
                            callback(data);
                        }
                    });
                }.bind(this),
                error: function (data) {
                    this.Schedule.error(data);
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'loadSchedules',
        value: function loadSchedules() {
            var action = {
                controller: 'System',
                action: 'GetSchedules',
                success: function (data) {
                    this.Schedules.setState({ value: data });
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'loadTasks',
        value: function loadTasks() {
            var action = {
                controller: 'System',
                action: 'GetTasks',
                success: function (data) {
                    this.Name.setState({ data: data });
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'addSchedule',
        value: function addSchedule() {
            this.validateCroneSchedule(function (scheduleDescription) {
                var model = this.model();
                var selectedSchedule = this.Name.selected();
                var newItem = {
                    Name: !bb.inu(selectedSchedule) ? selectedSchedule.Name : "",
                    Schedule: model.Schedule,
                    ScheduleDescription: scheduleDescription,
                    Explanation: !bb.inu(selectedSchedule) ? selectedSchedule.Explanation : "",
                    State: model.State,
                    Params: model.Params
                };
                this.validate(newItem, "SchedulerModel", function (item) {
                    this.Schedules.add(item);
                }.bind(this));
            }.bind(this));
        }
    }, {
        key: 'updateSchedule',
        value: function updateSchedule(selected, selectedIndex) {
            this.validateCroneSchedule(function (scheduleDescription) {
                var model = this.model();
                var newItem = {
                    Id: selected.Id,
                    Name: model.Name,
                    Schedule: model.Schedule,
                    ScheduleDescription: scheduleDescription,
                    Explanation: model.Explanation,
                    State: model.State,
                    Params: model.Params
                };
                this.validate(newItem, "SchedulerModel", function (item) {
                    this.Schedules.update(item, selectedIndex);
                }.bind(this));
            }.bind(this));
        }
    }, {
        key: 'schedulesSelected',
        value: function schedulesSelected(selected) {
            var type = this.parameters("SchedulerType");
            var val = "";
            if (type != null) {
                var key = selected.ScheduleDescription.replace(/\s+/g, '').toLowerCase();
                type.forEach(function (item) {
                    if (item.Name == key) {
                        val = item.Value;
                    }
                });
            }
            this.model(selected);
            this.setState({ croneDescription: selected.ScheduleDescription });
            this.Explanation.setState({ value: this.localize(selected.Explanation) });
            this.SchedulerType.setState({ value: val });
        }
    }, {
        key: 'onTaskNameChange',
        value: function onTaskNameChange(value) {
            this.Explanation.setState({ value: this.localize(value) });
        }
    }, {
        key: 'onSchedulerTypeChange',
        value: function onSchedulerTypeChange(value) {
            var _this2 = this;

            this.Schedule.setState({ value: value }, function () {
                _this2.validateCroneSchedule(function () {});
            });
        }
    }, {
        key: 'clearPage',
        value: function clearPage() {
            this.clear();
            this.setState({ croneDescription: "" });
        }
    }, {
        key: 'render',
        value: function render() {
            var schedulerTypes = this.parameters('SchedulerType');
            var schedulerStates = this.parameters('SchedulerState');
            return React.createElement(
                'div',
                null,
                React.createElement(
                    Panel,
                    null,
                    React.createElement(PageButtons, { Id: 'PageButtons', Run: this, Buttons: ['Done'], OnDone: this.onDone.bind(this) }),
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: 3 },
                            React.createElement(ComboBox, { Run: this, Id: 'Name', Caption: 'Name', KeyField: 'Name', ValueField: 'Name', OnChange: this.onTaskNameChange.bind(this) })
                        ),
                        React.createElement(
                            Col,
                            { Md: 6 },
                            React.createElement(TextBox, { Run: this, Id: 'Explanation', Caption: 'Explanation', Disabled: true })
                        ),
                        React.createElement(
                            Col,
                            { Md: 3 },
                            React.createElement(ComboBox, { Run: this, Id: 'State', Caption: 'State', Data: schedulerStates, KeyField: 'Definition', ValueField: 'Value' })
                        )
                    ),
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: 3 },
                            React.createElement(ComboBox, { Run: this, Id: 'SchedulerType', Caption: 'SchedulerType', Data: schedulerTypes, KeyField: 'Definition', ValueField: 'Value', OnChange: this.onSchedulerTypeChange.bind(this) })
                        ),
                        React.createElement(
                            Col,
                            { Md: 6 },
                            React.createElement(TextBox, { Run: this, Id: 'Schedule', Caption: 'Schedule', ActionButton: true, ActionCaption: 'Validate', Action: this.validateCroneSchedule.bind(this) }),
                            React.createElement(
                                Label,
                                null,
                                this.state.croneDescription
                            )
                        ),
                        React.createElement(
                            Col,
                            { Md: 3 },
                            React.createElement(TextBox, { Run: this, Id: 'Params', Caption: 'Params' })
                        )
                    )
                ),
                React.createElement(
                    Panel,
                    { CssClass: 'm-t-md' },
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: '12' },
                            React.createElement(
                                DataGrid,
                                { Run: this, Id: 'Schedules', Buttons: 'Add,Update,Clear,List',
                                    OnAdd: this.addSchedule.bind(this),
                                    OnUpdate: this.updateSchedule.bind(this),
                                    OnClear: this.clearPage.bind(this),
                                    OnRowSelect: this.schedulesSelected.bind(this),
                                    OnList: this.loadSchedules.bind(this) },
                                React.createElement(DataGridColumn, { Name: 'Name', Caption: 'Name', Unique: true }),
                                React.createElement(DataGridColumn, { Name: 'Schedule', Caption: 'Cron Schedule' }),
                                React.createElement(DataGridColumn, { Name: 'ScheduleDescription', Caption: 'ScheduleDescription' }),
                                React.createElement(DataGridColumn, { Name: 'Params', Caption: 'Params' }),
                                React.createElement(DataGridColumn, { Name: 'State', Caption: 'State' })
                            )
                        )
                    )
                )
            );
        }
    }]);

    return ScheduledTaskManagement;
}(ViewBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SchedulerTasks = function (_ViewBase) {
    _inherits(SchedulerTasks, _ViewBase);

    function SchedulerTasks() {
        _classCallCheck(this, SchedulerTasks);

        return _possibleConstructorReturn(this, (SchedulerTasks.__proto__ || Object.getPrototypeOf(SchedulerTasks)).apply(this, arguments));
    }

    _createClass(SchedulerTasks, [{
        key: 'load',
        value: function load() {
            this.loadScheduledTasks();
        }
    }, {
        key: 'editTask',
        value: function editTask(index) {
            var row = this.ScheduledTasks.state.value[index];
            this.open('ScheduledTaskManagement', row);
        }
    }, {
        key: 'invokeTask',
        value: function invokeTask(index) {
            var row = this.ScheduledTasks.state.value[index];
            var action = {
                controller: 'Socket',
                action: 'InvokeScheduleTask',
                params: row.Name
            };
            this.post(action);
        }
    }, {
        key: 'loadScheduledTasks',
        value: function loadScheduledTasks() {
            var action = {
                controller: 'System',
                action: 'GetScheduledTasks',
                success: function (data) {
                    this.ScheduledTasks.setState({ value: data });
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'clearPage',
        value: function clearPage() {
            this.clear();
        }
    }, {
        key: 'render',
        value: function render() {
            return React.createElement(
                Panel,
                null,
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: 12 },
                        React.createElement(PageButtons, { Id: 'PageButtons', Run: this, HideRefresh: true })
                    )
                ),
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: 12 },
                        React.createElement(
                            DataGrid,
                            { Run: this, Id: 'ScheduledTasks', Buttons: 'List', OnList: this.loadScheduledTasks.bind(this) },
                            React.createElement(DataGridColumn, { Name: 'Name', Caption: 'Name' }),
                            React.createElement(DataGridColumn, { Name: 'Schedule', Caption: 'Cron Schedule' }),
                            React.createElement(DataGridColumn, { Name: 'ScheduleDescription', Caption: 'ScheduleDescription' }),
                            React.createElement(DataGridColumn, { Name: 'LastRunTime', Caption: 'LastRunTime' }),
                            React.createElement(DataGridColumn, { Name: 'NextRunTime', Caption: 'NextRunTime' }),
                            React.createElement(DataGridColumn, { Name: 'Health', Caption: 'Health', Formatter: 'Bool', Width: 60 }),
                            React.createElement(DataGridColumn, { Name: 'State', Caption: 'State', Width: 60 }),
                            React.createElement(DataGridColumn, { Name: 'Edit', Caption: 'Edit', Width: 60, Editor: { Type: Button, Props: { Icon: 'edit', CssClass: "btn-data-table", OnClick: this.editTask.bind(this) } } }),
                            React.createElement(DataGridColumn, { Name: 'Run', Caption: 'Run', Width: 60, Editor: { Type: Button, Props: { Icon: 'flash', CssClass: "btn-data-table", OnClick: this.invokeTask.bind(this) } } })
                        )
                    )
                )
            );
        }
    }]);

    return SchedulerTasks;
}(ViewBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Signup = function (_ViewBase) {
    _inherits(Signup, _ViewBase);

    function Signup() {
        _classCallCheck(this, Signup);

        return _possibleConstructorReturn(this, (Signup.__proto__ || Object.getPrototypeOf(Signup)).apply(this, arguments));
    }

    _createClass(Signup, [{
        key: "title",
        value: function title() {
            return false;
        }
    }, {
        key: "returnToLogin",
        value: function returnToLogin() {
            this.props.App.open("Login");
        }
    }, {
        key: "userRegister",
        value: function userRegister() {
            var _this2 = this;

            var params = this.model();
            params.TimeZone = "GMT Standard Time";
            if (!bb.inu(brand)) {
                params.Brand = brand;
            }

            this.validate(params, "RegistrationModel", function () {
                var action = {
                    controller: "Registration",
                    action: "Register",
                    params: params,
                    success: function (user) {
                        var navAction = {
                            controller: "Navigation",
                            action: "GetUserNavigation",
                            success: function (navResult) {
                                this.props.App.login(user, navResult);
                            }.bind(this)
                        };
                        this.post(navAction);
                    }.bind(_this2)
                };
                _this2.post(action);
            });
        }
    }, {
        key: "render",
        value: function render() {

            var clientType = [{ Code: "Individual", Value: "IndividualClient" }, { Code: "Corporate", Value: "CorporateClient" }];

            return React.createElement(
                "div",
                null,
                React.createElement(
                    "div",
                    { className: "container" },
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Xs: "12" },
                            React.createElement(
                                Panel,
                                { Caption: "itllbringyorcloser", CssClass: "middle-box", CaptionClass: "full-width text-center" },
                                React.createElement(
                                    "div",
                                    { className: "text-center" },
                                    React.createElement(
                                        Localize,
                                        null,
                                        "alreadysignedup"
                                    ),
                                    " ",
                                    React.createElement(
                                        "a",
                                        { href: "javascript:void(0)", onClick: this.returnToLogin.bind(this) },
                                        React.createElement(
                                            Localize,
                                            { Upper: true },
                                            "Login"
                                        )
                                    )
                                ),
                                React.createElement("div", { ref: "error", className: "alert alert-danger page-alert animated fadeInDown ibox-shadow" }),
                                React.createElement(
                                    Row,
                                    { CssClass: "m-t-lg" },
                                    React.createElement(
                                        Col,
                                        { Md: "12" },
                                        React.createElement(RadioButton, { Run: this, Id: "ClientType", Data: clientType, Value: "IndividualClient" })
                                    )
                                ),
                                React.createElement(
                                    Row,
                                    null,
                                    React.createElement(
                                        Col,
                                        { Md: "12" },
                                        React.createElement(TextBox, { Run: this, Id: "UserName", Caption: "Email" })
                                    )
                                ),
                                React.createElement(
                                    Row,
                                    null,
                                    React.createElement(
                                        Col,
                                        { Md: "12" },
                                        React.createElement(Password, { Run: this, Id: "Password", Caption: "Password" })
                                    )
                                ),
                                React.createElement(
                                    Row,
                                    { CssClass: "m-t-md" },
                                    React.createElement(Col, { Md: "3" }),
                                    React.createElement(
                                        Col,
                                        { Md: "6" },
                                        React.createElement(Button, { Run: this, Id: "SignUp", Value: "SignUp", Type: "primary", OnClick: this.userRegister.bind(this) })
                                    )
                                )
                            )
                        )
                    )
                )
            );
        }
    }]);

    return Signup;
}(ViewBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var StringLocalization = function (_ViewBase) {
    _inherits(StringLocalization, _ViewBase);

    function StringLocalization() {
        _classCallCheck(this, StringLocalization);

        return _possibleConstructorReturn(this, (StringLocalization.__proto__ || Object.getPrototypeOf(StringLocalization)).apply(this, arguments));
    }

    _createClass(StringLocalization, [{
        key: 'load',
        value: function load() {
            var actionString = {
                controller: 'Localization',
                action: 'GetStrings',
                success: function (data) {
                    this.StringList.setState({ value: data });
                }.bind(this)
            };
            var actionLang = {
                controller: 'Localization',
                action: 'GetLanguageList',
                success: function (data) {
                    this.Lang.setState({ data: data });
                }.bind(this)
            };
            this.post(actionString);
            this.post(actionLang);
        }
    }, {
        key: 'stringSelected',
        value: function stringSelected(item) {
            this.model(item);
        }
    }, {
        key: 'stringAdd',
        value: function stringAdd() {
            var model = this.model();

            this.validate(model, "StringKeyModel", function () {
                var gridObject = {
                    Key: model.Key,
                    Value: model.Value,
                    Lang: model.Lang
                };
                this.StringList.add(gridObject);
            }.bind(this));
        }
    }, {
        key: 'stringUpdate',
        value: function stringUpdate(selected, selectedIndex) {
            var model = this.model();
            this.validate(model, "StringKeyModel", function () {
                var gridObject = {
                    Id: model.Id,
                    Key: model.Key,
                    Value: model.Value,
                    Lang: model.Lang
                };
                this.StringList.update(gridObject, selectedIndex);
            }.bind(this));
        }
    }, {
        key: 'stringRemove',
        value: function stringRemove(selected, selectedIndex) {
            this.StringList.remove(selectedIndex);
        }
    }, {
        key: 'stringSearch',
        value: function stringSearch() {
            var model = this.model();

            var requestObject = {
                Key: model.Key,
                Value: model.Value,
                Lang: model.Lang
            };

            var action = {
                controller: 'Localization',
                action: 'ReturnStringSearchResults',
                params: requestObject,
                success: function (result) {
                    this.StringList.setState({ value: result });
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'saveStrings',
        value: function saveStrings() {
            var action = {
                controller: 'Localization',
                action: 'AddOrUpdateString',
                params: this.model(),
                success: function (data, msg) {
                    this.success(msg);
                    this.disable();
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'render',
        value: function render() {
            return React.createElement(
                'div',
                null,
                React.createElement(TextBox, { Run: this, Id: 'Id', Hidden: true }),
                React.createElement(
                    Panel,
                    null,
                    React.createElement(PageButtons, { Id: 'PageButtons', Run: this, Buttons: ['Done'], OnDone: this.saveStrings.bind(this) }),
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: 4 },
                            React.createElement(TextBox, { Run: this, Id: 'Key', Caption: 'Key' })
                        ),
                        React.createElement(
                            Col,
                            { Md: 4 },
                            React.createElement(TextBox, { Run: this, Id: 'Value', Caption: 'Value' })
                        ),
                        React.createElement(
                            Col,
                            { Md: 4 },
                            React.createElement(ComboBox, { Run: this, Id: 'Lang', Caption: 'Lang', KeyField: 'Name', ValueField: 'Code' })
                        )
                    )
                ),
                React.createElement(
                    Panel,
                    { CssClass: 'm-t-md' },
                    React.createElement(
                        DataGrid,
                        {
                            Run: this,
                            Id: 'StringList',
                            Height: 500,
                            Buttons: 'Add,Update,Remove,Clear,List',
                            OnRowSelect: this.stringSelected.bind(this),
                            OnAdd: this.stringAdd.bind(this),
                            OnUpdate: this.stringUpdate.bind(this),
                            OnRemove: this.stringRemove.bind(this),
                            OnList: this.stringSearch.bind(this) },
                        React.createElement(DataGridColumn, { Name: 'Key', Caption: 'Key', Unique: true }),
                        React.createElement(DataGridColumn, { Name: 'Value', Caption: 'Value' }),
                        React.createElement(DataGridColumn, { Name: 'Lang', Caption: 'Lang', Unique: true })
                    )
                )
            );
        }
    }]);

    return StringLocalization;
}(ViewBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TransactionApprove = function (_ViewBase) {
    _inherits(TransactionApprove, _ViewBase);

    function TransactionApprove() {
        _classCallCheck(this, TransactionApprove);

        return _possibleConstructorReturn(this, (TransactionApprove.__proto__ || Object.getPrototypeOf(TransactionApprove)).apply(this, arguments));
    }

    _createClass(TransactionApprove, [{
        key: 'load',
        value: function load() {
            this.loadWaitingApprovalTransaction();
        }
    }, {
        key: 'loadWaitingApprovalTransaction',
        value: function loadWaitingApprovalTransaction(callback) {
            var _this2 = this;

            var action = {
                controller: 'Transaction',
                action: 'GetWaitingApprovalTransactionList',
                success: function success(result) {
                    _this2.ApproveList.val(result);
                    if (callback != null) {
                        callback();
                    }
                }
            };
            this.post(action);
        }
    }, {
        key: 'detail',
        value: function detail(index) {
            var _this3 = this;

            var ref = this.ApproveList.val()[index].Id;
            var action = {
                controller: 'Transaction',
                action: 'GetTransactionLogDetail',
                params: ref,
                success: function success(result, message) {
                    _this3.TransactionExplanation.val(_this3.localize(result.Explanation));
                    _this3.TransactionDetails.val(result.Fields);
                    _this3.TransactionDetailModal.open();
                },
                error: function error(msg) {
                    _this3.error(msg);
                }
            };
            this.post(action);
        }
    }, {
        key: 'reject',
        value: function reject(index) {
            var _this4 = this;

            var ref = this.ApproveList.val()[index].Id;
            var action = {
                controller: 'Transaction',
                action: 'RejectTransaction',
                params: ref,
                success: function success(result, message) {
                    _this4.loadWaitingApprovalTransaction(function () {
                        _this4.success(message);
                    });
                }
            };
            this.post(action);
        }
    }, {
        key: 'approve',
        value: function approve(index) {
            var _this5 = this;

            var ref = this.ApproveList.val()[index].Id;
            var action = {
                controller: 'Transaction',
                action: 'ApproveTransaction',
                params: ref,
                success: function success(result, message) {
                    _this5.loadWaitingApprovalTransaction(function () {
                        _this5.success(message);
                    });
                }
            };
            this.post(action);
        }
    }, {
        key: 'render',
        value: function render() {
            return React.createElement(
                Row,
                null,
                React.createElement(
                    Col,
                    { Md: '8', Lg: '8', Sm: '10', Xs: '12' },
                    React.createElement(
                        Panel,
                        null,
                        React.createElement(PageButtons, { Run: this, Id: 'Pagebuttans', HideRefresh: true }),
                        React.createElement(
                            Row,
                            null,
                            React.createElement(
                                Table,
                                { Run: this, Id: 'ApproveList' },
                                React.createElement(TableColumn, { Name: 'Id', Caption: 'TransactionId' }),
                                React.createElement(TableColumn, { Name: 'TransactionName', Caption: 'TransactionName' }),
                                React.createElement(TableColumn, { Name: 'CreateUser', Caption: 'CreateUser' }),
                                React.createElement(TableColumn, { Name: 'Detail', Width: 50, Editor: { Type: Button, Props: { Icon: 'eye', OnClick: this.detail.bind(this), CssClass: "btn-data-table" } } }),
                                React.createElement(TableColumn, { Name: 'Reject', Width: 50, Editor: { Type: Button, Props: { Icon: 'times', OnClick: this.reject.bind(this), CssClass: "btn-data-table" } } }),
                                React.createElement(TableColumn, { Name: 'Approve', Width: 50, Editor: { Type: Button, Props: { Icon: 'check', OnClick: this.approve.bind(this), CssClass: "btn-data-table" } } })
                            )
                        ),
                        React.createElement(
                            Modal,
                            { Run: this, Id: 'TransactionDetailModal', Caption: 'Detail', Height: 300 },
                            React.createElement(LabelValue, { Run: this, Id: 'TransactionExplanation', Caption: 'Explanation' }),
                            React.createElement(
                                Table,
                                { Run: this, Id: 'TransactionDetails' },
                                React.createElement(TableColumn, { Name: 'FieldName', Caption: 'Field' }),
                                React.createElement(TableColumn, { Name: 'OldValue', Caption: 'OldValue' }),
                                React.createElement(TableColumn, { Name: 'NewValue', Caption: 'NewValue' })
                            )
                        )
                    )
                )
            );
        }
    }]);

    return TransactionApprove;
}(ViewBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TransactionManagement = function (_ViewBase) {
    _inherits(TransactionManagement, _ViewBase);

    function TransactionManagement() {
        _classCallCheck(this, TransactionManagement);

        return _possibleConstructorReturn(this, (TransactionManagement.__proto__ || Object.getPrototypeOf(TransactionManagement)).apply(this, arguments));
    }

    _createClass(TransactionManagement, [{
        key: "init",
        value: function init() {
            this.state.casePanelClass = "hidden";
            this.state.caseDetailPanelClass = "hidden";
            this.state.confirmCallBack = null;
            this.state.conditionInfo = null;
            this.state.modelClassInfo = null;
        }
    }, {
        key: "load",
        value: function load() {
            var _this2 = this;

            this.loadTransactions();

            var action2 = {
                controller: 'Transaction',
                action: 'GetTransactionListFromSystem',
                success: function success(result) {
                    _this2.TransactionName.setState({ data: result });
                }
            };
            this.post(action2);
            this.CaseStatus.val("Active");
        }
    }, {
        key: "transactionActionChange",
        value: function transactionActionChange(value, credential) {
            if (value == "Approve") {
                this.loadCredentials(credential);
            } else {
                this.ApproveCredential.hide();
            }
        }
    }, {
        key: "loadCredentials",
        value: function loadCredentials(value) {
            var _this3 = this;

            var action = {
                controller: 'User',
                action: 'GetCredentials',
                success: function success(result) {
                    _this3.ApproveCredential.show();
                    _this3.ApproveCredential.setState({ data: result }, function () {
                        if (!bb.inu(value)) {
                            _this3.ApproveCredential.val(value);
                        }
                    });
                }
            };
            this.post(action);
        }
    }, {
        key: "loadTransactions",
        value: function loadTransactions() {
            var _this4 = this;

            var action = {
                controller: 'Transaction',
                action: 'GetTransactionList',
                success: function success(result) {
                    _this4.Transactions.val(result);
                }
            };
            this.post(action);
        }
    }, {
        key: "loadTransactionFields",
        value: function loadTransactionFields(selected) {
            var _this5 = this;

            var action = {
                controller: 'Transaction',
                action: 'GetTransactionModelFieldList',
                params: selected,
                success: function success(result) {
                    var objList = {
                        Model: [],
                        User: [],
                        Channel: []
                    };

                    var modelClassInfo = [];

                    result.Model.forEach(function (item) {
                        objList.Model.push(item.Name);
                        modelClassInfo.push(React.createElement(LabelValue, { key: bb.guid(), Id: bb.guid(), Caption: item.Name + " (" + bb.localize(item.Name) + ")", Value: item.Type }));
                    });

                    result.User.forEach(function (item) {
                        objList.User.push(item.Name);
                    });

                    result.Channel.forEach(function (item) {
                        objList.Channel.push(item.Name);
                    });

                    _this5.setState({ modelClassInfo: result });

                    _this5.Condition.setState({ objList: objList });
                    _this5.Action.setState({ objList: objList });

                    _this5.ConditionInfo.content(modelClassInfo);
                }
            };
            this.post(action);
        }
    }, {
        key: "askConfirm",
        value: function askConfirm(message, confirmCallBack) {
            var _this6 = this;

            this.setState({ confirmCallBack: confirmCallBack }, function () {
                _this6.ConfirmBox.content(React.createElement(
                    "div",
                    { className: "text-center" },
                    bb.localize(message)
                ));
                _this6.ConfirmBox.open();
            });
        }
    }, {
        key: "onDone",
        value: function onDone() {
            var _this7 = this;

            if (this.state.caseDetailPanelClass == "") {
                this.updateTransactionCase();
            }
            var selected = this.Transactions.selected();
            if (selected != null) {
                var selectedIndex = this.Transactions.selectedIndex();
                if (this.state.casePanelClass == "") {
                    selected.Cases = this.Cases.val();
                }
                selected.RecordStatus = selected.RecordStatus != "New" && selected.RecordStatus != "Deleted" ? "Updated" : selected.RecordStatus;
                this.Transactions.update(selected, selectedIndex, function () {
                    _this7.createorUpdateTransactions();
                });
            } else {
                this.createorUpdateTransactions();
            }
        }
    }, {
        key: "createorUpdateTransactions",
        value: function createorUpdateTransactions() {
            var _this8 = this;

            var action = {
                controller: "Transaction",
                action: 'CreateOrUpdateTransaction',
                params: { Transactions: this.Transactions.val() },
                success: function success(result, msg) {
                    _this8.success(msg);
                    _this8.setState({ casePanelClass: "hidden", caseDetailPanelClass: "hidden" }, function () {
                        _this8.Transactions.enable();
                        _this8.loadTransactions();
                    });
                }
            };
            this.post(action);
        }
    }, {
        key: "onCancel",
        value: function onCancel() {
            var _this9 = this;

            this.askConfirm("yourchangeswillbelostifyoucancel", function () {
                _this9.setState({ casePanelClass: "hidden", caseDetailPanelClass: "hidden" }, function () {
                    _this9.Transactions.enable();
                    _this9.Cases.enable();
                    _this9.Transactions.clear();
                    _this9.Cases.clear();
                    _this9.clearDetail();
                    _this9.loadTransactions();
                });
            });
        }
    }, {
        key: "newTransaction",
        value: function newTransaction() {
            this.TransactionName.clear();
            this.TransactionSelection.open();
        }
    }, {
        key: "newTransactionCase",
        value: function newTransactionCase() {
            var _this10 = this;

            this.CaseName.clear();
            if (this.state.caseDetailPanelClass == "") {
                this.ApproveCredential.hide();
                this.askConfirm("yourchangesoncurrentcasewillbelost", function () {
                    _this10.clearDetail();
                    _this10.TransactionCaseNameSelection.open();
                });
            } else {
                this.TransactionCaseNameSelection.open();
            }
        }
    }, {
        key: "addNewTransaction",
        value: function addNewTransaction(callback) {
            var _this11 = this;

            var selected = this.TransactionName.selected();
            var row = { Name: selected.Name, Cases: [], AssemblyName: selected.AssemblyName };
            this.Transactions.add(row, null, function () {
                _this11.Transactions.select(0);
                _this11.transactionSelected(0);
            });
            this.Transactions.disable();
            callback();
        }
    }, {
        key: "addNewTransactionCase",
        value: function addNewTransactionCase(callback) {
            var _this12 = this;

            var name = this.CaseName.val();
            if (name != "") {
                var row = { Name: this.CaseName.val(), Order: 0 };
                this.Cases.add(row, null, function () {
                    _this12.Cases.select(0);
                    _this12.transactionCaseSelected(0);
                    var cases = _this12.Cases.val();
                    var list = [];
                    if (cases.length != 0) {
                        cases.forEach(function (item, index) {
                            if (index != 0) {
                                item.Order = index;
                            }
                            list.push(item);
                        });
                    }
                    _this12.Cases.val(list);
                });
                callback();
            } else {
                this.CaseName.error("requiredfieldvalidationmessage");
            }
        }
    }, {
        key: "transactionSelected",
        value: function transactionSelected(rowIndex) {
            this.Transactions.select(rowIndex);
            var list = this.Transactions.val();
            var selected = list[rowIndex];
            this.Cases.val(selected.Cases);
            this.setState({ casePanelClass: "" });
            this.loadTransactionFields(selected);
            this.Transactions.disable();
        }
    }, {
        key: "transactionCaseSelected",
        value: function transactionCaseSelected(rowIndex) {
            var _this13 = this;

            this.Cases.select(rowIndex);
            var list = this.Cases.val();
            var selected = list[rowIndex];

            this.Explanation.val(selected.Explanation);
            this.Condition.val(selected.Condition);
            this.Action.val(selected.Action);
            this.TransactionAction.val(selected.TransactionAction);
            if (selected.TransactionAction == "Approve") {
                this.transactionActionChange(selected.TransactionAction, selected.ApproveCredential);
            }
            this.CaseStatus.val(selected.CaseStatus);
            this.setState({ caseDetailPanelClass: "" }, function () {
                _this13.ApproveCredential.hide();
            });
        }
    }, {
        key: "removeTransaction",
        value: function removeTransaction(rowIndex) {
            this.Transactions.remove(rowIndex);
            this.setState({ casePanelClass: "hidden", caseDetailPanelClass: "hidden" });
        }
    }, {
        key: "removeTransactionCase",
        value: function removeTransactionCase(rowIndex) {
            this.Cases.remove(rowIndex);
            this.setState({ caseDetailPanelClass: "hidden" });
        }
    }, {
        key: "updateTransactionCase",
        value: function updateTransactionCase() {
            var _this14 = this;

            var approveCredential = 0;
            if (!bb.inu(this.ApproveCredential)) {
                approveCredential = this.ApproveCredential.val();
            }
            var selected = this.Cases.selected();
            var selectedIndex = this.Cases.selectedIndex();
            var caseDetail = {
                Id: selected.Id,
                Name: selected.Name,
                Order: selected.Order,
                Explanation: this.Explanation.val(),
                Condition: this.Condition.val(),
                Action: this.Action.val(),
                CaseStatus: this.CaseStatus.val(),
                TransactionAction: this.TransactionAction.val(),
                ApproveCredential: approveCredential
            };
            this.validate(caseDetail, "TransactionCaseModel", function () {
                _this14.Cases.update(caseDetail, selectedIndex, function () {
                    _this14.setState({ caseDetailPanelClass: "hidden" });
                    _this14.clearDetail();
                });
            });
        }
    }, {
        key: "clearDetail",
        value: function clearDetail() {
            this.Explanation.clear();
            this.Condition.clear();
            this.Action.clear();
            this.TransactionAction.clear();
            this.CaseStatus.val("Active");
        }
    }, {
        key: "caseOrderUp",
        value: function caseOrderUp(value) {
            var cases = this.Cases.val();
            var list = [];
            cases.forEach(function (item, index) {
                if (value != 0) {
                    if (index == value - 1) {
                        item.Order = item.Order + 1;
                    } else if (index == value) {
                        item.Order = item.Order - 1;
                    }
                    list.push(item);
                }
            });
            if (list.length > 0) {
                cases = list.sort(function (a, b) {
                    return a.Order - b.Order;
                });
            }
            this.Cases.val(cases);
        }
    }, {
        key: "caseOrderDown",
        value: function caseOrderDown(value) {
            var cases = this.Cases.val();
            var list = [];
            cases.forEach(function (item, index) {
                if (value != cases.length - 1) {
                    if (index == value + 1) {
                        item.Order = item.Order - 1;
                    } else if (index == value) {
                        item.Order = item.Order + 1;
                    }
                    list.push(item);
                }
            });
            if (list.length > 0) {
                cases = list.sort(function (a, b) {
                    return a.Order - b.Order;
                });
            }
            this.Cases.val(cases);
        }
    }, {
        key: "showInfoContent",
        value: function showInfoContent() {
            this.ConditionInfo.open();
        }
    }, {
        key: "render",
        value: function render() {
            var _this15 = this;

            return React.createElement(
                Panel,
                null,
                React.createElement(PageButtons, { Run: this, Id: "Pagebuttans", HideRefresh: true }),
                React.createElement(
                    Row,
                    { CssClass: "m-b-sm" },
                    React.createElement(
                        Col,
                        { Md: "12" },
                        React.createElement(
                            Table,
                            { Id: "Transactions", Run: this,
                                Caption: "Transactions",
                                Buttons: "Add",
                                DisableSelect: true,
                                OnAdd: this.newTransaction.bind(this),
                                Height: "200" },
                            React.createElement(TableColumn, { Name: "Name", Caption: "Name", Unique: true }),
                            React.createElement(TableColumn, { Name: "EditButton", Editor: { Type: Button, Props: { Icon: 'pencil', CssClass: "btn-data-table", OnClick: this.transactionSelected.bind(this) } }, Width: "30" }),
                            React.createElement(TableColumn, { Name: "RemoveButton", Editor: { Type: Button, Props: { Icon: 'times', CssClass: "btn-data-table", OnClick: this.removeTransaction.bind(this) } }, Width: "30" })
                        )
                    )
                ),
                React.createElement(
                    Row,
                    { CssClass: "m-b-sm" },
                    React.createElement(
                        Col,
                        { Md: "6", CssClass: this.state.casePanelClass },
                        React.createElement(
                            Table,
                            { Id: "Cases", Run: this,
                                Caption: "TransasctionCases",
                                Buttons: "Add",
                                DisableSelect: true,
                                OnAdd: this.newTransactionCase.bind(this),
                                Height: "400" },
                            React.createElement(TableColumn, { Name: "Name", Caption: "Name", Unique: true }),
                            React.createElement(TableColumn, { Name: "UpButton", Editor: { Type: Button, Props: { Icon: 'caret-up', CssClass: "btn-data-table", OnClick: this.caseOrderUp.bind(this) } }, Width: "30" }),
                            React.createElement(TableColumn, { Name: "DownButton", Editor: { Type: Button, Props: { Icon: 'caret-down', CssClass: "btn-data-table", OnClick: this.caseOrderDown.bind(this) } }, Width: "30" }),
                            React.createElement(TableColumn, { Name: "EditButton", Editor: { Type: Button, Props: { Icon: 'pencil', CssClass: "btn-data-table", OnClick: this.transactionCaseSelected.bind(this) } }, Width: "30" }),
                            React.createElement(TableColumn, { Name: "RemoveButton", Editor: { Type: Button, Props: { Icon: 'times', CssClass: "btn-data-table", OnClick: this.removeTransactionCase.bind(this) } }, Width: "30" })
                        )
                    ),
                    React.createElement(
                        Col,
                        { Md: "6", CssClass: this.state.caseDetailPanelClass },
                        React.createElement(
                            Row,
                            { CssClass: "m-b-sm" },
                            React.createElement(
                                Col,
                                { Md: "12" },
                                React.createElement(TextBox, { Id: "Explanation", Caption: "Explanation", Run: this })
                            )
                        ),
                        React.createElement(
                            Row,
                            { CssClass: "m-b-sm" },
                            React.createElement(
                                Col,
                                { Md: "12" },
                                React.createElement(AutoCompleteTextarea, { Id: "Condition", Caption: "Condition", Run: this, Rows: 3, InfoClick: this.showInfoContent.bind(this) }),
                                React.createElement(Modal, { Run: this, Id: "ConditionInfo", Caption: "ModelDefinition", Height: "200" })
                            )
                        ),
                        React.createElement(
                            Row,
                            { CssClass: "m-b-sm" },
                            React.createElement(
                                Col,
                                { Md: "12" },
                                React.createElement(ComboBox, { Id: "TransactionAction", Caption: "TransactionAction", Run: this,
                                    Data: this.parameters("TransactionAction"),
                                    KeyField: "Definition",
                                    ValueField: "Value",
                                    OnChange: this.transactionActionChange.bind(this)
                                })
                            )
                        ),
                        React.createElement(
                            Row,
                            { CssClass: "m-b-sm" },
                            React.createElement(
                                Col,
                                { Md: "12" },
                                React.createElement(ComboBox, { Id: "ApproveCredential", Caption: "ApproveCredential", Run: this,
                                    KeyField: "Name",
                                    ValueField: "Id"
                                })
                            )
                        ),
                        React.createElement(
                            Row,
                            { CssClass: "m-b-sm" },
                            React.createElement(
                                Col,
                                { Md: "12" },
                                React.createElement(AutoCompleteTextarea, { Id: "Action", Caption: "Action", Run: this, Rows: 3 })
                            )
                        ),
                        React.createElement(
                            Row,
                            { CssClass: "m-b-sm" },
                            React.createElement(
                                Col,
                                { Md: "6" },
                                React.createElement(
                                    "div",
                                    { className: "field-wrapper" },
                                    React.createElement(
                                        Label,
                                        null,
                                        "CaseStatus"
                                    )
                                ),
                                React.createElement(RadioButton, { Id: "CaseStatus", Caption: "CaseStatus", Run: this,
                                    NoSelect: true,
                                    Data: this.parameters("ActivePassive"),
                                    KeyField: "Definition",
                                    ValueField: "Value",
                                    Class: "pull-left"
                                })
                            ),
                            React.createElement(
                                Col,
                                { Md: "6" },
                                React.createElement(Button, { Id: "SaveDetailButton", Run: this,
                                    Value: "SaveDetail", Width: "100", Type: "primary", Class: "pull-right m-r-xs", OnClick: this.updateTransactionCase.bind(this)
                                })
                            )
                        )
                    )
                ),
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: "12", CssClass: "text-center m-t-md" },
                        React.createElement(Button, { Id: "CancelCaseButton", Run: this,
                            Value: "Cancel", Width: "100", Class: "btn-wizard m-r-xs", OnClick: this.onCancel.bind(this)
                        }),
                        React.createElement(Button, { Id: "SaveCaseButton", Run: this,
                            Value: "Save", Width: "100", Type: "primary", Class: "btn-wizard m-l-xs", OnClick: this.onDone.bind(this)
                        })
                    )
                ),
                React.createElement(
                    Modal,
                    { Id: "TransactionSelection", Run: this, Size: "Medium", Caption: "Transactions", Height: "260px", OnClose: this.addNewTransaction.bind(this) },
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: "12" },
                            React.createElement(AutoComplete, { Run: this, Id: "TransactionName", Caption: "TransactionName", KeyField: "Name", ValueField: "Name", Number: "9999" })
                        )
                    )
                ),
                React.createElement(
                    Modal,
                    { Id: "TransactionCaseNameSelection", Run: this, Size: "Medium", Caption: "EnterCaseName", Height: "150px", OnClose: this.addNewTransactionCase.bind(this) },
                    React.createElement(
                        Row,
                        null,
                        React.createElement(
                            Col,
                            { Md: "12" },
                            React.createElement(TextBox, { Run: this, Id: "CaseName", Caption: "CaseName" })
                        )
                    )
                ),
                React.createElement(ConfirmBox, { Run: this, OnConfirm: function OnConfirm(callback) {
                        if (bb.isFunction(_this15.state.confirmCallBack)) {
                            _this15.state.confirmCallBack(callback);
                        }
                    } })
            );
        }
    }]);

    return TransactionManagement;
}(ViewBase);
"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var UserInfo = function (_React$Component) {
    _inherits(UserInfo, _React$Component);

    function UserInfo(props) {
        _classCallCheck(this, UserInfo);

        return _possibleConstructorReturn(this, (UserInfo.__proto__ || Object.getPrototypeOf(UserInfo)).call(this, props));
    }

    _createClass(UserInfo, [{
        key: "componentDidMount",
        value: function componentDidMount() {
            page.post("/User/GetUserData", null, function (data) {
                page.model(data);
            });
        }
    }, {
        key: "render",
        value: function render() {
            return React.createElement(
                "div",
                null,
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: 6 },
                        React.createElement(TextBox, { Run: this, Id: "Name", Caption: "Name", Disabled: true })
                    ),
                    React.createElement(
                        Col,
                        { Md: 6 },
                        React.createElement(TextBox, { Run: this, Id: "Surname", Caption: "Surname", Disabled: true })
                    )
                ),
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: 6 },
                        React.createElement(TextBox, { Run: this, Id: "UserName", Caption: "UserName", Disabled: true })
                    ),
                    React.createElement(
                        Col,
                        { Md: 6 },
                        React.createElement(TextBox, { Run: this, Id: "Email", Caption: "Email", Disabled: true })
                    )
                ),
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: 6 },
                        React.createElement(TextBox, { Run: this, Id: "Title", Caption: "Title", Disabled: true })
                    ),
                    React.createElement(
                        Col,
                        { Md: 6 },
                        React.createElement(TextBox, { Run: this, Id: "PhoneNumber", Caption: "PhoneNumber", Disabled: true })
                    )
                ),
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: 6 },
                        React.createElement(TextBox, { Run: this, Id: "Branch", Caption: "Branch", Disabled: true })
                    )
                )
            );
        }
    }]);

    return UserInfo;
}(React.Component);
'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var UserManagement = function (_ViewBase) {
    _inherits(UserManagement, _ViewBase);

    function UserManagement() {
        _classCallCheck(this, UserManagement);

        return _possibleConstructorReturn(this, (UserManagement.__proto__ || Object.getPrototypeOf(UserManagement)).apply(this, arguments));
    }

    _createClass(UserManagement, [{
        key: 'title',
        value: function title() {
            return "User";
        }
    }, {
        key: 'init',
        value: function init(props) {
            this.state.roles = [];
            this.state.userNameDisabled = false;
            this.state.emailTxtDisabled = false;
        }
    }, {
        key: 'load',
        value: function load() {
            this.EmailConfirmed.val(false);
            this.PhoneNumberConfirmed.val(false);
            this.loadSourceRoles();
            this.loadCurrentUser();
        }
    }, {
        key: 'loadSourceRoles',
        value: function loadSourceRoles() {
            var action = {
                controller: 'User',
                action: 'GetRolesForCombo',
                success: function (data, msg) {
                    for (var i = 0; i < data.length; i++) {
                        data[i]["Selected"] = false;
                    }
                    this.state.roles = data;
                    this.Roles.setState({ value: data });
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'loadCurrentUser',
        value: function loadCurrentUser() {
            var params = this.params();

            if (!bb.inu(params) && (typeof params === 'undefined' ? 'undefined' : _typeof(params)) === 'object') {
                this.model(params);
            } else if (!bb.inu(params)) {
                var action = {
                    controller: 'User',
                    action: 'GetUserDataForUpdate',
                    params: params,
                    success: function (data) {
                        var assignedRoles = data.Roles;
                        var roles = this.state.roles;

                        data.Roles.forEach(function (userRole) {
                            var role = roles.find(function (item) {
                                return item.Id == userRole.Id;
                            });
                            if (!bb.inu(role)) {
                                role.Selected = true;
                            }
                        });

                        data.Roles = roles;

                        data.Password = "password";
                        data.PasswordConfirm = "password";

                        if (!bb.inu(data.Phones)) {
                            data.Phones.forEach(function (phone) {
                                phone.AreaCode = bb.clone(phone.Phone.AreaCode);
                                phone.Number = bb.clone(phone.Phone.Number);
                            });
                        }
                        this.model(data);
                        this.setState({ emailTxtDisabled: true });
                        this.setState({ userNameDisabled: true });
                    }.bind(this)
                };
                this.post(action);
            }
        }
    }, {
        key: 'createUpdateUser',
        value: function createUpdateUser() {
            var model = this.model();
            this.validate(model, "UserCreateUpdateModel", function (serverModel) {
                var action = {
                    controller: 'User',
                    action: 'CreateOrUpdate',
                    params: serverModel,
                    success: function (data, msg) {
                        this.success(msg);
                        this.disable();
                    }.bind(this)
                };
                this.post(action);
            }.bind(this));
        }
    }, {
        key: 'renderRole',
        value: function renderRole() {
            var className = "hidden";

            if (this.user().UserName.toLowerCase() == "admin") {
                className = "";
            }
            return React.createElement(
                'div',
                { className: className },
                React.createElement(
                    Row,
                    null,
                    React.createElement(
                        Col,
                        { Md: 12 },
                        React.createElement(
                            DataGrid,
                            {
                                Run: this, ShowPagination: false,
                                Id: 'Roles', Caption: 'Roles' },
                            React.createElement(DataGridColumn, { Name: 'Selected', Width: 40, Editor: { Type: CheckBox } }),
                            React.createElement(DataGridColumn, { Name: 'Name', Caption: 'Roles' })
                        )
                    )
                )
            );
        }
    }, {
        key: 'render',
        value: function render() {

            var languages = this.appState().Languages;

            return React.createElement(
                Row,
                null,
                React.createElement(
                    Col,
                    { Md: '8', Lg: '8', Sm: '10', Xs: '12' },
                    React.createElement(
                        Panel,
                        null,
                        React.createElement(PageButtons, { Id: 'PageButtons', HideRefresh: true, Run: this }),
                        React.createElement(TextBox, { Run: this, Id: 'Id', Hidden: true }),
                        React.createElement(TextBox, { Run: this, Id: 'EmailConfirmed', Hidden: true }),
                        React.createElement(TextBox, { Run: this, Id: 'PhoneNumberConfirmed', Hidden: true }),
                        React.createElement(TextBox, { Run: this, Id: 'Reseller', Hidden: true }),
                        React.createElement(TextBox, { Run: this, Id: 'Client', Hidden: true }),
                        React.createElement(TextBox, { Run: this, Id: 'Reserve1', Hidden: true }),
                        React.createElement(TextBox, { Run: this, Id: 'Reserve2', Hidden: true }),
                        React.createElement(TextBox, { Run: this, Id: 'Reserve3', Hidden: true }),
                        React.createElement(TextBox, { Run: this, Id: 'Reserve4', Hidden: true }),
                        React.createElement(TextBox, { Run: this, Id: 'Reserve5', Hidden: true }),
                        React.createElement(
                            Row,
                            null,
                            React.createElement(
                                Col,
                                { Md: 6 },
                                React.createElement(TextBox, { Run: this, Id: 'Name', Caption: 'Name', Rules: 'presence: true' })
                            ),
                            React.createElement(
                                Col,
                                { Md: 6 },
                                React.createElement(TextBox, { Run: this, Id: 'Surname', Caption: 'Surname', Rules: 'presence: true' })
                            )
                        ),
                        React.createElement(
                            Row,
                            null,
                            React.createElement(
                                Col,
                                { Md: 6 },
                                React.createElement(TextBox, { Run: this, Id: 'Email', Caption: 'Email', Rules: 'presence: true', Disabled: this.state.emailTxtDisabled })
                            ),
                            React.createElement(
                                Col,
                                { Md: 6 },
                                React.createElement(ComboBox, { Run: this, Id: 'Language', Caption: 'Language', Data: languages })
                            )
                        ),
                        React.createElement(
                            Row,
                            null,
                            React.createElement(
                                Col,
                                { Md: 6 },
                                React.createElement(TextBox, { Run: this, Id: 'Password', Type: 'password', Caption: 'Password', Rules: 'presence: true' })
                            ),
                            React.createElement(
                                Col,
                                { Md: 6 },
                                React.createElement(TextBox, { Run: this, Id: 'PasswordConfirm', Type: 'password', Caption: 'PasswordConfirm', Rules: 'presence: true, equality: \'Password\'' })
                            )
                        ),
                        this.renderRole(),
                        React.createElement(AddressGrid, { Run: this, ShowPagination: false, Id: 'Addresses', Caption: 'Addresses' }),
                        React.createElement(PhoneGrid, { Run: this, ShowPagination: false, Id: 'Phones', Caption: 'Phones' }),
                        React.createElement(EmailGrid, { Run: this, AppendToLast: true, ShowPagination: false, Id: 'Emails', Caption: 'Emails' }),
                        React.createElement(
                            Col,
                            { Md: '12', CssClass: 'text-center m-t-md' },
                            React.createElement(Button, { Disabled: this.state.disabled, Run: this, key: 'DoneButton', Id: 'DoneButton', Width: 200, Type: 'primary', Class: 'btn-wizard', Icon: 'check', Value: bb.localize('Done'), OnClick: this.createUpdateUser.bind(this) })
                        )
                    )
                )
            );
        }
    }]);

    return UserManagement;
}(ViewBase);
'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var UserSearch = function (_ViewBase) {
    _inherits(UserSearch, _ViewBase);

    function UserSearch() {
        _classCallCheck(this, UserSearch);

        return _possibleConstructorReturn(this, (UserSearch.__proto__ || Object.getPrototypeOf(UserSearch)).apply(this, arguments));
    }

    _createClass(UserSearch, [{
        key: 'title',
        value: function title() {
            return "Users";
        }
    }, {
        key: 'init',
        value: function init() {
            this.state.confirmCallBack = null;
        }
    }, {
        key: 'load',
        value: function load() {
            this.userSearch();
        }
    }, {
        key: 'userSearch',
        value: function userSearch() {
            var model = this.model();

            var requestObject = {
                Name: model.Name,
                Surname: model.Surname,
                Username: model.Username,
                Email: model.Email
            };

            var action = {
                controller: 'User',
                action: 'GetUsersSearhResult',
                params: requestObject,
                success: function (result) {
                    this.UserList.setState({ value: result });
                }.bind(this)
            };
            this.post(action);
        }
    }, {
        key: 'userClear',
        value: function userClear() {
            this.clear();
        }
    }, {
        key: 'userUpdate',
        value: function userUpdate(rowData) {
            if (!bb.inu(rowData)) {
                this.open("UserManagement", rowData.Id);
            }
        }
    }, {
        key: 'addUser',
        value: function addUser() {
            var user = this.user();

            var credentials = user.AnonymousCredentials;
            var model = {
                Reseller: user.Reseller,
                Client: user.Client,
                Reserve1: user.Reserve1,
                Reserve2: user.Reserve2,
                Reserve3: user.Reserve3,
                Reserve4: user.Reserve4,
                Reserve5: user.Reserve5
            };

            this.open("UserManagement", model);
        }
    }, {
        key: 'confirmDelete',
        value: function confirmDelete(index) {
            var _this2 = this;

            this.askConfirm("doyouwanttoremoveuser", function () {
                _this2.deleteUser(index);
            });
        }
    }, {
        key: 'askConfirm',
        value: function askConfirm(message, confirmCallBack) {
            var _this3 = this;

            this.setState({ confirmCallBack: confirmCallBack }, function () {
                _this3.ConfirmBox.content(React.createElement(
                    'div',
                    { className: 'text-center' },
                    bb.localize(message)
                ));
                _this3.ConfirmBox.open();
            });
        }
    }, {
        key: 'deleteUser',
        value: function deleteUser(index) {
            var _this4 = this;

            var user = this.UserList.val()[index];
            var action = {
                controller: 'User',
                action: 'DeleteUser',
                params: user.Id,
                success: function success(result, message) {
                    _this4.success(message);
                }
            };
            this.post(action);
        }
    }, {
        key: 'render',
        value: function render() {
            var _this5 = this;

            return React.createElement(
                Row,
                null,
                React.createElement(
                    Col,
                    { Md: '8', Lg: '8', Sm: '10', Xs: '12' },
                    React.createElement(
                        Panel,
                        null,
                        React.createElement(
                            Row,
                            null,
                            React.createElement(
                                Col,
                                { Md: 12 },
                                React.createElement(PageButtons, { Id: 'PageButtons', Run: this, HideRefresh: true })
                            )
                        ),
                        React.createElement(
                            Row,
                            null,
                            React.createElement(
                                Col,
                                { Md: 6 },
                                React.createElement(TextBox, { Run: this, Id: 'Name', Caption: 'Name' })
                            ),
                            React.createElement(
                                Col,
                                { Md: 6 },
                                React.createElement(TextBox, { Run: this, Id: 'Surname', Caption: 'Surname' })
                            )
                        ),
                        React.createElement(
                            Row,
                            null,
                            React.createElement(
                                Col,
                                { Md: 6 },
                                React.createElement(TextBox, { Run: this, Id: 'Email', Caption: 'Email' })
                            )
                        )
                    ),
                    React.createElement(
                        Panel,
                        { CssClass: 'm-t-md' },
                        React.createElement(
                            DataGrid,
                            {
                                Run: this,
                                Id: 'UserList',
                                Buttons: 'AddUser,Update,List,Clear,Remove',
                                OnAddUser: this.addUser.bind(this),
                                OnRemove: this.deleteUser.bind(this),
                                OnUpdate: this.userUpdate.bind(this),
                                OnClear: this.userClear.bind(this),
                                OnList: this.userSearch.bind(this) },
                            React.createElement(DataGridColumn, { Name: 'Email', Caption: 'Email' }),
                            React.createElement(DataGridColumn, { Name: 'Name', Width: 150, Caption: 'Name' }),
                            React.createElement(DataGridColumn, { Name: 'Surname', Width: 150, Caption: 'Surname' }),
                            React.createElement(DataGridColumn, { Name: 'Delete', Width: 50, Editor: { Type: Button, Props: { Icon: 'trash', OnClick: this.confirmDelete.bind(this), CssClass: "btn-data-table" } } })
                        )
                    ),
                    React.createElement(ConfirmBox, { Run: this, OnConfirm: function OnConfirm(callback) {
                            if (bb.isFunction(_this5.state.confirmCallBack)) {
                                _this5.state.confirmCallBack(callback);
                            }
                        } })
                )
            );
        }
    }]);

    return UserSearch;
}(ViewBase);